// Implementation file for parser generated by fsyacc
module internal FSharp.Compiler.Parser
#nowarn "64";; // turn off warnings that type variables used in production annotations are instantiated to concrete type
open FSharp.Compiler
open Internal.Utilities.Text.Lexing
open Internal.Utilities.Text.Parsing.ParseHelpers
//# 3 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"


#nowarn "1182"  // generated code has lots of unused "parseState"

open Internal.Utilities

open FSharp.Compiler.AbstractIL
open FSharp.Compiler.AbstractIL.Internal
open FSharp.Compiler.AbstractIL.Internal.Library
open FSharp.Compiler
open Internal.Utilities.Text.Parsing

open System
open FSharp.Compiler.Range
open FSharp.Compiler.Ast
open FSharp.Compiler.Lib
open FSharp.Compiler.PrettyNaming
open FSharp.Compiler.ErrorLogger

#if DEBUG
let debugPrint(s) =
    if Internal.Utilities.Text.Parsing.Flags.debug then 
        printfn "\n%s" s
#else
let debugPrint(s) = ignore s
#endif

let exprFromParseError (e:SynExpr) = SynExpr.FromParseError (e,e.Range)
let patFromParseError (e:SynPat) = SynPat.FromParseError(e, e.Range)

let mkSynOptionalExpr (m: range) xopt = 
    let m = m.MakeSynthetic()
    match xopt with 
    | None -> mkSynLidGet m Ast.FSharpLib.CorePath "None"
    | Some x  -> SynExpr.App (ExprAtomicFlag.NonAtomic, false, mkSynLidGet m Ast.FSharpLib.CorePath "Some",x,m)

// record bindings returned by the recdExprBindings rule has shape:
// (binding, separator-before-this-binding)
// this function converts arguments from form
// binding1 (binding2*sep1, binding3*sep2...) sepN
// to form
// binding1*sep1, binding2*sep2
let rebindRanges first fields lastSep = 
    let rec run (name, value) l acc = 
        match l with
        | [] -> List.rev ((name, value, lastSep) :: acc)
        | (f, m) :: xs -> run f xs ((name, value, m) :: acc)
    run first fields []

let mkUnderscoreRecdField m = LongIdentWithDots([ident("_", m)], []), false
let mkRecdField lidwd = lidwd, true

let mkSynDoBinding (vis,strict,expr,m) = 
    match vis with
    | Some vis -> errorR(Error(FSComp.SR.parsDoCannotHaveVisibilityDeclarations (vis.ToString()),m))
    | None -> ()
    Binding (None,
             (if strict then DoBinding else StandaloneExpression),
             false,false,[],PreXmlDoc.Empty,SynInfo.emptySynValData,
             (if strict then SynPat.Const(SynConst.Unit,m) else SynPat.Wild m),
             None,expr,m,NoSequencePointAtDoBinding)

let mkSynDoDecl (e: SynExpr) = 
    let spExpr = if IsControlFlowExpression e then NoSequencePointAtDoBinding else SequencePointAtBinding e.Range in
    SynModuleDecl.DoExpr(spExpr, e, e.Range)

let addAttribs attrs p =  SynPat.Attrib(p,attrs,p.Range)


// This function is called by the generated parser code. Returning initiates error recovery 
// It must be called precisely "parse_error_rich"
let parse_error_rich = Some (fun (ctxt: ParseErrorContext<_>) -> 
    errorR(SyntaxError(box ctxt, ctxt.ParseState.LexBuffer.LexemeRange)))

let reportParseErrorAt m s = errorR(Error(s,m))

let unionRangeWithPos (r:range) p =
    let r2 = mkRange r.FileName p p
    unionRanges r r2

let raiseParseErrorAt m s = 
    reportParseErrorAt m s; 
    // This initiates error recovery
    raise RecoverableParseError 

let checkEndOfFileError t = 
  match t with 
  | LexCont.IfDefSkip(_,_,m)                      -> reportParseErrorAt m (FSComp.SR.parsEofInHashIf())
  | LexCont.String (_,m)                          -> reportParseErrorAt m (FSComp.SR.parsEofInString())
  | LexCont.TripleQuoteString (_,m)               -> reportParseErrorAt m (FSComp.SR.parsEofInTripleQuoteString())
  | LexCont.VerbatimString (_,m)                  -> reportParseErrorAt m (FSComp.SR.parsEofInVerbatimString())
  | LexCont.Comment (_,_,m)                       -> reportParseErrorAt m (FSComp.SR.parsEofInComment())
  | LexCont.SingleLineComment (_,_,m)             -> reportParseErrorAt m (FSComp.SR.parsEofInComment())
  | LexCont.StringInComment (_,_,m)               -> reportParseErrorAt m (FSComp.SR.parsEofInStringInComment())
  | LexCont.VerbatimStringInComment (_,_,m)       -> reportParseErrorAt m (FSComp.SR.parsEofInVerbatimStringInComment())
  | LexCont.TripleQuoteStringInComment (_,_,m)    -> reportParseErrorAt m (FSComp.SR.parsEofInTripleQuoteStringInComment())
  | LexCont.MLOnly (_,m)                          -> reportParseErrorAt m (FSComp.SR.parsEofInIfOcaml())
  | LexCont.EndLine(LexerEndlineContinuation.Skip(_,_,m)) -> reportParseErrorAt m (FSComp.SR.parsEofInDirective())
  | LexCont.EndLine(LexerEndlineContinuation.Token(stack))
  | LexCont.Token(stack) -> 
      match stack with 
      | [] -> ()
      | (_,m) :: _  -> reportParseErrorAt m (FSComp.SR.parsNoHashEndIfFound())

//                BindingSetPreAttrs(letRange, isRec, isUse, builderFunction, wholeRange)
type BindingSet = BindingSetPreAttrs of range * bool * bool * (SynAttributes -> SynAccess option -> SynAttributes * SynBinding list) * range

let mkClassMemberLocalBindings(isStatic,initialRangeOpt,attrs,vis,BindingSetPreAttrs(_,isRec,isUse,declsPreAttrs,bindingSetRange)) = 
   let ignoredFreeAttrs,decls = declsPreAttrs attrs vis
   let wholeRange = 
       match initialRangeOpt with 
       | None -> bindingSetRange
       | Some m -> unionRanges m bindingSetRange
   if not (isNil ignoredFreeAttrs) then warning(Error(FSComp.SR.parsAttributesIgnored(),wholeRange));
   if isUse then errorR(Error(FSComp.SR.parsUseBindingsIllegalInImplicitClassConstructors(),wholeRange))
   SynMemberDefn.LetBindings (decls,isStatic,isRec,wholeRange)

let mkLocalBindings (mWhole,BindingSetPreAttrs(_,isRec,isUse,declsPreAttrs,_),body) = 
   let ignoredFreeAttrs,decls = declsPreAttrs [] None 
   if not (isNil ignoredFreeAttrs) then warning(Error(FSComp.SR.parsAttributesIgnored(),mWhole))
   SynExpr.LetOrUse (isRec,isUse,decls,body,mWhole) 

let mkDefnBindings (mWhole,BindingSetPreAttrs(_,isRec,isUse,declsPreAttrs,_bindingSetRange),attrs,vis,attrsm) = 
    if isUse then warning(Error(FSComp.SR.parsUseBindingsIllegalInModules(),mWhole))
    let freeAttrs,decls = declsPreAttrs attrs vis 
    let letDecls = [ SynModuleDecl.Let (isRec,decls,mWhole) ] 
    let attrDecls = if not (isNil freeAttrs) then [ SynModuleDecl.Attributes (freeAttrs,attrsm) ] else [] 
    attrDecls @ letDecls

let idOfPat m p = 
    match p with 
    | SynPat.Named (SynPat.Wild _,id,false,_,_) -> id 
    | SynPat.LongIdent(LongIdentWithDots([id],_),_,None, SynConstructorArgs.Pats [], None,_) -> id
    | _ -> raiseParseErrorAt m (FSComp.SR.parsIntegerForLoopRequiresSimpleIdentifier())

let checkForMultipleAugmentations m a1 a2 = 
    if not (isNil a1) && not (isNil a2) then raiseParseErrorAt m (FSComp.SR.parsOnlyOneWithAugmentationAllowed())
    a1 @ a2

let grabXmlDoc(parseState:IParseState,elemIdx) = 
    LexbufLocalXmlDocStore.GrabXmlDocBeforeMarker(parseState.LexBuffer,rhs parseState elemIdx)

let unionRangeWithListBy projectRangeFromThing m listOfThing = 
    (m, listOfThing) ||> List.fold (fun m thing -> unionRanges m (projectRangeFromThing thing))

let rangeOfNonNilAttrs(attrs:SynAttributes) =
    (attrs.Head.Range,attrs.Tail) ||> unionRangeWithListBy (fun a -> a.Range)

let rangeOfLongIdent(lid:LongIdent) =
    System.Diagnostics.Debug.Assert(not lid.IsEmpty, "the parser should never produce a long-id that is the empty list") 
    (lid.Head.idRange,lid) ||> unionRangeWithListBy (fun id -> id.idRange) 


//# 161 "pars.fs"
// This type is the type of tokens accepted by the parser
type token = 
  | HASH_IF of (range * string * Ast.LexerWhitespaceContinuation)
  | HASH_ELSE of (range * string * Ast.LexerWhitespaceContinuation)
  | HASH_ENDIF of (range * string * Ast.LexerWhitespaceContinuation)
  | COMMENT of (Ast.LexerWhitespaceContinuation)
  | WHITESPACE of (Ast.LexerWhitespaceContinuation)
  | HASH_LINE of (Ast.LexerWhitespaceContinuation)
  | HASH_LIGHT of (Ast.LexerWhitespaceContinuation)
  | INACTIVECODE of (Ast.LexerWhitespaceContinuation)
  | LINE_COMMENT of (Ast.LexerWhitespaceContinuation)
  | STRING_TEXT of (Ast.LexerWhitespaceContinuation)
  | EOF of (Ast.LexerWhitespaceContinuation)
  | LEX_FAILURE of (string)
  | ODUMMY of (token)
  | FIXED
  | OINTERFACE_MEMBER
  | OBLOCKEND
  | OBLOCKEND_COMING_SOON
  | OBLOCKEND_IS_HERE
  | ORIGHT_BLOCK_END
  | ODECLEND
  | OEND
  | OBLOCKSEP
  | OBLOCKBEGIN
  | ORESET
  | OFUN
  | OFUNCTION
  | OWITH
  | OELSE
  | OTHEN
  | ODO_BANG
  | ODO
  | OBINDER of (string)
  | OLET of (bool)
  | HIGH_PRECEDENCE_TYAPP
  | HIGH_PRECEDENCE_PAREN_APP
  | HIGH_PRECEDENCE_BRACK_APP
  | TYPE_COMING_SOON
  | TYPE_IS_HERE
  | MODULE_COMING_SOON
  | MODULE_IS_HERE
  | EXTERN
  | VOID
  | PUBLIC
  | PRIVATE
  | INTERNAL
  | GLOBAL
  | STATIC
  | MEMBER
  | CLASS
  | ABSTRACT
  | OVERRIDE
  | DEFAULT
  | CONSTRUCTOR
  | INHERIT
  | GREATER_RBRACK
  | STRUCT
  | SIG
  | BAR
  | RBRACK
  | RBRACE
  | RBRACE_COMING_SOON
  | RBRACE_IS_HERE
  | MINUS
  | DOLLAR
  | BAR_RBRACK
  | BAR_RBRACE
  | UNDERSCORE
  | SEMICOLON_SEMICOLON
  | LARROW
  | EQUALS
  | LBRACK
  | LBRACK_BAR
  | LBRACE_BAR
  | LBRACK_LESS
  | LBRACE
  | QMARK
  | QMARK_QMARK
  | DOT
  | COLON
  | COLON_COLON
  | COLON_GREATER
  | COLON_QMARK_GREATER
  | COLON_QMARK
  | COLON_EQUALS
  | SEMICOLON
  | WHEN
  | WHILE
  | WITH
  | HASH
  | AMP
  | AMP_AMP
  | QUOTE
  | LPAREN
  | RPAREN
  | RPAREN_COMING_SOON
  | RPAREN_IS_HERE
  | STAR
  | COMMA
  | RARROW
  | GREATER_BAR_RBRACK
  | LPAREN_STAR_RPAREN
  | OPEN
  | OR
  | REC
  | THEN
  | TO
  | TRUE
  | TRY
  | TYPE
  | VAL
  | INLINE
  | INTERFACE
  | INSTANCE
  | CONST
  | LAZY
  | OLAZY
  | MATCH
  | MATCH_BANG
  | MUTABLE
  | NEW
  | OF
  | EXCEPTION
  | FALSE
  | FOR
  | FUN
  | FUNCTION
  | IF
  | IN
  | JOIN_IN
  | FINALLY
  | DO_BANG
  | AND
  | AS
  | ASSERT
  | OASSERT
  | ASR
  | BEGIN
  | DO
  | DONE
  | DOWNTO
  | ELSE
  | ELIF
  | END
  | DOT_DOT
  | BAR_BAR
  | UPCAST
  | DOWNCAST
  | NULL
  | RESERVED
  | MODULE
  | NAMESPACE
  | DELEGATE
  | CONSTRAINT
  | BASE
  | LQUOTE of (string * bool)
  | RQUOTE of (string * bool)
  | RQUOTE_DOT of (string * bool)
  | PERCENT_OP of (string)
  | BINDER of (string)
  | LESS of (bool)
  | GREATER of (bool)
  | LET of (bool)
  | YIELD of (bool)
  | YIELD_BANG of (bool)
  | BIGNUM of ((string * string))
  | DECIMAL of (System.Decimal)
  | CHAR of (char)
  | IEEE64 of (double)
  | IEEE32 of (single)
  | NATIVEINT of (int64)
  | UNATIVEINT of (uint64)
  | UINT64 of (uint64)
  | UINT32 of (uint32)
  | UINT16 of (uint16)
  | UINT8 of (byte)
  | INT64 of (int64 * bool)
  | INT32 of (int32 * bool)
  | INT32_DOT_DOT of (int32 * bool)
  | INT16 of (int16 * bool)
  | INT8 of (sbyte * bool)
  | FUNKY_OPERATOR_NAME of (string)
  | ADJACENT_PREFIX_OP of (string)
  | PLUS_MINUS_OP of (string)
  | INFIX_AMP_OP of (string)
  | INFIX_STAR_DIV_MOD_OP of (string)
  | PREFIX_OP of (string)
  | INFIX_BAR_OP of (string)
  | INFIX_AT_HAT_OP of (string)
  | INFIX_COMPARE_OP of (string)
  | INFIX_STAR_STAR_OP of (string)
  | IDENT of (string)
  | KEYWORD_STRING of (string)
  | STRING of (string)
  | BYTEARRAY of (byte[])
// This type is used to give symbolic names to token indexes, useful for error messages
type tokenId = 
    | TOKEN_HASH_IF
    | TOKEN_HASH_ELSE
    | TOKEN_HASH_ENDIF
    | TOKEN_COMMENT
    | TOKEN_WHITESPACE
    | TOKEN_HASH_LINE
    | TOKEN_HASH_LIGHT
    | TOKEN_INACTIVECODE
    | TOKEN_LINE_COMMENT
    | TOKEN_STRING_TEXT
    | TOKEN_EOF
    | TOKEN_LEX_FAILURE
    | TOKEN_ODUMMY
    | TOKEN_FIXED
    | TOKEN_OINTERFACE_MEMBER
    | TOKEN_OBLOCKEND
    | TOKEN_OBLOCKEND_COMING_SOON
    | TOKEN_OBLOCKEND_IS_HERE
    | TOKEN_ORIGHT_BLOCK_END
    | TOKEN_ODECLEND
    | TOKEN_OEND
    | TOKEN_OBLOCKSEP
    | TOKEN_OBLOCKBEGIN
    | TOKEN_ORESET
    | TOKEN_OFUN
    | TOKEN_OFUNCTION
    | TOKEN_OWITH
    | TOKEN_OELSE
    | TOKEN_OTHEN
    | TOKEN_ODO_BANG
    | TOKEN_ODO
    | TOKEN_OBINDER
    | TOKEN_OLET
    | TOKEN_HIGH_PRECEDENCE_TYAPP
    | TOKEN_HIGH_PRECEDENCE_PAREN_APP
    | TOKEN_HIGH_PRECEDENCE_BRACK_APP
    | TOKEN_TYPE_COMING_SOON
    | TOKEN_TYPE_IS_HERE
    | TOKEN_MODULE_COMING_SOON
    | TOKEN_MODULE_IS_HERE
    | TOKEN_EXTERN
    | TOKEN_VOID
    | TOKEN_PUBLIC
    | TOKEN_PRIVATE
    | TOKEN_INTERNAL
    | TOKEN_GLOBAL
    | TOKEN_STATIC
    | TOKEN_MEMBER
    | TOKEN_CLASS
    | TOKEN_ABSTRACT
    | TOKEN_OVERRIDE
    | TOKEN_DEFAULT
    | TOKEN_CONSTRUCTOR
    | TOKEN_INHERIT
    | TOKEN_GREATER_RBRACK
    | TOKEN_STRUCT
    | TOKEN_SIG
    | TOKEN_BAR
    | TOKEN_RBRACK
    | TOKEN_RBRACE
    | TOKEN_RBRACE_COMING_SOON
    | TOKEN_RBRACE_IS_HERE
    | TOKEN_MINUS
    | TOKEN_DOLLAR
    | TOKEN_BAR_RBRACK
    | TOKEN_BAR_RBRACE
    | TOKEN_UNDERSCORE
    | TOKEN_SEMICOLON_SEMICOLON
    | TOKEN_LARROW
    | TOKEN_EQUALS
    | TOKEN_LBRACK
    | TOKEN_LBRACK_BAR
    | TOKEN_LBRACE_BAR
    | TOKEN_LBRACK_LESS
    | TOKEN_LBRACE
    | TOKEN_QMARK
    | TOKEN_QMARK_QMARK
    | TOKEN_DOT
    | TOKEN_COLON
    | TOKEN_COLON_COLON
    | TOKEN_COLON_GREATER
    | TOKEN_COLON_QMARK_GREATER
    | TOKEN_COLON_QMARK
    | TOKEN_COLON_EQUALS
    | TOKEN_SEMICOLON
    | TOKEN_WHEN
    | TOKEN_WHILE
    | TOKEN_WITH
    | TOKEN_HASH
    | TOKEN_AMP
    | TOKEN_AMP_AMP
    | TOKEN_QUOTE
    | TOKEN_LPAREN
    | TOKEN_RPAREN
    | TOKEN_RPAREN_COMING_SOON
    | TOKEN_RPAREN_IS_HERE
    | TOKEN_STAR
    | TOKEN_COMMA
    | TOKEN_RARROW
    | TOKEN_GREATER_BAR_RBRACK
    | TOKEN_LPAREN_STAR_RPAREN
    | TOKEN_OPEN
    | TOKEN_OR
    | TOKEN_REC
    | TOKEN_THEN
    | TOKEN_TO
    | TOKEN_TRUE
    | TOKEN_TRY
    | TOKEN_TYPE
    | TOKEN_VAL
    | TOKEN_INLINE
    | TOKEN_INTERFACE
    | TOKEN_INSTANCE
    | TOKEN_CONST
    | TOKEN_LAZY
    | TOKEN_OLAZY
    | TOKEN_MATCH
    | TOKEN_MATCH_BANG
    | TOKEN_MUTABLE
    | TOKEN_NEW
    | TOKEN_OF
    | TOKEN_EXCEPTION
    | TOKEN_FALSE
    | TOKEN_FOR
    | TOKEN_FUN
    | TOKEN_FUNCTION
    | TOKEN_IF
    | TOKEN_IN
    | TOKEN_JOIN_IN
    | TOKEN_FINALLY
    | TOKEN_DO_BANG
    | TOKEN_AND
    | TOKEN_AS
    | TOKEN_ASSERT
    | TOKEN_OASSERT
    | TOKEN_ASR
    | TOKEN_BEGIN
    | TOKEN_DO
    | TOKEN_DONE
    | TOKEN_DOWNTO
    | TOKEN_ELSE
    | TOKEN_ELIF
    | TOKEN_END
    | TOKEN_DOT_DOT
    | TOKEN_BAR_BAR
    | TOKEN_UPCAST
    | TOKEN_DOWNCAST
    | TOKEN_NULL
    | TOKEN_RESERVED
    | TOKEN_MODULE
    | TOKEN_NAMESPACE
    | TOKEN_DELEGATE
    | TOKEN_CONSTRAINT
    | TOKEN_BASE
    | TOKEN_LQUOTE
    | TOKEN_RQUOTE
    | TOKEN_RQUOTE_DOT
    | TOKEN_PERCENT_OP
    | TOKEN_BINDER
    | TOKEN_LESS
    | TOKEN_GREATER
    | TOKEN_LET
    | TOKEN_YIELD
    | TOKEN_YIELD_BANG
    | TOKEN_BIGNUM
    | TOKEN_DECIMAL
    | TOKEN_CHAR
    | TOKEN_IEEE64
    | TOKEN_IEEE32
    | TOKEN_NATIVEINT
    | TOKEN_UNATIVEINT
    | TOKEN_UINT64
    | TOKEN_UINT32
    | TOKEN_UINT16
    | TOKEN_UINT8
    | TOKEN_INT64
    | TOKEN_INT32
    | TOKEN_INT32_DOT_DOT
    | TOKEN_INT16
    | TOKEN_INT8
    | TOKEN_FUNKY_OPERATOR_NAME
    | TOKEN_ADJACENT_PREFIX_OP
    | TOKEN_PLUS_MINUS_OP
    | TOKEN_INFIX_AMP_OP
    | TOKEN_INFIX_STAR_DIV_MOD_OP
    | TOKEN_PREFIX_OP
    | TOKEN_INFIX_BAR_OP
    | TOKEN_INFIX_AT_HAT_OP
    | TOKEN_INFIX_COMPARE_OP
    | TOKEN_INFIX_STAR_STAR_OP
    | TOKEN_IDENT
    | TOKEN_KEYWORD_STRING
    | TOKEN_STRING
    | TOKEN_BYTEARRAY
    | TOKEN_end_of_input
    | TOKEN_error
// This type is used to give symbolic names to token indexes, useful for error messages
type nonTerminalId = 
    | NONTERM__startsignatureFile
    | NONTERM__startimplementationFile
    | NONTERM__startinteraction
    | NONTERM__starttypedSeqExprEOF
    | NONTERM__starttypEOF
    | NONTERM_interaction
    | NONTERM_interactiveTerminator
    | NONTERM_interactiveItemsTerminator
    | NONTERM_interactiveDefns
    | NONTERM_interactiveExpr
    | NONTERM_interactiveHash
    | NONTERM_interactiveSeparators
    | NONTERM_interactiveSeparator
    | NONTERM_hashDirective
    | NONTERM_hashDirectiveArgs
    | NONTERM_hashDirectiveArg
    | NONTERM_signatureFile
    | NONTERM_moduleIntro
    | NONTERM_namespaceIntro
    | NONTERM_fileNamespaceSpecs
    | NONTERM_fileNamespaceSpecList
    | NONTERM_fileNamespaceSpec
    | NONTERM_fileModuleSpec
    | NONTERM_moduleSpfnsPossiblyEmptyBlock
    | NONTERM_moduleSpfnsPossiblyEmpty
    | NONTERM_moduleSpfns
    | NONTERM_moduleSpfn
    | NONTERM_valSpfn
    | NONTERM_optLiteralValueSpfn
    | NONTERM_moduleSpecBlock
    | NONTERM_tyconSpfns
    | NONTERM_tyconSpfnList
    | NONTERM_tyconSpfn
    | NONTERM_tyconSpfnRhsBlock
    | NONTERM_tyconSpfnRhs
    | NONTERM_tyconClassSpfn
    | NONTERM_classSpfnBlockKindUnspecified
    | NONTERM_classSpfnBlock
    | NONTERM_classSpfnMembers
    | NONTERM_classSpfnMembersAtLeastOne
    | NONTERM_classMemberSpfn
    | NONTERM_classMemberSpfnGetSet
    | NONTERM_classMemberSpfnGetSetElements
    | NONTERM_memberSpecFlags
    | NONTERM_exconSpfn
    | NONTERM_opt_classSpfn
    | NONTERM_implementationFile
    | NONTERM_fileNamespaceImpls
    | NONTERM_fileNamespaceImplList
    | NONTERM_fileNamespaceImpl
    | NONTERM_fileModuleImpl
    | NONTERM_moduleDefnsOrExprPossiblyEmptyOrBlock
    | NONTERM_moduleDefnsOrExprPossiblyEmpty
    | NONTERM_moduleDefnsOrExpr
    | NONTERM_moduleDefns
    | NONTERM_moduleDefnOrDirective
    | NONTERM_moduleDefn
    | NONTERM_namedModuleAbbrevBlock
    | NONTERM_namedModuleDefnBlock
    | NONTERM_wrappedNamedModuleDefn
    | NONTERM_tyconDefnAugmentation
    | NONTERM_opt_attributes
    | NONTERM_attributes
    | NONTERM_attributeList
    | NONTERM_attributeListElements
    | NONTERM_attribute
    | NONTERM_attributeTarget
    | NONTERM_memberFlags
    | NONTERM_typeNameInfo
    | NONTERM_tyconDefnList
    | NONTERM_tyconDefn
    | NONTERM_tyconDefnRhsBlock
    | NONTERM_tyconDefnRhs
    | NONTERM_tyconClassDefn
    | NONTERM_classDefnBlockKindUnspecified
    | NONTERM_classDefnBlock
    | NONTERM_classDefnMembers
    | NONTERM_classDefnMembersAtLeastOne
    | NONTERM_classDefnMemberGetSet
    | NONTERM_classDefnMemberGetSetElements
    | NONTERM_classDefnMemberGetSetElement
    | NONTERM_memberCore
    | NONTERM_abstractMemberFlags
    | NONTERM_classDefnMember
    | NONTERM_valDefnDecl
    | NONTERM_autoPropsDefnDecl
    | NONTERM_opt_typ
    | NONTERM_atomicPatternLongIdent
    | NONTERM_opt_access
    | NONTERM_access
    | NONTERM_opt_declVisibility
    | NONTERM_opt_interfaceImplDefn
    | NONTERM_opt_classDefn
    | NONTERM_inheritsDefn
    | NONTERM_optAsSpec
    | NONTERM_asSpec
    | NONTERM_optBaseSpec
    | NONTERM_baseSpec
    | NONTERM_objectImplementationBlock
    | NONTERM_objectImplementationMembers
    | NONTERM_objectImplementationMember
    | NONTERM_memberOrOverride
    | NONTERM_tyconDefnOrSpfnSimpleRepr
    | NONTERM_braceFieldDeclList
    | NONTERM_anonRecdType
    | NONTERM_braceBarFieldDeclListCore
    | NONTERM_inlineAssemblyTyconRepr
    | NONTERM_classOrInterfaceOrStruct
    | NONTERM_interfaceMember
    | NONTERM_tyconNameAndTyparDecls
    | NONTERM_prefixTyparDecls
    | NONTERM_typarDeclList
    | NONTERM_typarDecl
    | NONTERM_postfixTyparDecls
    | NONTERM_explicitValTyparDeclsCore
    | NONTERM_explicitValTyparDecls
    | NONTERM_opt_explicitValTyparDecls
    | NONTERM_opt_explicitValTyparDecls2
    | NONTERM_opt_typeConstraints
    | NONTERM_typeConstraints
    | NONTERM_typeConstraint
    | NONTERM_typarAlts
    | NONTERM_unionTypeRepr
    | NONTERM_barAndgrabXmlDoc
    | NONTERM_attrUnionCaseDecls
    | NONTERM_attrUnionCaseDecl
    | NONTERM_unionCaseName
    | NONTERM_firstUnionCaseDeclOfMany
    | NONTERM_firstUnionCaseDecl
    | NONTERM_unionCaseReprElements
    | NONTERM_unionCaseReprElement
    | NONTERM_unionCaseRepr
    | NONTERM_recdFieldDeclList
    | NONTERM_recdFieldDecl
    | NONTERM_fieldDecl
    | NONTERM_exconDefn
    | NONTERM_exceptionAndGrabDoc
    | NONTERM_exconCore
    | NONTERM_exconIntro
    | NONTERM_exconRepr
    | NONTERM_openDecl
    | NONTERM_defnBindings
    | NONTERM_doBinding
    | NONTERM_hardwhiteLetBindings
    | NONTERM_hardwhiteDoBinding
    | NONTERM_classDefnBindings
    | NONTERM_hardwhiteDefnBindingsTerminator
    | NONTERM_cPrototype
    | NONTERM_cArgs
    | NONTERM_cMoreArgs
    | NONTERM_cArg
    | NONTERM_cType
    | NONTERM_cRetType
    | NONTERM_localBindings
    | NONTERM_moreLocalBindings
    | NONTERM_attr_localBinding
    | NONTERM_localBinding
    | NONTERM_typedExprWithStaticOptimizationsBlock
    | NONTERM_typedExprWithStaticOptimizations
    | NONTERM_opt_staticOptimizations
    | NONTERM_staticOptimization
    | NONTERM_staticOptimizationConditions
    | NONTERM_staticOptimizationCondition
    | NONTERM_rawConstant
    | NONTERM_rationalConstant
    | NONTERM_atomicUnsignedRationalConstant
    | NONTERM_atomicRationalConstant
    | NONTERM_constant
    | NONTERM_bindingPattern
    | NONTERM_simplePattern
    | NONTERM_simplePatternCommaList
    | NONTERM_simplePatterns
    | NONTERM_headBindingPattern
    | NONTERM_tuplePatternElements
    | NONTERM_conjPatternElements
    | NONTERM_namePatPairs
    | NONTERM_namePatPair
    | NONTERM_constrPattern
    | NONTERM_atomicPatsOrNamePatPairs
    | NONTERM_atomicPatterns
    | NONTERM_atomicPattern
    | NONTERM_parenPatternBody
    | NONTERM_parenPattern
    | NONTERM_tupleParenPatternElements
    | NONTERM_conjParenPatternElements
    | NONTERM_recordPatternElementsAux
    | NONTERM_recordPatternElement
    | NONTERM_listPatternElements
    | NONTERM_typedSeqExprBlock
    | NONTERM_declExprBlock
    | NONTERM_typedSeqExprBlockR
    | NONTERM_typedSeqExpr
    | NONTERM_typedSeqExprEOF
    | NONTERM_seqExpr
    | NONTERM_recover
    | NONTERM_declExpr
    | NONTERM_dynamicArg
    | NONTERM_withClauses
    | NONTERM_withPatternClauses
    | NONTERM_patternAndGuard
    | NONTERM_patternClauses
    | NONTERM_patternGuard
    | NONTERM_patternResult
    | NONTERM_ifExprCases
    | NONTERM_ifExprThen
    | NONTERM_ifExprElifs
    | NONTERM_tupleExpr
    | NONTERM_minusExpr
    | NONTERM_appExpr
    | NONTERM_argExpr
    | NONTERM_atomicExpr
    | NONTERM_atomicExprQualification
    | NONTERM_optRangeSeqExpr
    | NONTERM_optRange
    | NONTERM_atomicExprAfterType
    | NONTERM_beginEndExpr
    | NONTERM_quoteExpr
    | NONTERM_arrayExpr
    | NONTERM_parenExpr
    | NONTERM_parenExprBody
    | NONTERM_staticallyKnownHeadTypars
    | NONTERM_staticallyKnownHeadTyparAlts
    | NONTERM_braceExpr
    | NONTERM_braceExprBody
    | NONTERM_listExprElements
    | NONTERM_monadicExprInitial
    | NONTERM_rangeSequenceExpr
    | NONTERM_arrowThenExprR
    | NONTERM_forLoopBinder
    | NONTERM_forLoopRange
    | NONTERM_forLoopDirection
    | NONTERM_inlineAssemblyExpr
    | NONTERM_opt_curriedArgExprs
    | NONTERM_opt_atomicExprAfterType
    | NONTERM_opt_inlineAssemblyTypeArg
    | NONTERM_opt_inlineAssemblyReturnTypes
    | NONTERM_recdExpr
    | NONTERM_recdExprCore
    | NONTERM_opt_seps_recd
    | NONTERM_seps_recd
    | NONTERM_pathOrUnderscore
    | NONTERM_recdExprBindings
    | NONTERM_recdBinding
    | NONTERM_objExpr
    | NONTERM_objExprBaseCall
    | NONTERM_opt_objExprBindings
    | NONTERM_objExprBindings
    | NONTERM_objExprInterfaces
    | NONTERM_opt_objExprInterfaces
    | NONTERM_objExprInterface
    | NONTERM_braceBarExpr
    | NONTERM_braceBarExprCore
    | NONTERM_anonLambdaExpr
    | NONTERM_anonMatchingExpr
    | NONTERM_typeWithTypeConstraints
    | NONTERM_topTypeWithTypeConstraints
    | NONTERM_opt_topReturnTypeWithTypeConstraints
    | NONTERM_topType
    | NONTERM_topTupleType
    | NONTERM_topTupleTypeElements
    | NONTERM_topAppType
    | NONTERM_typ
    | NONTERM_typEOF
    | NONTERM_tupleType
    | NONTERM_tupleOrQuotTypeElements
    | NONTERM_appTypeCon
    | NONTERM_appTypeConPower
    | NONTERM_appType
    | NONTERM_arrayTypeSuffix
    | NONTERM_appTypePrefixArguments
    | NONTERM_typeArgListElements
    | NONTERM_powerType
    | NONTERM_atomTypeNonAtomicDeprecated
    | NONTERM_atomTypeOrAnonRecdType
    | NONTERM_atomType
    | NONTERM_typeArgsNoHpaDeprecated
    | NONTERM_typeArgsActual
    | NONTERM_typeArgActual
    | NONTERM_typeArgActualOrDummyIfEmpty
    | NONTERM_dummyTypeArg
    | NONTERM_measureTypeArg
    | NONTERM_measureTypeAtom
    | NONTERM_measureTypePower
    | NONTERM_measureTypeSeq
    | NONTERM_measureTypeExpr
    | NONTERM_typar
    | NONTERM_staticallyKnownHeadTypar
    | NONTERM_ident
    | NONTERM_path
    | NONTERM_opName
    | NONTERM_operatorName
    | NONTERM_activePatternCaseName
    | NONTERM_activePatternCaseNames
    | NONTERM_identOrOp
    | NONTERM_pathOp
    | NONTERM_nameop
    | NONTERM_topSeparator
    | NONTERM_topSeparators
    | NONTERM_opt_topSeparators
    | NONTERM_seps
    | NONTERM_declEnd
    | NONTERM_opt_declEnd
    | NONTERM_opt_ODECLEND
    | NONTERM_deprecated_opt_equals
    | NONTERM_opt_OBLOCKSEP
    | NONTERM_opt_seps
    | NONTERM_opt_rec
    | NONTERM_opt_bar
    | NONTERM_opt_inline
    | NONTERM_opt_mutable
    | NONTERM_doToken
    | NONTERM_doneDeclEnd
    | NONTERM_structOrBegin
    | NONTERM_sigOrBegin
    | NONTERM_colonOrEquals
    | NONTERM_stringOrKeywordString
    | NONTERM_opt_HIGH_PRECEDENCE_APP
    | NONTERM_opt_HIGH_PRECEDENCE_TYAPP
    | NONTERM_typeKeyword
    | NONTERM_moduleKeyword
    | NONTERM_rbrace
    | NONTERM_bar_rbrace
    | NONTERM_rparen
    | NONTERM_oblockend
    | NONTERM_ends_other_than_rparen_coming_soon_or_recover
    | NONTERM_ends_coming_soon_or_recover

// This function maps tokens to integer indexes
let tagOfToken (t:token) = 
  match t with
  | HASH_IF _ -> 0 
  | HASH_ELSE _ -> 1 
  | HASH_ENDIF _ -> 2 
  | COMMENT _ -> 3 
  | WHITESPACE _ -> 4 
  | HASH_LINE _ -> 5 
  | HASH_LIGHT _ -> 6 
  | INACTIVECODE _ -> 7 
  | LINE_COMMENT _ -> 8 
  | STRING_TEXT _ -> 9 
  | EOF _ -> 10 
  | LEX_FAILURE _ -> 11 
  | ODUMMY _ -> 12 
  | FIXED  -> 13 
  | OINTERFACE_MEMBER  -> 14 
  | OBLOCKEND  -> 15 
  | OBLOCKEND_COMING_SOON  -> 16 
  | OBLOCKEND_IS_HERE  -> 17 
  | ORIGHT_BLOCK_END  -> 18 
  | ODECLEND  -> 19 
  | OEND  -> 20 
  | OBLOCKSEP  -> 21 
  | OBLOCKBEGIN  -> 22 
  | ORESET  -> 23 
  | OFUN  -> 24 
  | OFUNCTION  -> 25 
  | OWITH  -> 26 
  | OELSE  -> 27 
  | OTHEN  -> 28 
  | ODO_BANG  -> 29 
  | ODO  -> 30 
  | OBINDER _ -> 31 
  | OLET _ -> 32 
  | HIGH_PRECEDENCE_TYAPP  -> 33 
  | HIGH_PRECEDENCE_PAREN_APP  -> 34 
  | HIGH_PRECEDENCE_BRACK_APP  -> 35 
  | TYPE_COMING_SOON  -> 36 
  | TYPE_IS_HERE  -> 37 
  | MODULE_COMING_SOON  -> 38 
  | MODULE_IS_HERE  -> 39 
  | EXTERN  -> 40 
  | VOID  -> 41 
  | PUBLIC  -> 42 
  | PRIVATE  -> 43 
  | INTERNAL  -> 44 
  | GLOBAL  -> 45 
  | STATIC  -> 46 
  | MEMBER  -> 47 
  | CLASS  -> 48 
  | ABSTRACT  -> 49 
  | OVERRIDE  -> 50 
  | DEFAULT  -> 51 
  | CONSTRUCTOR  -> 52 
  | INHERIT  -> 53 
  | GREATER_RBRACK  -> 54 
  | STRUCT  -> 55 
  | SIG  -> 56 
  | BAR  -> 57 
  | RBRACK  -> 58 
  | RBRACE  -> 59 
  | RBRACE_COMING_SOON  -> 60 
  | RBRACE_IS_HERE  -> 61 
  | MINUS  -> 62 
  | DOLLAR  -> 63 
  | BAR_RBRACK  -> 64 
  | BAR_RBRACE  -> 65 
  | UNDERSCORE  -> 66 
  | SEMICOLON_SEMICOLON  -> 67 
  | LARROW  -> 68 
  | EQUALS  -> 69 
  | LBRACK  -> 70 
  | LBRACK_BAR  -> 71 
  | LBRACE_BAR  -> 72 
  | LBRACK_LESS  -> 73 
  | LBRACE  -> 74 
  | QMARK  -> 75 
  | QMARK_QMARK  -> 76 
  | DOT  -> 77 
  | COLON  -> 78 
  | COLON_COLON  -> 79 
  | COLON_GREATER  -> 80 
  | COLON_QMARK_GREATER  -> 81 
  | COLON_QMARK  -> 82 
  | COLON_EQUALS  -> 83 
  | SEMICOLON  -> 84 
  | WHEN  -> 85 
  | WHILE  -> 86 
  | WITH  -> 87 
  | HASH  -> 88 
  | AMP  -> 89 
  | AMP_AMP  -> 90 
  | QUOTE  -> 91 
  | LPAREN  -> 92 
  | RPAREN  -> 93 
  | RPAREN_COMING_SOON  -> 94 
  | RPAREN_IS_HERE  -> 95 
  | STAR  -> 96 
  | COMMA  -> 97 
  | RARROW  -> 98 
  | GREATER_BAR_RBRACK  -> 99 
  | LPAREN_STAR_RPAREN  -> 100 
  | OPEN  -> 101 
  | OR  -> 102 
  | REC  -> 103 
  | THEN  -> 104 
  | TO  -> 105 
  | TRUE  -> 106 
  | TRY  -> 107 
  | TYPE  -> 108 
  | VAL  -> 109 
  | INLINE  -> 110 
  | INTERFACE  -> 111 
  | INSTANCE  -> 112 
  | CONST  -> 113 
  | LAZY  -> 114 
  | OLAZY  -> 115 
  | MATCH  -> 116 
  | MATCH_BANG  -> 117 
  | MUTABLE  -> 118 
  | NEW  -> 119 
  | OF  -> 120 
  | EXCEPTION  -> 121 
  | FALSE  -> 122 
  | FOR  -> 123 
  | FUN  -> 124 
  | FUNCTION  -> 125 
  | IF  -> 126 
  | IN  -> 127 
  | JOIN_IN  -> 128 
  | FINALLY  -> 129 
  | DO_BANG  -> 130 
  | AND  -> 131 
  | AS  -> 132 
  | ASSERT  -> 133 
  | OASSERT  -> 134 
  | ASR  -> 135 
  | BEGIN  -> 136 
  | DO  -> 137 
  | DONE  -> 138 
  | DOWNTO  -> 139 
  | ELSE  -> 140 
  | ELIF  -> 141 
  | END  -> 142 
  | DOT_DOT  -> 143 
  | BAR_BAR  -> 144 
  | UPCAST  -> 145 
  | DOWNCAST  -> 146 
  | NULL  -> 147 
  | RESERVED  -> 148 
  | MODULE  -> 149 
  | NAMESPACE  -> 150 
  | DELEGATE  -> 151 
  | CONSTRAINT  -> 152 
  | BASE  -> 153 
  | LQUOTE _ -> 154 
  | RQUOTE _ -> 155 
  | RQUOTE_DOT _ -> 156 
  | PERCENT_OP _ -> 157 
  | BINDER _ -> 158 
  | LESS _ -> 159 
  | GREATER _ -> 160 
  | LET _ -> 161 
  | YIELD _ -> 162 
  | YIELD_BANG _ -> 163 
  | BIGNUM _ -> 164 
  | DECIMAL _ -> 165 
  | CHAR _ -> 166 
  | IEEE64 _ -> 167 
  | IEEE32 _ -> 168 
  | NATIVEINT _ -> 169 
  | UNATIVEINT _ -> 170 
  | UINT64 _ -> 171 
  | UINT32 _ -> 172 
  | UINT16 _ -> 173 
  | UINT8 _ -> 174 
  | INT64 _ -> 175 
  | INT32 _ -> 176 
  | INT32_DOT_DOT _ -> 177 
  | INT16 _ -> 178 
  | INT8 _ -> 179 
  | FUNKY_OPERATOR_NAME _ -> 180 
  | ADJACENT_PREFIX_OP _ -> 181 
  | PLUS_MINUS_OP _ -> 182 
  | INFIX_AMP_OP _ -> 183 
  | INFIX_STAR_DIV_MOD_OP _ -> 184 
  | PREFIX_OP _ -> 185 
  | INFIX_BAR_OP _ -> 186 
  | INFIX_AT_HAT_OP _ -> 187 
  | INFIX_COMPARE_OP _ -> 188 
  | INFIX_STAR_STAR_OP _ -> 189 
  | IDENT _ -> 190 
  | KEYWORD_STRING _ -> 191 
  | STRING _ -> 192 
  | BYTEARRAY _ -> 193 

// This function maps integer indexes to symbolic token ids
let tokenTagToTokenId (tokenIdx:int) = 
  match tokenIdx with
  | 0 -> TOKEN_HASH_IF 
  | 1 -> TOKEN_HASH_ELSE 
  | 2 -> TOKEN_HASH_ENDIF 
  | 3 -> TOKEN_COMMENT 
  | 4 -> TOKEN_WHITESPACE 
  | 5 -> TOKEN_HASH_LINE 
  | 6 -> TOKEN_HASH_LIGHT 
  | 7 -> TOKEN_INACTIVECODE 
  | 8 -> TOKEN_LINE_COMMENT 
  | 9 -> TOKEN_STRING_TEXT 
  | 10 -> TOKEN_EOF 
  | 11 -> TOKEN_LEX_FAILURE 
  | 12 -> TOKEN_ODUMMY 
  | 13 -> TOKEN_FIXED 
  | 14 -> TOKEN_OINTERFACE_MEMBER 
  | 15 -> TOKEN_OBLOCKEND 
  | 16 -> TOKEN_OBLOCKEND_COMING_SOON 
  | 17 -> TOKEN_OBLOCKEND_IS_HERE 
  | 18 -> TOKEN_ORIGHT_BLOCK_END 
  | 19 -> TOKEN_ODECLEND 
  | 20 -> TOKEN_OEND 
  | 21 -> TOKEN_OBLOCKSEP 
  | 22 -> TOKEN_OBLOCKBEGIN 
  | 23 -> TOKEN_ORESET 
  | 24 -> TOKEN_OFUN 
  | 25 -> TOKEN_OFUNCTION 
  | 26 -> TOKEN_OWITH 
  | 27 -> TOKEN_OELSE 
  | 28 -> TOKEN_OTHEN 
  | 29 -> TOKEN_ODO_BANG 
  | 30 -> TOKEN_ODO 
  | 31 -> TOKEN_OBINDER 
  | 32 -> TOKEN_OLET 
  | 33 -> TOKEN_HIGH_PRECEDENCE_TYAPP 
  | 34 -> TOKEN_HIGH_PRECEDENCE_PAREN_APP 
  | 35 -> TOKEN_HIGH_PRECEDENCE_BRACK_APP 
  | 36 -> TOKEN_TYPE_COMING_SOON 
  | 37 -> TOKEN_TYPE_IS_HERE 
  | 38 -> TOKEN_MODULE_COMING_SOON 
  | 39 -> TOKEN_MODULE_IS_HERE 
  | 40 -> TOKEN_EXTERN 
  | 41 -> TOKEN_VOID 
  | 42 -> TOKEN_PUBLIC 
  | 43 -> TOKEN_PRIVATE 
  | 44 -> TOKEN_INTERNAL 
  | 45 -> TOKEN_GLOBAL 
  | 46 -> TOKEN_STATIC 
  | 47 -> TOKEN_MEMBER 
  | 48 -> TOKEN_CLASS 
  | 49 -> TOKEN_ABSTRACT 
  | 50 -> TOKEN_OVERRIDE 
  | 51 -> TOKEN_DEFAULT 
  | 52 -> TOKEN_CONSTRUCTOR 
  | 53 -> TOKEN_INHERIT 
  | 54 -> TOKEN_GREATER_RBRACK 
  | 55 -> TOKEN_STRUCT 
  | 56 -> TOKEN_SIG 
  | 57 -> TOKEN_BAR 
  | 58 -> TOKEN_RBRACK 
  | 59 -> TOKEN_RBRACE 
  | 60 -> TOKEN_RBRACE_COMING_SOON 
  | 61 -> TOKEN_RBRACE_IS_HERE 
  | 62 -> TOKEN_MINUS 
  | 63 -> TOKEN_DOLLAR 
  | 64 -> TOKEN_BAR_RBRACK 
  | 65 -> TOKEN_BAR_RBRACE 
  | 66 -> TOKEN_UNDERSCORE 
  | 67 -> TOKEN_SEMICOLON_SEMICOLON 
  | 68 -> TOKEN_LARROW 
  | 69 -> TOKEN_EQUALS 
  | 70 -> TOKEN_LBRACK 
  | 71 -> TOKEN_LBRACK_BAR 
  | 72 -> TOKEN_LBRACE_BAR 
  | 73 -> TOKEN_LBRACK_LESS 
  | 74 -> TOKEN_LBRACE 
  | 75 -> TOKEN_QMARK 
  | 76 -> TOKEN_QMARK_QMARK 
  | 77 -> TOKEN_DOT 
  | 78 -> TOKEN_COLON 
  | 79 -> TOKEN_COLON_COLON 
  | 80 -> TOKEN_COLON_GREATER 
  | 81 -> TOKEN_COLON_QMARK_GREATER 
  | 82 -> TOKEN_COLON_QMARK 
  | 83 -> TOKEN_COLON_EQUALS 
  | 84 -> TOKEN_SEMICOLON 
  | 85 -> TOKEN_WHEN 
  | 86 -> TOKEN_WHILE 
  | 87 -> TOKEN_WITH 
  | 88 -> TOKEN_HASH 
  | 89 -> TOKEN_AMP 
  | 90 -> TOKEN_AMP_AMP 
  | 91 -> TOKEN_QUOTE 
  | 92 -> TOKEN_LPAREN 
  | 93 -> TOKEN_RPAREN 
  | 94 -> TOKEN_RPAREN_COMING_SOON 
  | 95 -> TOKEN_RPAREN_IS_HERE 
  | 96 -> TOKEN_STAR 
  | 97 -> TOKEN_COMMA 
  | 98 -> TOKEN_RARROW 
  | 99 -> TOKEN_GREATER_BAR_RBRACK 
  | 100 -> TOKEN_LPAREN_STAR_RPAREN 
  | 101 -> TOKEN_OPEN 
  | 102 -> TOKEN_OR 
  | 103 -> TOKEN_REC 
  | 104 -> TOKEN_THEN 
  | 105 -> TOKEN_TO 
  | 106 -> TOKEN_TRUE 
  | 107 -> TOKEN_TRY 
  | 108 -> TOKEN_TYPE 
  | 109 -> TOKEN_VAL 
  | 110 -> TOKEN_INLINE 
  | 111 -> TOKEN_INTERFACE 
  | 112 -> TOKEN_INSTANCE 
  | 113 -> TOKEN_CONST 
  | 114 -> TOKEN_LAZY 
  | 115 -> TOKEN_OLAZY 
  | 116 -> TOKEN_MATCH 
  | 117 -> TOKEN_MATCH_BANG 
  | 118 -> TOKEN_MUTABLE 
  | 119 -> TOKEN_NEW 
  | 120 -> TOKEN_OF 
  | 121 -> TOKEN_EXCEPTION 
  | 122 -> TOKEN_FALSE 
  | 123 -> TOKEN_FOR 
  | 124 -> TOKEN_FUN 
  | 125 -> TOKEN_FUNCTION 
  | 126 -> TOKEN_IF 
  | 127 -> TOKEN_IN 
  | 128 -> TOKEN_JOIN_IN 
  | 129 -> TOKEN_FINALLY 
  | 130 -> TOKEN_DO_BANG 
  | 131 -> TOKEN_AND 
  | 132 -> TOKEN_AS 
  | 133 -> TOKEN_ASSERT 
  | 134 -> TOKEN_OASSERT 
  | 135 -> TOKEN_ASR 
  | 136 -> TOKEN_BEGIN 
  | 137 -> TOKEN_DO 
  | 138 -> TOKEN_DONE 
  | 139 -> TOKEN_DOWNTO 
  | 140 -> TOKEN_ELSE 
  | 141 -> TOKEN_ELIF 
  | 142 -> TOKEN_END 
  | 143 -> TOKEN_DOT_DOT 
  | 144 -> TOKEN_BAR_BAR 
  | 145 -> TOKEN_UPCAST 
  | 146 -> TOKEN_DOWNCAST 
  | 147 -> TOKEN_NULL 
  | 148 -> TOKEN_RESERVED 
  | 149 -> TOKEN_MODULE 
  | 150 -> TOKEN_NAMESPACE 
  | 151 -> TOKEN_DELEGATE 
  | 152 -> TOKEN_CONSTRAINT 
  | 153 -> TOKEN_BASE 
  | 154 -> TOKEN_LQUOTE 
  | 155 -> TOKEN_RQUOTE 
  | 156 -> TOKEN_RQUOTE_DOT 
  | 157 -> TOKEN_PERCENT_OP 
  | 158 -> TOKEN_BINDER 
  | 159 -> TOKEN_LESS 
  | 160 -> TOKEN_GREATER 
  | 161 -> TOKEN_LET 
  | 162 -> TOKEN_YIELD 
  | 163 -> TOKEN_YIELD_BANG 
  | 164 -> TOKEN_BIGNUM 
  | 165 -> TOKEN_DECIMAL 
  | 166 -> TOKEN_CHAR 
  | 167 -> TOKEN_IEEE64 
  | 168 -> TOKEN_IEEE32 
  | 169 -> TOKEN_NATIVEINT 
  | 170 -> TOKEN_UNATIVEINT 
  | 171 -> TOKEN_UINT64 
  | 172 -> TOKEN_UINT32 
  | 173 -> TOKEN_UINT16 
  | 174 -> TOKEN_UINT8 
  | 175 -> TOKEN_INT64 
  | 176 -> TOKEN_INT32 
  | 177 -> TOKEN_INT32_DOT_DOT 
  | 178 -> TOKEN_INT16 
  | 179 -> TOKEN_INT8 
  | 180 -> TOKEN_FUNKY_OPERATOR_NAME 
  | 181 -> TOKEN_ADJACENT_PREFIX_OP 
  | 182 -> TOKEN_PLUS_MINUS_OP 
  | 183 -> TOKEN_INFIX_AMP_OP 
  | 184 -> TOKEN_INFIX_STAR_DIV_MOD_OP 
  | 185 -> TOKEN_PREFIX_OP 
  | 186 -> TOKEN_INFIX_BAR_OP 
  | 187 -> TOKEN_INFIX_AT_HAT_OP 
  | 188 -> TOKEN_INFIX_COMPARE_OP 
  | 189 -> TOKEN_INFIX_STAR_STAR_OP 
  | 190 -> TOKEN_IDENT 
  | 191 -> TOKEN_KEYWORD_STRING 
  | 192 -> TOKEN_STRING 
  | 193 -> TOKEN_BYTEARRAY 
  | 196 -> TOKEN_end_of_input
  | 194 -> TOKEN_error
  | _ -> failwith "tokenTagToTokenId: bad token"

/// This function maps production indexes returned in syntax errors to strings representing the non terminal that would be produced by that production
let prodIdxToNonTerminal (prodIdx:int) = 
  match prodIdx with
    | 0 -> NONTERM__startsignatureFile 
    | 1 -> NONTERM__startimplementationFile 
    | 2 -> NONTERM__startinteraction 
    | 3 -> NONTERM__starttypedSeqExprEOF 
    | 4 -> NONTERM__starttypEOF 
    | 5 -> NONTERM_interaction 
    | 6 -> NONTERM_interaction 
    | 7 -> NONTERM_interaction 
    | 8 -> NONTERM_interactiveTerminator 
    | 9 -> NONTERM_interactiveTerminator 
    | 10 -> NONTERM_interactiveItemsTerminator 
    | 11 -> NONTERM_interactiveItemsTerminator 
    | 12 -> NONTERM_interactiveItemsTerminator 
    | 13 -> NONTERM_interactiveItemsTerminator 
    | 14 -> NONTERM_interactiveItemsTerminator 
    | 15 -> NONTERM_interactiveItemsTerminator 
    | 16 -> NONTERM_interactiveItemsTerminator 
    | 17 -> NONTERM_interactiveDefns 
    | 18 -> NONTERM_interactiveDefns 
    | 19 -> NONTERM_interactiveExpr 
    | 20 -> NONTERM_interactiveHash 
    | 21 -> NONTERM_interactiveSeparators 
    | 22 -> NONTERM_interactiveSeparators 
    | 23 -> NONTERM_interactiveSeparator 
    | 24 -> NONTERM_interactiveSeparator 
    | 25 -> NONTERM_hashDirective 
    | 26 -> NONTERM_hashDirectiveArgs 
    | 27 -> NONTERM_hashDirectiveArgs 
    | 28 -> NONTERM_hashDirectiveArg 
    | 29 -> NONTERM_signatureFile 
    | 30 -> NONTERM_signatureFile 
    | 31 -> NONTERM_signatureFile 
    | 32 -> NONTERM_moduleIntro 
    | 33 -> NONTERM_namespaceIntro 
    | 34 -> NONTERM_fileNamespaceSpecs 
    | 35 -> NONTERM_fileNamespaceSpecs 
    | 36 -> NONTERM_fileNamespaceSpecList 
    | 37 -> NONTERM_fileNamespaceSpecList 
    | 38 -> NONTERM_fileNamespaceSpec 
    | 39 -> NONTERM_fileModuleSpec 
    | 40 -> NONTERM_fileModuleSpec 
    | 41 -> NONTERM_moduleSpfnsPossiblyEmptyBlock 
    | 42 -> NONTERM_moduleSpfnsPossiblyEmptyBlock 
    | 43 -> NONTERM_moduleSpfnsPossiblyEmptyBlock 
    | 44 -> NONTERM_moduleSpfnsPossiblyEmptyBlock 
    | 45 -> NONTERM_moduleSpfnsPossiblyEmpty 
    | 46 -> NONTERM_moduleSpfnsPossiblyEmpty 
    | 47 -> NONTERM_moduleSpfnsPossiblyEmpty 
    | 48 -> NONTERM_moduleSpfns 
    | 49 -> NONTERM_moduleSpfns 
    | 50 -> NONTERM_moduleSpfns 
    | 51 -> NONTERM_moduleSpfn 
    | 52 -> NONTERM_moduleSpfn 
    | 53 -> NONTERM_moduleSpfn 
    | 54 -> NONTERM_moduleSpfn 
    | 55 -> NONTERM_moduleSpfn 
    | 56 -> NONTERM_moduleSpfn 
    | 57 -> NONTERM_moduleSpfn 
    | 58 -> NONTERM_valSpfn 
    | 59 -> NONTERM_optLiteralValueSpfn 
    | 60 -> NONTERM_optLiteralValueSpfn 
    | 61 -> NONTERM_optLiteralValueSpfn 
    | 62 -> NONTERM_moduleSpecBlock 
    | 63 -> NONTERM_moduleSpecBlock 
    | 64 -> NONTERM_moduleSpecBlock 
    | 65 -> NONTERM_tyconSpfns 
    | 66 -> NONTERM_tyconSpfnList 
    | 67 -> NONTERM_tyconSpfnList 
    | 68 -> NONTERM_tyconSpfn 
    | 69 -> NONTERM_tyconSpfn 
    | 70 -> NONTERM_tyconSpfnRhsBlock 
    | 71 -> NONTERM_tyconSpfnRhsBlock 
    | 72 -> NONTERM_tyconSpfnRhs 
    | 73 -> NONTERM_tyconSpfnRhs 
    | 74 -> NONTERM_tyconSpfnRhs 
    | 75 -> NONTERM_tyconClassSpfn 
    | 76 -> NONTERM_tyconClassSpfn 
    | 77 -> NONTERM_tyconClassSpfn 
    | 78 -> NONTERM_tyconClassSpfn 
    | 79 -> NONTERM_classSpfnBlockKindUnspecified 
    | 80 -> NONTERM_classSpfnBlockKindUnspecified 
    | 81 -> NONTERM_classSpfnBlockKindUnspecified 
    | 82 -> NONTERM_classSpfnBlockKindUnspecified 
    | 83 -> NONTERM_classSpfnBlock 
    | 84 -> NONTERM_classSpfnBlock 
    | 85 -> NONTERM_classSpfnBlock 
    | 86 -> NONTERM_classSpfnMembers 
    | 87 -> NONTERM_classSpfnMembers 
    | 88 -> NONTERM_classSpfnMembersAtLeastOne 
    | 89 -> NONTERM_classMemberSpfn 
    | 90 -> NONTERM_classMemberSpfn 
    | 91 -> NONTERM_classMemberSpfn 
    | 92 -> NONTERM_classMemberSpfn 
    | 93 -> NONTERM_classMemberSpfn 
    | 94 -> NONTERM_classMemberSpfn 
    | 95 -> NONTERM_classMemberSpfn 
    | 96 -> NONTERM_classMemberSpfnGetSet 
    | 97 -> NONTERM_classMemberSpfnGetSet 
    | 98 -> NONTERM_classMemberSpfnGetSet 
    | 99 -> NONTERM_classMemberSpfnGetSet 
    | 100 -> NONTERM_classMemberSpfnGetSetElements 
    | 101 -> NONTERM_classMemberSpfnGetSetElements 
    | 102 -> NONTERM_memberSpecFlags 
    | 103 -> NONTERM_memberSpecFlags 
    | 104 -> NONTERM_memberSpecFlags 
    | 105 -> NONTERM_exconSpfn 
    | 106 -> NONTERM_opt_classSpfn 
    | 107 -> NONTERM_opt_classSpfn 
    | 108 -> NONTERM_implementationFile 
    | 109 -> NONTERM_implementationFile 
    | 110 -> NONTERM_implementationFile 
    | 111 -> NONTERM_fileNamespaceImpls 
    | 112 -> NONTERM_fileNamespaceImpls 
    | 113 -> NONTERM_fileNamespaceImplList 
    | 114 -> NONTERM_fileNamespaceImplList 
    | 115 -> NONTERM_fileNamespaceImpl 
    | 116 -> NONTERM_fileModuleImpl 
    | 117 -> NONTERM_fileModuleImpl 
    | 118 -> NONTERM_moduleDefnsOrExprPossiblyEmptyOrBlock 
    | 119 -> NONTERM_moduleDefnsOrExprPossiblyEmptyOrBlock 
    | 120 -> NONTERM_moduleDefnsOrExprPossiblyEmptyOrBlock 
    | 121 -> NONTERM_moduleDefnsOrExprPossiblyEmptyOrBlock 
    | 122 -> NONTERM_moduleDefnsOrExprPossiblyEmpty 
    | 123 -> NONTERM_moduleDefnsOrExprPossiblyEmpty 
    | 124 -> NONTERM_moduleDefnsOrExpr 
    | 125 -> NONTERM_moduleDefnsOrExpr 
    | 126 -> NONTERM_moduleDefnsOrExpr 
    | 127 -> NONTERM_moduleDefnsOrExpr 
    | 128 -> NONTERM_moduleDefnsOrExpr 
    | 129 -> NONTERM_moduleDefns 
    | 130 -> NONTERM_moduleDefns 
    | 131 -> NONTERM_moduleDefns 
    | 132 -> NONTERM_moduleDefns 
    | 133 -> NONTERM_moduleDefns 
    | 134 -> NONTERM_moduleDefnOrDirective 
    | 135 -> NONTERM_moduleDefnOrDirective 
    | 136 -> NONTERM_moduleDefn 
    | 137 -> NONTERM_moduleDefn 
    | 138 -> NONTERM_moduleDefn 
    | 139 -> NONTERM_moduleDefn 
    | 140 -> NONTERM_moduleDefn 
    | 141 -> NONTERM_moduleDefn 
    | 142 -> NONTERM_moduleDefn 
    | 143 -> NONTERM_moduleDefn 
    | 144 -> NONTERM_namedModuleAbbrevBlock 
    | 145 -> NONTERM_namedModuleAbbrevBlock 
    | 146 -> NONTERM_namedModuleDefnBlock 
    | 147 -> NONTERM_namedModuleDefnBlock 
    | 148 -> NONTERM_namedModuleDefnBlock 
    | 149 -> NONTERM_namedModuleDefnBlock 
    | 150 -> NONTERM_namedModuleDefnBlock 
    | 151 -> NONTERM_namedModuleDefnBlock 
    | 152 -> NONTERM_namedModuleDefnBlock 
    | 153 -> NONTERM_wrappedNamedModuleDefn 
    | 154 -> NONTERM_wrappedNamedModuleDefn 
    | 155 -> NONTERM_wrappedNamedModuleDefn 
    | 156 -> NONTERM_tyconDefnAugmentation 
    | 157 -> NONTERM_opt_attributes 
    | 158 -> NONTERM_opt_attributes 
    | 159 -> NONTERM_attributes 
    | 160 -> NONTERM_attributes 
    | 161 -> NONTERM_attributeList 
    | 162 -> NONTERM_attributeList 
    | 163 -> NONTERM_attributeList 
    | 164 -> NONTERM_attributeList 
    | 165 -> NONTERM_attributeListElements 
    | 166 -> NONTERM_attributeListElements 
    | 167 -> NONTERM_attribute 
    | 168 -> NONTERM_attribute 
    | 169 -> NONTERM_attribute 
    | 170 -> NONTERM_attributeTarget 
    | 171 -> NONTERM_attributeTarget 
    | 172 -> NONTERM_attributeTarget 
    | 173 -> NONTERM_attributeTarget 
    | 174 -> NONTERM_memberFlags 
    | 175 -> NONTERM_memberFlags 
    | 176 -> NONTERM_memberFlags 
    | 177 -> NONTERM_memberFlags 
    | 178 -> NONTERM_typeNameInfo 
    | 179 -> NONTERM_tyconDefnList 
    | 180 -> NONTERM_tyconDefnList 
    | 181 -> NONTERM_tyconDefn 
    | 182 -> NONTERM_tyconDefn 
    | 183 -> NONTERM_tyconDefn 
    | 184 -> NONTERM_tyconDefn 
    | 185 -> NONTERM_tyconDefnRhsBlock 
    | 186 -> NONTERM_tyconDefnRhsBlock 
    | 187 -> NONTERM_tyconDefnRhsBlock 
    | 188 -> NONTERM_tyconDefnRhs 
    | 189 -> NONTERM_tyconDefnRhs 
    | 190 -> NONTERM_tyconDefnRhs 
    | 191 -> NONTERM_tyconClassDefn 
    | 192 -> NONTERM_tyconClassDefn 
    | 193 -> NONTERM_tyconClassDefn 
    | 194 -> NONTERM_tyconClassDefn 
    | 195 -> NONTERM_classDefnBlockKindUnspecified 
    | 196 -> NONTERM_classDefnBlockKindUnspecified 
    | 197 -> NONTERM_classDefnBlock 
    | 198 -> NONTERM_classDefnBlock 
    | 199 -> NONTERM_classDefnBlock 
    | 200 -> NONTERM_classDefnMembers 
    | 201 -> NONTERM_classDefnMembers 
    | 202 -> NONTERM_classDefnMembers 
    | 203 -> NONTERM_classDefnMembersAtLeastOne 
    | 204 -> NONTERM_classDefnMemberGetSet 
    | 205 -> NONTERM_classDefnMemberGetSet 
    | 206 -> NONTERM_classDefnMemberGetSet 
    | 207 -> NONTERM_classDefnMemberGetSetElements 
    | 208 -> NONTERM_classDefnMemberGetSetElements 
    | 209 -> NONTERM_classDefnMemberGetSetElement 
    | 210 -> NONTERM_memberCore 
    | 211 -> NONTERM_memberCore 
    | 212 -> NONTERM_abstractMemberFlags 
    | 213 -> NONTERM_abstractMemberFlags 
    | 214 -> NONTERM_classDefnMember 
    | 215 -> NONTERM_classDefnMember 
    | 216 -> NONTERM_classDefnMember 
    | 217 -> NONTERM_classDefnMember 
    | 218 -> NONTERM_classDefnMember 
    | 219 -> NONTERM_classDefnMember 
    | 220 -> NONTERM_classDefnMember 
    | 221 -> NONTERM_classDefnMember 
    | 222 -> NONTERM_classDefnMember 
    | 223 -> NONTERM_classDefnMember 
    | 224 -> NONTERM_classDefnMember 
    | 225 -> NONTERM_valDefnDecl 
    | 226 -> NONTERM_autoPropsDefnDecl 
    | 227 -> NONTERM_opt_typ 
    | 228 -> NONTERM_opt_typ 
    | 229 -> NONTERM_atomicPatternLongIdent 
    | 230 -> NONTERM_atomicPatternLongIdent 
    | 231 -> NONTERM_atomicPatternLongIdent 
    | 232 -> NONTERM_opt_access 
    | 233 -> NONTERM_opt_access 
    | 234 -> NONTERM_access 
    | 235 -> NONTERM_access 
    | 236 -> NONTERM_access 
    | 237 -> NONTERM_opt_declVisibility 
    | 238 -> NONTERM_opt_declVisibility 
    | 239 -> NONTERM_opt_interfaceImplDefn 
    | 240 -> NONTERM_opt_interfaceImplDefn 
    | 241 -> NONTERM_opt_classDefn 
    | 242 -> NONTERM_opt_classDefn 
    | 243 -> NONTERM_inheritsDefn 
    | 244 -> NONTERM_inheritsDefn 
    | 245 -> NONTERM_inheritsDefn 
    | 246 -> NONTERM_optAsSpec 
    | 247 -> NONTERM_optAsSpec 
    | 248 -> NONTERM_asSpec 
    | 249 -> NONTERM_optBaseSpec 
    | 250 -> NONTERM_optBaseSpec 
    | 251 -> NONTERM_baseSpec 
    | 252 -> NONTERM_baseSpec 
    | 253 -> NONTERM_objectImplementationBlock 
    | 254 -> NONTERM_objectImplementationBlock 
    | 255 -> NONTERM_objectImplementationBlock 
    | 256 -> NONTERM_objectImplementationMembers 
    | 257 -> NONTERM_objectImplementationMembers 
    | 258 -> NONTERM_objectImplementationMember 
    | 259 -> NONTERM_objectImplementationMember 
    | 260 -> NONTERM_objectImplementationMember 
    | 261 -> NONTERM_objectImplementationMember 
    | 262 -> NONTERM_memberOrOverride 
    | 263 -> NONTERM_memberOrOverride 
    | 264 -> NONTERM_tyconDefnOrSpfnSimpleRepr 
    | 265 -> NONTERM_tyconDefnOrSpfnSimpleRepr 
    | 266 -> NONTERM_tyconDefnOrSpfnSimpleRepr 
    | 267 -> NONTERM_tyconDefnOrSpfnSimpleRepr 
    | 268 -> NONTERM_tyconDefnOrSpfnSimpleRepr 
    | 269 -> NONTERM_braceFieldDeclList 
    | 270 -> NONTERM_braceFieldDeclList 
    | 271 -> NONTERM_braceFieldDeclList 
    | 272 -> NONTERM_anonRecdType 
    | 273 -> NONTERM_anonRecdType 
    | 274 -> NONTERM_braceBarFieldDeclListCore 
    | 275 -> NONTERM_braceBarFieldDeclListCore 
    | 276 -> NONTERM_braceBarFieldDeclListCore 
    | 277 -> NONTERM_inlineAssemblyTyconRepr 
    | 278 -> NONTERM_classOrInterfaceOrStruct 
    | 279 -> NONTERM_classOrInterfaceOrStruct 
    | 280 -> NONTERM_classOrInterfaceOrStruct 
    | 281 -> NONTERM_interfaceMember 
    | 282 -> NONTERM_interfaceMember 
    | 283 -> NONTERM_tyconNameAndTyparDecls 
    | 284 -> NONTERM_tyconNameAndTyparDecls 
    | 285 -> NONTERM_tyconNameAndTyparDecls 
    | 286 -> NONTERM_prefixTyparDecls 
    | 287 -> NONTERM_prefixTyparDecls 
    | 288 -> NONTERM_typarDeclList 
    | 289 -> NONTERM_typarDeclList 
    | 290 -> NONTERM_typarDecl 
    | 291 -> NONTERM_postfixTyparDecls 
    | 292 -> NONTERM_explicitValTyparDeclsCore 
    | 293 -> NONTERM_explicitValTyparDeclsCore 
    | 294 -> NONTERM_explicitValTyparDeclsCore 
    | 295 -> NONTERM_explicitValTyparDecls 
    | 296 -> NONTERM_opt_explicitValTyparDecls 
    | 297 -> NONTERM_opt_explicitValTyparDecls 
    | 298 -> NONTERM_opt_explicitValTyparDecls2 
    | 299 -> NONTERM_opt_explicitValTyparDecls2 
    | 300 -> NONTERM_opt_typeConstraints 
    | 301 -> NONTERM_opt_typeConstraints 
    | 302 -> NONTERM_typeConstraints 
    | 303 -> NONTERM_typeConstraints 
    | 304 -> NONTERM_typeConstraint 
    | 305 -> NONTERM_typeConstraint 
    | 306 -> NONTERM_typeConstraint 
    | 307 -> NONTERM_typeConstraint 
    | 308 -> NONTERM_typeConstraint 
    | 309 -> NONTERM_typeConstraint 
    | 310 -> NONTERM_typeConstraint 
    | 311 -> NONTERM_typeConstraint 
    | 312 -> NONTERM_typeConstraint 
    | 313 -> NONTERM_typeConstraint 
    | 314 -> NONTERM_typarAlts 
    | 315 -> NONTERM_typarAlts 
    | 316 -> NONTERM_unionTypeRepr 
    | 317 -> NONTERM_unionTypeRepr 
    | 318 -> NONTERM_unionTypeRepr 
    | 319 -> NONTERM_barAndgrabXmlDoc 
    | 320 -> NONTERM_attrUnionCaseDecls 
    | 321 -> NONTERM_attrUnionCaseDecls 
    | 322 -> NONTERM_attrUnionCaseDecl 
    | 323 -> NONTERM_attrUnionCaseDecl 
    | 324 -> NONTERM_attrUnionCaseDecl 
    | 325 -> NONTERM_attrUnionCaseDecl 
    | 326 -> NONTERM_unionCaseName 
    | 327 -> NONTERM_unionCaseName 
    | 328 -> NONTERM_unionCaseName 
    | 329 -> NONTERM_firstUnionCaseDeclOfMany 
    | 330 -> NONTERM_firstUnionCaseDeclOfMany 
    | 331 -> NONTERM_firstUnionCaseDeclOfMany 
    | 332 -> NONTERM_firstUnionCaseDecl 
    | 333 -> NONTERM_firstUnionCaseDecl 
    | 334 -> NONTERM_unionCaseReprElements 
    | 335 -> NONTERM_unionCaseReprElements 
    | 336 -> NONTERM_unionCaseReprElement 
    | 337 -> NONTERM_unionCaseReprElement 
    | 338 -> NONTERM_unionCaseRepr 
    | 339 -> NONTERM_unionCaseRepr 
    | 340 -> NONTERM_recdFieldDeclList 
    | 341 -> NONTERM_recdFieldDeclList 
    | 342 -> NONTERM_recdFieldDecl 
    | 343 -> NONTERM_fieldDecl 
    | 344 -> NONTERM_exconDefn 
    | 345 -> NONTERM_exceptionAndGrabDoc 
    | 346 -> NONTERM_exconCore 
    | 347 -> NONTERM_exconIntro 
    | 348 -> NONTERM_exconIntro 
    | 349 -> NONTERM_exconRepr 
    | 350 -> NONTERM_exconRepr 
    | 351 -> NONTERM_openDecl 
    | 352 -> NONTERM_defnBindings 
    | 353 -> NONTERM_defnBindings 
    | 354 -> NONTERM_doBinding 
    | 355 -> NONTERM_hardwhiteLetBindings 
    | 356 -> NONTERM_hardwhiteDoBinding 
    | 357 -> NONTERM_classDefnBindings 
    | 358 -> NONTERM_classDefnBindings 
    | 359 -> NONTERM_classDefnBindings 
    | 360 -> NONTERM_classDefnBindings 
    | 361 -> NONTERM_hardwhiteDefnBindingsTerminator 
    | 362 -> NONTERM_hardwhiteDefnBindingsTerminator 
    | 363 -> NONTERM_cPrototype 
    | 364 -> NONTERM_cArgs 
    | 365 -> NONTERM_cArgs 
    | 366 -> NONTERM_cArgs 
    | 367 -> NONTERM_cMoreArgs 
    | 368 -> NONTERM_cMoreArgs 
    | 369 -> NONTERM_cArg 
    | 370 -> NONTERM_cArg 
    | 371 -> NONTERM_cType 
    | 372 -> NONTERM_cType 
    | 373 -> NONTERM_cType 
    | 374 -> NONTERM_cType 
    | 375 -> NONTERM_cType 
    | 376 -> NONTERM_cRetType 
    | 377 -> NONTERM_cRetType 
    | 378 -> NONTERM_localBindings 
    | 379 -> NONTERM_moreLocalBindings 
    | 380 -> NONTERM_moreLocalBindings 
    | 381 -> NONTERM_attr_localBinding 
    | 382 -> NONTERM_attr_localBinding 
    | 383 -> NONTERM_localBinding 
    | 384 -> NONTERM_localBinding 
    | 385 -> NONTERM_localBinding 
    | 386 -> NONTERM_typedExprWithStaticOptimizationsBlock 
    | 387 -> NONTERM_typedExprWithStaticOptimizationsBlock 
    | 388 -> NONTERM_typedExprWithStaticOptimizationsBlock 
    | 389 -> NONTERM_typedExprWithStaticOptimizations 
    | 390 -> NONTERM_opt_staticOptimizations 
    | 391 -> NONTERM_opt_staticOptimizations 
    | 392 -> NONTERM_staticOptimization 
    | 393 -> NONTERM_staticOptimizationConditions 
    | 394 -> NONTERM_staticOptimizationConditions 
    | 395 -> NONTERM_staticOptimizationCondition 
    | 396 -> NONTERM_staticOptimizationCondition 
    | 397 -> NONTERM_rawConstant 
    | 398 -> NONTERM_rawConstant 
    | 399 -> NONTERM_rawConstant 
    | 400 -> NONTERM_rawConstant 
    | 401 -> NONTERM_rawConstant 
    | 402 -> NONTERM_rawConstant 
    | 403 -> NONTERM_rawConstant 
    | 404 -> NONTERM_rawConstant 
    | 405 -> NONTERM_rawConstant 
    | 406 -> NONTERM_rawConstant 
    | 407 -> NONTERM_rawConstant 
    | 408 -> NONTERM_rawConstant 
    | 409 -> NONTERM_rawConstant 
    | 410 -> NONTERM_rawConstant 
    | 411 -> NONTERM_rawConstant 
    | 412 -> NONTERM_rawConstant 
    | 413 -> NONTERM_rawConstant 
    | 414 -> NONTERM_rationalConstant 
    | 415 -> NONTERM_rationalConstant 
    | 416 -> NONTERM_rationalConstant 
    | 417 -> NONTERM_rationalConstant 
    | 418 -> NONTERM_atomicUnsignedRationalConstant 
    | 419 -> NONTERM_atomicUnsignedRationalConstant 
    | 420 -> NONTERM_atomicRationalConstant 
    | 421 -> NONTERM_atomicRationalConstant 
    | 422 -> NONTERM_constant 
    | 423 -> NONTERM_constant 
    | 424 -> NONTERM_bindingPattern 
    | 425 -> NONTERM_simplePattern 
    | 426 -> NONTERM_simplePattern 
    | 427 -> NONTERM_simplePattern 
    | 428 -> NONTERM_simplePattern 
    | 429 -> NONTERM_simplePatternCommaList 
    | 430 -> NONTERM_simplePatternCommaList 
    | 431 -> NONTERM_simplePatterns 
    | 432 -> NONTERM_simplePatterns 
    | 433 -> NONTERM_simplePatterns 
    | 434 -> NONTERM_simplePatterns 
    | 435 -> NONTERM_simplePatterns 
    | 436 -> NONTERM_headBindingPattern 
    | 437 -> NONTERM_headBindingPattern 
    | 438 -> NONTERM_headBindingPattern 
    | 439 -> NONTERM_headBindingPattern 
    | 440 -> NONTERM_headBindingPattern 
    | 441 -> NONTERM_headBindingPattern 
    | 442 -> NONTERM_tuplePatternElements 
    | 443 -> NONTERM_tuplePatternElements 
    | 444 -> NONTERM_conjPatternElements 
    | 445 -> NONTERM_conjPatternElements 
    | 446 -> NONTERM_namePatPairs 
    | 447 -> NONTERM_namePatPairs 
    | 448 -> NONTERM_namePatPair 
    | 449 -> NONTERM_constrPattern 
    | 450 -> NONTERM_constrPattern 
    | 451 -> NONTERM_constrPattern 
    | 452 -> NONTERM_constrPattern 
    | 453 -> NONTERM_constrPattern 
    | 454 -> NONTERM_constrPattern 
    | 455 -> NONTERM_atomicPatsOrNamePatPairs 
    | 456 -> NONTERM_atomicPatsOrNamePatPairs 
    | 457 -> NONTERM_atomicPatterns 
    | 458 -> NONTERM_atomicPatterns 
    | 459 -> NONTERM_atomicPatterns 
    | 460 -> NONTERM_atomicPatterns 
    | 461 -> NONTERM_atomicPattern 
    | 462 -> NONTERM_atomicPattern 
    | 463 -> NONTERM_atomicPattern 
    | 464 -> NONTERM_atomicPattern 
    | 465 -> NONTERM_atomicPattern 
    | 466 -> NONTERM_atomicPattern 
    | 467 -> NONTERM_atomicPattern 
    | 468 -> NONTERM_atomicPattern 
    | 469 -> NONTERM_atomicPattern 
    | 470 -> NONTERM_atomicPattern 
    | 471 -> NONTERM_atomicPattern 
    | 472 -> NONTERM_atomicPattern 
    | 473 -> NONTERM_atomicPattern 
    | 474 -> NONTERM_atomicPattern 
    | 475 -> NONTERM_atomicPattern 
    | 476 -> NONTERM_atomicPattern 
    | 477 -> NONTERM_atomicPattern 
    | 478 -> NONTERM_atomicPattern 
    | 479 -> NONTERM_atomicPattern 
    | 480 -> NONTERM_atomicPattern 
    | 481 -> NONTERM_parenPatternBody 
    | 482 -> NONTERM_parenPatternBody 
    | 483 -> NONTERM_parenPattern 
    | 484 -> NONTERM_parenPattern 
    | 485 -> NONTERM_parenPattern 
    | 486 -> NONTERM_parenPattern 
    | 487 -> NONTERM_parenPattern 
    | 488 -> NONTERM_parenPattern 
    | 489 -> NONTERM_parenPattern 
    | 490 -> NONTERM_parenPattern 
    | 491 -> NONTERM_tupleParenPatternElements 
    | 492 -> NONTERM_tupleParenPatternElements 
    | 493 -> NONTERM_conjParenPatternElements 
    | 494 -> NONTERM_conjParenPatternElements 
    | 495 -> NONTERM_recordPatternElementsAux 
    | 496 -> NONTERM_recordPatternElementsAux 
    | 497 -> NONTERM_recordPatternElement 
    | 498 -> NONTERM_listPatternElements 
    | 499 -> NONTERM_listPatternElements 
    | 500 -> NONTERM_listPatternElements 
    | 501 -> NONTERM_typedSeqExprBlock 
    | 502 -> NONTERM_typedSeqExprBlock 
    | 503 -> NONTERM_typedSeqExprBlock 
    | 504 -> NONTERM_declExprBlock 
    | 505 -> NONTERM_declExprBlock 
    | 506 -> NONTERM_typedSeqExprBlockR 
    | 507 -> NONTERM_typedSeqExprBlockR 
    | 508 -> NONTERM_typedSeqExpr 
    | 509 -> NONTERM_typedSeqExpr 
    | 510 -> NONTERM_typedSeqExprEOF 
    | 511 -> NONTERM_seqExpr 
    | 512 -> NONTERM_seqExpr 
    | 513 -> NONTERM_seqExpr 
    | 514 -> NONTERM_seqExpr 
    | 515 -> NONTERM_seqExpr 
    | 516 -> NONTERM_seqExpr 
    | 517 -> NONTERM_recover 
    | 518 -> NONTERM_recover 
    | 519 -> NONTERM_declExpr 
    | 520 -> NONTERM_declExpr 
    | 521 -> NONTERM_declExpr 
    | 522 -> NONTERM_declExpr 
    | 523 -> NONTERM_declExpr 
    | 524 -> NONTERM_declExpr 
    | 525 -> NONTERM_declExpr 
    | 526 -> NONTERM_declExpr 
    | 527 -> NONTERM_declExpr 
    | 528 -> NONTERM_declExpr 
    | 529 -> NONTERM_declExpr 
    | 530 -> NONTERM_declExpr 
    | 531 -> NONTERM_declExpr 
    | 532 -> NONTERM_declExpr 
    | 533 -> NONTERM_declExpr 
    | 534 -> NONTERM_declExpr 
    | 535 -> NONTERM_declExpr 
    | 536 -> NONTERM_declExpr 
    | 537 -> NONTERM_declExpr 
    | 538 -> NONTERM_declExpr 
    | 539 -> NONTERM_declExpr 
    | 540 -> NONTERM_declExpr 
    | 541 -> NONTERM_declExpr 
    | 542 -> NONTERM_declExpr 
    | 543 -> NONTERM_declExpr 
    | 544 -> NONTERM_declExpr 
    | 545 -> NONTERM_declExpr 
    | 546 -> NONTERM_declExpr 
    | 547 -> NONTERM_declExpr 
    | 548 -> NONTERM_declExpr 
    | 549 -> NONTERM_declExpr 
    | 550 -> NONTERM_declExpr 
    | 551 -> NONTERM_declExpr 
    | 552 -> NONTERM_declExpr 
    | 553 -> NONTERM_declExpr 
    | 554 -> NONTERM_declExpr 
    | 555 -> NONTERM_declExpr 
    | 556 -> NONTERM_declExpr 
    | 557 -> NONTERM_declExpr 
    | 558 -> NONTERM_declExpr 
    | 559 -> NONTERM_declExpr 
    | 560 -> NONTERM_declExpr 
    | 561 -> NONTERM_declExpr 
    | 562 -> NONTERM_declExpr 
    | 563 -> NONTERM_declExpr 
    | 564 -> NONTERM_declExpr 
    | 565 -> NONTERM_declExpr 
    | 566 -> NONTERM_declExpr 
    | 567 -> NONTERM_declExpr 
    | 568 -> NONTERM_declExpr 
    | 569 -> NONTERM_declExpr 
    | 570 -> NONTERM_declExpr 
    | 571 -> NONTERM_declExpr 
    | 572 -> NONTERM_declExpr 
    | 573 -> NONTERM_declExpr 
    | 574 -> NONTERM_declExpr 
    | 575 -> NONTERM_declExpr 
    | 576 -> NONTERM_declExpr 
    | 577 -> NONTERM_declExpr 
    | 578 -> NONTERM_declExpr 
    | 579 -> NONTERM_declExpr 
    | 580 -> NONTERM_declExpr 
    | 581 -> NONTERM_declExpr 
    | 582 -> NONTERM_declExpr 
    | 583 -> NONTERM_declExpr 
    | 584 -> NONTERM_declExpr 
    | 585 -> NONTERM_declExpr 
    | 586 -> NONTERM_declExpr 
    | 587 -> NONTERM_declExpr 
    | 588 -> NONTERM_declExpr 
    | 589 -> NONTERM_declExpr 
    | 590 -> NONTERM_declExpr 
    | 591 -> NONTERM_declExpr 
    | 592 -> NONTERM_declExpr 
    | 593 -> NONTERM_declExpr 
    | 594 -> NONTERM_declExpr 
    | 595 -> NONTERM_declExpr 
    | 596 -> NONTERM_declExpr 
    | 597 -> NONTERM_declExpr 
    | 598 -> NONTERM_declExpr 
    | 599 -> NONTERM_declExpr 
    | 600 -> NONTERM_declExpr 
    | 601 -> NONTERM_declExpr 
    | 602 -> NONTERM_declExpr 
    | 603 -> NONTERM_declExpr 
    | 604 -> NONTERM_declExpr 
    | 605 -> NONTERM_declExpr 
    | 606 -> NONTERM_declExpr 
    | 607 -> NONTERM_declExpr 
    | 608 -> NONTERM_declExpr 
    | 609 -> NONTERM_declExpr 
    | 610 -> NONTERM_declExpr 
    | 611 -> NONTERM_declExpr 
    | 612 -> NONTERM_declExpr 
    | 613 -> NONTERM_declExpr 
    | 614 -> NONTERM_declExpr 
    | 615 -> NONTERM_declExpr 
    | 616 -> NONTERM_declExpr 
    | 617 -> NONTERM_declExpr 
    | 618 -> NONTERM_declExpr 
    | 619 -> NONTERM_declExpr 
    | 620 -> NONTERM_declExpr 
    | 621 -> NONTERM_declExpr 
    | 622 -> NONTERM_dynamicArg 
    | 623 -> NONTERM_dynamicArg 
    | 624 -> NONTERM_withClauses 
    | 625 -> NONTERM_withClauses 
    | 626 -> NONTERM_withClauses 
    | 627 -> NONTERM_withPatternClauses 
    | 628 -> NONTERM_withPatternClauses 
    | 629 -> NONTERM_withPatternClauses 
    | 630 -> NONTERM_withPatternClauses 
    | 631 -> NONTERM_patternAndGuard 
    | 632 -> NONTERM_patternClauses 
    | 633 -> NONTERM_patternClauses 
    | 634 -> NONTERM_patternClauses 
    | 635 -> NONTERM_patternClauses 
    | 636 -> NONTERM_patternClauses 
    | 637 -> NONTERM_patternGuard 
    | 638 -> NONTERM_patternGuard 
    | 639 -> NONTERM_patternResult 
    | 640 -> NONTERM_ifExprCases 
    | 641 -> NONTERM_ifExprThen 
    | 642 -> NONTERM_ifExprThen 
    | 643 -> NONTERM_ifExprThen 
    | 644 -> NONTERM_ifExprElifs 
    | 645 -> NONTERM_ifExprElifs 
    | 646 -> NONTERM_ifExprElifs 
    | 647 -> NONTERM_ifExprElifs 
    | 648 -> NONTERM_ifExprElifs 
    | 649 -> NONTERM_ifExprElifs 
    | 650 -> NONTERM_tupleExpr 
    | 651 -> NONTERM_tupleExpr 
    | 652 -> NONTERM_tupleExpr 
    | 653 -> NONTERM_tupleExpr 
    | 654 -> NONTERM_minusExpr 
    | 655 -> NONTERM_minusExpr 
    | 656 -> NONTERM_minusExpr 
    | 657 -> NONTERM_minusExpr 
    | 658 -> NONTERM_minusExpr 
    | 659 -> NONTERM_minusExpr 
    | 660 -> NONTERM_minusExpr 
    | 661 -> NONTERM_minusExpr 
    | 662 -> NONTERM_minusExpr 
    | 663 -> NONTERM_minusExpr 
    | 664 -> NONTERM_minusExpr 
    | 665 -> NONTERM_minusExpr 
    | 666 -> NONTERM_appExpr 
    | 667 -> NONTERM_appExpr 
    | 668 -> NONTERM_argExpr 
    | 669 -> NONTERM_argExpr 
    | 670 -> NONTERM_atomicExpr 
    | 671 -> NONTERM_atomicExpr 
    | 672 -> NONTERM_atomicExpr 
    | 673 -> NONTERM_atomicExpr 
    | 674 -> NONTERM_atomicExpr 
    | 675 -> NONTERM_atomicExpr 
    | 676 -> NONTERM_atomicExpr 
    | 677 -> NONTERM_atomicExpr 
    | 678 -> NONTERM_atomicExpr 
    | 679 -> NONTERM_atomicExpr 
    | 680 -> NONTERM_atomicExpr 
    | 681 -> NONTERM_atomicExpr 
    | 682 -> NONTERM_atomicExpr 
    | 683 -> NONTERM_atomicExpr 
    | 684 -> NONTERM_atomicExpr 
    | 685 -> NONTERM_atomicExpr 
    | 686 -> NONTERM_atomicExpr 
    | 687 -> NONTERM_atomicExprQualification 
    | 688 -> NONTERM_atomicExprQualification 
    | 689 -> NONTERM_atomicExprQualification 
    | 690 -> NONTERM_atomicExprQualification 
    | 691 -> NONTERM_atomicExprQualification 
    | 692 -> NONTERM_atomicExprQualification 
    | 693 -> NONTERM_atomicExprQualification 
    | 694 -> NONTERM_atomicExprQualification 
    | 695 -> NONTERM_atomicExprQualification 
    | 696 -> NONTERM_atomicExprQualification 
    | 697 -> NONTERM_atomicExprQualification 
    | 698 -> NONTERM_atomicExprQualification 
    | 699 -> NONTERM_optRangeSeqExpr 
    | 700 -> NONTERM_optRangeSeqExpr 
    | 701 -> NONTERM_optRange 
    | 702 -> NONTERM_optRange 
    | 703 -> NONTERM_optRange 
    | 704 -> NONTERM_optRange 
    | 705 -> NONTERM_optRange 
    | 706 -> NONTERM_atomicExprAfterType 
    | 707 -> NONTERM_atomicExprAfterType 
    | 708 -> NONTERM_atomicExprAfterType 
    | 709 -> NONTERM_atomicExprAfterType 
    | 710 -> NONTERM_atomicExprAfterType 
    | 711 -> NONTERM_atomicExprAfterType 
    | 712 -> NONTERM_atomicExprAfterType 
    | 713 -> NONTERM_atomicExprAfterType 
    | 714 -> NONTERM_atomicExprAfterType 
    | 715 -> NONTERM_atomicExprAfterType 
    | 716 -> NONTERM_beginEndExpr 
    | 717 -> NONTERM_beginEndExpr 
    | 718 -> NONTERM_beginEndExpr 
    | 719 -> NONTERM_beginEndExpr 
    | 720 -> NONTERM_quoteExpr 
    | 721 -> NONTERM_quoteExpr 
    | 722 -> NONTERM_quoteExpr 
    | 723 -> NONTERM_quoteExpr 
    | 724 -> NONTERM_arrayExpr 
    | 725 -> NONTERM_arrayExpr 
    | 726 -> NONTERM_arrayExpr 
    | 727 -> NONTERM_arrayExpr 
    | 728 -> NONTERM_parenExpr 
    | 729 -> NONTERM_parenExpr 
    | 730 -> NONTERM_parenExpr 
    | 731 -> NONTERM_parenExpr 
    | 732 -> NONTERM_parenExpr 
    | 733 -> NONTERM_parenExpr 
    | 734 -> NONTERM_parenExpr 
    | 735 -> NONTERM_parenExpr 
    | 736 -> NONTERM_parenExpr 
    | 737 -> NONTERM_parenExprBody 
    | 738 -> NONTERM_parenExprBody 
    | 739 -> NONTERM_parenExprBody 
    | 740 -> NONTERM_staticallyKnownHeadTypars 
    | 741 -> NONTERM_staticallyKnownHeadTypars 
    | 742 -> NONTERM_staticallyKnownHeadTyparAlts 
    | 743 -> NONTERM_staticallyKnownHeadTyparAlts 
    | 744 -> NONTERM_braceExpr 
    | 745 -> NONTERM_braceExpr 
    | 746 -> NONTERM_braceExpr 
    | 747 -> NONTERM_braceExpr 
    | 748 -> NONTERM_braceExpr 
    | 749 -> NONTERM_braceExprBody 
    | 750 -> NONTERM_braceExprBody 
    | 751 -> NONTERM_braceExprBody 
    | 752 -> NONTERM_listExprElements 
    | 753 -> NONTERM_listExprElements 
    | 754 -> NONTERM_monadicExprInitial 
    | 755 -> NONTERM_monadicExprInitial 
    | 756 -> NONTERM_rangeSequenceExpr 
    | 757 -> NONTERM_rangeSequenceExpr 
    | 758 -> NONTERM_rangeSequenceExpr 
    | 759 -> NONTERM_arrowThenExprR 
    | 760 -> NONTERM_forLoopBinder 
    | 761 -> NONTERM_forLoopBinder 
    | 762 -> NONTERM_forLoopBinder 
    | 763 -> NONTERM_forLoopBinder 
    | 764 -> NONTERM_forLoopRange 
    | 765 -> NONTERM_forLoopRange 
    | 766 -> NONTERM_forLoopDirection 
    | 767 -> NONTERM_forLoopDirection 
    | 768 -> NONTERM_inlineAssemblyExpr 
    | 769 -> NONTERM_opt_curriedArgExprs 
    | 770 -> NONTERM_opt_curriedArgExprs 
    | 771 -> NONTERM_opt_atomicExprAfterType 
    | 772 -> NONTERM_opt_atomicExprAfterType 
    | 773 -> NONTERM_opt_inlineAssemblyTypeArg 
    | 774 -> NONTERM_opt_inlineAssemblyTypeArg 
    | 775 -> NONTERM_opt_inlineAssemblyReturnTypes 
    | 776 -> NONTERM_opt_inlineAssemblyReturnTypes 
    | 777 -> NONTERM_opt_inlineAssemblyReturnTypes 
    | 778 -> NONTERM_recdExpr 
    | 779 -> NONTERM_recdExpr 
    | 780 -> NONTERM_recdExprCore 
    | 781 -> NONTERM_recdExprCore 
    | 782 -> NONTERM_recdExprCore 
    | 783 -> NONTERM_recdExprCore 
    | 784 -> NONTERM_recdExprCore 
    | 785 -> NONTERM_recdExprCore 
    | 786 -> NONTERM_recdExprCore 
    | 787 -> NONTERM_opt_seps_recd 
    | 788 -> NONTERM_opt_seps_recd 
    | 789 -> NONTERM_seps_recd 
    | 790 -> NONTERM_seps_recd 
    | 791 -> NONTERM_seps_recd 
    | 792 -> NONTERM_seps_recd 
    | 793 -> NONTERM_pathOrUnderscore 
    | 794 -> NONTERM_pathOrUnderscore 
    | 795 -> NONTERM_recdExprBindings 
    | 796 -> NONTERM_recdExprBindings 
    | 797 -> NONTERM_recdBinding 
    | 798 -> NONTERM_recdBinding 
    | 799 -> NONTERM_recdBinding 
    | 800 -> NONTERM_recdBinding 
    | 801 -> NONTERM_recdBinding 
    | 802 -> NONTERM_objExpr 
    | 803 -> NONTERM_objExpr 
    | 804 -> NONTERM_objExpr 
    | 805 -> NONTERM_objExprBaseCall 
    | 806 -> NONTERM_objExprBaseCall 
    | 807 -> NONTERM_objExprBaseCall 
    | 808 -> NONTERM_opt_objExprBindings 
    | 809 -> NONTERM_opt_objExprBindings 
    | 810 -> NONTERM_objExprBindings 
    | 811 -> NONTERM_objExprBindings 
    | 812 -> NONTERM_objExprBindings 
    | 813 -> NONTERM_objExprInterfaces 
    | 814 -> NONTERM_opt_objExprInterfaces 
    | 815 -> NONTERM_opt_objExprInterfaces 
    | 816 -> NONTERM_opt_objExprInterfaces 
    | 817 -> NONTERM_objExprInterface 
    | 818 -> NONTERM_braceBarExpr 
    | 819 -> NONTERM_braceBarExpr 
    | 820 -> NONTERM_braceBarExprCore 
    | 821 -> NONTERM_braceBarExprCore 
    | 822 -> NONTERM_braceBarExprCore 
    | 823 -> NONTERM_braceBarExprCore 
    | 824 -> NONTERM_braceBarExprCore 
    | 825 -> NONTERM_anonLambdaExpr 
    | 826 -> NONTERM_anonLambdaExpr 
    | 827 -> NONTERM_anonLambdaExpr 
    | 828 -> NONTERM_anonLambdaExpr 
    | 829 -> NONTERM_anonLambdaExpr 
    | 830 -> NONTERM_anonLambdaExpr 
    | 831 -> NONTERM_anonLambdaExpr 
    | 832 -> NONTERM_anonLambdaExpr 
    | 833 -> NONTERM_anonMatchingExpr 
    | 834 -> NONTERM_anonMatchingExpr 
    | 835 -> NONTERM_typeWithTypeConstraints 
    | 836 -> NONTERM_typeWithTypeConstraints 
    | 837 -> NONTERM_topTypeWithTypeConstraints 
    | 838 -> NONTERM_topTypeWithTypeConstraints 
    | 839 -> NONTERM_opt_topReturnTypeWithTypeConstraints 
    | 840 -> NONTERM_opt_topReturnTypeWithTypeConstraints 
    | 841 -> NONTERM_topType 
    | 842 -> NONTERM_topType 
    | 843 -> NONTERM_topTupleType 
    | 844 -> NONTERM_topTupleType 
    | 845 -> NONTERM_topTupleTypeElements 
    | 846 -> NONTERM_topTupleTypeElements 
    | 847 -> NONTERM_topAppType 
    | 848 -> NONTERM_topAppType 
    | 849 -> NONTERM_topAppType 
    | 850 -> NONTERM_topAppType 
    | 851 -> NONTERM_topAppType 
    | 852 -> NONTERM_topAppType 
    | 853 -> NONTERM_typ 
    | 854 -> NONTERM_typ 
    | 855 -> NONTERM_typEOF 
    | 856 -> NONTERM_tupleType 
    | 857 -> NONTERM_tupleType 
    | 858 -> NONTERM_tupleType 
    | 859 -> NONTERM_tupleType 
    | 860 -> NONTERM_tupleOrQuotTypeElements 
    | 861 -> NONTERM_tupleOrQuotTypeElements 
    | 862 -> NONTERM_tupleOrQuotTypeElements 
    | 863 -> NONTERM_appTypeCon 
    | 864 -> NONTERM_appTypeCon 
    | 865 -> NONTERM_appTypeConPower 
    | 866 -> NONTERM_appTypeConPower 
    | 867 -> NONTERM_appType 
    | 868 -> NONTERM_appType 
    | 869 -> NONTERM_appType 
    | 870 -> NONTERM_appType 
    | 871 -> NONTERM_appType 
    | 872 -> NONTERM_appType 
    | 873 -> NONTERM_appType 
    | 874 -> NONTERM_arrayTypeSuffix 
    | 875 -> NONTERM_arrayTypeSuffix 
    | 876 -> NONTERM_arrayTypeSuffix 
    | 877 -> NONTERM_arrayTypeSuffix 
    | 878 -> NONTERM_appTypePrefixArguments 
    | 879 -> NONTERM_typeArgListElements 
    | 880 -> NONTERM_typeArgListElements 
    | 881 -> NONTERM_typeArgListElements 
    | 882 -> NONTERM_powerType 
    | 883 -> NONTERM_powerType 
    | 884 -> NONTERM_atomTypeNonAtomicDeprecated 
    | 885 -> NONTERM_atomTypeNonAtomicDeprecated 
    | 886 -> NONTERM_atomTypeOrAnonRecdType 
    | 887 -> NONTERM_atomTypeOrAnonRecdType 
    | 888 -> NONTERM_atomType 
    | 889 -> NONTERM_atomType 
    | 890 -> NONTERM_atomType 
    | 891 -> NONTERM_atomType 
    | 892 -> NONTERM_atomType 
    | 893 -> NONTERM_atomType 
    | 894 -> NONTERM_atomType 
    | 895 -> NONTERM_atomType 
    | 896 -> NONTERM_atomType 
    | 897 -> NONTERM_atomType 
    | 898 -> NONTERM_atomType 
    | 899 -> NONTERM_atomType 
    | 900 -> NONTERM_atomType 
    | 901 -> NONTERM_atomType 
    | 902 -> NONTERM_atomType 
    | 903 -> NONTERM_atomType 
    | 904 -> NONTERM_atomType 
    | 905 -> NONTERM_atomType 
    | 906 -> NONTERM_atomType 
    | 907 -> NONTERM_atomType 
    | 908 -> NONTERM_typeArgsNoHpaDeprecated 
    | 909 -> NONTERM_typeArgsNoHpaDeprecated 
    | 910 -> NONTERM_typeArgsActual 
    | 911 -> NONTERM_typeArgsActual 
    | 912 -> NONTERM_typeArgsActual 
    | 913 -> NONTERM_typeArgsActual 
    | 914 -> NONTERM_typeArgsActual 
    | 915 -> NONTERM_typeArgsActual 
    | 916 -> NONTERM_typeArgsActual 
    | 917 -> NONTERM_typeArgActual 
    | 918 -> NONTERM_typeArgActual 
    | 919 -> NONTERM_typeArgActual 
    | 920 -> NONTERM_typeArgActualOrDummyIfEmpty 
    | 921 -> NONTERM_typeArgActualOrDummyIfEmpty 
    | 922 -> NONTERM_dummyTypeArg 
    | 923 -> NONTERM_measureTypeArg 
    | 924 -> NONTERM_measureTypeArg 
    | 925 -> NONTERM_measureTypeAtom 
    | 926 -> NONTERM_measureTypeAtom 
    | 927 -> NONTERM_measureTypeAtom 
    | 928 -> NONTERM_measureTypePower 
    | 929 -> NONTERM_measureTypePower 
    | 930 -> NONTERM_measureTypePower 
    | 931 -> NONTERM_measureTypeSeq 
    | 932 -> NONTERM_measureTypeSeq 
    | 933 -> NONTERM_measureTypeExpr 
    | 934 -> NONTERM_measureTypeExpr 
    | 935 -> NONTERM_measureTypeExpr 
    | 936 -> NONTERM_measureTypeExpr 
    | 937 -> NONTERM_typar 
    | 938 -> NONTERM_typar 
    | 939 -> NONTERM_staticallyKnownHeadTypar 
    | 940 -> NONTERM_ident 
    | 941 -> NONTERM_path 
    | 942 -> NONTERM_path 
    | 943 -> NONTERM_path 
    | 944 -> NONTERM_path 
    | 945 -> NONTERM_opName 
    | 946 -> NONTERM_opName 
    | 947 -> NONTERM_opName 
    | 948 -> NONTERM_opName 
    | 949 -> NONTERM_opName 
    | 950 -> NONTERM_operatorName 
    | 951 -> NONTERM_operatorName 
    | 952 -> NONTERM_operatorName 
    | 953 -> NONTERM_operatorName 
    | 954 -> NONTERM_operatorName 
    | 955 -> NONTERM_operatorName 
    | 956 -> NONTERM_operatorName 
    | 957 -> NONTERM_operatorName 
    | 958 -> NONTERM_operatorName 
    | 959 -> NONTERM_operatorName 
    | 960 -> NONTERM_operatorName 
    | 961 -> NONTERM_operatorName 
    | 962 -> NONTERM_operatorName 
    | 963 -> NONTERM_operatorName 
    | 964 -> NONTERM_operatorName 
    | 965 -> NONTERM_operatorName 
    | 966 -> NONTERM_operatorName 
    | 967 -> NONTERM_operatorName 
    | 968 -> NONTERM_operatorName 
    | 969 -> NONTERM_operatorName 
    | 970 -> NONTERM_operatorName 
    | 971 -> NONTERM_operatorName 
    | 972 -> NONTERM_operatorName 
    | 973 -> NONTERM_operatorName 
    | 974 -> NONTERM_operatorName 
    | 975 -> NONTERM_operatorName 
    | 976 -> NONTERM_activePatternCaseName 
    | 977 -> NONTERM_activePatternCaseNames 
    | 978 -> NONTERM_activePatternCaseNames 
    | 979 -> NONTERM_identOrOp 
    | 980 -> NONTERM_identOrOp 
    | 981 -> NONTERM_pathOp 
    | 982 -> NONTERM_pathOp 
    | 983 -> NONTERM_pathOp 
    | 984 -> NONTERM_pathOp 
    | 985 -> NONTERM_nameop 
    | 986 -> NONTERM_topSeparator 
    | 987 -> NONTERM_topSeparator 
    | 988 -> NONTERM_topSeparator 
    | 989 -> NONTERM_topSeparators 
    | 990 -> NONTERM_topSeparators 
    | 991 -> NONTERM_opt_topSeparators 
    | 992 -> NONTERM_opt_topSeparators 
    | 993 -> NONTERM_seps 
    | 994 -> NONTERM_seps 
    | 995 -> NONTERM_seps 
    | 996 -> NONTERM_seps 
    | 997 -> NONTERM_declEnd 
    | 998 -> NONTERM_declEnd 
    | 999 -> NONTERM_declEnd 
    | 1000 -> NONTERM_opt_declEnd 
    | 1001 -> NONTERM_opt_declEnd 
    | 1002 -> NONTERM_opt_declEnd 
    | 1003 -> NONTERM_opt_declEnd 
    | 1004 -> NONTERM_opt_ODECLEND 
    | 1005 -> NONTERM_opt_ODECLEND 
    | 1006 -> NONTERM_deprecated_opt_equals 
    | 1007 -> NONTERM_deprecated_opt_equals 
    | 1008 -> NONTERM_opt_OBLOCKSEP 
    | 1009 -> NONTERM_opt_OBLOCKSEP 
    | 1010 -> NONTERM_opt_seps 
    | 1011 -> NONTERM_opt_seps 
    | 1012 -> NONTERM_opt_rec 
    | 1013 -> NONTERM_opt_rec 
    | 1014 -> NONTERM_opt_bar 
    | 1015 -> NONTERM_opt_bar 
    | 1016 -> NONTERM_opt_inline 
    | 1017 -> NONTERM_opt_inline 
    | 1018 -> NONTERM_opt_mutable 
    | 1019 -> NONTERM_opt_mutable 
    | 1020 -> NONTERM_doToken 
    | 1021 -> NONTERM_doToken 
    | 1022 -> NONTERM_doneDeclEnd 
    | 1023 -> NONTERM_doneDeclEnd 
    | 1024 -> NONTERM_structOrBegin 
    | 1025 -> NONTERM_structOrBegin 
    | 1026 -> NONTERM_sigOrBegin 
    | 1027 -> NONTERM_sigOrBegin 
    | 1028 -> NONTERM_colonOrEquals 
    | 1029 -> NONTERM_colonOrEquals 
    | 1030 -> NONTERM_stringOrKeywordString 
    | 1031 -> NONTERM_stringOrKeywordString 
    | 1032 -> NONTERM_opt_HIGH_PRECEDENCE_APP 
    | 1033 -> NONTERM_opt_HIGH_PRECEDENCE_APP 
    | 1034 -> NONTERM_opt_HIGH_PRECEDENCE_APP 
    | 1035 -> NONTERM_opt_HIGH_PRECEDENCE_TYAPP 
    | 1036 -> NONTERM_opt_HIGH_PRECEDENCE_TYAPP 
    | 1037 -> NONTERM_typeKeyword 
    | 1038 -> NONTERM_typeKeyword 
    | 1039 -> NONTERM_typeKeyword 
    | 1040 -> NONTERM_moduleKeyword 
    | 1041 -> NONTERM_moduleKeyword 
    | 1042 -> NONTERM_moduleKeyword 
    | 1043 -> NONTERM_rbrace 
    | 1044 -> NONTERM_rbrace 
    | 1045 -> NONTERM_rbrace 
    | 1046 -> NONTERM_bar_rbrace 
    | 1047 -> NONTERM_rparen 
    | 1048 -> NONTERM_rparen 
    | 1049 -> NONTERM_rparen 
    | 1050 -> NONTERM_oblockend 
    | 1051 -> NONTERM_oblockend 
    | 1052 -> NONTERM_oblockend 
    | 1053 -> NONTERM_ends_other_than_rparen_coming_soon_or_recover 
    | 1054 -> NONTERM_ends_other_than_rparen_coming_soon_or_recover 
    | 1055 -> NONTERM_ends_other_than_rparen_coming_soon_or_recover 
    | 1056 -> NONTERM_ends_other_than_rparen_coming_soon_or_recover 
    | 1057 -> NONTERM_ends_other_than_rparen_coming_soon_or_recover 
    | 1058 -> NONTERM_ends_coming_soon_or_recover 
    | 1059 -> NONTERM_ends_coming_soon_or_recover 
    | 1060 -> NONTERM_ends_coming_soon_or_recover 
    | 1061 -> NONTERM_ends_coming_soon_or_recover 
    | 1062 -> NONTERM_ends_coming_soon_or_recover 
    | 1063 -> NONTERM_ends_coming_soon_or_recover 
    | _ -> failwith "prodIdxToNonTerminal: bad production index"

let _fsyacc_endOfInputTag = 196 
let _fsyacc_tagOfErrorTerminal = 194

// This function gets the name of a token as a string
let token_to_string (t:token) = 
  match t with 
  | HASH_IF _ -> "HASH_IF" 
  | HASH_ELSE _ -> "HASH_ELSE" 
  | HASH_ENDIF _ -> "HASH_ENDIF" 
  | COMMENT _ -> "COMMENT" 
  | WHITESPACE _ -> "WHITESPACE" 
  | HASH_LINE _ -> "HASH_LINE" 
  | HASH_LIGHT _ -> "HASH_LIGHT" 
  | INACTIVECODE _ -> "INACTIVECODE" 
  | LINE_COMMENT _ -> "LINE_COMMENT" 
  | STRING_TEXT _ -> "STRING_TEXT" 
  | EOF _ -> "EOF" 
  | LEX_FAILURE _ -> "LEX_FAILURE" 
  | ODUMMY _ -> "ODUMMY" 
  | FIXED  -> "FIXED" 
  | OINTERFACE_MEMBER  -> "OINTERFACE_MEMBER" 
  | OBLOCKEND  -> "OBLOCKEND" 
  | OBLOCKEND_COMING_SOON  -> "OBLOCKEND_COMING_SOON" 
  | OBLOCKEND_IS_HERE  -> "OBLOCKEND_IS_HERE" 
  | ORIGHT_BLOCK_END  -> "ORIGHT_BLOCK_END" 
  | ODECLEND  -> "ODECLEND" 
  | OEND  -> "OEND" 
  | OBLOCKSEP  -> "OBLOCKSEP" 
  | OBLOCKBEGIN  -> "OBLOCKBEGIN" 
  | ORESET  -> "ORESET" 
  | OFUN  -> "OFUN" 
  | OFUNCTION  -> "OFUNCTION" 
  | OWITH  -> "OWITH" 
  | OELSE  -> "OELSE" 
  | OTHEN  -> "OTHEN" 
  | ODO_BANG  -> "ODO_BANG" 
  | ODO  -> "ODO" 
  | OBINDER _ -> "OBINDER" 
  | OLET _ -> "OLET" 
  | HIGH_PRECEDENCE_TYAPP  -> "HIGH_PRECEDENCE_TYAPP" 
  | HIGH_PRECEDENCE_PAREN_APP  -> "HIGH_PRECEDENCE_PAREN_APP" 
  | HIGH_PRECEDENCE_BRACK_APP  -> "HIGH_PRECEDENCE_BRACK_APP" 
  | TYPE_COMING_SOON  -> "TYPE_COMING_SOON" 
  | TYPE_IS_HERE  -> "TYPE_IS_HERE" 
  | MODULE_COMING_SOON  -> "MODULE_COMING_SOON" 
  | MODULE_IS_HERE  -> "MODULE_IS_HERE" 
  | EXTERN  -> "EXTERN" 
  | VOID  -> "VOID" 
  | PUBLIC  -> "PUBLIC" 
  | PRIVATE  -> "PRIVATE" 
  | INTERNAL  -> "INTERNAL" 
  | GLOBAL  -> "GLOBAL" 
  | STATIC  -> "STATIC" 
  | MEMBER  -> "MEMBER" 
  | CLASS  -> "CLASS" 
  | ABSTRACT  -> "ABSTRACT" 
  | OVERRIDE  -> "OVERRIDE" 
  | DEFAULT  -> "DEFAULT" 
  | CONSTRUCTOR  -> "CONSTRUCTOR" 
  | INHERIT  -> "INHERIT" 
  | GREATER_RBRACK  -> "GREATER_RBRACK" 
  | STRUCT  -> "STRUCT" 
  | SIG  -> "SIG" 
  | BAR  -> "BAR" 
  | RBRACK  -> "RBRACK" 
  | RBRACE  -> "RBRACE" 
  | RBRACE_COMING_SOON  -> "RBRACE_COMING_SOON" 
  | RBRACE_IS_HERE  -> "RBRACE_IS_HERE" 
  | MINUS  -> "MINUS" 
  | DOLLAR  -> "DOLLAR" 
  | BAR_RBRACK  -> "BAR_RBRACK" 
  | BAR_RBRACE  -> "BAR_RBRACE" 
  | UNDERSCORE  -> "UNDERSCORE" 
  | SEMICOLON_SEMICOLON  -> "SEMICOLON_SEMICOLON" 
  | LARROW  -> "LARROW" 
  | EQUALS  -> "EQUALS" 
  | LBRACK  -> "LBRACK" 
  | LBRACK_BAR  -> "LBRACK_BAR" 
  | LBRACE_BAR  -> "LBRACE_BAR" 
  | LBRACK_LESS  -> "LBRACK_LESS" 
  | LBRACE  -> "LBRACE" 
  | QMARK  -> "QMARK" 
  | QMARK_QMARK  -> "QMARK_QMARK" 
  | DOT  -> "DOT" 
  | COLON  -> "COLON" 
  | COLON_COLON  -> "COLON_COLON" 
  | COLON_GREATER  -> "COLON_GREATER" 
  | COLON_QMARK_GREATER  -> "COLON_QMARK_GREATER" 
  | COLON_QMARK  -> "COLON_QMARK" 
  | COLON_EQUALS  -> "COLON_EQUALS" 
  | SEMICOLON  -> "SEMICOLON" 
  | WHEN  -> "WHEN" 
  | WHILE  -> "WHILE" 
  | WITH  -> "WITH" 
  | HASH  -> "HASH" 
  | AMP  -> "AMP" 
  | AMP_AMP  -> "AMP_AMP" 
  | QUOTE  -> "QUOTE" 
  | LPAREN  -> "LPAREN" 
  | RPAREN  -> "RPAREN" 
  | RPAREN_COMING_SOON  -> "RPAREN_COMING_SOON" 
  | RPAREN_IS_HERE  -> "RPAREN_IS_HERE" 
  | STAR  -> "STAR" 
  | COMMA  -> "COMMA" 
  | RARROW  -> "RARROW" 
  | GREATER_BAR_RBRACK  -> "GREATER_BAR_RBRACK" 
  | LPAREN_STAR_RPAREN  -> "LPAREN_STAR_RPAREN" 
  | OPEN  -> "OPEN" 
  | OR  -> "OR" 
  | REC  -> "REC" 
  | THEN  -> "THEN" 
  | TO  -> "TO" 
  | TRUE  -> "TRUE" 
  | TRY  -> "TRY" 
  | TYPE  -> "TYPE" 
  | VAL  -> "VAL" 
  | INLINE  -> "INLINE" 
  | INTERFACE  -> "INTERFACE" 
  | INSTANCE  -> "INSTANCE" 
  | CONST  -> "CONST" 
  | LAZY  -> "LAZY" 
  | OLAZY  -> "OLAZY" 
  | MATCH  -> "MATCH" 
  | MATCH_BANG  -> "MATCH_BANG" 
  | MUTABLE  -> "MUTABLE" 
  | NEW  -> "NEW" 
  | OF  -> "OF" 
  | EXCEPTION  -> "EXCEPTION" 
  | FALSE  -> "FALSE" 
  | FOR  -> "FOR" 
  | FUN  -> "FUN" 
  | FUNCTION  -> "FUNCTION" 
  | IF  -> "IF" 
  | IN  -> "IN" 
  | JOIN_IN  -> "JOIN_IN" 
  | FINALLY  -> "FINALLY" 
  | DO_BANG  -> "DO_BANG" 
  | AND  -> "AND" 
  | AS  -> "AS" 
  | ASSERT  -> "ASSERT" 
  | OASSERT  -> "OASSERT" 
  | ASR  -> "ASR" 
  | BEGIN  -> "BEGIN" 
  | DO  -> "DO" 
  | DONE  -> "DONE" 
  | DOWNTO  -> "DOWNTO" 
  | ELSE  -> "ELSE" 
  | ELIF  -> "ELIF" 
  | END  -> "END" 
  | DOT_DOT  -> "DOT_DOT" 
  | BAR_BAR  -> "BAR_BAR" 
  | UPCAST  -> "UPCAST" 
  | DOWNCAST  -> "DOWNCAST" 
  | NULL  -> "NULL" 
  | RESERVED  -> "RESERVED" 
  | MODULE  -> "MODULE" 
  | NAMESPACE  -> "NAMESPACE" 
  | DELEGATE  -> "DELEGATE" 
  | CONSTRAINT  -> "CONSTRAINT" 
  | BASE  -> "BASE" 
  | LQUOTE _ -> "LQUOTE" 
  | RQUOTE _ -> "RQUOTE" 
  | RQUOTE_DOT _ -> "RQUOTE_DOT" 
  | PERCENT_OP _ -> "PERCENT_OP" 
  | BINDER _ -> "BINDER" 
  | LESS _ -> "LESS" 
  | GREATER _ -> "GREATER" 
  | LET _ -> "LET" 
  | YIELD _ -> "YIELD" 
  | YIELD_BANG _ -> "YIELD_BANG" 
  | BIGNUM _ -> "BIGNUM" 
  | DECIMAL _ -> "DECIMAL" 
  | CHAR _ -> "CHAR" 
  | IEEE64 _ -> "IEEE64" 
  | IEEE32 _ -> "IEEE32" 
  | NATIVEINT _ -> "NATIVEINT" 
  | UNATIVEINT _ -> "UNATIVEINT" 
  | UINT64 _ -> "UINT64" 
  | UINT32 _ -> "UINT32" 
  | UINT16 _ -> "UINT16" 
  | UINT8 _ -> "UINT8" 
  | INT64 _ -> "INT64" 
  | INT32 _ -> "INT32" 
  | INT32_DOT_DOT _ -> "INT32_DOT_DOT" 
  | INT16 _ -> "INT16" 
  | INT8 _ -> "INT8" 
  | FUNKY_OPERATOR_NAME _ -> "FUNKY_OPERATOR_NAME" 
  | ADJACENT_PREFIX_OP _ -> "ADJACENT_PREFIX_OP" 
  | PLUS_MINUS_OP _ -> "PLUS_MINUS_OP" 
  | INFIX_AMP_OP _ -> "INFIX_AMP_OP" 
  | INFIX_STAR_DIV_MOD_OP _ -> "INFIX_STAR_DIV_MOD_OP" 
  | PREFIX_OP _ -> "PREFIX_OP" 
  | INFIX_BAR_OP _ -> "INFIX_BAR_OP" 
  | INFIX_AT_HAT_OP _ -> "INFIX_AT_HAT_OP" 
  | INFIX_COMPARE_OP _ -> "INFIX_COMPARE_OP" 
  | INFIX_STAR_STAR_OP _ -> "INFIX_STAR_STAR_OP" 
  | IDENT _ -> "IDENT" 
  | KEYWORD_STRING _ -> "KEYWORD_STRING" 
  | STRING _ -> "STRING" 
  | BYTEARRAY _ -> "BYTEARRAY" 

// This function gets the data carried by a token as an object
let _fsyacc_dataOfToken (t:token) = 
  match t with 
  | HASH_IF _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | HASH_ELSE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | HASH_ENDIF _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | COMMENT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | WHITESPACE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | HASH_LINE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | HASH_LIGHT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INACTIVECODE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | LINE_COMMENT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | STRING_TEXT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | EOF _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | LEX_FAILURE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | ODUMMY _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | FIXED  -> (null : System.Object) 
  | OINTERFACE_MEMBER  -> (null : System.Object) 
  | OBLOCKEND  -> (null : System.Object) 
  | OBLOCKEND_COMING_SOON  -> (null : System.Object) 
  | OBLOCKEND_IS_HERE  -> (null : System.Object) 
  | ORIGHT_BLOCK_END  -> (null : System.Object) 
  | ODECLEND  -> (null : System.Object) 
  | OEND  -> (null : System.Object) 
  | OBLOCKSEP  -> (null : System.Object) 
  | OBLOCKBEGIN  -> (null : System.Object) 
  | ORESET  -> (null : System.Object) 
  | OFUN  -> (null : System.Object) 
  | OFUNCTION  -> (null : System.Object) 
  | OWITH  -> (null : System.Object) 
  | OELSE  -> (null : System.Object) 
  | OTHEN  -> (null : System.Object) 
  | ODO_BANG  -> (null : System.Object) 
  | ODO  -> (null : System.Object) 
  | OBINDER _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | OLET _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | HIGH_PRECEDENCE_TYAPP  -> (null : System.Object) 
  | HIGH_PRECEDENCE_PAREN_APP  -> (null : System.Object) 
  | HIGH_PRECEDENCE_BRACK_APP  -> (null : System.Object) 
  | TYPE_COMING_SOON  -> (null : System.Object) 
  | TYPE_IS_HERE  -> (null : System.Object) 
  | MODULE_COMING_SOON  -> (null : System.Object) 
  | MODULE_IS_HERE  -> (null : System.Object) 
  | EXTERN  -> (null : System.Object) 
  | VOID  -> (null : System.Object) 
  | PUBLIC  -> (null : System.Object) 
  | PRIVATE  -> (null : System.Object) 
  | INTERNAL  -> (null : System.Object) 
  | GLOBAL  -> (null : System.Object) 
  | STATIC  -> (null : System.Object) 
  | MEMBER  -> (null : System.Object) 
  | CLASS  -> (null : System.Object) 
  | ABSTRACT  -> (null : System.Object) 
  | OVERRIDE  -> (null : System.Object) 
  | DEFAULT  -> (null : System.Object) 
  | CONSTRUCTOR  -> (null : System.Object) 
  | INHERIT  -> (null : System.Object) 
  | GREATER_RBRACK  -> (null : System.Object) 
  | STRUCT  -> (null : System.Object) 
  | SIG  -> (null : System.Object) 
  | BAR  -> (null : System.Object) 
  | RBRACK  -> (null : System.Object) 
  | RBRACE  -> (null : System.Object) 
  | RBRACE_COMING_SOON  -> (null : System.Object) 
  | RBRACE_IS_HERE  -> (null : System.Object) 
  | MINUS  -> (null : System.Object) 
  | DOLLAR  -> (null : System.Object) 
  | BAR_RBRACK  -> (null : System.Object) 
  | BAR_RBRACE  -> (null : System.Object) 
  | UNDERSCORE  -> (null : System.Object) 
  | SEMICOLON_SEMICOLON  -> (null : System.Object) 
  | LARROW  -> (null : System.Object) 
  | EQUALS  -> (null : System.Object) 
  | LBRACK  -> (null : System.Object) 
  | LBRACK_BAR  -> (null : System.Object) 
  | LBRACE_BAR  -> (null : System.Object) 
  | LBRACK_LESS  -> (null : System.Object) 
  | LBRACE  -> (null : System.Object) 
  | QMARK  -> (null : System.Object) 
  | QMARK_QMARK  -> (null : System.Object) 
  | DOT  -> (null : System.Object) 
  | COLON  -> (null : System.Object) 
  | COLON_COLON  -> (null : System.Object) 
  | COLON_GREATER  -> (null : System.Object) 
  | COLON_QMARK_GREATER  -> (null : System.Object) 
  | COLON_QMARK  -> (null : System.Object) 
  | COLON_EQUALS  -> (null : System.Object) 
  | SEMICOLON  -> (null : System.Object) 
  | WHEN  -> (null : System.Object) 
  | WHILE  -> (null : System.Object) 
  | WITH  -> (null : System.Object) 
  | HASH  -> (null : System.Object) 
  | AMP  -> (null : System.Object) 
  | AMP_AMP  -> (null : System.Object) 
  | QUOTE  -> (null : System.Object) 
  | LPAREN  -> (null : System.Object) 
  | RPAREN  -> (null : System.Object) 
  | RPAREN_COMING_SOON  -> (null : System.Object) 
  | RPAREN_IS_HERE  -> (null : System.Object) 
  | STAR  -> (null : System.Object) 
  | COMMA  -> (null : System.Object) 
  | RARROW  -> (null : System.Object) 
  | GREATER_BAR_RBRACK  -> (null : System.Object) 
  | LPAREN_STAR_RPAREN  -> (null : System.Object) 
  | OPEN  -> (null : System.Object) 
  | OR  -> (null : System.Object) 
  | REC  -> (null : System.Object) 
  | THEN  -> (null : System.Object) 
  | TO  -> (null : System.Object) 
  | TRUE  -> (null : System.Object) 
  | TRY  -> (null : System.Object) 
  | TYPE  -> (null : System.Object) 
  | VAL  -> (null : System.Object) 
  | INLINE  -> (null : System.Object) 
  | INTERFACE  -> (null : System.Object) 
  | INSTANCE  -> (null : System.Object) 
  | CONST  -> (null : System.Object) 
  | LAZY  -> (null : System.Object) 
  | OLAZY  -> (null : System.Object) 
  | MATCH  -> (null : System.Object) 
  | MATCH_BANG  -> (null : System.Object) 
  | MUTABLE  -> (null : System.Object) 
  | NEW  -> (null : System.Object) 
  | OF  -> (null : System.Object) 
  | EXCEPTION  -> (null : System.Object) 
  | FALSE  -> (null : System.Object) 
  | FOR  -> (null : System.Object) 
  | FUN  -> (null : System.Object) 
  | FUNCTION  -> (null : System.Object) 
  | IF  -> (null : System.Object) 
  | IN  -> (null : System.Object) 
  | JOIN_IN  -> (null : System.Object) 
  | FINALLY  -> (null : System.Object) 
  | DO_BANG  -> (null : System.Object) 
  | AND  -> (null : System.Object) 
  | AS  -> (null : System.Object) 
  | ASSERT  -> (null : System.Object) 
  | OASSERT  -> (null : System.Object) 
  | ASR  -> (null : System.Object) 
  | BEGIN  -> (null : System.Object) 
  | DO  -> (null : System.Object) 
  | DONE  -> (null : System.Object) 
  | DOWNTO  -> (null : System.Object) 
  | ELSE  -> (null : System.Object) 
  | ELIF  -> (null : System.Object) 
  | END  -> (null : System.Object) 
  | DOT_DOT  -> (null : System.Object) 
  | BAR_BAR  -> (null : System.Object) 
  | UPCAST  -> (null : System.Object) 
  | DOWNCAST  -> (null : System.Object) 
  | NULL  -> (null : System.Object) 
  | RESERVED  -> (null : System.Object) 
  | MODULE  -> (null : System.Object) 
  | NAMESPACE  -> (null : System.Object) 
  | DELEGATE  -> (null : System.Object) 
  | CONSTRAINT  -> (null : System.Object) 
  | BASE  -> (null : System.Object) 
  | LQUOTE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | RQUOTE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | RQUOTE_DOT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | PERCENT_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | BINDER _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | LESS _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | GREATER _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | LET _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | YIELD _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | YIELD_BANG _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | BIGNUM _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | DECIMAL _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | CHAR _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | IEEE64 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | IEEE32 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | NATIVEINT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | UNATIVEINT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | UINT64 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | UINT32 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | UINT16 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | UINT8 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT64 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT32 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT32_DOT_DOT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT16 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT8 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | FUNKY_OPERATOR_NAME _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | ADJACENT_PREFIX_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | PLUS_MINUS_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_AMP_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_STAR_DIV_MOD_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | PREFIX_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_BAR_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_AT_HAT_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_COMPARE_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_STAR_STAR_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | IDENT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | KEYWORD_STRING _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | STRING _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | BYTEARRAY _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
let _fsyacc_gotos = [| 0us; 65535us; 0us; 65535us; 0us; 65535us; 0us; 65535us; 0us; 65535us; 1us; 65535us; 4us; 5us; 7us; 65535us; 4us; 15us; 16us; 17us; 18us; 19us; 20us; 21us; 22us; 15us; 24us; 15us; 26us; 15us; 4us; 65535us; 4us; 10us; 22us; 23us; 24us; 25us; 26us; 27us; 5us; 65535us; 4us; 16us; 22us; 16us; 24us; 16us; 26us; 16us; 28us; 29us; 4us; 65535us; 4us; 18us; 22us; 18us; 24us; 18us; 26us; 18us; 4us; 65535us; 4us; 20us; 22us; 20us; 24us; 20us; 26us; 20us; 4us; 65535us; 16us; 22us; 18us; 24us; 20us; 26us; 34us; 35us; 4us; 65535us; 16us; 34us; 18us; 34us; 20us; 34us; 34us; 34us; 23us; 65535us; 0us; 84us; 2us; 256us; 4us; 33us; 22us; 33us; 24us; 33us; 26us; 33us; 61us; 84us; 65us; 84us; 69us; 84us; 79us; 84us; 82us; 84us; 111us; 84us; 114us; 84us; 118us; 84us; 223us; 256us; 227us; 256us; 230us; 256us; 242us; 256us; 246us; 256us; 248us; 256us; 253us; 256us; 277us; 256us; 287us; 256us; 1us; 65535us; 39us; 40us; 1us; 65535us; 40us; 41us; 1us; 65535us; 0us; 1us; 6us; 65535us; 31us; 268us; 64us; 65us; 87us; 88us; 226us; 227us; 240us; 268us; 258us; 268us; 4us; 65535us; 56us; 60us; 58us; 60us; 218us; 222us; 220us; 222us; 1us; 65535us; 0us; 43us; 2us; 65535us; 56us; 57us; 58us; 59us; 2us; 65535us; 56us; 58us; 58us; 58us; 2us; 65535us; 0us; 56us; 61us; 62us; 3us; 65535us; 0us; 67us; 61us; 67us; 65us; 66us; 6us; 65535us; 0us; 68us; 61us; 68us; 65us; 68us; 69us; 70us; 114us; 115us; 118us; 119us; 9us; 65535us; 0us; 76us; 61us; 76us; 65us; 76us; 69us; 76us; 79us; 80us; 82us; 83us; 111us; 112us; 114us; 76us; 118us; 76us; 9us; 65535us; 0us; 78us; 61us; 78us; 65us; 78us; 69us; 78us; 79us; 78us; 82us; 78us; 111us; 78us; 114us; 78us; 118us; 78us; 9us; 65535us; 0us; 85us; 61us; 85us; 65us; 85us; 69us; 85us; 79us; 85us; 82us; 85us; 111us; 85us; 114us; 85us; 118us; 85us; 2us; 65535us; 104us; 105us; 179us; 180us; 1us; 65535us; 89us; 91us; 2us; 65535us; 64us; 92us; 87us; 92us; 2us; 65535us; 121us; 122us; 124us; 125us; 3us; 65535us; 121us; 123us; 124us; 123us; 190us; 191us; 1us; 65535us; 127us; 128us; 2us; 65535us; 127us; 137us; 130us; 131us; 2us; 65535us; 127us; 140us; 130us; 140us; 2us; 65535us; 127us; 144us; 130us; 144us; 3us; 65535us; 145us; 146us; 155us; 156us; 209us; 210us; 8us; 65535us; 130us; 152us; 132us; 133us; 145us; 163us; 151us; 152us; 155us; 163us; 159us; 160us; 166us; 167us; 209us; 163us; 8us; 65535us; 130us; 164us; 132us; 164us; 145us; 164us; 151us; 164us; 155us; 164us; 159us; 164us; 166us; 164us; 209us; 164us; 11us; 65535us; 130us; 165us; 132us; 165us; 145us; 165us; 151us; 165us; 155us; 165us; 159us; 165us; 166us; 165us; 209us; 165us; 599us; 600us; 606us; 607us; 1371us; 1372us; 3us; 65535us; 178us; 179us; 430us; 431us; 460us; 461us; 2us; 65535us; 195us; 196us; 197us; 198us; 2us; 65535us; 170us; 172us; 171us; 172us; 2us; 65535us; 64us; 93us; 87us; 93us; 5us; 65535us; 126us; 129us; 133us; 134us; 135us; 136us; 137us; 138us; 207us; 208us; 1us; 65535us; 2us; 3us; 1us; 65535us; 2us; 212us; 2us; 65535us; 218us; 219us; 220us; 221us; 2us; 65535us; 218us; 220us; 220us; 220us; 2us; 65535us; 2us; 218us; 223us; 224us; 3us; 65535us; 2us; 229us; 223us; 229us; 227us; 228us; 5us; 65535us; 2us; 237us; 223us; 237us; 227us; 237us; 230us; 231us; 287us; 288us; 9us; 65535us; 2us; 238us; 223us; 238us; 227us; 238us; 230us; 238us; 242us; 243us; 248us; 249us; 253us; 254us; 277us; 281us; 287us; 238us; 10us; 65535us; 2us; 244us; 223us; 244us; 227us; 244us; 230us; 244us; 242us; 244us; 246us; 247us; 248us; 244us; 253us; 244us; 277us; 244us; 287us; 244us; 10us; 65535us; 2us; 246us; 223us; 246us; 227us; 246us; 230us; 246us; 242us; 246us; 246us; 246us; 248us; 246us; 253us; 246us; 277us; 246us; 287us; 246us; 15us; 65535us; 2us; 255us; 4us; 28us; 22us; 28us; 24us; 28us; 26us; 28us; 28us; 28us; 223us; 255us; 227us; 255us; 230us; 255us; 242us; 255us; 246us; 255us; 248us; 255us; 253us; 255us; 277us; 255us; 287us; 255us; 1us; 65535us; 89us; 90us; 1us; 65535us; 269us; 270us; 2us; 65535us; 269us; 285us; 277us; 278us; 1us; 65535us; 342us; 345us; 81us; 65535us; 0us; 63us; 2us; 225us; 4us; 30us; 22us; 30us; 24us; 30us; 26us; 30us; 28us; 257us; 61us; 63us; 65us; 86us; 69us; 86us; 79us; 86us; 82us; 86us; 96us; 97us; 111us; 86us; 114us; 86us; 118us; 86us; 121us; 336us; 124us; 336us; 127us; 516us; 130us; 169us; 132us; 168us; 145us; 168us; 151us; 168us; 155us; 168us; 159us; 168us; 166us; 168us; 190us; 336us; 209us; 168us; 223us; 225us; 227us; 239us; 230us; 239us; 242us; 239us; 246us; 257us; 248us; 239us; 253us; 239us; 264us; 336us; 277us; 239us; 287us; 239us; 292us; 413us; 339us; 336us; 342us; 346us; 343us; 516us; 351us; 516us; 353us; 414us; 355us; 413us; 369us; 413us; 373us; 413us; 375us; 413us; 379us; 413us; 385us; 413us; 388us; 413us; 399us; 400us; 446us; 336us; 475us; 503us; 478us; 413us; 495us; 503us; 501us; 503us; 528us; 666us; 537us; 666us; 557us; 566us; 562us; 566us; 563us; 566us; 569us; 566us; 574us; 566us; 599us; 168us; 606us; 168us; 615us; 625us; 618us; 625us; 623us; 625us; 663us; 666us; 676us; 677us; 689us; 740us; 695us; 740us; 707us; 734us; 712us; 721us; 717us; 721us; 719us; 721us; 737us; 740us; 1371us; 168us; 1475us; 504us; 1477us; 740us; 118us; 65535us; 0us; 295us; 2us; 271us; 4us; 271us; 22us; 271us; 24us; 271us; 26us; 271us; 28us; 271us; 61us; 295us; 65us; 295us; 69us; 295us; 79us; 295us; 82us; 295us; 96us; 295us; 103us; 1541us; 111us; 295us; 114us; 295us; 118us; 295us; 121us; 295us; 124us; 295us; 127us; 295us; 130us; 295us; 132us; 295us; 142us; 1541us; 145us; 295us; 151us; 295us; 155us; 295us; 159us; 295us; 166us; 295us; 177us; 1541us; 190us; 295us; 193us; 1541us; 209us; 295us; 223us; 271us; 227us; 271us; 230us; 271us; 242us; 271us; 246us; 271us; 248us; 271us; 253us; 271us; 264us; 295us; 277us; 271us; 287us; 271us; 292us; 295us; 296us; 297us; 339us; 295us; 342us; 295us; 343us; 295us; 351us; 295us; 353us; 295us; 355us; 295us; 366us; 1541us; 369us; 295us; 373us; 295us; 375us; 295us; 379us; 295us; 385us; 295us; 388us; 295us; 399us; 295us; 429us; 1541us; 446us; 295us; 475us; 295us; 478us; 295us; 495us; 295us; 501us; 295us; 528us; 295us; 537us; 295us; 557us; 295us; 562us; 295us; 563us; 295us; 569us; 295us; 574us; 295us; 599us; 295us; 606us; 295us; 615us; 295us; 618us; 295us; 623us; 295us; 632us; 1541us; 663us; 295us; 676us; 295us; 689us; 295us; 695us; 295us; 707us; 295us; 712us; 295us; 717us; 295us; 719us; 295us; 737us; 295us; 813us; 813us; 814us; 813us; 816us; 813us; 849us; 927us; 861us; 927us; 877us; 927us; 880us; 927us; 892us; 927us; 900us; 927us; 922us; 927us; 927us; 927us; 928us; 927us; 930us; 927us; 931us; 927us; 932us; 927us; 933us; 927us; 939us; 927us; 941us; 927us; 1037us; 927us; 1184us; 927us; 1186us; 927us; 1191us; 927us; 1198us; 927us; 1371us; 295us; 1475us; 295us; 1477us; 295us; 1521us; 927us; 1523us; 927us; 1530us; 1541us; 1533us; 1541us; 1536us; 1541us; 1539us; 1541us; 118us; 65535us; 0us; 296us; 2us; 296us; 4us; 296us; 22us; 296us; 24us; 296us; 26us; 296us; 28us; 296us; 61us; 296us; 65us; 296us; 69us; 296us; 79us; 296us; 82us; 296us; 96us; 296us; 103us; 296us; 111us; 296us; 114us; 296us; 118us; 296us; 121us; 296us; 124us; 296us; 127us; 296us; 130us; 296us; 132us; 296us; 142us; 296us; 145us; 296us; 151us; 296us; 155us; 296us; 159us; 296us; 166us; 296us; 177us; 296us; 190us; 296us; 193us; 296us; 209us; 296us; 223us; 296us; 227us; 296us; 230us; 296us; 242us; 296us; 246us; 296us; 248us; 296us; 253us; 296us; 264us; 296us; 277us; 296us; 287us; 296us; 292us; 296us; 296us; 296us; 339us; 296us; 342us; 296us; 343us; 296us; 351us; 296us; 353us; 296us; 355us; 296us; 366us; 296us; 369us; 296us; 373us; 296us; 375us; 296us; 379us; 296us; 385us; 296us; 388us; 296us; 399us; 296us; 429us; 296us; 446us; 296us; 475us; 296us; 478us; 296us; 495us; 296us; 501us; 296us; 528us; 296us; 537us; 296us; 557us; 296us; 562us; 296us; 563us; 296us; 569us; 296us; 574us; 296us; 599us; 296us; 606us; 296us; 615us; 296us; 618us; 296us; 623us; 296us; 632us; 296us; 663us; 296us; 676us; 296us; 689us; 296us; 695us; 296us; 707us; 296us; 712us; 296us; 717us; 296us; 719us; 296us; 737us; 296us; 813us; 296us; 814us; 296us; 816us; 296us; 849us; 296us; 861us; 296us; 877us; 296us; 880us; 296us; 892us; 296us; 900us; 296us; 922us; 296us; 927us; 296us; 928us; 296us; 930us; 296us; 931us; 296us; 932us; 296us; 933us; 296us; 939us; 296us; 941us; 296us; 1037us; 296us; 1184us; 296us; 1186us; 296us; 1191us; 296us; 1198us; 296us; 1371us; 296us; 1475us; 296us; 1477us; 296us; 1521us; 296us; 1523us; 296us; 1530us; 296us; 1533us; 296us; 1536us; 296us; 1539us; 296us; 1us; 65535us; 298us; 299us; 2us; 65535us; 298us; 308us; 309us; 310us; 2us; 65535us; 298us; 314us; 309us; 314us; 4us; 65535us; 170us; 204us; 171us; 204us; 415us; 419us; 416us; 419us; 6us; 65535us; 121us; 126us; 124us; 126us; 190us; 126us; 264us; 342us; 339us; 342us; 446us; 342us; 2us; 65535us; 265us; 266us; 340us; 341us; 3us; 65535us; 264us; 265us; 339us; 340us; 446us; 447us; 2us; 65535us; 343us; 344us; 351us; 352us; 3us; 65535us; 343us; 361us; 351us; 361us; 353us; 354us; 3us; 65535us; 343us; 364us; 351us; 364us; 353us; 364us; 3us; 65535us; 343us; 368us; 351us; 368us; 353us; 368us; 3us; 65535us; 292us; 293us; 369us; 370us; 478us; 479us; 10us; 65535us; 292us; 383us; 353us; 376us; 355us; 356us; 369us; 383us; 373us; 386us; 375us; 376us; 379us; 380us; 385us; 386us; 388us; 389us; 478us; 383us; 10us; 65535us; 292us; 384us; 353us; 384us; 355us; 384us; 369us; 384us; 373us; 384us; 375us; 384us; 379us; 384us; 385us; 384us; 388us; 384us; 478us; 384us; 1us; 65535us; 407us; 410us; 2us; 65535us; 390us; 391us; 392us; 393us; 3us; 65535us; 390us; 396us; 392us; 396us; 397us; 398us; 3us; 65535us; 419us; 420us; 505us; 506us; 511us; 512us; 2us; 65535us; 415us; 425us; 416us; 425us; 10us; 65535us; 292us; 387us; 353us; 387us; 355us; 387us; 369us; 387us; 373us; 387us; 375us; 387us; 379us; 387us; 385us; 387us; 388us; 387us; 478us; 387us; 3us; 65535us; 331us; 436us; 415us; 434us; 416us; 434us; 2us; 65535us; 419us; 438us; 505us; 508us; 1us; 65535us; 457us; 458us; 42us; 65535us; 400us; 851us; 405us; 851us; 440us; 887us; 744us; 851us; 834us; 851us; 835us; 851us; 839us; 851us; 840us; 851us; 841us; 851us; 842us; 851us; 849us; 851us; 852us; 887us; 854us; 887us; 856us; 887us; 861us; 851us; 865us; 887us; 867us; 887us; 869us; 887us; 877us; 851us; 880us; 851us; 892us; 851us; 900us; 851us; 922us; 851us; 927us; 851us; 928us; 851us; 930us; 851us; 931us; 851us; 932us; 851us; 933us; 851us; 939us; 851us; 941us; 851us; 1037us; 851us; 1064us; 851us; 1070us; 851us; 1184us; 851us; 1186us; 851us; 1191us; 851us; 1198us; 851us; 1503us; 887us; 1508us; 887us; 1521us; 851us; 1523us; 851us; 10us; 65535us; 49us; 50us; 99us; 100us; 173us; 174us; 336us; 551us; 449us; 450us; 455us; 456us; 625us; 626us; 668us; 669us; 677us; 678us; 708us; 709us; 64us; 65535us; 30us; 474us; 49us; 470us; 63us; 474us; 86us; 474us; 99us; 470us; 168us; 474us; 169us; 474us; 173us; 470us; 225us; 474us; 239us; 474us; 257us; 474us; 336us; 470us; 346us; 474us; 400us; 468us; 405us; 468us; 413us; 474us; 414us; 474us; 440us; 468us; 449us; 470us; 455us; 470us; 516us; 474us; 625us; 470us; 668us; 470us; 677us; 470us; 708us; 470us; 744us; 468us; 834us; 468us; 835us; 468us; 839us; 468us; 840us; 468us; 841us; 468us; 842us; 468us; 849us; 468us; 852us; 468us; 854us; 468us; 856us; 468us; 861us; 468us; 865us; 468us; 867us; 468us; 869us; 468us; 877us; 468us; 880us; 468us; 892us; 468us; 900us; 468us; 922us; 468us; 927us; 468us; 928us; 468us; 930us; 468us; 931us; 468us; 932us; 468us; 933us; 468us; 939us; 468us; 941us; 468us; 1037us; 468us; 1064us; 468us; 1070us; 468us; 1184us; 468us; 1186us; 468us; 1191us; 468us; 1198us; 468us; 1503us; 468us; 1508us; 468us; 1521us; 468us; 1523us; 468us; 12us; 65535us; 30us; 31us; 63us; 64us; 86us; 87us; 168us; 170us; 169us; 171us; 225us; 226us; 239us; 240us; 257us; 258us; 346us; 347us; 413us; 415us; 414us; 416us; 516us; 517us; 1us; 65535us; 423us; 424us; 4us; 65535us; 356us; 357us; 358us; 359us; 361us; 362us; 673us; 674us; 2us; 65535us; 415us; 433us; 416us; 433us; 2us; 65535us; 349us; 350us; 441us; 442us; 2us; 65535us; 349us; 488us; 441us; 488us; 2us; 65535us; 482us; 483us; 485us; 486us; 3us; 65535us; 482us; 491us; 485us; 491us; 1252us; 1473us; 2us; 65535us; 475us; 476us; 1475us; 1480us; 4us; 65535us; 475us; 499us; 495us; 496us; 501us; 502us; 1475us; 499us; 4us; 65535us; 475us; 500us; 495us; 500us; 501us; 500us; 1475us; 500us; 2us; 65535us; 503us; 505us; 504us; 505us; 5us; 65535us; 127us; 139us; 130us; 139us; 343us; 363us; 351us; 363us; 353us; 363us; 6us; 65535us; 171us; 524us; 416us; 524us; 517us; 524us; 629us; 660us; 651us; 660us; 682us; 660us; 66us; 65535us; 8us; 1620us; 103us; 1620us; 142us; 1620us; 171us; 1620us; 177us; 1620us; 181us; 1620us; 183us; 1620us; 193us; 1620us; 366us; 1620us; 416us; 1620us; 422us; 1620us; 429us; 1620us; 452us; 1620us; 462us; 1620us; 517us; 1620us; 525us; 1620us; 589us; 1620us; 592us; 1620us; 602us; 1620us; 612us; 1620us; 629us; 1620us; 632us; 1620us; 651us; 1620us; 654us; 1620us; 657us; 1620us; 671us; 1620us; 682us; 1620us; 767us; 1620us; 811us; 1620us; 858us; 1620us; 925us; 1620us; 955us; 1620us; 1127us; 1620us; 1129us; 1620us; 1131us; 1620us; 1419us; 1620us; 1422us; 1620us; 1424us; 1620us; 1488us; 1620us; 1530us; 1620us; 1533us; 1620us; 1536us; 1620us; 1539us; 1620us; 1541us; 1620us; 1543us; 1620us; 1547us; 1620us; 1550us; 1620us; 1554us; 1620us; 1557us; 1620us; 1562us; 1620us; 1564us; 1620us; 1566us; 1620us; 1569us; 1620us; 1571us; 1620us; 1585us; 1620us; 1590us; 1620us; 1593us; 1620us; 1604us; 1620us; 1608us; 1620us; 1614us; 1620us; 1625us; 1620us; 1631us; 1620us; 1632us; 1620us; 1655us; 1620us; 1657us; 1620us; 1668us; 1620us; 67us; 65535us; 8us; 536us; 103us; 536us; 142us; 536us; 171us; 536us; 177us; 536us; 181us; 536us; 183us; 536us; 193us; 536us; 366us; 536us; 416us; 536us; 422us; 536us; 429us; 536us; 452us; 536us; 462us; 536us; 517us; 536us; 525us; 536us; 534us; 535us; 589us; 536us; 592us; 536us; 602us; 536us; 612us; 536us; 629us; 536us; 632us; 536us; 651us; 536us; 654us; 536us; 657us; 536us; 671us; 536us; 682us; 536us; 767us; 536us; 811us; 536us; 858us; 536us; 925us; 536us; 955us; 536us; 1127us; 536us; 1129us; 536us; 1131us; 536us; 1419us; 536us; 1422us; 536us; 1424us; 536us; 1488us; 536us; 1530us; 536us; 1533us; 536us; 1536us; 536us; 1539us; 536us; 1541us; 536us; 1543us; 536us; 1547us; 536us; 1550us; 536us; 1554us; 536us; 1557us; 536us; 1562us; 536us; 1564us; 536us; 1566us; 536us; 1569us; 536us; 1571us; 536us; 1585us; 536us; 1590us; 536us; 1593us; 536us; 1604us; 536us; 1608us; 536us; 1614us; 536us; 1625us; 536us; 1631us; 536us; 1632us; 536us; 1655us; 536us; 1657us; 536us; 1668us; 536us; 1us; 65535us; 525us; 526us; 5us; 65535us; 127us; 145us; 130us; 145us; 343us; 369us; 351us; 369us; 353us; 369us; 9us; 65535us; 170us; 181us; 171us; 181us; 415us; 422us; 416us; 422us; 1469us; 1488us; 1471us; 1488us; 1482us; 1488us; 1484us; 1488us; 1486us; 1488us; 1us; 65535us; 336us; 337us; 1us; 65535us; 551us; 553us; 3us; 65535us; 557us; 558us; 569us; 560us; 574us; 561us; 5us; 65535us; 557us; 565us; 562us; 564us; 563us; 564us; 569us; 565us; 574us; 565us; 1us; 65535us; 552us; 555us; 1us; 65535us; 574us; 575us; 4us; 65535us; 101us; 578us; 175us; 578us; 427us; 578us; 851us; 579us; 3us; 65535us; 101us; 102us; 175us; 176us; 427us; 428us; 1us; 65535us; 851us; 852us; 3us; 65535us; 337us; 338us; 560us; 570us; 575us; 576us; 3us; 65535us; 580us; 581us; 1527us; 582us; 1529us; 583us; 4us; 65535us; 580us; 586us; 584us; 585us; 1527us; 586us; 1529us; 586us; 1us; 65535us; 602us; 603us; 3us; 65535us; 171us; 523us; 416us; 523us; 517us; 523us; 5us; 65535us; 171us; 615us; 416us; 615us; 517us; 615us; 617us; 618us; 622us; 623us; 3us; 65535us; 615us; 616us; 618us; 619us; 623us; 624us; 3us; 65535us; 615us; 622us; 618us; 622us; 623us; 622us; 1us; 65535us; 626us; 627us; 3us; 65535us; 171us; 617us; 416us; 617us; 517us; 617us; 3us; 65535us; 171us; 620us; 416us; 620us; 517us; 620us; 4us; 65535us; 629us; 661us; 651us; 661us; 654us; 655us; 682us; 661us; 4us; 65535us; 629us; 653us; 651us; 653us; 654us; 653us; 682us; 653us; 3us; 65535us; 629us; 630us; 651us; 652us; 682us; 683us; 3us; 65535us; 528us; 529us; 537us; 538us; 663us; 664us; 3us; 65535us; 528us; 662us; 537us; 662us; 663us; 662us; 3us; 65535us; 185us; 186us; 188us; 189us; 666us; 667us; 4us; 65535us; 31us; 267us; 226us; 267us; 240us; 267us; 258us; 267us; 6us; 65535us; 31us; 676us; 64us; 676us; 87us; 676us; 226us; 676us; 240us; 676us; 258us; 676us; 6us; 65535us; 31us; 673us; 64us; 207us; 87us; 207us; 226us; 673us; 240us; 673us; 258us; 673us; 1us; 65535us; 678us; 679us; 1us; 65535us; 679us; 680us; 15us; 65535us; 2us; 273us; 4us; 273us; 22us; 273us; 24us; 273us; 26us; 273us; 28us; 273us; 223us; 273us; 227us; 273us; 230us; 273us; 242us; 273us; 246us; 273us; 248us; 273us; 253us; 273us; 277us; 273us; 287us; 273us; 113us; 65535us; 6us; 986us; 31us; 260us; 106us; 986us; 108us; 986us; 226us; 260us; 240us; 260us; 258us; 259us; 262us; 986us; 331us; 701us; 403us; 986us; 408us; 986us; 415us; 701us; 416us; 701us; 443us; 986us; 459us; 986us; 692us; 986us; 698us; 986us; 747us; 986us; 751us; 986us; 761us; 986us; 943us; 986us; 948us; 986us; 962us; 986us; 964us; 986us; 967us; 986us; 970us; 986us; 987us; 986us; 990us; 986us; 993us; 986us; 999us; 986us; 1003us; 986us; 1007us; 986us; 1011us; 986us; 1013us; 986us; 1018us; 986us; 1020us; 986us; 1022us; 986us; 1024us; 986us; 1026us; 986us; 1028us; 986us; 1039us; 986us; 1047us; 986us; 1054us; 986us; 1060us; 986us; 1062us; 986us; 1065us; 986us; 1068us; 986us; 1071us; 986us; 1074us; 986us; 1077us; 986us; 1080us; 986us; 1082us; 986us; 1087us; 986us; 1089us; 986us; 1133us; 986us; 1135us; 986us; 1139us; 986us; 1140us; 986us; 1141us; 986us; 1142us; 986us; 1143us; 986us; 1144us; 986us; 1145us; 986us; 1146us; 986us; 1147us; 986us; 1148us; 986us; 1149us; 986us; 1151us; 986us; 1152us; 986us; 1153us; 986us; 1154us; 986us; 1155us; 986us; 1156us; 986us; 1157us; 986us; 1158us; 986us; 1159us; 986us; 1181us; 986us; 1203us; 986us; 1204us; 986us; 1208us; 986us; 1210us; 986us; 1214us; 986us; 1216us; 986us; 1220us; 986us; 1223us; 986us; 1225us; 986us; 1289us; 986us; 1296us; 986us; 1303us; 986us; 1310us; 986us; 1320us; 986us; 1322us; 986us; 1323us; 986us; 1335us; 986us; 1342us; 986us; 1343us; 986us; 1349us; 986us; 1355us; 986us; 1356us; 986us; 1357us; 986us; 1373us; 986us; 1383us; 986us; 1396us; 986us; 1397us; 986us; 1399us; 986us; 1401us; 986us; 1405us; 986us; 1406us; 986us; 1433us; 986us; 1438us; 986us; 1463us; 986us; 1505us; 986us; 1510us; 986us; 7us; 65535us; 31us; 263us; 226us; 263us; 240us; 263us; 258us; 263us; 331us; 702us; 415us; 702us; 416us; 702us; 113us; 65535us; 6us; 970us; 31us; 262us; 106us; 990us; 108us; 990us; 226us; 262us; 240us; 262us; 258us; 261us; 262us; 970us; 331us; 703us; 403us; 970us; 408us; 970us; 415us; 703us; 416us; 703us; 443us; 970us; 459us; 970us; 692us; 970us; 698us; 970us; 747us; 970us; 751us; 970us; 761us; 970us; 943us; 970us; 948us; 970us; 962us; 970us; 964us; 970us; 967us; 970us; 970us; 970us; 987us; 970us; 990us; 970us; 993us; 970us; 999us; 970us; 1003us; 970us; 1007us; 970us; 1011us; 970us; 1013us; 990us; 1018us; 990us; 1020us; 990us; 1022us; 990us; 1024us; 990us; 1026us; 990us; 1028us; 970us; 1039us; 970us; 1047us; 970us; 1054us; 970us; 1060us; 990us; 1062us; 990us; 1065us; 970us; 1068us; 970us; 1071us; 970us; 1074us; 970us; 1077us; 970us; 1080us; 970us; 1082us; 970us; 1087us; 990us; 1089us; 970us; 1133us; 990us; 1135us; 990us; 1139us; 990us; 1140us; 990us; 1141us; 990us; 1142us; 990us; 1143us; 990us; 1144us; 990us; 1145us; 990us; 1146us; 990us; 1147us; 990us; 1148us; 990us; 1149us; 990us; 1151us; 990us; 1152us; 990us; 1153us; 990us; 1154us; 990us; 1155us; 990us; 1156us; 990us; 1157us; 990us; 1158us; 990us; 1159us; 990us; 1181us; 970us; 1203us; 990us; 1204us; 970us; 1208us; 990us; 1210us; 970us; 1214us; 990us; 1216us; 970us; 1220us; 990us; 1223us; 990us; 1225us; 990us; 1289us; 970us; 1296us; 990us; 1303us; 970us; 1310us; 970us; 1320us; 990us; 1322us; 990us; 1323us; 990us; 1335us; 970us; 1342us; 970us; 1343us; 970us; 1349us; 970us; 1355us; 970us; 1356us; 970us; 1357us; 970us; 1373us; 970us; 1383us; 970us; 1396us; 990us; 1397us; 990us; 1399us; 970us; 1401us; 990us; 1405us; 990us; 1406us; 990us; 1433us; 990us; 1438us; 990us; 1463us; 990us; 1505us; 970us; 1510us; 970us; 112us; 65535us; 6us; 996us; 31us; 996us; 106us; 996us; 108us; 996us; 226us; 996us; 240us; 996us; 262us; 996us; 331us; 704us; 403us; 996us; 408us; 996us; 415us; 704us; 416us; 704us; 443us; 996us; 459us; 996us; 692us; 996us; 698us; 996us; 747us; 996us; 751us; 996us; 761us; 996us; 943us; 996us; 948us; 996us; 962us; 996us; 964us; 996us; 967us; 996us; 970us; 996us; 987us; 996us; 990us; 996us; 993us; 996us; 999us; 996us; 1003us; 996us; 1007us; 996us; 1011us; 996us; 1013us; 996us; 1018us; 996us; 1020us; 996us; 1022us; 996us; 1024us; 996us; 1026us; 996us; 1028us; 996us; 1039us; 996us; 1047us; 996us; 1054us; 996us; 1060us; 996us; 1062us; 996us; 1065us; 996us; 1068us; 996us; 1071us; 996us; 1074us; 996us; 1077us; 996us; 1080us; 996us; 1082us; 996us; 1087us; 996us; 1089us; 996us; 1133us; 996us; 1135us; 996us; 1139us; 996us; 1140us; 996us; 1141us; 996us; 1142us; 996us; 1143us; 996us; 1144us; 996us; 1145us; 996us; 1146us; 996us; 1147us; 996us; 1148us; 996us; 1149us; 996us; 1151us; 996us; 1152us; 996us; 1153us; 996us; 1154us; 996us; 1155us; 996us; 1156us; 996us; 1157us; 996us; 1158us; 996us; 1159us; 996us; 1181us; 996us; 1203us; 996us; 1204us; 996us; 1208us; 996us; 1210us; 996us; 1214us; 996us; 1216us; 996us; 1220us; 996us; 1223us; 996us; 1225us; 996us; 1289us; 996us; 1296us; 996us; 1303us; 996us; 1310us; 996us; 1320us; 996us; 1322us; 996us; 1323us; 996us; 1335us; 996us; 1342us; 996us; 1343us; 996us; 1349us; 996us; 1355us; 996us; 1356us; 996us; 1357us; 996us; 1373us; 996us; 1383us; 996us; 1396us; 996us; 1397us; 996us; 1399us; 996us; 1401us; 996us; 1405us; 996us; 1406us; 996us; 1433us; 996us; 1438us; 996us; 1463us; 996us; 1505us; 996us; 1510us; 996us; 3us; 65535us; 331us; 418us; 415us; 417us; 416us; 417us; 4us; 65535us; 696us; 697us; 699us; 700us; 1072us; 1073us; 1083us; 1084us; 113us; 65535us; 6us; 691us; 31us; 691us; 106us; 691us; 108us; 691us; 226us; 691us; 240us; 691us; 258us; 691us; 262us; 691us; 331us; 691us; 403us; 691us; 408us; 691us; 415us; 691us; 416us; 691us; 443us; 691us; 459us; 691us; 692us; 691us; 698us; 691us; 747us; 691us; 751us; 691us; 761us; 691us; 943us; 691us; 948us; 691us; 962us; 691us; 964us; 691us; 967us; 691us; 970us; 691us; 987us; 691us; 990us; 691us; 993us; 691us; 999us; 691us; 1003us; 691us; 1007us; 691us; 1011us; 691us; 1013us; 691us; 1018us; 691us; 1020us; 691us; 1022us; 691us; 1024us; 691us; 1026us; 691us; 1028us; 691us; 1039us; 691us; 1047us; 691us; 1054us; 691us; 1060us; 691us; 1062us; 691us; 1065us; 691us; 1068us; 691us; 1071us; 691us; 1074us; 691us; 1077us; 691us; 1080us; 691us; 1082us; 691us; 1087us; 691us; 1089us; 691us; 1133us; 691us; 1135us; 691us; 1139us; 691us; 1140us; 691us; 1141us; 691us; 1142us; 691us; 1143us; 691us; 1144us; 691us; 1145us; 691us; 1146us; 691us; 1147us; 691us; 1148us; 691us; 1149us; 691us; 1151us; 691us; 1152us; 691us; 1153us; 691us; 1154us; 691us; 1155us; 691us; 1156us; 691us; 1157us; 691us; 1158us; 691us; 1159us; 691us; 1181us; 691us; 1203us; 691us; 1204us; 691us; 1208us; 691us; 1210us; 691us; 1214us; 691us; 1216us; 691us; 1220us; 691us; 1223us; 691us; 1225us; 691us; 1289us; 691us; 1296us; 691us; 1303us; 691us; 1310us; 691us; 1320us; 691us; 1322us; 691us; 1323us; 691us; 1335us; 691us; 1342us; 691us; 1343us; 691us; 1349us; 691us; 1355us; 691us; 1356us; 691us; 1357us; 691us; 1373us; 691us; 1383us; 691us; 1396us; 691us; 1397us; 691us; 1399us; 691us; 1401us; 691us; 1405us; 691us; 1406us; 691us; 1433us; 691us; 1438us; 691us; 1463us; 691us; 1505us; 691us; 1510us; 691us; 1us; 65535us; 712us; 713us; 1us; 65535us; 712us; 715us; 3us; 65535us; 712us; 716us; 717us; 718us; 719us; 720us; 2us; 65535us; 721us; 722us; 734us; 725us; 1us; 65535us; 707us; 708us; 4us; 65535us; 689us; 690us; 695us; 696us; 1475us; 1476us; 1477us; 1478us; 2us; 65535us; 735us; 736us; 738us; 739us; 5us; 65535us; 689us; 735us; 695us; 735us; 737us; 738us; 1475us; 735us; 1477us; 735us; 2us; 65535us; 504us; 741us; 740us; 741us; 1us; 65535us; 747us; 748us; 2us; 65535us; 747us; 755us; 751us; 752us; 1us; 65535us; 756us; 757us; 1us; 65535us; 757us; 758us; 1us; 65535us; 759us; 760us; 2us; 65535us; 759us; 765us; 763us; 764us; 257us; 65535us; 6us; 802us; 8us; 1639us; 31us; 802us; 103us; 1639us; 106us; 802us; 108us; 802us; 142us; 1639us; 171us; 1639us; 177us; 1639us; 181us; 1639us; 183us; 1639us; 193us; 1639us; 226us; 802us; 240us; 802us; 262us; 802us; 312us; 802us; 316us; 802us; 321us; 802us; 366us; 1639us; 400us; 802us; 403us; 802us; 405us; 802us; 408us; 802us; 416us; 1639us; 422us; 1639us; 429us; 1639us; 440us; 802us; 443us; 802us; 452us; 1639us; 459us; 802us; 462us; 1639us; 481us; 1639us; 484us; 802us; 517us; 1639us; 525us; 1639us; 543us; 1639us; 589us; 1639us; 592us; 1639us; 602us; 1639us; 612us; 1639us; 629us; 1639us; 632us; 1639us; 635us; 802us; 647us; 802us; 651us; 1639us; 654us; 1639us; 657us; 1639us; 671us; 1639us; 682us; 1639us; 692us; 802us; 698us; 802us; 744us; 802us; 747us; 802us; 751us; 802us; 761us; 802us; 767us; 1639us; 811us; 1639us; 834us; 802us; 835us; 802us; 839us; 802us; 840us; 802us; 841us; 802us; 842us; 802us; 849us; 802us; 852us; 802us; 854us; 802us; 856us; 802us; 858us; 1639us; 861us; 802us; 865us; 802us; 867us; 802us; 869us; 802us; 877us; 802us; 880us; 802us; 892us; 802us; 900us; 802us; 922us; 802us; 925us; 1639us; 927us; 802us; 928us; 802us; 930us; 802us; 931us; 802us; 932us; 802us; 933us; 802us; 939us; 802us; 941us; 802us; 943us; 802us; 948us; 802us; 955us; 1639us; 962us; 802us; 964us; 802us; 967us; 802us; 970us; 802us; 987us; 802us; 990us; 802us; 993us; 802us; 999us; 802us; 1003us; 802us; 1007us; 802us; 1011us; 802us; 1013us; 802us; 1018us; 802us; 1020us; 802us; 1022us; 802us; 1024us; 802us; 1026us; 802us; 1028us; 802us; 1037us; 802us; 1039us; 802us; 1047us; 802us; 1054us; 802us; 1060us; 802us; 1062us; 802us; 1064us; 802us; 1065us; 802us; 1068us; 802us; 1070us; 802us; 1071us; 802us; 1074us; 802us; 1077us; 802us; 1080us; 802us; 1082us; 802us; 1087us; 802us; 1089us; 802us; 1127us; 1639us; 1129us; 1639us; 1131us; 1639us; 1133us; 802us; 1135us; 802us; 1139us; 802us; 1140us; 802us; 1141us; 802us; 1142us; 802us; 1143us; 802us; 1144us; 802us; 1145us; 802us; 1146us; 802us; 1147us; 802us; 1148us; 802us; 1149us; 802us; 1151us; 802us; 1152us; 802us; 1153us; 802us; 1154us; 802us; 1155us; 802us; 1156us; 802us; 1157us; 802us; 1158us; 802us; 1159us; 802us; 1181us; 802us; 1184us; 802us; 1186us; 802us; 1191us; 802us; 1198us; 802us; 1203us; 802us; 1204us; 802us; 1208us; 802us; 1210us; 802us; 1214us; 802us; 1216us; 802us; 1220us; 802us; 1223us; 802us; 1225us; 802us; 1227us; 802us; 1228us; 802us; 1230us; 802us; 1231us; 802us; 1233us; 802us; 1234us; 802us; 1236us; 802us; 1237us; 802us; 1239us; 802us; 1240us; 802us; 1242us; 802us; 1243us; 802us; 1245us; 1639us; 1246us; 1639us; 1249us; 802us; 1250us; 802us; 1255us; 802us; 1257us; 802us; 1259us; 802us; 1260us; 802us; 1261us; 802us; 1264us; 802us; 1271us; 802us; 1272us; 802us; 1275us; 802us; 1276us; 802us; 1289us; 802us; 1296us; 802us; 1303us; 802us; 1310us; 802us; 1320us; 802us; 1322us; 802us; 1323us; 802us; 1335us; 802us; 1342us; 802us; 1343us; 802us; 1349us; 802us; 1355us; 802us; 1356us; 802us; 1357us; 802us; 1373us; 802us; 1383us; 802us; 1396us; 802us; 1397us; 802us; 1399us; 802us; 1401us; 802us; 1405us; 802us; 1406us; 802us; 1413us; 802us; 1419us; 1639us; 1422us; 1639us; 1424us; 1639us; 1426us; 1639us; 1428us; 802us; 1433us; 802us; 1438us; 802us; 1463us; 802us; 1488us; 1639us; 1496us; 802us; 1503us; 802us; 1505us; 802us; 1508us; 802us; 1510us; 802us; 1521us; 802us; 1523us; 802us; 1530us; 1639us; 1533us; 1639us; 1536us; 1639us; 1539us; 1639us; 1541us; 1639us; 1543us; 1639us; 1547us; 1639us; 1550us; 1639us; 1554us; 1639us; 1557us; 1639us; 1562us; 1639us; 1564us; 1639us; 1566us; 1639us; 1569us; 1639us; 1571us; 1639us; 1585us; 1639us; 1590us; 1639us; 1593us; 1639us; 1604us; 1639us; 1608us; 1639us; 1614us; 1639us; 1621us; 1639us; 1625us; 1639us; 1631us; 1639us; 1632us; 1639us; 1641us; 802us; 1655us; 1639us; 1657us; 1639us; 1668us; 1639us; 1us; 65535us; 796us; 797us; 4us; 65535us; 800us; 801us; 1578us; 799us; 1612us; 799us; 1683us; 799us; 3us; 65535us; 1578us; 1579us; 1612us; 1613us; 1683us; 1684us; 185us; 65535us; 6us; 1325us; 31us; 1325us; 106us; 1325us; 108us; 1325us; 226us; 1325us; 240us; 1325us; 262us; 1325us; 312us; 1325us; 316us; 1325us; 321us; 1325us; 400us; 888us; 403us; 1325us; 405us; 888us; 408us; 1325us; 440us; 888us; 443us; 1325us; 459us; 1325us; 484us; 1325us; 635us; 636us; 647us; 648us; 692us; 1325us; 698us; 1325us; 744us; 888us; 747us; 1325us; 751us; 1325us; 761us; 1325us; 834us; 888us; 835us; 888us; 839us; 888us; 840us; 888us; 841us; 888us; 842us; 888us; 849us; 888us; 852us; 888us; 854us; 888us; 856us; 888us; 861us; 888us; 865us; 888us; 867us; 888us; 869us; 888us; 877us; 888us; 880us; 888us; 892us; 888us; 900us; 888us; 922us; 888us; 927us; 888us; 928us; 888us; 930us; 888us; 931us; 888us; 932us; 888us; 933us; 888us; 939us; 888us; 941us; 888us; 943us; 1325us; 948us; 1325us; 962us; 1325us; 964us; 1325us; 967us; 1325us; 970us; 1325us; 987us; 1325us; 990us; 1325us; 993us; 1325us; 999us; 1325us; 1003us; 1325us; 1007us; 1325us; 1011us; 1325us; 1013us; 1325us; 1018us; 1325us; 1020us; 1325us; 1022us; 1325us; 1024us; 1325us; 1026us; 1325us; 1028us; 1325us; 1037us; 888us; 1039us; 1325us; 1047us; 1325us; 1054us; 1325us; 1060us; 1325us; 1062us; 1325us; 1064us; 888us; 1065us; 1325us; 1068us; 1325us; 1070us; 888us; 1071us; 1325us; 1074us; 1325us; 1077us; 1325us; 1080us; 1325us; 1082us; 1325us; 1087us; 1325us; 1089us; 1325us; 1133us; 1325us; 1135us; 1325us; 1139us; 1325us; 1140us; 1325us; 1141us; 1325us; 1142us; 1325us; 1143us; 1325us; 1144us; 1325us; 1145us; 1325us; 1146us; 1325us; 1147us; 1325us; 1148us; 1325us; 1149us; 1325us; 1151us; 1325us; 1152us; 1325us; 1153us; 1325us; 1154us; 1325us; 1155us; 1325us; 1156us; 1325us; 1157us; 1325us; 1158us; 1325us; 1159us; 1325us; 1181us; 1325us; 1184us; 888us; 1186us; 888us; 1191us; 888us; 1198us; 888us; 1203us; 1325us; 1204us; 1325us; 1208us; 1325us; 1210us; 1325us; 1214us; 1325us; 1216us; 1325us; 1220us; 1325us; 1223us; 1325us; 1225us; 1325us; 1227us; 1325us; 1228us; 1325us; 1230us; 1325us; 1231us; 1325us; 1233us; 1325us; 1234us; 1325us; 1236us; 1325us; 1237us; 1325us; 1239us; 1325us; 1240us; 1325us; 1242us; 1325us; 1243us; 1325us; 1249us; 1325us; 1250us; 1325us; 1255us; 1325us; 1257us; 1325us; 1259us; 1325us; 1260us; 1325us; 1261us; 1325us; 1264us; 1325us; 1271us; 1325us; 1272us; 1325us; 1275us; 1325us; 1276us; 1325us; 1289us; 1325us; 1296us; 1325us; 1303us; 1325us; 1310us; 1325us; 1320us; 1325us; 1322us; 1325us; 1323us; 1325us; 1335us; 1325us; 1342us; 1325us; 1343us; 1325us; 1349us; 1325us; 1355us; 1325us; 1356us; 1325us; 1357us; 1325us; 1373us; 1325us; 1383us; 1325us; 1396us; 1325us; 1397us; 1325us; 1399us; 1325us; 1401us; 1325us; 1405us; 1325us; 1406us; 1325us; 1413us; 1325us; 1428us; 1325us; 1433us; 1325us; 1438us; 1325us; 1463us; 1325us; 1496us; 1325us; 1503us; 888us; 1505us; 1325us; 1508us; 888us; 1510us; 1325us; 1521us; 888us; 1523us; 888us; 1641us; 1325us; 3us; 65535us; 400us; 401us; 405us; 406us; 744us; 745us; 3us; 65535us; 813us; 809us; 814us; 810us; 816us; 810us; 2us; 65535us; 814us; 815us; 816us; 817us; 1us; 65535us; 348us; 349us; 11us; 65535us; 400us; 805us; 405us; 805us; 744us; 805us; 834us; 824us; 835us; 825us; 839us; 826us; 840us; 827us; 841us; 828us; 842us; 829us; 1064us; 830us; 1070us; 831us; 11us; 65535us; 400us; 836us; 405us; 836us; 744us; 836us; 834us; 836us; 835us; 836us; 839us; 836us; 840us; 836us; 841us; 836us; 842us; 836us; 1064us; 836us; 1070us; 836us; 11us; 65535us; 400us; 837us; 405us; 837us; 744us; 837us; 834us; 837us; 835us; 837us; 839us; 837us; 840us; 837us; 841us; 837us; 842us; 837us; 1064us; 837us; 1070us; 837us; 2us; 65535us; 845us; 846us; 861us; 862us; 2us; 65535us; 845us; 843us; 861us; 843us; 33us; 65535us; 400us; 838us; 405us; 838us; 744us; 838us; 834us; 838us; 835us; 838us; 839us; 838us; 840us; 838us; 841us; 838us; 842us; 838us; 849us; 929us; 861us; 929us; 877us; 929us; 880us; 929us; 892us; 929us; 900us; 929us; 922us; 929us; 927us; 929us; 928us; 929us; 930us; 929us; 931us; 929us; 932us; 929us; 933us; 929us; 939us; 929us; 941us; 929us; 1037us; 929us; 1064us; 838us; 1070us; 838us; 1184us; 929us; 1186us; 929us; 1191us; 929us; 1198us; 929us; 1521us; 929us; 1523us; 929us; 3us; 65535us; 852us; 853us; 854us; 855us; 856us; 857us; 8us; 65535us; 852us; 864us; 854us; 864us; 856us; 864us; 865us; 866us; 867us; 868us; 869us; 870us; 1503us; 1504us; 1508us; 1509us; 42us; 65535us; 400us; 860us; 405us; 860us; 440us; 441us; 744us; 860us; 834us; 860us; 835us; 860us; 839us; 860us; 840us; 860us; 841us; 860us; 842us; 860us; 849us; 860us; 852us; 865us; 854us; 865us; 856us; 865us; 861us; 860us; 865us; 865us; 867us; 865us; 869us; 865us; 877us; 860us; 880us; 860us; 892us; 860us; 900us; 860us; 922us; 860us; 927us; 860us; 928us; 860us; 930us; 860us; 931us; 860us; 932us; 860us; 933us; 860us; 939us; 860us; 941us; 860us; 1037us; 860us; 1064us; 860us; 1070us; 860us; 1184us; 860us; 1186us; 860us; 1191us; 860us; 1198us; 860us; 1503us; 865us; 1508us; 865us; 1521us; 860us; 1523us; 860us; 2us; 65535us; 861us; 893us; 892us; 893us; 22us; 65535us; 849us; 850us; 861us; 907us; 877us; 917us; 880us; 917us; 892us; 907us; 900us; 914us; 922us; 908us; 927us; 909us; 928us; 910us; 930us; 911us; 931us; 912us; 932us; 913us; 933us; 915us; 939us; 916us; 941us; 917us; 1037us; 918us; 1184us; 919us; 1186us; 919us; 1191us; 919us; 1198us; 919us; 1521us; 919us; 1523us; 919us; 22us; 65535us; 849us; 923us; 861us; 923us; 877us; 923us; 880us; 923us; 892us; 923us; 900us; 901us; 922us; 923us; 927us; 923us; 928us; 923us; 930us; 923us; 931us; 923us; 932us; 923us; 933us; 923us; 939us; 923us; 941us; 923us; 1037us; 923us; 1184us; 923us; 1186us; 923us; 1191us; 923us; 1198us; 923us; 1521us; 923us; 1523us; 923us; 22us; 65535us; 849us; 924us; 861us; 924us; 877us; 924us; 880us; 924us; 892us; 924us; 900us; 924us; 922us; 924us; 927us; 924us; 928us; 924us; 930us; 924us; 931us; 924us; 932us; 924us; 933us; 924us; 939us; 924us; 941us; 924us; 1037us; 924us; 1184us; 924us; 1186us; 924us; 1191us; 924us; 1198us; 924us; 1521us; 924us; 1523us; 924us; 2us; 65535us; 874us; 875us; 936us; 937us; 2us; 65535us; 874us; 934us; 936us; 934us; 3us; 65535us; 877us; 878us; 880us; 881us; 941us; 942us; 23us; 65535us; 262us; 991us; 403us; 404us; 408us; 409us; 443us; 444us; 459us; 460us; 692us; 693us; 698us; 699us; 761us; 762us; 970us; 991us; 990us; 991us; 993us; 994us; 1011us; 1012us; 1028us; 1029us; 1039us; 1040us; 1047us; 1048us; 1054us; 1055us; 1065us; 1066us; 1068us; 1069us; 1071us; 1072us; 1074us; 1075us; 1080us; 1081us; 1082us; 1083us; 1505us; 1506us; 6us; 65535us; 1022us; 1023us; 1024us; 1025us; 1135us; 1136us; 1433us; 1434us; 1438us; 1439us; 1463us; 1464us; 5us; 65535us; 1007us; 1008us; 1089us; 1090us; 1204us; 1205us; 1399us; 1400us; 1510us; 1511us; 50us; 65535us; 6us; 957us; 262us; 947us; 403us; 947us; 408us; 947us; 443us; 947us; 459us; 947us; 692us; 947us; 698us; 947us; 747us; 756us; 751us; 756us; 761us; 947us; 943us; 944us; 948us; 949us; 967us; 968us; 970us; 947us; 987us; 988us; 990us; 947us; 993us; 947us; 999us; 1000us; 1003us; 1004us; 1007us; 952us; 1011us; 947us; 1028us; 947us; 1039us; 947us; 1047us; 947us; 1054us; 947us; 1065us; 947us; 1068us; 947us; 1071us; 947us; 1074us; 947us; 1077us; 1078us; 1080us; 947us; 1082us; 947us; 1089us; 952us; 1181us; 1182us; 1204us; 952us; 1210us; 1211us; 1216us; 1217us; 1303us; 1308us; 1310us; 1311us; 1335us; 1336us; 1342us; 1344us; 1343us; 1344us; 1355us; 1375us; 1356us; 1375us; 1357us; 1375us; 1373us; 1374us; 1399us; 952us; 1505us; 947us; 1510us; 952us; 1us; 65535us; 6us; 7us; 55us; 65535us; 6us; 954us; 262us; 954us; 403us; 954us; 408us; 954us; 443us; 954us; 459us; 954us; 692us; 954us; 698us; 954us; 747us; 954us; 751us; 954us; 761us; 954us; 943us; 954us; 948us; 954us; 962us; 963us; 964us; 965us; 967us; 954us; 970us; 954us; 987us; 954us; 990us; 954us; 993us; 954us; 999us; 954us; 1003us; 954us; 1007us; 954us; 1011us; 954us; 1028us; 954us; 1039us; 954us; 1047us; 954us; 1054us; 954us; 1065us; 954us; 1068us; 954us; 1071us; 954us; 1074us; 954us; 1077us; 954us; 1080us; 954us; 1082us; 954us; 1089us; 954us; 1181us; 954us; 1204us; 954us; 1210us; 954us; 1216us; 954us; 1289us; 1394us; 1303us; 954us; 1310us; 954us; 1335us; 954us; 1342us; 954us; 1343us; 954us; 1349us; 1394us; 1355us; 954us; 1356us; 954us; 1357us; 954us; 1373us; 954us; 1383us; 1394us; 1399us; 954us; 1505us; 954us; 1510us; 954us; 98us; 65535us; 70us; 73us; 146us; 148us; 152us; 154us; 156us; 158us; 160us; 162us; 231us; 234us; 271us; 272us; 278us; 280us; 281us; 283us; 288us; 290us; 298us; 1830us; 300us; 1830us; 357us; 360us; 370us; 372us; 376us; 377us; 380us; 381us; 481us; 1830us; 496us; 498us; 520us; 521us; 529us; 531us; 538us; 540us; 696us; 706us; 699us; 706us; 746us; 750us; 752us; 754us; 816us; 823us; 817us; 820us; 861us; 898us; 892us; 898us; 893us; 895us; 900us; 906us; 901us; 903us; 918us; 1059us; 944us; 946us; 1000us; 1002us; 1004us; 1006us; 1008us; 1010us; 1013us; 1017us; 1014us; 1016us; 1026us; 1035us; 1027us; 1034us; 1029us; 1031us; 1037us; 1830us; 1038us; 1830us; 1039us; 1830us; 1040us; 1830us; 1046us; 1053us; 1047us; 1052us; 1048us; 1050us; 1072us; 706us; 1083us; 706us; 1115us; 1222us; 1138us; 1298us; 1149us; 1150us; 1187us; 1189us; 1211us; 1213us; 1217us; 1219us; 1223us; 1830us; 1225us; 1830us; 1277us; 1302us; 1280us; 1302us; 1289us; 1294us; 1290us; 1292us; 1310us; 1318us; 1311us; 1313us; 1314us; 1316us; 1336us; 1338us; 1342us; 1348us; 1343us; 1348us; 1344us; 1346us; 1349us; 1354us; 1350us; 1352us; 1355us; 1368us; 1356us; 1368us; 1357us; 1368us; 1359us; 1824us; 1383us; 1388us; 1384us; 1386us; 1396us; 1398us; 1401us; 1830us; 1462us; 1830us; 1463us; 1830us; 1496us; 1501us; 1497us; 1499us; 1510us; 1516us; 1511us; 1513us; 1580us; 1637us; 1607us; 1660us; 1626us; 1629us; 1627us; 1629us; 1631us; 1638us; 1632us; 1636us; 1633us; 1635us; 1650us; 1830us; 1655us; 1666us; 1657us; 1830us; 1662us; 1830us; 1704us; 1830us; 109us; 65535us; 6us; 959us; 31us; 32us; 106us; 107us; 108us; 109us; 226us; 241us; 240us; 241us; 262us; 959us; 403us; 959us; 408us; 959us; 443us; 959us; 459us; 959us; 692us; 959us; 698us; 959us; 747us; 959us; 751us; 959us; 761us; 959us; 943us; 959us; 948us; 959us; 962us; 959us; 964us; 959us; 967us; 959us; 970us; 959us; 987us; 959us; 990us; 959us; 993us; 959us; 999us; 959us; 1003us; 959us; 1007us; 959us; 1011us; 959us; 1013us; 1014us; 1018us; 1019us; 1020us; 1021us; 1022us; 951us; 1024us; 951us; 1026us; 1027us; 1028us; 959us; 1039us; 959us; 1047us; 959us; 1054us; 959us; 1060us; 1061us; 1062us; 1063us; 1065us; 959us; 1068us; 959us; 1071us; 959us; 1074us; 959us; 1077us; 959us; 1080us; 959us; 1082us; 959us; 1087us; 1088us; 1089us; 959us; 1133us; 1091us; 1135us; 951us; 1139us; 1092us; 1140us; 1093us; 1141us; 1094us; 1142us; 1095us; 1143us; 1096us; 1144us; 1097us; 1145us; 1098us; 1146us; 1099us; 1147us; 1100us; 1148us; 1101us; 1149us; 1102us; 1151us; 1103us; 1152us; 1104us; 1153us; 1105us; 1154us; 1106us; 1155us; 1107us; 1156us; 1108us; 1157us; 1109us; 1158us; 1110us; 1159us; 1111us; 1181us; 959us; 1203us; 1112us; 1204us; 959us; 1208us; 1113us; 1210us; 959us; 1214us; 1114us; 1216us; 959us; 1220us; 1115us; 1223us; 1116us; 1225us; 1118us; 1289us; 961us; 1296us; 1117us; 1303us; 959us; 1310us; 960us; 1320us; 1119us; 1322us; 1120us; 1323us; 1121us; 1335us; 959us; 1342us; 959us; 1343us; 959us; 1349us; 961us; 1355us; 959us; 1356us; 959us; 1357us; 959us; 1373us; 959us; 1383us; 961us; 1396us; 1124us; 1397us; 1125us; 1399us; 959us; 1401us; 1122us; 1405us; 1123us; 1406us; 1126us; 1433us; 951us; 1438us; 951us; 1463us; 951us; 1505us; 959us; 1510us; 959us; 1us; 65535us; 1285us; 1286us; 3us; 65535us; 1000us; 1001us; 1004us; 1005us; 1008us; 1009us; 4us; 65535us; 1184us; 1185us; 1186us; 1187us; 1521us; 1522us; 1523us; 1524us; 6us; 65535us; 1184us; 1196us; 1186us; 1196us; 1191us; 1196us; 1198us; 1196us; 1521us; 1196us; 1523us; 1196us; 6us; 65535us; 1184us; 1190us; 1186us; 1190us; 1191us; 1192us; 1198us; 1199us; 1521us; 1190us; 1523us; 1190us; 1us; 65535us; 919us; 1195us; 1us; 65535us; 1196us; 1197us; 2us; 65535us; 1014us; 1015us; 1115us; 1221us; 2us; 65535us; 1014us; 1206us; 1115us; 1206us; 1us; 65535us; 1206us; 1207us; 109us; 65535us; 6us; 1137us; 31us; 1137us; 106us; 1137us; 108us; 1137us; 226us; 1137us; 240us; 1137us; 262us; 1137us; 403us; 1137us; 408us; 1137us; 443us; 1137us; 459us; 1137us; 692us; 1137us; 698us; 1137us; 747us; 1137us; 751us; 1137us; 761us; 1137us; 943us; 1137us; 948us; 1137us; 962us; 1137us; 964us; 1137us; 967us; 1137us; 970us; 1137us; 987us; 1137us; 990us; 1137us; 993us; 1137us; 999us; 1137us; 1003us; 1137us; 1007us; 1137us; 1011us; 1137us; 1013us; 1137us; 1018us; 1137us; 1020us; 1137us; 1022us; 1137us; 1024us; 1137us; 1026us; 1137us; 1028us; 1137us; 1039us; 1137us; 1047us; 1137us; 1054us; 1137us; 1060us; 1137us; 1062us; 1137us; 1065us; 1137us; 1068us; 1137us; 1071us; 1137us; 1074us; 1137us; 1077us; 1137us; 1080us; 1137us; 1082us; 1137us; 1087us; 1137us; 1089us; 1137us; 1133us; 1137us; 1135us; 1137us; 1139us; 1137us; 1140us; 1137us; 1141us; 1137us; 1142us; 1137us; 1143us; 1137us; 1144us; 1137us; 1145us; 1137us; 1146us; 1137us; 1147us; 1137us; 1148us; 1137us; 1149us; 1137us; 1151us; 1137us; 1152us; 1137us; 1153us; 1137us; 1154us; 1137us; 1155us; 1137us; 1156us; 1137us; 1157us; 1137us; 1158us; 1137us; 1159us; 1137us; 1181us; 1137us; 1203us; 1137us; 1204us; 1137us; 1208us; 1137us; 1210us; 1137us; 1214us; 1137us; 1216us; 1137us; 1220us; 1137us; 1223us; 1137us; 1225us; 1137us; 1289us; 1137us; 1296us; 1138us; 1303us; 1137us; 1310us; 1137us; 1320us; 1137us; 1322us; 1137us; 1323us; 1137us; 1335us; 1137us; 1342us; 1137us; 1343us; 1137us; 1349us; 1137us; 1355us; 1137us; 1356us; 1137us; 1357us; 1137us; 1373us; 1137us; 1383us; 1137us; 1396us; 1137us; 1397us; 1137us; 1399us; 1137us; 1401us; 1137us; 1405us; 1137us; 1406us; 1137us; 1433us; 1137us; 1438us; 1137us; 1463us; 1137us; 1505us; 1137us; 1510us; 1137us; 123us; 65535us; 6us; 1134us; 31us; 1134us; 106us; 1134us; 108us; 1134us; 226us; 1134us; 240us; 1134us; 262us; 1134us; 403us; 1134us; 408us; 1134us; 443us; 1134us; 459us; 1134us; 692us; 1134us; 698us; 1134us; 747us; 1134us; 751us; 1134us; 761us; 1134us; 943us; 1134us; 948us; 1134us; 962us; 1134us; 964us; 1134us; 967us; 1134us; 970us; 1134us; 987us; 1134us; 990us; 1134us; 993us; 1134us; 999us; 1134us; 1003us; 1134us; 1007us; 1134us; 1011us; 1134us; 1013us; 1134us; 1018us; 1134us; 1020us; 1134us; 1022us; 1134us; 1024us; 1134us; 1026us; 1134us; 1028us; 1134us; 1039us; 1134us; 1047us; 1134us; 1054us; 1134us; 1060us; 1134us; 1062us; 1134us; 1065us; 1134us; 1068us; 1134us; 1071us; 1134us; 1074us; 1134us; 1077us; 1134us; 1080us; 1134us; 1082us; 1134us; 1087us; 1134us; 1089us; 1134us; 1133us; 1134us; 1135us; 1134us; 1139us; 1134us; 1140us; 1134us; 1141us; 1134us; 1142us; 1134us; 1143us; 1134us; 1144us; 1134us; 1145us; 1134us; 1146us; 1134us; 1147us; 1134us; 1148us; 1134us; 1149us; 1134us; 1151us; 1134us; 1152us; 1134us; 1153us; 1134us; 1154us; 1134us; 1155us; 1134us; 1156us; 1134us; 1157us; 1134us; 1158us; 1134us; 1159us; 1134us; 1181us; 1134us; 1203us; 1134us; 1204us; 1134us; 1208us; 1134us; 1210us; 1134us; 1214us; 1134us; 1216us; 1134us; 1220us; 1134us; 1223us; 1134us; 1225us; 1134us; 1227us; 1229us; 1228us; 1229us; 1230us; 1232us; 1231us; 1232us; 1233us; 1235us; 1234us; 1235us; 1236us; 1238us; 1237us; 1238us; 1239us; 1241us; 1240us; 1241us; 1242us; 1244us; 1243us; 1244us; 1255us; 1256us; 1257us; 1258us; 1289us; 1134us; 1296us; 1134us; 1303us; 1134us; 1310us; 1134us; 1320us; 1134us; 1322us; 1134us; 1323us; 1134us; 1335us; 1134us; 1342us; 1134us; 1343us; 1134us; 1349us; 1134us; 1355us; 1134us; 1356us; 1134us; 1357us; 1134us; 1373us; 1134us; 1383us; 1134us; 1396us; 1134us; 1397us; 1134us; 1399us; 1134us; 1401us; 1134us; 1405us; 1134us; 1406us; 1134us; 1433us; 1134us; 1438us; 1134us; 1463us; 1134us; 1505us; 1134us; 1510us; 1134us; 124us; 65535us; 6us; 1259us; 31us; 1259us; 106us; 1259us; 108us; 1259us; 226us; 1259us; 240us; 1259us; 262us; 1259us; 403us; 1259us; 408us; 1259us; 443us; 1259us; 459us; 1259us; 692us; 1259us; 698us; 1259us; 747us; 1259us; 751us; 1259us; 761us; 1259us; 943us; 1259us; 948us; 1259us; 962us; 1259us; 964us; 1259us; 967us; 1259us; 970us; 1259us; 987us; 1259us; 990us; 1259us; 993us; 1259us; 999us; 1259us; 1003us; 1259us; 1007us; 1259us; 1011us; 1259us; 1013us; 1259us; 1018us; 1259us; 1020us; 1259us; 1022us; 1259us; 1024us; 1259us; 1026us; 1259us; 1028us; 1259us; 1039us; 1259us; 1047us; 1259us; 1054us; 1259us; 1060us; 1259us; 1062us; 1259us; 1065us; 1259us; 1068us; 1259us; 1071us; 1259us; 1074us; 1259us; 1077us; 1259us; 1080us; 1259us; 1082us; 1259us; 1087us; 1259us; 1089us; 1259us; 1133us; 1259us; 1135us; 1259us; 1139us; 1259us; 1140us; 1259us; 1141us; 1259us; 1142us; 1259us; 1143us; 1259us; 1144us; 1259us; 1145us; 1259us; 1146us; 1259us; 1147us; 1259us; 1148us; 1259us; 1149us; 1259us; 1151us; 1259us; 1152us; 1259us; 1153us; 1259us; 1154us; 1259us; 1155us; 1259us; 1156us; 1259us; 1157us; 1259us; 1158us; 1259us; 1159us; 1259us; 1181us; 1259us; 1203us; 1259us; 1204us; 1259us; 1208us; 1259us; 1210us; 1259us; 1214us; 1259us; 1216us; 1259us; 1220us; 1259us; 1223us; 1259us; 1225us; 1259us; 1227us; 1259us; 1228us; 1259us; 1230us; 1259us; 1231us; 1259us; 1233us; 1259us; 1234us; 1259us; 1236us; 1259us; 1237us; 1259us; 1239us; 1259us; 1240us; 1259us; 1242us; 1259us; 1243us; 1259us; 1255us; 1259us; 1257us; 1259us; 1289us; 1259us; 1296us; 1259us; 1303us; 1259us; 1310us; 1259us; 1320us; 1259us; 1322us; 1259us; 1323us; 1259us; 1335us; 1259us; 1342us; 1259us; 1343us; 1259us; 1349us; 1259us; 1355us; 1259us; 1356us; 1259us; 1357us; 1259us; 1373us; 1259us; 1383us; 1260us; 1396us; 1259us; 1397us; 1259us; 1399us; 1259us; 1401us; 1259us; 1405us; 1259us; 1406us; 1259us; 1433us; 1259us; 1438us; 1259us; 1463us; 1259us; 1496us; 1261us; 1505us; 1259us; 1510us; 1259us; 4us; 65535us; 1259us; 1262us; 1260us; 1262us; 1261us; 1262us; 1413us; 1416us; 134us; 65535us; 6us; 1263us; 31us; 1263us; 106us; 1263us; 108us; 1263us; 226us; 1263us; 240us; 1263us; 262us; 1263us; 403us; 1263us; 408us; 1263us; 443us; 1263us; 459us; 1263us; 692us; 1263us; 698us; 1263us; 747us; 1263us; 751us; 1263us; 761us; 1263us; 943us; 1263us; 948us; 1263us; 962us; 1263us; 964us; 1263us; 967us; 1263us; 970us; 1263us; 987us; 1263us; 990us; 1263us; 993us; 1263us; 999us; 1263us; 1003us; 1263us; 1007us; 1263us; 1011us; 1263us; 1013us; 1263us; 1018us; 1263us; 1020us; 1263us; 1022us; 1263us; 1024us; 1263us; 1026us; 1263us; 1028us; 1263us; 1039us; 1263us; 1047us; 1263us; 1054us; 1263us; 1060us; 1263us; 1062us; 1263us; 1065us; 1263us; 1068us; 1263us; 1071us; 1263us; 1074us; 1263us; 1077us; 1263us; 1080us; 1263us; 1082us; 1263us; 1087us; 1263us; 1089us; 1263us; 1133us; 1263us; 1135us; 1263us; 1139us; 1263us; 1140us; 1263us; 1141us; 1263us; 1142us; 1263us; 1143us; 1263us; 1144us; 1263us; 1145us; 1263us; 1146us; 1263us; 1147us; 1263us; 1148us; 1263us; 1149us; 1263us; 1151us; 1263us; 1152us; 1263us; 1153us; 1263us; 1154us; 1263us; 1155us; 1263us; 1156us; 1263us; 1157us; 1263us; 1158us; 1263us; 1159us; 1263us; 1181us; 1263us; 1203us; 1263us; 1204us; 1263us; 1208us; 1263us; 1210us; 1263us; 1214us; 1263us; 1216us; 1263us; 1220us; 1263us; 1223us; 1263us; 1225us; 1263us; 1227us; 1263us; 1228us; 1263us; 1230us; 1263us; 1231us; 1263us; 1233us; 1263us; 1234us; 1263us; 1236us; 1263us; 1237us; 1263us; 1239us; 1263us; 1240us; 1263us; 1242us; 1263us; 1243us; 1263us; 1255us; 1263us; 1257us; 1263us; 1259us; 1266us; 1260us; 1266us; 1261us; 1266us; 1264us; 1265us; 1271us; 1267us; 1272us; 1268us; 1275us; 1269us; 1276us; 1269us; 1289us; 1263us; 1296us; 1263us; 1303us; 1263us; 1310us; 1263us; 1320us; 1263us; 1322us; 1263us; 1323us; 1263us; 1335us; 1263us; 1342us; 1263us; 1343us; 1263us; 1349us; 1263us; 1355us; 1263us; 1356us; 1263us; 1357us; 1263us; 1373us; 1263us; 1383us; 1263us; 1396us; 1263us; 1397us; 1263us; 1399us; 1263us; 1401us; 1263us; 1405us; 1263us; 1406us; 1263us; 1413us; 1266us; 1433us; 1263us; 1438us; 1263us; 1463us; 1263us; 1496us; 1263us; 1505us; 1263us; 1510us; 1263us; 1641us; 1270us; 2us; 65535us; 1277us; 1278us; 1280us; 1281us; 2us; 65535us; 1310us; 1314us; 1320us; 1321us; 2us; 65535us; 1310us; 1319us; 1320us; 1319us; 141us; 65535us; 6us; 1299us; 31us; 1299us; 106us; 1299us; 108us; 1299us; 226us; 1299us; 240us; 1299us; 262us; 1299us; 312us; 1417us; 316us; 1417us; 321us; 1417us; 403us; 1299us; 408us; 1299us; 443us; 1299us; 459us; 1299us; 484us; 485us; 692us; 1299us; 698us; 1299us; 747us; 1299us; 751us; 1299us; 761us; 1299us; 943us; 1299us; 948us; 1299us; 962us; 1299us; 964us; 1299us; 967us; 1299us; 970us; 1299us; 987us; 1299us; 990us; 1299us; 993us; 1299us; 999us; 1299us; 1003us; 1299us; 1007us; 1299us; 1011us; 1299us; 1013us; 1299us; 1018us; 1299us; 1020us; 1299us; 1022us; 1299us; 1024us; 1299us; 1026us; 1299us; 1028us; 1299us; 1039us; 1299us; 1047us; 1299us; 1054us; 1299us; 1060us; 1299us; 1062us; 1299us; 1065us; 1299us; 1068us; 1299us; 1071us; 1299us; 1074us; 1299us; 1077us; 1299us; 1080us; 1299us; 1082us; 1299us; 1087us; 1299us; 1089us; 1299us; 1133us; 1299us; 1135us; 1299us; 1139us; 1299us; 1140us; 1299us; 1141us; 1299us; 1142us; 1299us; 1143us; 1299us; 1144us; 1299us; 1145us; 1299us; 1146us; 1299us; 1147us; 1299us; 1148us; 1299us; 1149us; 1299us; 1151us; 1299us; 1152us; 1299us; 1153us; 1299us; 1154us; 1299us; 1155us; 1299us; 1156us; 1299us; 1157us; 1299us; 1158us; 1299us; 1159us; 1299us; 1181us; 1299us; 1203us; 1299us; 1204us; 1299us; 1208us; 1299us; 1210us; 1299us; 1214us; 1299us; 1216us; 1299us; 1220us; 1299us; 1223us; 1299us; 1225us; 1299us; 1227us; 1299us; 1228us; 1299us; 1230us; 1299us; 1231us; 1299us; 1233us; 1299us; 1234us; 1299us; 1236us; 1299us; 1237us; 1299us; 1239us; 1299us; 1240us; 1299us; 1242us; 1299us; 1243us; 1299us; 1249us; 1251us; 1250us; 1252us; 1255us; 1299us; 1257us; 1299us; 1259us; 1299us; 1260us; 1299us; 1261us; 1299us; 1264us; 1299us; 1271us; 1299us; 1272us; 1299us; 1275us; 1299us; 1276us; 1299us; 1289us; 1299us; 1296us; 1299us; 1303us; 1299us; 1310us; 1299us; 1320us; 1299us; 1322us; 1299us; 1323us; 1299us; 1335us; 1299us; 1342us; 1299us; 1343us; 1299us; 1349us; 1299us; 1355us; 1299us; 1356us; 1299us; 1357us; 1299us; 1373us; 1299us; 1383us; 1299us; 1396us; 1299us; 1397us; 1299us; 1399us; 1299us; 1401us; 1299us; 1405us; 1299us; 1406us; 1299us; 1413us; 1299us; 1428us; 1417us; 1433us; 1299us; 1438us; 1299us; 1463us; 1299us; 1496us; 1299us; 1505us; 1299us; 1510us; 1299us; 1641us; 1299us; 141us; 65535us; 6us; 1334us; 31us; 1334us; 106us; 1334us; 108us; 1334us; 226us; 1334us; 240us; 1334us; 262us; 1334us; 312us; 1334us; 316us; 1334us; 321us; 1334us; 403us; 1334us; 408us; 1334us; 443us; 1334us; 459us; 1334us; 484us; 1334us; 692us; 1334us; 698us; 1334us; 747us; 1334us; 751us; 1334us; 761us; 1334us; 943us; 1334us; 948us; 1334us; 962us; 1334us; 964us; 1334us; 967us; 1334us; 970us; 1334us; 987us; 1334us; 990us; 1334us; 993us; 1334us; 999us; 1334us; 1003us; 1334us; 1007us; 1334us; 1011us; 1334us; 1013us; 1334us; 1018us; 1334us; 1020us; 1334us; 1022us; 1334us; 1024us; 1334us; 1026us; 1334us; 1028us; 1334us; 1039us; 1334us; 1047us; 1334us; 1054us; 1334us; 1060us; 1334us; 1062us; 1334us; 1065us; 1334us; 1068us; 1334us; 1071us; 1334us; 1074us; 1334us; 1077us; 1334us; 1080us; 1334us; 1082us; 1334us; 1087us; 1334us; 1089us; 1334us; 1133us; 1334us; 1135us; 1334us; 1139us; 1334us; 1140us; 1334us; 1141us; 1334us; 1142us; 1334us; 1143us; 1334us; 1144us; 1334us; 1145us; 1334us; 1146us; 1334us; 1147us; 1334us; 1148us; 1334us; 1149us; 1334us; 1151us; 1334us; 1152us; 1334us; 1153us; 1334us; 1154us; 1334us; 1155us; 1334us; 1156us; 1334us; 1157us; 1334us; 1158us; 1334us; 1159us; 1334us; 1181us; 1334us; 1203us; 1334us; 1204us; 1334us; 1208us; 1334us; 1210us; 1334us; 1214us; 1334us; 1216us; 1334us; 1220us; 1334us; 1223us; 1334us; 1225us; 1334us; 1227us; 1334us; 1228us; 1334us; 1230us; 1334us; 1231us; 1334us; 1233us; 1334us; 1234us; 1334us; 1236us; 1334us; 1237us; 1334us; 1239us; 1334us; 1240us; 1334us; 1242us; 1334us; 1243us; 1334us; 1249us; 1334us; 1250us; 1334us; 1255us; 1334us; 1257us; 1334us; 1259us; 1334us; 1260us; 1334us; 1261us; 1334us; 1264us; 1334us; 1271us; 1334us; 1272us; 1334us; 1275us; 1334us; 1276us; 1334us; 1289us; 1334us; 1296us; 1334us; 1303us; 1334us; 1310us; 1334us; 1320us; 1334us; 1322us; 1334us; 1323us; 1334us; 1335us; 1334us; 1342us; 1334us; 1343us; 1334us; 1349us; 1334us; 1355us; 1334us; 1356us; 1334us; 1357us; 1334us; 1373us; 1334us; 1383us; 1334us; 1396us; 1334us; 1397us; 1334us; 1399us; 1334us; 1401us; 1334us; 1405us; 1334us; 1406us; 1334us; 1413us; 1334us; 1428us; 1334us; 1433us; 1334us; 1438us; 1334us; 1463us; 1334us; 1496us; 1334us; 1505us; 1334us; 1510us; 1334us; 1641us; 1334us; 183us; 65535us; 6us; 1332us; 31us; 1332us; 106us; 1332us; 108us; 1332us; 226us; 1332us; 240us; 1332us; 262us; 1332us; 312us; 1332us; 316us; 1332us; 321us; 1332us; 400us; 871us; 403us; 1332us; 405us; 871us; 408us; 1332us; 440us; 871us; 443us; 1332us; 459us; 1332us; 484us; 1332us; 692us; 1332us; 698us; 1332us; 744us; 871us; 747us; 1332us; 751us; 1332us; 761us; 1332us; 834us; 871us; 835us; 871us; 839us; 871us; 840us; 871us; 841us; 871us; 842us; 871us; 849us; 871us; 852us; 871us; 854us; 871us; 856us; 871us; 861us; 871us; 865us; 871us; 867us; 871us; 869us; 871us; 877us; 871us; 880us; 871us; 892us; 871us; 900us; 871us; 922us; 871us; 927us; 871us; 928us; 871us; 930us; 871us; 931us; 871us; 932us; 871us; 933us; 871us; 939us; 871us; 941us; 871us; 943us; 1332us; 948us; 1332us; 962us; 1332us; 964us; 1332us; 967us; 1332us; 970us; 1332us; 987us; 1332us; 990us; 1332us; 993us; 1332us; 999us; 1332us; 1003us; 1332us; 1007us; 1332us; 1011us; 1332us; 1013us; 1332us; 1018us; 1332us; 1020us; 1332us; 1022us; 1332us; 1024us; 1332us; 1026us; 1332us; 1028us; 1332us; 1037us; 871us; 1039us; 1332us; 1047us; 1332us; 1054us; 1332us; 1060us; 1332us; 1062us; 1332us; 1064us; 871us; 1065us; 1332us; 1068us; 1332us; 1070us; 871us; 1071us; 1332us; 1074us; 1332us; 1077us; 1332us; 1080us; 1332us; 1082us; 1332us; 1087us; 1332us; 1089us; 1332us; 1133us; 1332us; 1135us; 1332us; 1139us; 1332us; 1140us; 1332us; 1141us; 1332us; 1142us; 1332us; 1143us; 1332us; 1144us; 1332us; 1145us; 1332us; 1146us; 1332us; 1147us; 1332us; 1148us; 1332us; 1149us; 1332us; 1151us; 1332us; 1152us; 1332us; 1153us; 1332us; 1154us; 1332us; 1155us; 1332us; 1156us; 1332us; 1157us; 1332us; 1158us; 1332us; 1159us; 1332us; 1181us; 1332us; 1184us; 871us; 1186us; 871us; 1191us; 871us; 1198us; 871us; 1203us; 1332us; 1204us; 1332us; 1208us; 1332us; 1210us; 1332us; 1214us; 1332us; 1216us; 1332us; 1220us; 1332us; 1223us; 1332us; 1225us; 1332us; 1227us; 1332us; 1228us; 1332us; 1230us; 1332us; 1231us; 1332us; 1233us; 1332us; 1234us; 1332us; 1236us; 1332us; 1237us; 1332us; 1239us; 1332us; 1240us; 1332us; 1242us; 1332us; 1243us; 1332us; 1249us; 1332us; 1250us; 1332us; 1255us; 1332us; 1257us; 1332us; 1259us; 1332us; 1260us; 1332us; 1261us; 1332us; 1264us; 1332us; 1271us; 1332us; 1272us; 1332us; 1275us; 1332us; 1276us; 1332us; 1289us; 1332us; 1296us; 1332us; 1303us; 1332us; 1310us; 1332us; 1320us; 1332us; 1322us; 1332us; 1323us; 1332us; 1335us; 1332us; 1342us; 1332us; 1343us; 1332us; 1349us; 1332us; 1355us; 1332us; 1356us; 1332us; 1357us; 1332us; 1373us; 1332us; 1383us; 1332us; 1396us; 1332us; 1397us; 1332us; 1399us; 1332us; 1401us; 1332us; 1405us; 1332us; 1406us; 1332us; 1413us; 1332us; 1428us; 1332us; 1433us; 1332us; 1438us; 1332us; 1463us; 1332us; 1496us; 1332us; 1503us; 871us; 1505us; 1332us; 1508us; 871us; 1510us; 1332us; 1521us; 871us; 1523us; 871us; 1641us; 1332us; 141us; 65535us; 6us; 1333us; 31us; 1333us; 106us; 1333us; 108us; 1333us; 226us; 1333us; 240us; 1333us; 262us; 1333us; 312us; 1333us; 316us; 1333us; 321us; 1333us; 403us; 1333us; 408us; 1333us; 443us; 1333us; 459us; 1333us; 484us; 1333us; 692us; 1333us; 698us; 1333us; 747us; 1333us; 751us; 1333us; 761us; 1333us; 943us; 1333us; 948us; 1333us; 962us; 1333us; 964us; 1333us; 967us; 1333us; 970us; 1333us; 987us; 1333us; 990us; 1333us; 993us; 1333us; 999us; 1333us; 1003us; 1333us; 1007us; 1333us; 1011us; 1333us; 1013us; 1333us; 1018us; 1333us; 1020us; 1333us; 1022us; 1333us; 1024us; 1333us; 1026us; 1333us; 1028us; 1333us; 1039us; 1333us; 1047us; 1333us; 1054us; 1333us; 1060us; 1333us; 1062us; 1333us; 1065us; 1333us; 1068us; 1333us; 1071us; 1333us; 1074us; 1333us; 1077us; 1333us; 1080us; 1333us; 1082us; 1333us; 1087us; 1333us; 1089us; 1333us; 1133us; 1333us; 1135us; 1333us; 1139us; 1333us; 1140us; 1333us; 1141us; 1333us; 1142us; 1333us; 1143us; 1333us; 1144us; 1333us; 1145us; 1333us; 1146us; 1333us; 1147us; 1333us; 1148us; 1333us; 1149us; 1333us; 1151us; 1333us; 1152us; 1333us; 1153us; 1333us; 1154us; 1333us; 1155us; 1333us; 1156us; 1333us; 1157us; 1333us; 1158us; 1333us; 1159us; 1333us; 1181us; 1333us; 1203us; 1333us; 1204us; 1333us; 1208us; 1333us; 1210us; 1333us; 1214us; 1333us; 1216us; 1333us; 1220us; 1333us; 1223us; 1333us; 1225us; 1333us; 1227us; 1333us; 1228us; 1333us; 1230us; 1333us; 1231us; 1333us; 1233us; 1333us; 1234us; 1333us; 1236us; 1333us; 1237us; 1333us; 1239us; 1333us; 1240us; 1333us; 1242us; 1333us; 1243us; 1333us; 1249us; 1333us; 1250us; 1333us; 1255us; 1333us; 1257us; 1333us; 1259us; 1333us; 1260us; 1333us; 1261us; 1333us; 1264us; 1333us; 1271us; 1333us; 1272us; 1333us; 1275us; 1333us; 1276us; 1333us; 1289us; 1333us; 1296us; 1333us; 1303us; 1333us; 1310us; 1333us; 1320us; 1333us; 1322us; 1333us; 1323us; 1333us; 1335us; 1333us; 1342us; 1333us; 1343us; 1333us; 1349us; 1333us; 1355us; 1333us; 1356us; 1333us; 1357us; 1333us; 1373us; 1333us; 1383us; 1333us; 1396us; 1333us; 1397us; 1333us; 1399us; 1333us; 1401us; 1333us; 1405us; 1333us; 1406us; 1333us; 1413us; 1333us; 1428us; 1333us; 1433us; 1333us; 1438us; 1333us; 1463us; 1333us; 1496us; 1333us; 1505us; 1333us; 1510us; 1333us; 1641us; 1333us; 141us; 65535us; 6us; 1326us; 31us; 1326us; 106us; 1326us; 108us; 1326us; 226us; 1326us; 240us; 1326us; 262us; 1326us; 312us; 1326us; 316us; 1326us; 321us; 1326us; 403us; 1326us; 408us; 1326us; 443us; 1326us; 459us; 1326us; 484us; 1326us; 692us; 1326us; 698us; 1326us; 747us; 1326us; 751us; 1326us; 761us; 1326us; 943us; 1326us; 948us; 1326us; 962us; 1326us; 964us; 1326us; 967us; 1326us; 970us; 1326us; 987us; 1326us; 990us; 1326us; 993us; 1326us; 999us; 1326us; 1003us; 1326us; 1007us; 1326us; 1011us; 1326us; 1013us; 1326us; 1018us; 1326us; 1020us; 1326us; 1022us; 1326us; 1024us; 1326us; 1026us; 1326us; 1028us; 1326us; 1039us; 1326us; 1047us; 1326us; 1054us; 1326us; 1060us; 1326us; 1062us; 1326us; 1065us; 1326us; 1068us; 1326us; 1071us; 1326us; 1074us; 1326us; 1077us; 1326us; 1080us; 1326us; 1082us; 1326us; 1087us; 1326us; 1089us; 1326us; 1133us; 1326us; 1135us; 1326us; 1139us; 1326us; 1140us; 1326us; 1141us; 1326us; 1142us; 1326us; 1143us; 1326us; 1144us; 1326us; 1145us; 1326us; 1146us; 1326us; 1147us; 1326us; 1148us; 1326us; 1149us; 1326us; 1151us; 1326us; 1152us; 1326us; 1153us; 1326us; 1154us; 1326us; 1155us; 1326us; 1156us; 1326us; 1157us; 1326us; 1158us; 1326us; 1159us; 1326us; 1181us; 1326us; 1203us; 1326us; 1204us; 1326us; 1208us; 1326us; 1210us; 1326us; 1214us; 1326us; 1216us; 1326us; 1220us; 1326us; 1223us; 1326us; 1225us; 1326us; 1227us; 1326us; 1228us; 1326us; 1230us; 1326us; 1231us; 1326us; 1233us; 1326us; 1234us; 1326us; 1236us; 1326us; 1237us; 1326us; 1239us; 1326us; 1240us; 1326us; 1242us; 1326us; 1243us; 1326us; 1249us; 1326us; 1250us; 1326us; 1255us; 1326us; 1257us; 1326us; 1259us; 1326us; 1260us; 1326us; 1261us; 1326us; 1264us; 1326us; 1271us; 1326us; 1272us; 1326us; 1275us; 1326us; 1276us; 1326us; 1289us; 1326us; 1296us; 1326us; 1303us; 1326us; 1310us; 1326us; 1320us; 1326us; 1322us; 1326us; 1323us; 1326us; 1335us; 1326us; 1342us; 1326us; 1343us; 1326us; 1349us; 1326us; 1355us; 1326us; 1356us; 1326us; 1357us; 1326us; 1373us; 1326us; 1383us; 1326us; 1396us; 1326us; 1397us; 1326us; 1399us; 1326us; 1401us; 1326us; 1405us; 1326us; 1406us; 1326us; 1413us; 1326us; 1428us; 1326us; 1433us; 1326us; 1438us; 1326us; 1463us; 1326us; 1496us; 1326us; 1505us; 1326us; 1510us; 1326us; 1641us; 1326us; 3us; 65535us; 1355us; 1359us; 1356us; 1359us; 1357us; 1359us; 3us; 65535us; 1355us; 1369us; 1356us; 1369us; 1357us; 1369us; 1us; 65535us; 1356us; 1379us; 141us; 65535us; 6us; 1327us; 31us; 1327us; 106us; 1327us; 108us; 1327us; 226us; 1327us; 240us; 1327us; 262us; 1327us; 312us; 1327us; 316us; 1327us; 321us; 1327us; 403us; 1327us; 408us; 1327us; 443us; 1327us; 459us; 1327us; 484us; 1327us; 692us; 1327us; 698us; 1327us; 747us; 1327us; 751us; 1327us; 761us; 1327us; 943us; 1327us; 948us; 1327us; 962us; 1327us; 964us; 1327us; 967us; 1327us; 970us; 1327us; 987us; 1327us; 990us; 1327us; 993us; 1327us; 999us; 1327us; 1003us; 1327us; 1007us; 1327us; 1011us; 1327us; 1013us; 1327us; 1018us; 1327us; 1020us; 1327us; 1022us; 1327us; 1024us; 1327us; 1026us; 1327us; 1028us; 1327us; 1039us; 1327us; 1047us; 1327us; 1054us; 1327us; 1060us; 1327us; 1062us; 1327us; 1065us; 1327us; 1068us; 1327us; 1071us; 1327us; 1074us; 1327us; 1077us; 1327us; 1080us; 1327us; 1082us; 1327us; 1087us; 1327us; 1089us; 1327us; 1133us; 1327us; 1135us; 1327us; 1139us; 1327us; 1140us; 1327us; 1141us; 1327us; 1142us; 1327us; 1143us; 1327us; 1144us; 1327us; 1145us; 1327us; 1146us; 1327us; 1147us; 1327us; 1148us; 1327us; 1149us; 1327us; 1151us; 1327us; 1152us; 1327us; 1153us; 1327us; 1154us; 1327us; 1155us; 1327us; 1156us; 1327us; 1157us; 1327us; 1158us; 1327us; 1159us; 1327us; 1181us; 1327us; 1203us; 1327us; 1204us; 1327us; 1208us; 1327us; 1210us; 1327us; 1214us; 1327us; 1216us; 1327us; 1220us; 1327us; 1223us; 1327us; 1225us; 1327us; 1227us; 1327us; 1228us; 1327us; 1230us; 1327us; 1231us; 1327us; 1233us; 1327us; 1234us; 1327us; 1236us; 1327us; 1237us; 1327us; 1239us; 1327us; 1240us; 1327us; 1242us; 1327us; 1243us; 1327us; 1249us; 1327us; 1250us; 1327us; 1255us; 1327us; 1257us; 1327us; 1259us; 1327us; 1260us; 1327us; 1261us; 1327us; 1264us; 1327us; 1271us; 1327us; 1272us; 1327us; 1275us; 1327us; 1276us; 1327us; 1289us; 1327us; 1296us; 1327us; 1303us; 1327us; 1310us; 1327us; 1320us; 1327us; 1322us; 1327us; 1323us; 1327us; 1335us; 1327us; 1342us; 1327us; 1343us; 1327us; 1349us; 1327us; 1355us; 1327us; 1356us; 1327us; 1357us; 1327us; 1373us; 1327us; 1383us; 1327us; 1396us; 1327us; 1397us; 1327us; 1399us; 1327us; 1401us; 1327us; 1405us; 1327us; 1406us; 1327us; 1413us; 1327us; 1428us; 1327us; 1433us; 1327us; 1438us; 1327us; 1463us; 1327us; 1496us; 1327us; 1505us; 1327us; 1510us; 1327us; 1641us; 1327us; 1us; 65535us; 1383us; 1384us; 2us; 65535us; 1289us; 1290us; 1349us; 1350us; 3us; 65535us; 1289us; 1393us; 1349us; 1393us; 1383us; 1392us; 5us; 65535us; 1289us; 1395us; 1349us; 1395us; 1383us; 1395us; 1401us; 1402us; 1405us; 1407us; 1us; 65535us; 1085us; 1086us; 1us; 65535us; 1037us; 1038us; 1us; 65535us; 1037us; 1046us; 1us; 65535us; 1123us; 1406us; 3us; 65535us; 1355us; 1376us; 1356us; 1376us; 1357us; 1376us; 1us; 65535us; 1412us; 1413us; 4us; 65535us; 312us; 313us; 316us; 317us; 321us; 322us; 1428us; 1429us; 1us; 65535us; 1411us; 1412us; 1us; 65535us; 1413us; 1414us; 1us; 65535us; 1383us; 1390us; 2us; 65535us; 1383us; 1432us; 1496us; 1497us; 6us; 65535us; 1430us; 1431us; 1435us; 1436us; 1440us; 1441us; 1444us; 1445us; 1446us; 1447us; 1450us; 1451us; 6us; 65535us; 1430us; 1454us; 1435us; 1454us; 1440us; 1454us; 1444us; 1454us; 1446us; 1453us; 1450us; 1454us; 3us; 65535us; 1442us; 1462us; 1446us; 1462us; 1454us; 1462us; 5us; 65535us; 1429us; 1430us; 1434us; 1435us; 1439us; 1440us; 1443us; 1444us; 1449us; 1450us; 3us; 65535us; 1442us; 1443us; 1446us; 1449us; 1454us; 1461us; 1us; 65535us; 1383us; 1391us; 1us; 65535us; 1383us; 1467us; 1us; 65535us; 1489us; 1490us; 2us; 65535us; 1467us; 1468us; 1489us; 1474us; 1us; 65535us; 1471us; 1472us; 4us; 65535us; 1469us; 1470us; 1482us; 1483us; 1484us; 1485us; 1486us; 1487us; 5us; 65535us; 1469us; 1484us; 1471us; 1482us; 1482us; 1484us; 1484us; 1484us; 1486us; 1484us; 141us; 65535us; 6us; 1328us; 31us; 1328us; 106us; 1328us; 108us; 1328us; 226us; 1328us; 240us; 1328us; 262us; 1328us; 312us; 1328us; 316us; 1328us; 321us; 1328us; 403us; 1328us; 408us; 1328us; 443us; 1328us; 459us; 1328us; 484us; 1328us; 692us; 1328us; 698us; 1328us; 747us; 1328us; 751us; 1328us; 761us; 1328us; 943us; 1328us; 948us; 1328us; 962us; 1328us; 964us; 1328us; 967us; 1328us; 970us; 1328us; 987us; 1328us; 990us; 1328us; 993us; 1328us; 999us; 1328us; 1003us; 1328us; 1007us; 1328us; 1011us; 1328us; 1013us; 1328us; 1018us; 1328us; 1020us; 1328us; 1022us; 1328us; 1024us; 1328us; 1026us; 1328us; 1028us; 1328us; 1039us; 1328us; 1047us; 1328us; 1054us; 1328us; 1060us; 1328us; 1062us; 1328us; 1065us; 1328us; 1068us; 1328us; 1071us; 1328us; 1074us; 1328us; 1077us; 1328us; 1080us; 1328us; 1082us; 1328us; 1087us; 1328us; 1089us; 1328us; 1133us; 1328us; 1135us; 1328us; 1139us; 1328us; 1140us; 1328us; 1141us; 1328us; 1142us; 1328us; 1143us; 1328us; 1144us; 1328us; 1145us; 1328us; 1146us; 1328us; 1147us; 1328us; 1148us; 1328us; 1149us; 1328us; 1151us; 1328us; 1152us; 1328us; 1153us; 1328us; 1154us; 1328us; 1155us; 1328us; 1156us; 1328us; 1157us; 1328us; 1158us; 1328us; 1159us; 1328us; 1181us; 1328us; 1203us; 1328us; 1204us; 1328us; 1208us; 1328us; 1210us; 1328us; 1214us; 1328us; 1216us; 1328us; 1220us; 1328us; 1223us; 1328us; 1225us; 1328us; 1227us; 1328us; 1228us; 1328us; 1230us; 1328us; 1231us; 1328us; 1233us; 1328us; 1234us; 1328us; 1236us; 1328us; 1237us; 1328us; 1239us; 1328us; 1240us; 1328us; 1242us; 1328us; 1243us; 1328us; 1249us; 1328us; 1250us; 1328us; 1255us; 1328us; 1257us; 1328us; 1259us; 1328us; 1260us; 1328us; 1261us; 1328us; 1264us; 1328us; 1271us; 1328us; 1272us; 1328us; 1275us; 1328us; 1276us; 1328us; 1289us; 1328us; 1296us; 1328us; 1303us; 1328us; 1310us; 1328us; 1320us; 1328us; 1322us; 1328us; 1323us; 1328us; 1335us; 1328us; 1342us; 1328us; 1343us; 1328us; 1349us; 1328us; 1355us; 1328us; 1356us; 1328us; 1357us; 1328us; 1373us; 1328us; 1383us; 1328us; 1396us; 1328us; 1397us; 1328us; 1399us; 1328us; 1401us; 1328us; 1405us; 1328us; 1406us; 1328us; 1413us; 1328us; 1428us; 1328us; 1433us; 1328us; 1438us; 1328us; 1463us; 1328us; 1496us; 1328us; 1505us; 1328us; 1510us; 1328us; 1641us; 1328us; 143us; 65535us; 6us; 1495us; 31us; 1495us; 106us; 1495us; 108us; 1495us; 226us; 1495us; 240us; 1495us; 262us; 1495us; 312us; 1495us; 316us; 1495us; 321us; 1495us; 403us; 1495us; 408us; 1495us; 443us; 1495us; 459us; 1495us; 484us; 1495us; 692us; 1495us; 698us; 1495us; 747us; 1495us; 751us; 1495us; 761us; 1495us; 943us; 1495us; 948us; 1495us; 962us; 1495us; 964us; 1495us; 967us; 1495us; 970us; 1495us; 987us; 1495us; 990us; 1495us; 993us; 1495us; 999us; 1495us; 1003us; 1495us; 1007us; 1495us; 1011us; 1495us; 1013us; 1495us; 1018us; 1495us; 1020us; 1495us; 1022us; 1495us; 1024us; 1495us; 1026us; 1495us; 1028us; 1495us; 1039us; 1495us; 1047us; 1495us; 1054us; 1495us; 1060us; 1495us; 1062us; 1495us; 1065us; 1495us; 1068us; 1495us; 1071us; 1495us; 1074us; 1495us; 1077us; 1495us; 1080us; 1495us; 1082us; 1495us; 1087us; 1495us; 1089us; 1495us; 1133us; 1495us; 1135us; 1495us; 1139us; 1495us; 1140us; 1495us; 1141us; 1495us; 1142us; 1495us; 1143us; 1495us; 1144us; 1495us; 1145us; 1495us; 1146us; 1495us; 1147us; 1495us; 1148us; 1495us; 1149us; 1495us; 1151us; 1495us; 1152us; 1495us; 1153us; 1495us; 1154us; 1495us; 1155us; 1495us; 1156us; 1495us; 1157us; 1495us; 1158us; 1495us; 1159us; 1495us; 1181us; 1495us; 1203us; 1495us; 1204us; 1495us; 1208us; 1495us; 1210us; 1495us; 1214us; 1495us; 1216us; 1495us; 1220us; 1495us; 1223us; 1495us; 1225us; 1495us; 1227us; 1495us; 1228us; 1495us; 1230us; 1495us; 1231us; 1495us; 1233us; 1495us; 1234us; 1495us; 1236us; 1495us; 1237us; 1495us; 1239us; 1495us; 1240us; 1495us; 1242us; 1495us; 1243us; 1495us; 1249us; 1495us; 1250us; 1495us; 1255us; 1495us; 1257us; 1495us; 1259us; 1495us; 1260us; 1495us; 1261us; 1495us; 1264us; 1495us; 1271us; 1495us; 1272us; 1495us; 1275us; 1495us; 1276us; 1495us; 1289us; 1495us; 1295us; 1494us; 1296us; 1495us; 1303us; 1495us; 1310us; 1495us; 1320us; 1495us; 1322us; 1495us; 1323us; 1495us; 1335us; 1495us; 1342us; 1495us; 1343us; 1495us; 1349us; 1495us; 1355us; 1495us; 1356us; 1495us; 1357us; 1495us; 1373us; 1495us; 1383us; 1495us; 1396us; 1495us; 1397us; 1495us; 1399us; 1495us; 1401us; 1495us; 1405us; 1495us; 1406us; 1495us; 1413us; 1495us; 1428us; 1495us; 1433us; 1495us; 1438us; 1495us; 1463us; 1495us; 1493us; 1494us; 1496us; 1495us; 1505us; 1495us; 1510us; 1495us; 1641us; 1495us; 109us; 65535us; 6us; 998us; 31us; 998us; 106us; 998us; 108us; 998us; 226us; 998us; 240us; 998us; 262us; 998us; 403us; 998us; 408us; 998us; 443us; 998us; 459us; 998us; 692us; 998us; 698us; 998us; 747us; 998us; 751us; 998us; 761us; 998us; 943us; 998us; 948us; 998us; 962us; 998us; 964us; 998us; 967us; 998us; 970us; 998us; 987us; 998us; 990us; 998us; 993us; 998us; 999us; 998us; 1003us; 998us; 1007us; 998us; 1011us; 998us; 1013us; 998us; 1018us; 998us; 1020us; 998us; 1022us; 998us; 1024us; 998us; 1026us; 998us; 1028us; 998us; 1039us; 998us; 1047us; 998us; 1054us; 998us; 1060us; 998us; 1062us; 998us; 1065us; 998us; 1068us; 998us; 1071us; 998us; 1074us; 998us; 1077us; 998us; 1080us; 998us; 1082us; 998us; 1087us; 998us; 1089us; 998us; 1133us; 998us; 1135us; 998us; 1139us; 998us; 1140us; 998us; 1141us; 998us; 1142us; 998us; 1143us; 998us; 1144us; 998us; 1145us; 998us; 1146us; 998us; 1147us; 998us; 1148us; 998us; 1149us; 998us; 1151us; 998us; 1152us; 998us; 1153us; 998us; 1154us; 998us; 1155us; 998us; 1156us; 998us; 1157us; 998us; 1158us; 998us; 1159us; 998us; 1181us; 998us; 1203us; 998us; 1204us; 998us; 1208us; 998us; 1210us; 998us; 1214us; 998us; 1216us; 998us; 1220us; 998us; 1223us; 998us; 1225us; 998us; 1289us; 998us; 1296us; 998us; 1303us; 998us; 1310us; 998us; 1320us; 998us; 1322us; 998us; 1323us; 998us; 1335us; 998us; 1342us; 998us; 1343us; 998us; 1349us; 998us; 1355us; 998us; 1356us; 998us; 1357us; 998us; 1373us; 998us; 1383us; 998us; 1396us; 998us; 1397us; 998us; 1399us; 998us; 1401us; 998us; 1405us; 998us; 1406us; 998us; 1433us; 998us; 1438us; 998us; 1463us; 998us; 1505us; 998us; 1510us; 998us; 109us; 65535us; 6us; 997us; 31us; 997us; 106us; 997us; 108us; 997us; 226us; 997us; 240us; 997us; 262us; 997us; 403us; 997us; 408us; 997us; 443us; 997us; 459us; 997us; 692us; 997us; 698us; 997us; 747us; 997us; 751us; 997us; 761us; 997us; 943us; 997us; 948us; 997us; 962us; 997us; 964us; 997us; 967us; 997us; 970us; 997us; 987us; 997us; 990us; 997us; 993us; 997us; 999us; 997us; 1003us; 997us; 1007us; 997us; 1011us; 997us; 1013us; 997us; 1018us; 997us; 1020us; 997us; 1022us; 997us; 1024us; 997us; 1026us; 997us; 1028us; 997us; 1039us; 997us; 1047us; 997us; 1054us; 997us; 1060us; 997us; 1062us; 997us; 1065us; 997us; 1068us; 997us; 1071us; 997us; 1074us; 997us; 1077us; 997us; 1080us; 997us; 1082us; 997us; 1087us; 997us; 1089us; 997us; 1133us; 997us; 1135us; 997us; 1139us; 997us; 1140us; 997us; 1141us; 997us; 1142us; 997us; 1143us; 997us; 1144us; 997us; 1145us; 997us; 1146us; 997us; 1147us; 997us; 1148us; 997us; 1149us; 997us; 1151us; 997us; 1152us; 997us; 1153us; 997us; 1154us; 997us; 1155us; 997us; 1156us; 997us; 1157us; 997us; 1158us; 997us; 1159us; 997us; 1181us; 997us; 1203us; 997us; 1204us; 997us; 1208us; 997us; 1210us; 997us; 1214us; 997us; 1216us; 997us; 1220us; 997us; 1223us; 997us; 1225us; 997us; 1289us; 997us; 1296us; 997us; 1303us; 997us; 1310us; 997us; 1320us; 997us; 1322us; 997us; 1323us; 997us; 1335us; 997us; 1342us; 997us; 1343us; 997us; 1349us; 997us; 1355us; 997us; 1356us; 997us; 1357us; 997us; 1373us; 997us; 1383us; 997us; 1396us; 997us; 1397us; 997us; 1399us; 997us; 1401us; 997us; 1405us; 997us; 1406us; 997us; 1433us; 997us; 1438us; 997us; 1463us; 997us; 1505us; 997us; 1510us; 997us; 3us; 65535us; 811us; 812us; 925us; 926us; 955us; 956us; 5us; 65535us; 103us; 104us; 177us; 178us; 193us; 194us; 429us; 430us; 1530us; 1531us; 3us; 65535us; 401us; 402us; 406us; 407us; 745us; 746us; 9us; 65535us; 103us; 1528us; 142us; 143us; 177us; 1528us; 193us; 1528us; 366us; 367us; 429us; 1528us; 632us; 633us; 1530us; 1528us; 1533us; 1534us; 9us; 65535us; 103us; 1532us; 142us; 1532us; 177us; 1532us; 193us; 1532us; 366us; 1532us; 429us; 1532us; 632us; 1532us; 1530us; 1532us; 1533us; 1532us; 2us; 65535us; 1536us; 1537us; 1539us; 1540us; 11us; 65535us; 103us; 1535us; 142us; 1535us; 177us; 1535us; 193us; 1535us; 366us; 1535us; 429us; 1535us; 632us; 1535us; 1530us; 1535us; 1533us; 1535us; 1536us; 1538us; 1539us; 1538us; 31us; 65535us; 8us; 1559us; 171us; 522us; 416us; 522us; 452us; 453us; 462us; 463us; 517us; 522us; 525us; 1627us; 589us; 590us; 592us; 593us; 671us; 672us; 767us; 768us; 811us; 1526us; 925us; 1526us; 955us; 1526us; 1127us; 1128us; 1129us; 1130us; 1131us; 1132us; 1419us; 1420us; 1422us; 1423us; 1424us; 1627us; 1557us; 1558us; 1585us; 1627us; 1590us; 1591us; 1593us; 1594us; 1604us; 1667us; 1608us; 1667us; 1614us; 1627us; 1625us; 1626us; 1655us; 1667us; 1657us; 1667us; 1668us; 1669us; 1us; 65535us; 8us; 9us; 31us; 65535us; 8us; 1556us; 171us; 1556us; 416us; 1556us; 452us; 1556us; 462us; 1556us; 517us; 1556us; 525us; 1556us; 589us; 1556us; 592us; 1556us; 671us; 1556us; 767us; 1556us; 811us; 1556us; 925us; 1556us; 955us; 1556us; 1127us; 1556us; 1129us; 1556us; 1131us; 1556us; 1419us; 1556us; 1422us; 1556us; 1424us; 1556us; 1557us; 1556us; 1585us; 1556us; 1590us; 1556us; 1593us; 1556us; 1604us; 1556us; 1608us; 1556us; 1614us; 1556us; 1625us; 1556us; 1655us; 1556us; 1657us; 1556us; 1668us; 1556us; 6us; 65535us; 1562us; 1563us; 1564us; 1565us; 1566us; 1567us; 1569us; 1570us; 1571us; 1572us; 1632us; 1633us; 91us; 65535us; 8us; 1577us; 103us; 1577us; 142us; 1577us; 171us; 1577us; 177us; 1577us; 181us; 1577us; 182us; 1576us; 183us; 1577us; 184us; 1576us; 193us; 1577us; 366us; 1577us; 416us; 1577us; 422us; 1577us; 423us; 1576us; 429us; 1577us; 452us; 1577us; 462us; 1577us; 481us; 1577us; 517us; 1577us; 525us; 1577us; 543us; 1577us; 589us; 1577us; 592us; 1577us; 602us; 1577us; 612us; 1577us; 613us; 1576us; 614us; 1576us; 629us; 1577us; 632us; 1577us; 651us; 1577us; 654us; 1577us; 657us; 1577us; 658us; 1576us; 659us; 1576us; 671us; 1577us; 682us; 1577us; 767us; 1577us; 811us; 1577us; 858us; 1577us; 925us; 1577us; 955us; 1577us; 1127us; 1577us; 1129us; 1577us; 1131us; 1577us; 1245us; 1577us; 1246us; 1577us; 1419us; 1577us; 1422us; 1577us; 1424us; 1577us; 1426us; 1577us; 1488us; 1577us; 1489us; 1576us; 1530us; 1577us; 1533us; 1577us; 1536us; 1577us; 1539us; 1577us; 1541us; 1577us; 1542us; 1576us; 1543us; 1577us; 1544us; 1576us; 1547us; 1577us; 1548us; 1576us; 1549us; 1576us; 1550us; 1577us; 1551us; 1576us; 1554us; 1577us; 1555us; 1576us; 1557us; 1577us; 1561us; 1576us; 1562us; 1577us; 1564us; 1577us; 1566us; 1577us; 1568us; 1576us; 1569us; 1577us; 1571us; 1577us; 1580us; 1576us; 1585us; 1577us; 1587us; 1576us; 1590us; 1577us; 1593us; 1577us; 1604us; 1577us; 1608us; 1577us; 1614us; 1577us; 1616us; 1576us; 1621us; 1577us; 1625us; 1577us; 1631us; 1577us; 1632us; 1577us; 1655us; 1577us; 1657us; 1577us; 1668us; 1577us; 91us; 65535us; 8us; 1623us; 103us; 1623us; 142us; 1623us; 171us; 1623us; 177us; 1623us; 181us; 1623us; 182us; 1584us; 183us; 1623us; 184us; 1584us; 193us; 1623us; 366us; 1623us; 416us; 1623us; 422us; 1623us; 423us; 1584us; 429us; 1623us; 452us; 1623us; 462us; 1623us; 481us; 1623us; 517us; 1623us; 525us; 1623us; 543us; 1623us; 589us; 1623us; 592us; 1623us; 602us; 1623us; 612us; 1623us; 613us; 1584us; 614us; 1584us; 629us; 1623us; 632us; 1623us; 651us; 1623us; 654us; 1623us; 657us; 1623us; 658us; 1584us; 659us; 1584us; 671us; 1623us; 682us; 1623us; 767us; 1623us; 811us; 1623us; 858us; 1623us; 925us; 1623us; 955us; 1623us; 1127us; 1623us; 1129us; 1623us; 1131us; 1623us; 1245us; 1623us; 1246us; 1623us; 1419us; 1623us; 1422us; 1623us; 1424us; 1623us; 1426us; 1623us; 1488us; 1623us; 1489us; 1584us; 1530us; 1623us; 1533us; 1623us; 1536us; 1623us; 1539us; 1623us; 1541us; 1623us; 1542us; 1584us; 1543us; 1623us; 1544us; 1584us; 1547us; 1623us; 1548us; 1584us; 1549us; 1584us; 1550us; 1623us; 1551us; 1584us; 1554us; 1623us; 1555us; 1584us; 1557us; 1623us; 1561us; 1584us; 1562us; 1623us; 1564us; 1623us; 1566us; 1623us; 1568us; 1584us; 1569us; 1623us; 1571us; 1623us; 1580us; 1584us; 1585us; 1623us; 1587us; 1588us; 1590us; 1623us; 1593us; 1623us; 1604us; 1623us; 1608us; 1623us; 1614us; 1623us; 1616us; 1617us; 1621us; 1623us; 1625us; 1623us; 1631us; 1623us; 1632us; 1623us; 1655us; 1623us; 1657us; 1623us; 1668us; 1623us; 65us; 65535us; 8us; 1561us; 103us; 1549us; 142us; 1549us; 171us; 1561us; 177us; 1549us; 181us; 182us; 183us; 184us; 193us; 1549us; 366us; 1549us; 416us; 1561us; 422us; 423us; 429us; 1549us; 452us; 1561us; 462us; 1561us; 517us; 1561us; 525us; 1561us; 589us; 1561us; 592us; 1561us; 602us; 614us; 612us; 613us; 629us; 659us; 632us; 1549us; 651us; 659us; 654us; 659us; 657us; 658us; 671us; 1561us; 682us; 659us; 767us; 1561us; 811us; 1561us; 925us; 1561us; 955us; 1561us; 1127us; 1561us; 1129us; 1561us; 1131us; 1561us; 1419us; 1561us; 1422us; 1561us; 1424us; 1561us; 1488us; 1489us; 1530us; 1549us; 1533us; 1549us; 1536us; 1549us; 1539us; 1549us; 1541us; 1542us; 1543us; 1544us; 1547us; 1548us; 1550us; 1551us; 1554us; 1555us; 1557us; 1561us; 1562us; 1568us; 1564us; 1568us; 1566us; 1568us; 1569us; 1568us; 1571us; 1568us; 1585us; 1561us; 1590us; 1561us; 1593us; 1561us; 1604us; 1561us; 1608us; 1561us; 1614us; 1561us; 1625us; 1561us; 1631us; 1580us; 1632us; 1568us; 1655us; 1561us; 1657us; 1561us; 1668us; 1561us; 18us; 65535us; 182us; 1581us; 184us; 1581us; 423us; 1581us; 613us; 1581us; 614us; 1581us; 658us; 1581us; 659us; 1581us; 1489us; 1581us; 1542us; 1581us; 1544us; 1581us; 1548us; 1581us; 1549us; 1581us; 1551us; 1581us; 1555us; 1581us; 1561us; 1581us; 1568us; 1581us; 1580us; 1581us; 1582us; 1583us; 4us; 65535us; 525us; 1586us; 1424us; 1586us; 1585us; 1586us; 1614us; 1615us; 2us; 65535us; 1605us; 1606us; 1658us; 1607us; 65us; 65535us; 8us; 1589us; 103us; 1589us; 142us; 1589us; 171us; 1589us; 177us; 1589us; 181us; 1589us; 183us; 1589us; 193us; 1589us; 366us; 1589us; 416us; 1589us; 422us; 1589us; 429us; 1589us; 452us; 1589us; 462us; 1589us; 517us; 1589us; 525us; 1589us; 589us; 1589us; 592us; 1589us; 602us; 1589us; 612us; 1589us; 629us; 1589us; 632us; 1589us; 651us; 1589us; 654us; 1589us; 657us; 1589us; 671us; 1589us; 682us; 1589us; 767us; 1589us; 811us; 1589us; 925us; 1589us; 955us; 1589us; 1127us; 1589us; 1129us; 1589us; 1131us; 1589us; 1419us; 1589us; 1422us; 1589us; 1424us; 1589us; 1488us; 1589us; 1530us; 1589us; 1533us; 1589us; 1536us; 1589us; 1539us; 1589us; 1541us; 1589us; 1543us; 1589us; 1547us; 1589us; 1550us; 1589us; 1554us; 1589us; 1557us; 1589us; 1562us; 1589us; 1564us; 1589us; 1566us; 1589us; 1569us; 1589us; 1571us; 1589us; 1585us; 1589us; 1590us; 1589us; 1593us; 1589us; 1604us; 1589us; 1608us; 1589us; 1614us; 1589us; 1625us; 1589us; 1631us; 1589us; 1632us; 1589us; 1655us; 1589us; 1657us; 1589us; 1668us; 1589us; 4us; 65535us; 481us; 482us; 1245us; 1247us; 1246us; 1248us; 1426us; 1427us; 66us; 65535us; 8us; 1611us; 103us; 1611us; 142us; 1611us; 171us; 1611us; 177us; 1611us; 181us; 1611us; 183us; 1611us; 193us; 1611us; 366us; 1611us; 416us; 1611us; 422us; 1611us; 429us; 1611us; 452us; 1611us; 462us; 1611us; 517us; 1611us; 525us; 1611us; 589us; 1611us; 592us; 1611us; 602us; 1611us; 612us; 1611us; 629us; 1611us; 632us; 1611us; 651us; 1611us; 654us; 1611us; 657us; 1611us; 671us; 1611us; 682us; 1611us; 767us; 1611us; 811us; 1611us; 858us; 859us; 925us; 1611us; 955us; 1611us; 1127us; 1611us; 1129us; 1611us; 1131us; 1611us; 1419us; 1611us; 1422us; 1611us; 1424us; 1611us; 1488us; 1611us; 1530us; 1611us; 1533us; 1611us; 1536us; 1611us; 1539us; 1611us; 1541us; 1611us; 1543us; 1611us; 1547us; 1611us; 1550us; 1611us; 1554us; 1611us; 1557us; 1611us; 1562us; 1611us; 1564us; 1611us; 1566us; 1611us; 1569us; 1611us; 1571us; 1611us; 1585us; 1611us; 1590us; 1611us; 1593us; 1611us; 1604us; 1611us; 1608us; 1611us; 1614us; 1611us; 1625us; 1611us; 1631us; 1611us; 1632us; 1611us; 1655us; 1611us; 1657us; 1611us; 1668us; 1611us; 72us; 65535us; 8us; 1619us; 103us; 1619us; 142us; 1619us; 171us; 1619us; 177us; 1619us; 181us; 1619us; 183us; 1619us; 193us; 1619us; 366us; 1619us; 416us; 1619us; 422us; 1619us; 429us; 1619us; 452us; 1619us; 462us; 1619us; 481us; 1618us; 517us; 1619us; 525us; 1619us; 543us; 1622us; 589us; 1619us; 592us; 1619us; 602us; 1619us; 612us; 1619us; 629us; 1619us; 632us; 1619us; 651us; 1619us; 654us; 1619us; 657us; 1619us; 671us; 1619us; 682us; 1619us; 767us; 1619us; 811us; 1619us; 858us; 1619us; 925us; 1619us; 955us; 1619us; 1127us; 1619us; 1129us; 1619us; 1131us; 1619us; 1245us; 1618us; 1246us; 1618us; 1419us; 1619us; 1422us; 1619us; 1424us; 1619us; 1426us; 1618us; 1488us; 1619us; 1530us; 1619us; 1533us; 1619us; 1536us; 1619us; 1539us; 1619us; 1541us; 1619us; 1543us; 1619us; 1547us; 1619us; 1550us; 1619us; 1554us; 1619us; 1557us; 1619us; 1562us; 1619us; 1564us; 1619us; 1566us; 1619us; 1569us; 1619us; 1571us; 1619us; 1585us; 1619us; 1590us; 1619us; 1593us; 1619us; 1604us; 1619us; 1608us; 1619us; 1614us; 1619us; 1621us; 1622us; 1625us; 1619us; 1631us; 1619us; 1632us; 1619us; 1655us; 1619us; 1657us; 1619us; 1668us; 1619us; 4us; 65535us; 596us; 611us; 609us; 610us; 1577us; 1646us; 1648us; 1649us; 6us; 65535us; 596us; 1652us; 609us; 1652us; 1273us; 1274us; 1577us; 1652us; 1648us; 1652us; 1653us; 1654us; 8us; 65535us; 525us; 1603us; 1424us; 1603us; 1585us; 1603us; 1604us; 1605us; 1608us; 1609us; 1614us; 1603us; 1655us; 1662us; 1657us; 1670us; 2us; 65535us; 1655us; 1656us; 1657us; 1658us; 3us; 65535us; 1608us; 1610us; 1655us; 1671us; 1657us; 1671us; 1us; 65535us; 803us; 804us; 6us; 65535us; 1672us; 1682us; 1679us; 1682us; 1686us; 1682us; 1692us; 1682us; 1693us; 1682us; 1694us; 1682us; 6us; 65535us; 1672us; 1686us; 1679us; 1686us; 1686us; 1686us; 1692us; 1686us; 1693us; 1686us; 1694us; 1686us; 6us; 65535us; 1672us; 1688us; 1679us; 1688us; 1686us; 1687us; 1692us; 1688us; 1693us; 1688us; 1694us; 1688us; 5us; 65535us; 1672us; 1673us; 1679us; 1680us; 1692us; 1689us; 1693us; 1690us; 1694us; 1691us; 106us; 65535us; 8us; 1575us; 103us; 1575us; 142us; 1575us; 171us; 1575us; 177us; 1575us; 181us; 1575us; 182us; 1574us; 183us; 1575us; 184us; 1574us; 193us; 1575us; 366us; 1575us; 416us; 1575us; 422us; 1575us; 423us; 1574us; 429us; 1575us; 452us; 1575us; 462us; 1575us; 481us; 1574us; 517us; 1575us; 525us; 1575us; 543us; 1574us; 551us; 556us; 566us; 567us; 580us; 591us; 584us; 591us; 587us; 588us; 589us; 1575us; 592us; 1575us; 602us; 1575us; 612us; 1575us; 613us; 1574us; 614us; 1574us; 629us; 1575us; 632us; 1575us; 651us; 1575us; 654us; 1575us; 657us; 1575us; 658us; 1574us; 659us; 1574us; 671us; 1575us; 682us; 1575us; 759us; 766us; 763us; 766us; 767us; 1575us; 811us; 1575us; 858us; 1574us; 925us; 1575us; 955us; 1575us; 1127us; 1575us; 1129us; 1575us; 1131us; 1575us; 1245us; 1574us; 1246us; 1574us; 1419us; 1575us; 1422us; 1575us; 1424us; 1575us; 1426us; 1574us; 1488us; 1575us; 1489us; 1574us; 1527us; 591us; 1529us; 591us; 1530us; 1575us; 1533us; 1575us; 1536us; 1575us; 1539us; 1575us; 1541us; 1575us; 1542us; 1574us; 1543us; 1575us; 1544us; 1574us; 1547us; 1575us; 1548us; 1574us; 1549us; 1574us; 1550us; 1575us; 1551us; 1574us; 1554us; 1575us; 1555us; 1574us; 1557us; 1575us; 1561us; 1574us; 1562us; 1575us; 1564us; 1575us; 1566us; 1575us; 1568us; 1574us; 1569us; 1575us; 1571us; 1575us; 1580us; 1574us; 1585us; 1575us; 1587us; 1574us; 1590us; 1575us; 1593us; 1575us; 1604us; 1575us; 1608us; 1575us; 1614us; 1575us; 1616us; 1574us; 1621us; 1574us; 1625us; 1575us; 1631us; 1575us; 1632us; 1575us; 1655us; 1575us; 1657us; 1575us; 1668us; 1575us; 1672us; 1678us; 1679us; 1678us; 1686us; 1678us; 1692us; 1678us; 1693us; 1678us; 1694us; 1678us; 110us; 65535us; 8us; 1697us; 103us; 1697us; 142us; 1697us; 171us; 1697us; 177us; 1697us; 181us; 1697us; 182us; 1697us; 183us; 1697us; 184us; 1697us; 193us; 1697us; 366us; 1697us; 416us; 1697us; 422us; 1697us; 423us; 1697us; 429us; 1697us; 452us; 1697us; 462us; 1697us; 481us; 1697us; 517us; 1697us; 525us; 1697us; 543us; 1697us; 551us; 1697us; 566us; 1697us; 580us; 1697us; 584us; 1697us; 587us; 1697us; 589us; 1697us; 592us; 1697us; 602us; 1697us; 612us; 1697us; 613us; 1697us; 614us; 1697us; 629us; 1697us; 632us; 1697us; 651us; 1697us; 654us; 1697us; 657us; 1697us; 658us; 1697us; 659us; 1697us; 671us; 1697us; 682us; 1697us; 759us; 1697us; 763us; 1697us; 767us; 1697us; 811us; 1697us; 858us; 1697us; 925us; 1697us; 955us; 1697us; 1127us; 1697us; 1129us; 1697us; 1131us; 1697us; 1245us; 1697us; 1246us; 1697us; 1355us; 1377us; 1356us; 1378us; 1357us; 1377us; 1381us; 1382us; 1419us; 1697us; 1422us; 1697us; 1424us; 1697us; 1426us; 1697us; 1488us; 1697us; 1489us; 1697us; 1527us; 1697us; 1529us; 1697us; 1530us; 1697us; 1533us; 1697us; 1536us; 1697us; 1539us; 1697us; 1541us; 1697us; 1542us; 1697us; 1543us; 1697us; 1544us; 1697us; 1547us; 1697us; 1548us; 1697us; 1549us; 1697us; 1550us; 1697us; 1551us; 1697us; 1554us; 1697us; 1555us; 1697us; 1557us; 1697us; 1561us; 1697us; 1562us; 1697us; 1564us; 1697us; 1566us; 1697us; 1568us; 1697us; 1569us; 1697us; 1571us; 1697us; 1580us; 1697us; 1585us; 1697us; 1587us; 1697us; 1590us; 1697us; 1593us; 1697us; 1604us; 1697us; 1608us; 1697us; 1614us; 1697us; 1616us; 1697us; 1621us; 1697us; 1625us; 1697us; 1631us; 1697us; 1632us; 1697us; 1655us; 1697us; 1657us; 1697us; 1668us; 1697us; 1672us; 1697us; 1679us; 1697us; 1686us; 1697us; 1692us; 1697us; 1693us; 1697us; 1694us; 1697us; 332us; 65535us; 6us; 1750us; 8us; 1703us; 31us; 1750us; 51us; 1703us; 54us; 1703us; 89us; 1703us; 94us; 1703us; 100us; 1750us; 103us; 1703us; 106us; 1750us; 108us; 1750us; 111us; 1703us; 142us; 1703us; 171us; 645us; 174us; 1750us; 177us; 1703us; 181us; 1703us; 182us; 1703us; 183us; 1703us; 184us; 1703us; 193us; 1703us; 195us; 1750us; 197us; 1750us; 202us; 1750us; 226us; 1750us; 240us; 1750us; 262us; 1750us; 269us; 1703us; 298us; 327us; 309us; 327us; 314us; 1703us; 318us; 1703us; 366us; 1703us; 400us; 1752us; 403us; 1750us; 405us; 1752us; 408us; 1750us; 416us; 645us; 422us; 1703us; 423us; 1703us; 426us; 1750us; 429us; 1703us; 440us; 1752us; 443us; 1750us; 450us; 451us; 452us; 1703us; 456us; 457us; 459us; 1750us; 462us; 1703us; 465us; 1752us; 468us; 1752us; 481us; 1703us; 489us; 490us; 492us; 493us; 517us; 645us; 525us; 1703us; 543us; 1703us; 551us; 1703us; 553us; 1703us; 589us; 1703us; 592us; 1703us; 602us; 1703us; 612us; 1703us; 613us; 1703us; 614us; 1703us; 626us; 1750us; 629us; 656us; 632us; 1703us; 651us; 656us; 654us; 656us; 657us; 1703us; 658us; 1703us; 659us; 1703us; 669us; 670us; 671us; 1703us; 678us; 681us; 682us; 656us; 684us; 1703us; 686us; 1703us; 692us; 1750us; 698us; 1750us; 709us; 710us; 721us; 1703us; 722us; 723us; 734us; 1703us; 744us; 1752us; 747us; 1750us; 751us; 1750us; 761us; 1750us; 767us; 1703us; 807us; 808us; 811us; 1703us; 813us; 806us; 814us; 806us; 816us; 806us; 832us; 833us; 834us; 1752us; 835us; 1752us; 839us; 1752us; 840us; 1752us; 841us; 1752us; 842us; 1752us; 845us; 847us; 849us; 1752us; 852us; 1752us; 854us; 1752us; 856us; 1752us; 858us; 1703us; 861us; 848us; 865us; 1752us; 867us; 1752us; 869us; 1752us; 874us; 1703us; 877us; 1752us; 880us; 1752us; 884us; 886us; 885us; 886us; 892us; 1752us; 900us; 1752us; 920us; 921us; 922us; 1752us; 925us; 1703us; 927us; 1752us; 928us; 1752us; 930us; 1752us; 931us; 1752us; 932us; 1752us; 933us; 1752us; 936us; 1703us; 939us; 1752us; 941us; 1752us; 943us; 1750us; 948us; 1750us; 955us; 1703us; 962us; 1750us; 964us; 1750us; 967us; 1750us; 970us; 1750us; 987us; 1750us; 990us; 1750us; 993us; 1750us; 999us; 1750us; 1003us; 1750us; 1007us; 1750us; 1011us; 1750us; 1013us; 1750us; 1018us; 1750us; 1020us; 1750us; 1022us; 1750us; 1024us; 1750us; 1026us; 1750us; 1028us; 1750us; 1037us; 1752us; 1039us; 1750us; 1047us; 1750us; 1054us; 1750us; 1060us; 1750us; 1062us; 1750us; 1064us; 1752us; 1065us; 1750us; 1068us; 1750us; 1070us; 1752us; 1071us; 1750us; 1074us; 1750us; 1077us; 1750us; 1080us; 1750us; 1082us; 1750us; 1087us; 1750us; 1089us; 1750us; 1127us; 1703us; 1129us; 1703us; 1131us; 1703us; 1133us; 1750us; 1135us; 1750us; 1139us; 1750us; 1140us; 1750us; 1141us; 1750us; 1142us; 1750us; 1143us; 1750us; 1144us; 1750us; 1145us; 1750us; 1146us; 1750us; 1147us; 1750us; 1148us; 1750us; 1149us; 1750us; 1151us; 1750us; 1152us; 1750us; 1153us; 1750us; 1154us; 1750us; 1155us; 1750us; 1156us; 1750us; 1157us; 1750us; 1158us; 1750us; 1159us; 1750us; 1181us; 1750us; 1184us; 1752us; 1186us; 1752us; 1191us; 1752us; 1198us; 1752us; 1203us; 1750us; 1204us; 1750us; 1208us; 1750us; 1210us; 1750us; 1214us; 1750us; 1216us; 1750us; 1220us; 1750us; 1223us; 1750us; 1225us; 1750us; 1227us; 1750us; 1228us; 1750us; 1230us; 1750us; 1231us; 1750us; 1233us; 1750us; 1234us; 1750us; 1236us; 1750us; 1237us; 1750us; 1239us; 1750us; 1240us; 1750us; 1242us; 1750us; 1243us; 1750us; 1245us; 1703us; 1246us; 1703us; 1255us; 1750us; 1257us; 1750us; 1259us; 1750us; 1260us; 1750us; 1261us; 1750us; 1264us; 1750us; 1271us; 1750us; 1272us; 1750us; 1275us; 1750us; 1276us; 1750us; 1277us; 1750us; 1280us; 1750us; 1282us; 1750us; 1283us; 1750us; 1289us; 1750us; 1296us; 1750us; 1303us; 1750us; 1310us; 1750us; 1320us; 1750us; 1322us; 1750us; 1323us; 1750us; 1335us; 1750us; 1342us; 1750us; 1343us; 1750us; 1349us; 1750us; 1355us; 1750us; 1356us; 1750us; 1357us; 1750us; 1373us; 1750us; 1383us; 1750us; 1396us; 1750us; 1397us; 1750us; 1399us; 1750us; 1401us; 1750us; 1405us; 1750us; 1406us; 1750us; 1413us; 1750us; 1419us; 1703us; 1422us; 1703us; 1424us; 1703us; 1426us; 1703us; 1433us; 1750us; 1438us; 1750us; 1442us; 1703us; 1446us; 1703us; 1454us; 1703us; 1463us; 1750us; 1488us; 1703us; 1489us; 1703us; 1496us; 1750us; 1503us; 1752us; 1505us; 1750us; 1508us; 1752us; 1510us; 1750us; 1521us; 1752us; 1523us; 1752us; 1530us; 1703us; 1533us; 1703us; 1536us; 1703us; 1539us; 1703us; 1541us; 1703us; 1542us; 1703us; 1543us; 1703us; 1544us; 1703us; 1545us; 1546us; 1547us; 1703us; 1548us; 1703us; 1549us; 1703us; 1550us; 1703us; 1551us; 1703us; 1552us; 1553us; 1554us; 1703us; 1555us; 1703us; 1557us; 1703us; 1561us; 1703us; 1562us; 1703us; 1564us; 1703us; 1566us; 1703us; 1568us; 1703us; 1569us; 1703us; 1571us; 1703us; 1580us; 1703us; 1585us; 1703us; 1587us; 1703us; 1590us; 1703us; 1593us; 1703us; 1604us; 1703us; 1608us; 1703us; 1614us; 1703us; 1616us; 1703us; 1621us; 1703us; 1625us; 1703us; 1631us; 1703us; 1632us; 1703us; 1641us; 1750us; 1647us; 1703us; 1655us; 1703us; 1657us; 1703us; 1668us; 1703us; 1672us; 1703us; 1679us; 1703us; 1686us; 1703us; 1692us; 1703us; 1693us; 1703us; 1694us; 1703us; 1695us; 1696us; 1698us; 1700us; 1699us; 1700us; 1704us; 1705us; 1754us; 1752us; 119us; 65535us; 8us; 1573us; 51us; 52us; 54us; 55us; 89us; 276us; 94us; 95us; 103us; 1573us; 111us; 274us; 142us; 1573us; 171us; 518us; 177us; 1573us; 181us; 1573us; 182us; 1573us; 183us; 1573us; 184us; 1573us; 193us; 1573us; 269us; 286us; 298us; 311us; 309us; 311us; 314us; 315us; 318us; 319us; 366us; 1573us; 416us; 518us; 422us; 1573us; 423us; 1573us; 429us; 1573us; 452us; 1573us; 462us; 1573us; 481us; 1573us; 517us; 518us; 525us; 1573us; 543us; 1573us; 551us; 552us; 553us; 554us; 589us; 1573us; 592us; 1573us; 602us; 1573us; 612us; 1573us; 613us; 1573us; 614us; 1573us; 629us; 1573us; 632us; 1573us; 651us; 1573us; 654us; 1573us; 657us; 1573us; 658us; 1573us; 659us; 1573us; 671us; 1573us; 682us; 1573us; 684us; 685us; 686us; 687us; 721us; 724us; 734us; 724us; 767us; 1573us; 811us; 1573us; 858us; 1573us; 874us; 938us; 925us; 1573us; 936us; 938us; 955us; 1573us; 1127us; 1573us; 1129us; 1573us; 1131us; 1573us; 1245us; 1573us; 1246us; 1573us; 1419us; 1573us; 1422us; 1573us; 1424us; 1573us; 1426us; 1573us; 1442us; 1459us; 1446us; 1459us; 1454us; 1459us; 1488us; 1573us; 1489us; 1573us; 1530us; 1573us; 1533us; 1573us; 1536us; 1573us; 1539us; 1573us; 1541us; 1573us; 1542us; 1573us; 1543us; 1573us; 1544us; 1573us; 1547us; 1573us; 1548us; 1573us; 1549us; 1573us; 1550us; 1573us; 1551us; 1573us; 1554us; 1573us; 1555us; 1573us; 1557us; 1573us; 1561us; 1573us; 1562us; 1573us; 1564us; 1573us; 1566us; 1573us; 1568us; 1573us; 1569us; 1573us; 1571us; 1573us; 1580us; 1573us; 1585us; 1573us; 1587us; 1573us; 1590us; 1573us; 1593us; 1573us; 1604us; 1573us; 1608us; 1573us; 1614us; 1573us; 1616us; 1573us; 1621us; 1573us; 1625us; 1573us; 1631us; 1573us; 1632us; 1573us; 1647us; 1648us; 1655us; 1573us; 1657us; 1573us; 1668us; 1573us; 1672us; 1677us; 1679us; 1677us; 1686us; 1677us; 1692us; 1677us; 1693us; 1677us; 1694us; 1677us; 190us; 65535us; 6us; 1751us; 31us; 1751us; 100us; 1751us; 106us; 1751us; 108us; 1751us; 174us; 1751us; 195us; 1751us; 197us; 1751us; 202us; 1751us; 226us; 1751us; 240us; 1751us; 262us; 1751us; 400us; 1753us; 403us; 1751us; 405us; 1753us; 408us; 1751us; 426us; 1751us; 440us; 1753us; 443us; 1751us; 459us; 1751us; 465us; 1753us; 468us; 1753us; 626us; 1751us; 692us; 1751us; 698us; 1751us; 744us; 1753us; 747us; 1751us; 751us; 1751us; 761us; 1751us; 834us; 1753us; 835us; 1753us; 839us; 1753us; 840us; 1753us; 841us; 1753us; 842us; 1753us; 849us; 1753us; 852us; 1753us; 854us; 1753us; 856us; 1753us; 861us; 1753us; 865us; 1753us; 867us; 1753us; 869us; 1753us; 877us; 1753us; 880us; 1753us; 892us; 1753us; 900us; 1753us; 922us; 1753us; 927us; 1753us; 928us; 1753us; 930us; 1753us; 931us; 1753us; 932us; 1753us; 933us; 1753us; 939us; 1753us; 941us; 1753us; 943us; 1751us; 948us; 1751us; 962us; 1751us; 964us; 1751us; 967us; 1751us; 970us; 1751us; 987us; 1751us; 990us; 1751us; 993us; 1751us; 999us; 1751us; 1003us; 1751us; 1007us; 1751us; 1011us; 1751us; 1013us; 1751us; 1018us; 1751us; 1020us; 1751us; 1022us; 1751us; 1024us; 1751us; 1026us; 1751us; 1028us; 1751us; 1037us; 1753us; 1039us; 1751us; 1047us; 1751us; 1054us; 1751us; 1060us; 1751us; 1062us; 1751us; 1064us; 1753us; 1065us; 1751us; 1068us; 1751us; 1070us; 1753us; 1071us; 1751us; 1074us; 1751us; 1077us; 1751us; 1080us; 1751us; 1082us; 1751us; 1087us; 1751us; 1089us; 1751us; 1133us; 1751us; 1135us; 1751us; 1139us; 1751us; 1140us; 1751us; 1141us; 1751us; 1142us; 1751us; 1143us; 1751us; 1144us; 1751us; 1145us; 1751us; 1146us; 1751us; 1147us; 1751us; 1148us; 1751us; 1149us; 1751us; 1151us; 1751us; 1152us; 1751us; 1153us; 1751us; 1154us; 1751us; 1155us; 1751us; 1156us; 1751us; 1157us; 1751us; 1158us; 1751us; 1159us; 1751us; 1181us; 1751us; 1184us; 1753us; 1186us; 1753us; 1191us; 1753us; 1198us; 1753us; 1203us; 1751us; 1204us; 1751us; 1208us; 1751us; 1210us; 1751us; 1214us; 1751us; 1216us; 1751us; 1220us; 1751us; 1223us; 1751us; 1225us; 1751us; 1227us; 1751us; 1228us; 1751us; 1230us; 1751us; 1231us; 1751us; 1233us; 1751us; 1234us; 1751us; 1236us; 1751us; 1237us; 1751us; 1239us; 1751us; 1240us; 1751us; 1242us; 1751us; 1243us; 1751us; 1255us; 1751us; 1257us; 1751us; 1259us; 1751us; 1260us; 1751us; 1261us; 1751us; 1264us; 1751us; 1271us; 1751us; 1272us; 1751us; 1275us; 1751us; 1276us; 1751us; 1277us; 1751us; 1280us; 1751us; 1282us; 1751us; 1283us; 1751us; 1289us; 1751us; 1296us; 1751us; 1303us; 1751us; 1310us; 1751us; 1320us; 1751us; 1322us; 1751us; 1323us; 1751us; 1335us; 1751us; 1342us; 1751us; 1343us; 1751us; 1349us; 1751us; 1355us; 1751us; 1356us; 1751us; 1357us; 1751us; 1373us; 1751us; 1383us; 1751us; 1396us; 1751us; 1397us; 1751us; 1399us; 1751us; 1401us; 1751us; 1405us; 1751us; 1406us; 1751us; 1413us; 1751us; 1433us; 1751us; 1438us; 1751us; 1463us; 1751us; 1496us; 1751us; 1503us; 1753us; 1505us; 1751us; 1508us; 1753us; 1510us; 1751us; 1521us; 1753us; 1523us; 1753us; 1641us; 1751us; 1754us; 1753us; 7us; 65535us; 639us; 1708us; 861us; 1708us; 892us; 1708us; 1303us; 1708us; 1356us; 1708us; 1357us; 1708us; 1707us; 1708us; 2us; 65535us; 1714us; 1749us; 1747us; 1748us; 7us; 65535us; 639us; 1713us; 861us; 1713us; 892us; 1713us; 1303us; 1713us; 1356us; 1713us; 1357us; 1713us; 1707us; 1713us; 145us; 65535us; 6us; 1757us; 31us; 1757us; 100us; 1757us; 106us; 1757us; 108us; 1757us; 174us; 1757us; 195us; 1757us; 197us; 1757us; 202us; 1757us; 226us; 1757us; 240us; 1757us; 262us; 1757us; 403us; 1757us; 408us; 1757us; 426us; 1757us; 443us; 1757us; 459us; 1757us; 626us; 1757us; 692us; 1757us; 698us; 1757us; 747us; 1757us; 751us; 1757us; 761us; 1757us; 943us; 1757us; 948us; 1757us; 962us; 1757us; 964us; 1757us; 967us; 1757us; 970us; 1757us; 987us; 1757us; 990us; 1757us; 993us; 1757us; 999us; 1757us; 1003us; 1757us; 1007us; 1757us; 1011us; 1757us; 1013us; 1757us; 1018us; 1757us; 1020us; 1757us; 1022us; 1757us; 1024us; 1757us; 1026us; 1757us; 1028us; 1757us; 1039us; 1757us; 1047us; 1757us; 1054us; 1757us; 1060us; 1757us; 1062us; 1757us; 1065us; 1757us; 1068us; 1757us; 1071us; 1757us; 1074us; 1757us; 1077us; 1757us; 1080us; 1757us; 1082us; 1757us; 1087us; 1757us; 1089us; 1757us; 1133us; 1757us; 1135us; 1757us; 1139us; 1757us; 1140us; 1757us; 1141us; 1757us; 1142us; 1757us; 1143us; 1757us; 1144us; 1757us; 1145us; 1757us; 1146us; 1757us; 1147us; 1757us; 1148us; 1757us; 1149us; 1757us; 1151us; 1757us; 1152us; 1757us; 1153us; 1757us; 1154us; 1757us; 1155us; 1757us; 1156us; 1757us; 1157us; 1757us; 1158us; 1757us; 1159us; 1757us; 1181us; 1757us; 1203us; 1757us; 1204us; 1757us; 1208us; 1757us; 1210us; 1757us; 1214us; 1757us; 1216us; 1757us; 1220us; 1757us; 1223us; 1757us; 1225us; 1757us; 1227us; 1757us; 1228us; 1757us; 1230us; 1757us; 1231us; 1757us; 1233us; 1757us; 1234us; 1757us; 1236us; 1757us; 1237us; 1757us; 1239us; 1757us; 1240us; 1757us; 1242us; 1757us; 1243us; 1757us; 1255us; 1757us; 1257us; 1757us; 1259us; 1757us; 1260us; 1757us; 1261us; 1757us; 1264us; 1757us; 1271us; 1757us; 1272us; 1757us; 1275us; 1757us; 1276us; 1757us; 1277us; 1300us; 1280us; 1300us; 1282us; 1757us; 1283us; 1757us; 1289us; 1757us; 1296us; 1757us; 1303us; 1757us; 1310us; 1757us; 1320us; 1757us; 1322us; 1757us; 1323us; 1757us; 1335us; 1757us; 1342us; 1757us; 1343us; 1757us; 1349us; 1757us; 1355us; 1757us; 1356us; 1757us; 1357us; 1757us; 1373us; 1757us; 1383us; 1757us; 1396us; 1757us; 1397us; 1757us; 1399us; 1757us; 1401us; 1757us; 1405us; 1757us; 1406us; 1757us; 1413us; 1757us; 1433us; 1757us; 1438us; 1757us; 1463us; 1757us; 1496us; 1757us; 1505us; 1757us; 1510us; 1757us; 1641us; 1757us; 45us; 65535us; 400us; 467us; 405us; 467us; 440us; 467us; 465us; 466us; 468us; 469us; 744us; 467us; 834us; 467us; 835us; 467us; 839us; 467us; 840us; 467us; 841us; 467us; 842us; 467us; 849us; 467us; 852us; 467us; 854us; 467us; 856us; 467us; 861us; 467us; 865us; 467us; 867us; 467us; 869us; 467us; 877us; 467us; 880us; 467us; 892us; 467us; 900us; 467us; 922us; 467us; 927us; 467us; 928us; 467us; 930us; 467us; 931us; 467us; 932us; 467us; 933us; 467us; 939us; 467us; 941us; 467us; 1037us; 467us; 1064us; 467us; 1070us; 467us; 1184us; 467us; 1186us; 467us; 1191us; 467us; 1198us; 467us; 1503us; 467us; 1508us; 467us; 1521us; 467us; 1523us; 467us; 1754us; 1755us; 143us; 65535us; 6us; 1288us; 31us; 1288us; 100us; 101us; 106us; 1288us; 108us; 1288us; 174us; 175us; 195us; 201us; 197us; 201us; 202us; 203us; 226us; 1288us; 240us; 1288us; 262us; 1288us; 403us; 1288us; 408us; 1288us; 426us; 427us; 443us; 1288us; 459us; 1288us; 626us; 638us; 692us; 1288us; 698us; 1288us; 747us; 1288us; 751us; 1288us; 761us; 1288us; 943us; 1288us; 948us; 1288us; 962us; 1288us; 964us; 1288us; 967us; 1288us; 970us; 1288us; 987us; 1288us; 990us; 1288us; 993us; 1288us; 999us; 1288us; 1003us; 1288us; 1007us; 1288us; 1011us; 1288us; 1013us; 1288us; 1018us; 1288us; 1020us; 1288us; 1022us; 1288us; 1024us; 1288us; 1026us; 1288us; 1028us; 1288us; 1039us; 1288us; 1047us; 1288us; 1054us; 1288us; 1060us; 1288us; 1062us; 1288us; 1065us; 1288us; 1068us; 1288us; 1071us; 1288us; 1074us; 1288us; 1077us; 1288us; 1080us; 1288us; 1082us; 1288us; 1087us; 1288us; 1089us; 1288us; 1133us; 1288us; 1135us; 1288us; 1139us; 1288us; 1140us; 1288us; 1141us; 1288us; 1142us; 1288us; 1143us; 1288us; 1144us; 1288us; 1145us; 1288us; 1146us; 1288us; 1147us; 1288us; 1148us; 1288us; 1149us; 1288us; 1151us; 1288us; 1152us; 1288us; 1153us; 1288us; 1154us; 1288us; 1155us; 1288us; 1156us; 1288us; 1157us; 1288us; 1158us; 1288us; 1159us; 1288us; 1181us; 1288us; 1203us; 1288us; 1204us; 1288us; 1208us; 1288us; 1210us; 1288us; 1214us; 1288us; 1216us; 1288us; 1220us; 1288us; 1223us; 1288us; 1225us; 1288us; 1227us; 1288us; 1228us; 1288us; 1230us; 1288us; 1231us; 1288us; 1233us; 1288us; 1234us; 1288us; 1236us; 1288us; 1237us; 1288us; 1239us; 1288us; 1240us; 1288us; 1242us; 1288us; 1243us; 1288us; 1255us; 1288us; 1257us; 1288us; 1259us; 1288us; 1260us; 1288us; 1261us; 1288us; 1264us; 1288us; 1271us; 1288us; 1272us; 1288us; 1275us; 1288us; 1276us; 1288us; 1282us; 1284us; 1283us; 1284us; 1289us; 1288us; 1296us; 1288us; 1303us; 1288us; 1310us; 1288us; 1320us; 1288us; 1322us; 1288us; 1323us; 1288us; 1335us; 1288us; 1342us; 1288us; 1343us; 1288us; 1349us; 1288us; 1355us; 1288us; 1356us; 1288us; 1357us; 1288us; 1373us; 1288us; 1383us; 1288us; 1396us; 1288us; 1397us; 1288us; 1399us; 1288us; 1401us; 1288us; 1405us; 1288us; 1406us; 1288us; 1413us; 1288us; 1433us; 1288us; 1438us; 1288us; 1463us; 1288us; 1496us; 1288us; 1505us; 1288us; 1510us; 1288us; 1641us; 1288us; 14us; 65535us; 47us; 1761us; 74us; 1761us; 77us; 1761us; 78us; 1763us; 81us; 1761us; 216us; 1761us; 235us; 1761us; 241us; 1761us; 246us; 1761us; 250us; 1761us; 251us; 1761us; 252us; 1761us; 1761us; 1761us; 1763us; 1763us; 12us; 65535us; 47us; 82us; 74us; 82us; 77us; 82us; 81us; 82us; 216us; 253us; 235us; 253us; 241us; 242us; 246us; 248us; 250us; 253us; 251us; 253us; 252us; 253us; 1761us; 1762us; 2us; 65535us; 78us; 79us; 1763us; 1764us; 11us; 65535us; 165us; 1778us; 299us; 309us; 387us; 1778us; 500us; 1778us; 662us; 663us; 843us; 845us; 917us; 941us; 934us; 936us; 959us; 962us; 960us; 962us; 961us; 962us; 4us; 65535us; 210us; 211us; 293us; 294us; 476us; 477us; 479us; 480us; 2us; 65535us; 1480us; 1481us; 1490us; 1491us; 9us; 65535us; 420us; 421us; 431us; 432us; 434us; 435us; 436us; 437us; 438us; 439us; 444us; 445us; 506us; 507us; 508us; 509us; 512us; 513us; 2us; 65535us; 60us; 61us; 222us; 223us; 20us; 65535us; 71us; 72us; 131us; 132us; 232us; 233us; 301us; 302us; 304us; 305us; 354us; 355us; 620us; 650us; 627us; 628us; 630us; 631us; 633us; 634us; 636us; 637us; 645us; 646us; 648us; 649us; 1038us; 1085us; 1067us; 1068us; 1073us; 1074us; 1079us; 1080us; 1467us; 1471us; 1468us; 1469us; 1491us; 1492us; 8us; 65535us; 165us; 166us; 299us; 300us; 387us; 388us; 500us; 501us; 662us; 665us; 843us; 844us; 917us; 940us; 934us; 935us; 4us; 65535us; 50us; 51us; 53us; 54us; 688us; 689us; 694us; 695us; 0us; 65535us; 11us; 65535us; 97us; 98us; 172us; 173us; 390us; 399us; 392us; 399us; 397us; 399us; 419us; 405us; 425us; 426us; 504us; 743us; 505us; 405us; 511us; 405us; 740us; 743us; 7us; 65535us; 98us; 99us; 185us; 668us; 188us; 668us; 448us; 449us; 454us; 455us; 666us; 668us; 743us; 744us; 4us; 65535us; 975us; 1054us; 1027us; 1028us; 1038us; 1039us; 1046us; 1047us; 9us; 65535us; 972us; 1036us; 973us; 1043us; 974us; 1051us; 976us; 1058us; 1029us; 1030us; 1032us; 1033us; 1040us; 1041us; 1048us; 1049us; 1055us; 1056us; 2us; 65535us; 269us; 287us; 277us; 287us; 2us; 65535us; 89us; 118us; 111us; 114us; 2us; 65535us; 65us; 89us; 88us; 89us; 259us; 65535us; 6us; 786us; 8us; 786us; 31us; 786us; 40us; 42us; 103us; 786us; 106us; 786us; 108us; 786us; 142us; 786us; 171us; 786us; 177us; 786us; 181us; 786us; 183us; 786us; 193us; 786us; 226us; 786us; 240us; 786us; 262us; 786us; 312us; 786us; 316us; 786us; 321us; 786us; 366us; 786us; 400us; 786us; 403us; 786us; 405us; 786us; 408us; 786us; 416us; 786us; 422us; 786us; 429us; 786us; 440us; 786us; 443us; 786us; 452us; 786us; 459us; 786us; 462us; 786us; 481us; 786us; 484us; 786us; 517us; 786us; 525us; 786us; 543us; 544us; 589us; 786us; 592us; 786us; 602us; 786us; 612us; 786us; 629us; 786us; 632us; 786us; 635us; 786us; 647us; 786us; 651us; 786us; 654us; 786us; 657us; 786us; 671us; 786us; 682us; 786us; 692us; 786us; 698us; 786us; 744us; 786us; 747us; 786us; 751us; 786us; 761us; 786us; 767us; 786us; 811us; 786us; 834us; 786us; 835us; 786us; 839us; 786us; 840us; 786us; 841us; 786us; 842us; 786us; 849us; 786us; 852us; 786us; 854us; 786us; 856us; 786us; 858us; 786us; 861us; 786us; 865us; 786us; 867us; 786us; 869us; 786us; 877us; 786us; 880us; 786us; 892us; 786us; 900us; 786us; 922us; 786us; 925us; 786us; 927us; 786us; 928us; 786us; 930us; 786us; 931us; 786us; 932us; 786us; 933us; 786us; 939us; 786us; 941us; 786us; 943us; 786us; 948us; 786us; 955us; 786us; 962us; 786us; 964us; 786us; 967us; 786us; 970us; 786us; 987us; 786us; 990us; 786us; 993us; 786us; 999us; 786us; 1003us; 786us; 1007us; 786us; 1011us; 786us; 1013us; 786us; 1018us; 786us; 1020us; 786us; 1022us; 786us; 1024us; 786us; 1026us; 786us; 1028us; 786us; 1037us; 786us; 1039us; 786us; 1047us; 786us; 1054us; 786us; 1060us; 786us; 1062us; 786us; 1064us; 786us; 1065us; 786us; 1068us; 786us; 1070us; 786us; 1071us; 786us; 1074us; 786us; 1077us; 786us; 1080us; 786us; 1082us; 786us; 1087us; 786us; 1089us; 786us; 1127us; 786us; 1129us; 786us; 1131us; 786us; 1133us; 786us; 1135us; 786us; 1139us; 786us; 1140us; 786us; 1141us; 786us; 1142us; 786us; 1143us; 786us; 1144us; 786us; 1145us; 786us; 1146us; 786us; 1147us; 786us; 1148us; 786us; 1149us; 786us; 1151us; 786us; 1152us; 786us; 1153us; 786us; 1154us; 786us; 1155us; 786us; 1156us; 786us; 1157us; 786us; 1158us; 786us; 1159us; 786us; 1181us; 786us; 1184us; 786us; 1186us; 786us; 1191us; 786us; 1198us; 786us; 1203us; 786us; 1204us; 786us; 1208us; 786us; 1210us; 786us; 1214us; 786us; 1216us; 786us; 1220us; 786us; 1223us; 786us; 1225us; 786us; 1227us; 786us; 1228us; 786us; 1230us; 786us; 1231us; 786us; 1233us; 786us; 1234us; 786us; 1236us; 786us; 1237us; 786us; 1239us; 786us; 1240us; 786us; 1242us; 786us; 1243us; 786us; 1245us; 786us; 1246us; 786us; 1249us; 786us; 1250us; 786us; 1255us; 786us; 1257us; 786us; 1259us; 786us; 1260us; 786us; 1261us; 786us; 1264us; 786us; 1271us; 786us; 1272us; 786us; 1275us; 786us; 1276us; 786us; 1289us; 786us; 1296us; 786us; 1303us; 786us; 1310us; 786us; 1320us; 786us; 1322us; 786us; 1323us; 786us; 1335us; 786us; 1342us; 786us; 1343us; 786us; 1349us; 786us; 1355us; 786us; 1356us; 786us; 1357us; 786us; 1373us; 786us; 1383us; 786us; 1396us; 786us; 1397us; 786us; 1399us; 786us; 1401us; 786us; 1405us; 786us; 1406us; 786us; 1410us; 1411us; 1413us; 786us; 1419us; 786us; 1422us; 786us; 1424us; 786us; 1426us; 786us; 1428us; 786us; 1433us; 786us; 1438us; 786us; 1463us; 786us; 1488us; 786us; 1496us; 786us; 1503us; 786us; 1505us; 786us; 1508us; 786us; 1510us; 786us; 1521us; 786us; 1523us; 786us; 1530us; 786us; 1533us; 786us; 1536us; 786us; 1539us; 786us; 1541us; 786us; 1543us; 786us; 1547us; 786us; 1550us; 786us; 1554us; 786us; 1557us; 786us; 1562us; 786us; 1564us; 786us; 1566us; 786us; 1569us; 786us; 1571us; 786us; 1585us; 786us; 1590us; 786us; 1593us; 786us; 1604us; 786us; 1608us; 786us; 1614us; 786us; 1621us; 786us; 1625us; 786us; 1631us; 786us; 1632us; 786us; 1641us; 786us; 1655us; 786us; 1657us; 786us; 1668us; 786us; 11us; 65535us; 311us; 312us; 315us; 316us; 320us; 321us; 347us; 348us; 482us; 484us; 710us; 711us; 722us; 726us; 725us; 726us; 1247us; 1249us; 1248us; 1250us; 1427us; 1428us; 5us; 65535us; 101us; 573us; 175us; 573us; 427us; 573us; 552us; 568us; 851us; 573us; 13us; 65535us; 31us; 264us; 64us; 121us; 87us; 121us; 187us; 190us; 226us; 264us; 240us; 264us; 258us; 264us; 298us; 325us; 309us; 325us; 331us; 446us; 1411us; 1418us; 1797us; 1799us; 1798us; 1799us; 10us; 65535us; 31us; 49us; 64us; 49us; 87us; 49us; 226us; 49us; 240us; 49us; 258us; 49us; 298us; 323us; 309us; 323us; 1802us; 1804us; 1803us; 1804us; 7us; 65535us; 529us; 530us; 532us; 533us; 875us; 876us; 983us; 1387us; 1383us; 1389us; 1384us; 1385us; 1807us; 1808us; 5us; 65535us; 538us; 539us; 541us; 542us; 984us; 1500us; 1496us; 1502us; 1497us; 1498us; 43us; 65535us; 526us; 527us; 558us; 559us; 600us; 601us; 603us; 604us; 607us; 608us; 640us; 641us; 643us; 644us; 713us; 714us; 797us; 798us; 816us; 819us; 817us; 818us; 821us; 822us; 862us; 863us; 893us; 894us; 896us; 897us; 901us; 902us; 904us; 905us; 981us; 1362us; 982us; 1363us; 1138us; 1297us; 1182us; 1183us; 1304us; 1305us; 1308us; 1309us; 1355us; 1358us; 1356us; 1358us; 1357us; 1358us; 1359us; 1360us; 1372us; 1373us; 1379us; 1380us; 1420us; 1421us; 1424us; 1425us; 1586us; 1587us; 1615us; 1616us; 1626us; 1628us; 1627us; 1628us; 1633us; 1634us; 1644us; 1645us; 1680us; 1681us; 1708us; 1709us; 1710us; 1711us; 1714us; 1715us; 1717us; 1718us; 1812us; 1813us; 26us; 65535us; 70us; 71us; 74us; 75us; 109us; 110us; 112us; 113us; 116us; 117us; 134us; 135us; 152us; 153us; 160us; 161us; 231us; 232us; 235us; 236us; 251us; 284us; 274us; 275us; 278us; 279us; 281us; 282us; 319us; 320us; 357us; 358us; 376us; 378us; 380us; 382us; 496us; 497us; 752us; 753us; 944us; 945us; 949us; 950us; 968us; 969us; 1211us; 1212us; 1217us; 1218us; 1816us; 1817us; 1us; 65535us; 1359us; 1361us; 17us; 65535us; 298us; 307us; 300us; 306us; 481us; 487us; 918us; 1404us; 1037us; 1057us; 1038us; 1045us; 1039us; 1044us; 1040us; 1042us; 1223us; 1224us; 1225us; 1226us; 1401us; 1403us; 1462us; 1466us; 1463us; 1465us; 1650us; 1651us; 1657us; 1661us; 1662us; 1664us; 1704us; 1706us; |]
let _fsyacc_sparseGotoTableRowOffsets = [|0us; 1us; 2us; 3us; 4us; 5us; 7us; 15us; 20us; 26us; 31us; 36us; 41us; 46us; 70us; 72us; 74us; 76us; 83us; 88us; 90us; 93us; 96us; 99us; 103us; 110us; 120us; 130us; 140us; 143us; 145us; 148us; 151us; 155us; 157us; 160us; 163us; 166us; 170us; 179us; 188us; 200us; 204us; 207us; 210us; 213us; 219us; 221us; 223us; 226us; 229us; 232us; 236us; 242us; 252us; 263us; 274us; 290us; 292us; 294us; 297us; 299us; 381us; 500us; 619us; 621us; 624us; 627us; 632us; 639us; 642us; 646us; 649us; 653us; 657us; 661us; 665us; 676us; 687us; 689us; 692us; 696us; 700us; 703us; 714us; 718us; 721us; 723us; 766us; 777us; 842us; 855us; 857us; 862us; 865us; 868us; 871us; 874us; 878us; 881us; 886us; 891us; 894us; 900us; 907us; 974us; 1042us; 1044us; 1050us; 1060us; 1062us; 1064us; 1068us; 1074us; 1076us; 1078us; 1083us; 1087us; 1089us; 1093us; 1097us; 1102us; 1104us; 1108us; 1114us; 1118us; 1122us; 1124us; 1128us; 1132us; 1137us; 1142us; 1146us; 1150us; 1154us; 1158us; 1163us; 1170us; 1177us; 1179us; 1181us; 1197us; 1311us; 1319us; 1433us; 1546us; 1550us; 1555us; 1669us; 1671us; 1673us; 1677us; 1680us; 1682us; 1687us; 1690us; 1696us; 1699us; 1701us; 1704us; 1706us; 1708us; 1710us; 1713us; 1971us; 1973us; 1978us; 1982us; 2168us; 2172us; 2176us; 2179us; 2181us; 2193us; 2205us; 2217us; 2220us; 2223us; 2257us; 2261us; 2270us; 2313us; 2316us; 2339us; 2362us; 2385us; 2388us; 2391us; 2395us; 2419us; 2426us; 2432us; 2483us; 2485us; 2541us; 2640us; 2750us; 2752us; 2756us; 2761us; 2768us; 2775us; 2777us; 2779us; 2782us; 2785us; 2787us; 2897us; 3021us; 3146us; 3151us; 3286us; 3289us; 3292us; 3295us; 3437us; 3579us; 3763us; 3905us; 4047us; 4051us; 4055us; 4057us; 4199us; 4201us; 4204us; 4208us; 4214us; 4216us; 4218us; 4220us; 4222us; 4226us; 4228us; 4233us; 4235us; 4237us; 4239us; 4242us; 4249us; 4256us; 4260us; 4266us; 4270us; 4272us; 4274us; 4276us; 4279us; 4281us; 4286us; 4292us; 4434us; 4578us; 4688us; 4798us; 4802us; 4808us; 4812us; 4822us; 4832us; 4835us; 4847us; 4879us; 4881us; 4913us; 4920us; 5012us; 5104us; 5170us; 5189us; 5194us; 5197us; 5263us; 5268us; 5335us; 5408us; 5413us; 5420us; 5429us; 5432us; 5436us; 5438us; 5445us; 5452us; 5459us; 5465us; 5572us; 5683us; 6016us; 6136us; 6327us; 6335us; 6338us; 6346us; 6492us; 6538us; 6682us; 6697us; 6710us; 6713us; 6725us; 6730us; 6733us; 6743us; 6746us; 6767us; 6776us; 6781us; 6782us; 6794us; 6802us; 6807us; 6817us; 6820us; 6823us; 6826us; 7086us; 7098us; 7104us; 7118us; 7129us; 7137us; 7143us; 7187us; 7214us; 7216us; |]
let _fsyacc_stateToProdIdxsTableElements = [| 1us; 0us; 1us; 0us; 1us; 1us; 1us; 1us; 1us; 2us; 1us; 2us; 1us; 3us; 1us; 3us; 1us; 4us; 1us; 4us; 1us; 5us; 1us; 6us; 1us; 7us; 1us; 8us; 1us; 9us; 1us; 10us; 2us; 11us; 14us; 1us; 11us; 2us; 12us; 15us; 1us; 12us; 2us; 13us; 16us; 1us; 13us; 1us; 14us; 1us; 14us; 1us; 15us; 1us; 15us; 1us; 16us; 1us; 16us; 2us; 17us; 18us; 1us; 18us; 7us; 19us; 136us; 137us; 138us; 139us; 140us; 141us; 7us; 19us; 136us; 137us; 138us; 139us; 140us; 141us; 48us; 19us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 1us; 20us; 2us; 21us; 22us; 1us; 22us; 1us; 23us; 1us; 24us; 1us; 25us; 1us; 25us; 2us; 25us; 27us; 1us; 27us; 1us; 28us; 2us; 29us; 30us; 1us; 29us; 1us; 30us; 1us; 30us; 3us; 31us; 46us; 49us; 1us; 31us; 1us; 32us; 1us; 32us; 1us; 32us; 3us; 32us; 943us; 944us; 1us; 33us; 1us; 33us; 3us; 33us; 943us; 944us; 2us; 34us; 35us; 1us; 35us; 2us; 36us; 37us; 1us; 36us; 1us; 38us; 1us; 38us; 1us; 38us; 6us; 39us; 53us; 54us; 55us; 56us; 58us; 6us; 39us; 53us; 54us; 55us; 56us; 58us; 3us; 39us; 53us; 54us; 1us; 39us; 1us; 40us; 1us; 41us; 3us; 42us; 43us; 44us; 2us; 42us; 43us; 1us; 42us; 1us; 42us; 1us; 43us; 3us; 44us; 46us; 49us; 1us; 44us; 1us; 45us; 2us; 46us; 49us; 2us; 48us; 50us; 2us; 48us; 50us; 1us; 48us; 1us; 49us; 1us; 49us; 1us; 49us; 1us; 51us; 1us; 52us; 5us; 53us; 54us; 55us; 56us; 58us; 5us; 53us; 54us; 55us; 56us; 58us; 2us; 53us; 54us; 2us; 53us; 54us; 1us; 53us; 1us; 54us; 1us; 55us; 1us; 56us; 1us; 57us; 3us; 57us; 943us; 944us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 2us; 60us; 61us; 48us; 60us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 1us; 61us; 48us; 61us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 1us; 61us; 3us; 62us; 63us; 144us; 1us; 62us; 1us; 62us; 1us; 63us; 1us; 63us; 1us; 63us; 1us; 63us; 1us; 64us; 1us; 64us; 1us; 64us; 1us; 65us; 1us; 65us; 2us; 66us; 67us; 1us; 66us; 1us; 66us; 2us; 68us; 69us; 1us; 68us; 1us; 68us; 1us; 69us; 3us; 70us; 79us; 80us; 1us; 70us; 1us; 70us; 1us; 70us; 1us; 70us; 1us; 70us; 1us; 70us; 1us; 71us; 1us; 71us; 1us; 72us; 1us; 73us; 1us; 74us; 1us; 74us; 1us; 74us; 1us; 75us; 3us; 76us; 77us; 78us; 2us; 76us; 77us; 1us; 76us; 1us; 77us; 1us; 78us; 1us; 78us; 2us; 79us; 80us; 2us; 79us; 80us; 1us; 79us; 1us; 80us; 2us; 81us; 82us; 2us; 81us; 82us; 1us; 81us; 1us; 82us; 2us; 83us; 84us; 2us; 83us; 84us; 1us; 83us; 1us; 84us; 1us; 85us; 1us; 86us; 1us; 88us; 1us; 88us; 1us; 88us; 7us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 12us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 264us; 265us; 266us; 267us; 268us; 7us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 12us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 264us; 265us; 266us; 267us; 268us; 1us; 89us; 1us; 89us; 1us; 89us; 1us; 89us; 1us; 89us; 1us; 89us; 1us; 89us; 1us; 89us; 1us; 89us; 1us; 90us; 4us; 90us; 867us; 868us; 869us; 1us; 91us; 4us; 91us; 867us; 868us; 869us; 1us; 92us; 1us; 92us; 3us; 93us; 94us; 174us; 1us; 93us; 1us; 93us; 1us; 94us; 1us; 94us; 1us; 95us; 1us; 95us; 1us; 95us; 1us; 97us; 1us; 97us; 2us; 98us; 99us; 2us; 98us; 99us; 1us; 98us; 1us; 99us; 2us; 100us; 101us; 1us; 101us; 1us; 101us; 1us; 102us; 2us; 103us; 104us; 1us; 104us; 1us; 105us; 1us; 105us; 1us; 106us; 1us; 106us; 1us; 106us; 2us; 108us; 109us; 1us; 108us; 1us; 109us; 1us; 109us; 2us; 110us; 133us; 1us; 110us; 2us; 111us; 112us; 1us; 112us; 2us; 113us; 114us; 1us; 113us; 1us; 115us; 1us; 115us; 1us; 115us; 11us; 116us; 124us; 125us; 126us; 128us; 136us; 137us; 138us; 139us; 140us; 141us; 10us; 116us; 124us; 125us; 126us; 136us; 137us; 138us; 139us; 140us; 141us; 2us; 116us; 141us; 1us; 116us; 1us; 117us; 3us; 118us; 119us; 120us; 2us; 118us; 119us; 1us; 118us; 1us; 118us; 1us; 119us; 2us; 120us; 133us; 1us; 120us; 1us; 121us; 1us; 122us; 10us; 124us; 125us; 126us; 128us; 136us; 137us; 138us; 139us; 140us; 141us; 9us; 124us; 125us; 126us; 136us; 137us; 138us; 139us; 140us; 141us; 50us; 124us; 125us; 126us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 2us; 124us; 125us; 1us; 124us; 1us; 127us; 1us; 128us; 4us; 129us; 130us; 131us; 132us; 1us; 129us; 2us; 130us; 132us; 1us; 130us; 1us; 133us; 2us; 133us; 150us; 2us; 133us; 155us; 1us; 133us; 1us; 133us; 1us; 134us; 1us; 135us; 6us; 136us; 137us; 138us; 139us; 140us; 141us; 6us; 136us; 137us; 138us; 139us; 140us; 141us; 1us; 136us; 3us; 136us; 519us; 520us; 1us; 137us; 5us; 137us; 521us; 522us; 523us; 524us; 1us; 138us; 1us; 139us; 1us; 139us; 1us; 139us; 1us; 140us; 1us; 141us; 1us; 141us; 1us; 141us; 2us; 142us; 157us; 1us; 142us; 1us; 143us; 3us; 144us; 943us; 944us; 1us; 144us; 3us; 145us; 943us; 944us; 5us; 146us; 147us; 148us; 149us; 150us; 2us; 146us; 147us; 1us; 146us; 1us; 147us; 2us; 148us; 149us; 1us; 148us; 1us; 149us; 1us; 150us; 1us; 151us; 3us; 152us; 943us; 944us; 3us; 153us; 154us; 155us; 2us; 153us; 154us; 1us; 153us; 1us; 154us; 1us; 155us; 1us; 156us; 1us; 156us; 1us; 156us; 1us; 157us; 2us; 159us; 160us; 1us; 160us; 4us; 161us; 162us; 163us; 164us; 3us; 161us; 163us; 166us; 2us; 161us; 163us; 1us; 161us; 1us; 161us; 2us; 162us; 517us; 1us; 162us; 1us; 162us; 1us; 163us; 1us; 164us; 1us; 165us; 2us; 166us; 1010us; 1us; 166us; 3us; 167us; 943us; 944us; 1us; 167us; 1us; 167us; 2us; 168us; 169us; 3us; 168us; 943us; 944us; 1us; 168us; 1us; 168us; 1us; 169us; 3us; 169us; 943us; 944us; 1us; 169us; 1us; 169us; 1us; 169us; 1us; 170us; 1us; 170us; 1us; 171us; 1us; 171us; 2us; 172us; 942us; 1us; 172us; 1us; 173us; 1us; 173us; 4us; 174us; 215us; 221us; 224us; 1us; 174us; 1us; 175us; 1us; 176us; 1us; 177us; 1us; 178us; 1us; 178us; 1us; 178us; 1us; 179us; 1us; 179us; 1us; 179us; 4us; 181us; 182us; 183us; 184us; 1us; 182us; 1us; 182us; 1us; 183us; 1us; 184us; 1us; 184us; 1us; 184us; 1us; 184us; 1us; 184us; 1us; 184us; 1us; 184us; 4us; 185us; 186us; 195us; 196us; 2us; 185us; 186us; 2us; 185us; 186us; 2us; 185us; 186us; 2us; 185us; 186us; 1us; 185us; 1us; 185us; 1us; 186us; 1us; 187us; 1us; 187us; 1us; 188us; 1us; 189us; 1us; 190us; 1us; 190us; 1us; 190us; 1us; 191us; 3us; 192us; 193us; 194us; 2us; 192us; 193us; 1us; 192us; 1us; 193us; 2us; 194us; 201us; 1us; 194us; 2us; 195us; 196us; 2us; 195us; 196us; 1us; 195us; 1us; 196us; 2us; 197us; 198us; 2us; 197us; 198us; 1us; 197us; 1us; 198us; 1us; 199us; 1us; 200us; 1us; 201us; 1us; 201us; 1us; 203us; 1us; 203us; 1us; 203us; 1us; 204us; 1us; 204us; 2us; 205us; 206us; 2us; 205us; 206us; 1us; 205us; 1us; 206us; 2us; 207us; 208us; 1us; 208us; 1us; 208us; 1us; 209us; 1us; 209us; 1us; 209us; 1us; 209us; 1us; 209us; 1us; 209us; 2us; 210us; 211us; 2us; 210us; 211us; 2us; 210us; 211us; 1us; 210us; 1us; 210us; 1us; 211us; 2us; 212us; 213us; 1us; 213us; 11us; 214us; 215us; 216us; 217us; 218us; 219us; 220us; 221us; 222us; 223us; 224us; 16us; 214us; 215us; 216us; 217us; 218us; 219us; 220us; 221us; 222us; 223us; 224us; 264us; 265us; 266us; 267us; 268us; 11us; 214us; 215us; 216us; 217us; 218us; 219us; 220us; 221us; 222us; 223us; 224us; 16us; 214us; 215us; 216us; 217us; 218us; 219us; 220us; 221us; 222us; 223us; 224us; 264us; 265us; 266us; 267us; 268us; 1us; 214us; 1us; 215us; 2us; 216us; 222us; 1us; 216us; 1us; 216us; 1us; 217us; 4us; 217us; 867us; 868us; 869us; 1us; 217us; 1us; 218us; 1us; 218us; 1us; 218us; 1us; 218us; 1us; 218us; 1us; 218us; 1us; 218us; 1us; 218us; 1us; 219us; 1us; 220us; 1us; 220us; 1us; 221us; 1us; 221us; 1us; 222us; 1us; 222us; 1us; 223us; 1us; 223us; 1us; 223us; 1us; 223us; 1us; 223us; 1us; 223us; 1us; 224us; 1us; 224us; 1us; 225us; 1us; 225us; 1us; 225us; 1us; 225us; 1us; 225us; 1us; 225us; 1us; 226us; 1us; 226us; 1us; 226us; 1us; 226us; 1us; 226us; 1us; 226us; 1us; 226us; 1us; 226us; 1us; 228us; 1us; 228us; 1us; 229us; 1us; 229us; 1us; 229us; 1us; 230us; 1us; 231us; 1us; 231us; 1us; 233us; 1us; 234us; 1us; 235us; 1us; 236us; 1us; 237us; 1us; 239us; 1us; 239us; 1us; 239us; 1us; 241us; 1us; 241us; 1us; 241us; 3us; 243us; 244us; 245us; 2us; 243us; 244us; 1us; 243us; 1us; 244us; 1us; 244us; 1us; 244us; 1us; 245us; 1us; 246us; 1us; 248us; 1us; 248us; 1us; 249us; 2us; 251us; 252us; 1us; 251us; 1us; 252us; 2us; 253us; 254us; 2us; 253us; 254us; 1us; 253us; 1us; 254us; 1us; 255us; 2us; 256us; 257us; 2us; 256us; 257us; 1us; 256us; 4us; 258us; 259us; 260us; 261us; 5us; 258us; 259us; 260us; 261us; 381us; 3us; 258us; 259us; 260us; 1us; 258us; 1us; 258us; 1us; 259us; 1us; 259us; 1us; 260us; 1us; 261us; 1us; 261us; 1us; 261us; 1us; 262us; 1us; 263us; 5us; 264us; 265us; 266us; 267us; 268us; 5us; 264us; 265us; 266us; 267us; 268us; 4us; 264us; 863us; 943us; 944us; 1us; 264us; 1us; 264us; 1us; 264us; 1us; 265us; 1us; 266us; 1us; 267us; 5us; 268us; 870us; 891us; 892us; 903us; 1us; 268us; 1us; 268us; 3us; 269us; 270us; 271us; 2us; 269us; 270us; 1us; 269us; 1us; 270us; 1us; 271us; 1us; 271us; 6us; 272us; 893us; 894us; 895us; 896us; 897us; 1us; 272us; 1us; 273us; 3us; 274us; 275us; 276us; 2us; 274us; 275us; 1us; 274us; 1us; 275us; 1us; 276us; 1us; 276us; 2us; 277us; 888us; 2us; 277us; 412us; 1us; 277us; 1us; 278us; 1us; 279us; 1us; 280us; 1us; 281us; 1us; 282us; 3us; 283us; 284us; 285us; 4us; 283us; 285us; 943us; 944us; 1us; 284us; 3us; 284us; 943us; 944us; 1us; 285us; 1us; 286us; 1us; 287us; 2us; 287us; 288us; 1us; 287us; 2us; 288us; 291us; 3us; 288us; 292us; 293us; 1us; 288us; 2us; 288us; 292us; 1us; 288us; 1us; 289us; 1us; 290us; 1us; 290us; 1us; 291us; 1us; 291us; 1us; 291us; 1us; 291us; 1us; 292us; 1us; 295us; 1us; 295us; 1us; 295us; 1us; 295us; 1us; 295us; 1us; 296us; 2us; 298us; 449us; 1us; 301us; 2us; 301us; 302us; 2us; 302us; 836us; 2us; 302us; 838us; 1us; 302us; 1us; 302us; 1us; 303us; 1us; 304us; 1us; 304us; 1us; 304us; 1us; 304us; 8us; 305us; 306us; 307us; 308us; 309us; 311us; 312us; 313us; 1us; 305us; 1us; 305us; 7us; 306us; 307us; 308us; 309us; 311us; 312us; 313us; 1us; 306us; 3us; 307us; 312us; 313us; 1us; 307us; 1us; 308us; 1us; 309us; 1us; 309us; 1us; 309us; 1us; 310us; 2us; 310us; 314us; 1us; 310us; 1us; 310us; 1us; 310us; 1us; 310us; 1us; 310us; 1us; 311us; 1us; 311us; 1us; 312us; 1us; 314us; 4us; 314us; 867us; 868us; 869us; 4us; 315us; 867us; 868us; 869us; 1us; 316us; 1us; 316us; 1us; 317us; 1us; 317us; 1us; 317us; 2us; 318us; 331us; 1us; 319us; 2us; 320us; 321us; 1us; 320us; 1us; 320us; 4us; 322us; 323us; 324us; 325us; 4us; 322us; 323us; 324us; 325us; 4us; 322us; 323us; 324us; 325us; 1us; 322us; 1us; 323us; 1us; 323us; 1us; 323us; 1us; 324us; 1us; 324us; 1us; 324us; 1us; 325us; 1us; 325us; 1us; 325us; 1us; 326us; 6us; 327us; 328us; 945us; 946us; 948us; 949us; 1us; 327us; 1us; 327us; 1us; 328us; 1us; 328us; 1us; 328us; 5us; 329us; 330us; 332us; 333us; 942us; 1us; 329us; 2us; 330us; 333us; 2us; 330us; 333us; 2us; 330us; 333us; 1us; 331us; 1us; 332us; 1us; 332us; 2us; 334us; 335us; 1us; 334us; 1us; 334us; 2us; 336us; 942us; 1us; 336us; 4us; 336us; 867us; 868us; 869us; 4us; 337us; 867us; 868us; 869us; 1us; 338us; 1us; 339us; 2us; 340us; 341us; 2us; 340us; 1010us; 1us; 340us; 1us; 341us; 1us; 342us; 1us; 342us; 1us; 343us; 1us; 343us; 1us; 343us; 1us; 343us; 1us; 343us; 1us; 344us; 1us; 344us; 1us; 345us; 1us; 346us; 1us; 346us; 1us; 346us; 1us; 346us; 1us; 346us; 2us; 347us; 348us; 1us; 348us; 1us; 348us; 1us; 350us; 3us; 350us; 943us; 944us; 1us; 351us; 3us; 351us; 943us; 944us; 1us; 352us; 1us; 352us; 1us; 352us; 1us; 353us; 1us; 354us; 1us; 354us; 1us; 355us; 1us; 355us; 1us; 355us; 1us; 355us; 1us; 356us; 1us; 356us; 1us; 356us; 1us; 357us; 1us; 358us; 1us; 359us; 1us; 360us; 1us; 361us; 1us; 362us; 1us; 363us; 1us; 363us; 1us; 363us; 1us; 363us; 1us; 363us; 1us; 363us; 1us; 363us; 1us; 363us; 2us; 364us; 367us; 2us; 365us; 368us; 1us; 367us; 1us; 367us; 1us; 368us; 1us; 368us; 2us; 369us; 370us; 5us; 369us; 370us; 372us; 373us; 374us; 1us; 370us; 3us; 371us; 943us; 944us; 4us; 372us; 373us; 374us; 376us; 1us; 372us; 1us; 372us; 1us; 372us; 1us; 373us; 1us; 374us; 1us; 375us; 2us; 375us; 377us; 1us; 375us; 2us; 376us; 377us; 1us; 378us; 1us; 378us; 1us; 379us; 1us; 379us; 1us; 379us; 1us; 381us; 1us; 381us; 1us; 382us; 3us; 383us; 384us; 385us; 3us; 383us; 384us; 385us; 3us; 383us; 384us; 385us; 3us; 383us; 384us; 385us; 2us; 383us; 384us; 1us; 383us; 1us; 384us; 1us; 385us; 2us; 386us; 387us; 2us; 386us; 387us; 1us; 386us; 1us; 387us; 1us; 388us; 1us; 389us; 2us; 389us; 390us; 1us; 390us; 1us; 392us; 2us; 392us; 393us; 1us; 392us; 1us; 392us; 1us; 393us; 1us; 393us; 1us; 394us; 2us; 395us; 396us; 1us; 395us; 1us; 395us; 1us; 396us; 1us; 397us; 1us; 398us; 1us; 399us; 1us; 400us; 1us; 401us; 1us; 402us; 1us; 403us; 1us; 404us; 1us; 405us; 1us; 406us; 1us; 407us; 1us; 408us; 1us; 409us; 2us; 409us; 462us; 1us; 410us; 1us; 411us; 1us; 412us; 1us; 413us; 2us; 414us; 416us; 1us; 414us; 1us; 414us; 2us; 415us; 417us; 2us; 415us; 417us; 1us; 415us; 1us; 415us; 1us; 418us; 1us; 419us; 1us; 419us; 1us; 419us; 1us; 420us; 1us; 421us; 1us; 421us; 2us; 422us; 423us; 1us; 423us; 1us; 423us; 6us; 424us; 436us; 437us; 438us; 443us; 445us; 1us; 425us; 1us; 426us; 1us; 426us; 2us; 427us; 428us; 3us; 427us; 429us; 430us; 1us; 427us; 1us; 427us; 1us; 428us; 1us; 430us; 1us; 430us; 5us; 431us; 432us; 433us; 434us; 435us; 2us; 431us; 433us; 1us; 431us; 1us; 432us; 1us; 433us; 2us; 434us; 517us; 1us; 434us; 1us; 435us; 6us; 436us; 437us; 437us; 438us; 443us; 445us; 6us; 436us; 437us; 438us; 438us; 443us; 445us; 6us; 436us; 437us; 438us; 442us; 443us; 445us; 6us; 436us; 437us; 438us; 443us; 443us; 445us; 6us; 436us; 437us; 438us; 443us; 444us; 445us; 6us; 436us; 437us; 438us; 443us; 445us; 445us; 6us; 436us; 437us; 438us; 443us; 445us; 566us; 7us; 436us; 437us; 438us; 443us; 445us; 567us; 568us; 1us; 436us; 1us; 436us; 1us; 437us; 1us; 438us; 2us; 439us; 442us; 2us; 440us; 444us; 1us; 441us; 1us; 442us; 1us; 443us; 1us; 444us; 1us; 445us; 2us; 446us; 447us; 1us; 446us; 2us; 447us; 1010us; 1us; 447us; 1us; 448us; 4us; 448us; 981us; 983us; 984us; 1us; 448us; 7us; 448us; 483us; 484us; 487us; 489us; 492us; 494us; 5us; 449us; 450us; 451us; 452us; 468us; 3us; 450us; 451us; 452us; 1us; 450us; 1us; 451us; 1us; 451us; 1us; 452us; 1us; 452us; 1us; 453us; 1us; 453us; 1us; 454us; 9us; 455us; 473us; 474us; 475us; 476us; 945us; 946us; 948us; 949us; 1us; 455us; 1us; 455us; 1us; 456us; 4us; 457us; 458us; 459us; 460us; 1us; 457us; 1us; 458us; 1us; 458us; 1us; 459us; 1us; 459us; 1us; 461us; 1us; 462us; 1us; 462us; 1us; 463us; 1us; 463us; 1us; 463us; 1us; 464us; 1us; 464us; 1us; 464us; 1us; 465us; 1us; 465us; 1us; 465us; 1us; 466us; 1us; 467us; 2us; 467us; 966us; 1us; 467us; 1us; 468us; 1us; 469us; 1us; 470us; 1us; 471us; 1us; 472us; 8us; 473us; 474us; 475us; 476us; 945us; 946us; 948us; 949us; 2us; 473us; 474us; 1us; 473us; 1us; 474us; 3us; 475us; 517us; 946us; 2us; 475us; 946us; 1us; 476us; 4us; 477us; 478us; 479us; 480us; 4us; 477us; 478us; 479us; 480us; 4us; 477us; 478us; 485us; 491us; 1us; 477us; 1us; 478us; 2us; 479us; 517us; 1us; 479us; 1us; 480us; 7us; 481us; 483us; 484us; 487us; 489us; 492us; 494us; 7us; 483us; 484us; 484us; 487us; 489us; 492us; 494us; 7us; 483us; 484us; 487us; 488us; 489us; 492us; 494us; 7us; 483us; 484us; 487us; 489us; 489us; 492us; 494us; 7us; 483us; 484us; 487us; 489us; 491us; 492us; 494us; 7us; 483us; 484us; 487us; 489us; 492us; 492us; 494us; 7us; 483us; 484us; 487us; 489us; 492us; 493us; 494us; 6us; 483us; 484us; 487us; 489us; 492us; 494us; 7us; 483us; 484us; 487us; 489us; 492us; 494us; 494us; 7us; 483us; 484us; 487us; 489us; 492us; 494us; 497us; 8us; 483us; 484us; 487us; 489us; 492us; 494us; 499us; 500us; 14us; 483us; 484us; 487us; 489us; 492us; 494us; 562us; 563us; 760us; 761us; 762us; 763us; 764us; 765us; 7us; 483us; 484us; 487us; 489us; 492us; 494us; 631us; 1us; 483us; 1us; 483us; 1us; 484us; 2us; 485us; 491us; 2us; 486us; 493us; 1us; 487us; 1us; 487us; 1us; 488us; 1us; 489us; 1us; 490us; 1us; 491us; 1us; 492us; 1us; 493us; 1us; 494us; 2us; 495us; 496us; 1us; 495us; 2us; 496us; 1010us; 1us; 496us; 3us; 497us; 943us; 944us; 1us; 497us; 1us; 499us; 2us; 500us; 1010us; 1us; 500us; 2us; 501us; 502us; 2us; 501us; 502us; 1us; 501us; 1us; 502us; 1us; 503us; 1us; 504us; 1us; 504us; 1us; 504us; 48us; 505us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 2us; 506us; 507us; 1us; 506us; 2us; 508us; 509us; 1us; 508us; 1us; 508us; 1us; 510us; 1us; 510us; 52us; 511us; 512us; 513us; 514us; 515us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 55us; 511us; 512us; 513us; 514us; 515us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 701us; 702us; 705us; 55us; 511us; 512us; 513us; 514us; 515us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 756us; 757us; 758us; 2us; 511us; 512us; 1us; 511us; 1us; 514us; 1us; 514us; 1us; 515us; 1us; 515us; 1us; 515us; 1us; 515us; 5us; 516us; 521us; 522us; 523us; 524us; 1us; 517us; 2us; 517us; 549us; 2us; 517us; 552us; 2us; 517us; 557us; 2us; 517us; 560us; 2us; 517us; 562us; 2us; 517us; 682us; 2us; 517us; 697us; 2us; 517us; 722us; 2us; 517us; 726us; 2us; 517us; 731us; 3us; 517us; 731us; 946us; 2us; 517us; 746us; 2us; 517us; 822us; 1us; 518us; 2us; 519us; 520us; 2us; 519us; 520us; 1us; 519us; 1us; 520us; 4us; 521us; 522us; 523us; 524us; 1us; 521us; 1us; 522us; 2us; 523us; 524us; 1us; 523us; 1us; 524us; 1us; 525us; 1us; 526us; 1us; 527us; 2us; 528us; 529us; 2us; 528us; 529us; 1us; 528us; 1us; 529us; 2us; 530us; 531us; 2us; 530us; 531us; 1us; 530us; 1us; 531us; 3us; 532us; 533us; 534us; 3us; 532us; 533us; 534us; 1us; 532us; 1us; 533us; 1us; 534us; 1us; 534us; 3us; 535us; 536us; 537us; 49us; 535us; 536us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 1us; 535us; 1us; 536us; 1us; 537us; 1us; 538us; 48us; 538us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 2us; 539us; 540us; 48us; 539us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 1us; 541us; 1us; 541us; 2us; 542us; 543us; 1us; 542us; 6us; 544us; 545us; 546us; 547us; 548us; 549us; 51us; 544us; 545us; 546us; 547us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 3us; 544us; 545us; 546us; 2us; 544us; 545us; 1us; 544us; 1us; 545us; 1us; 546us; 1us; 546us; 1us; 547us; 1us; 548us; 1us; 549us; 15us; 550us; 551us; 552us; 553us; 554us; 555us; 556us; 557us; 558us; 559us; 560us; 561us; 562us; 563us; 571us; 6us; 550us; 551us; 552us; 553us; 554us; 571us; 4us; 550us; 551us; 552us; 553us; 2us; 550us; 551us; 1us; 550us; 1us; 551us; 1us; 552us; 1us; 553us; 1us; 554us; 5us; 555us; 556us; 557us; 558us; 559us; 4us; 555us; 556us; 557us; 558us; 2us; 555us; 556us; 1us; 555us; 1us; 556us; 1us; 557us; 1us; 558us; 1us; 559us; 1us; 560us; 1us; 560us; 1us; 560us; 1us; 561us; 1us; 562us; 2us; 563us; 1063us; 1us; 564us; 48us; 564us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 1us; 565us; 48us; 565us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 1us; 566us; 1us; 566us; 1us; 566us; 1us; 566us; 1us; 566us; 1us; 566us; 2us; 567us; 568us; 2us; 567us; 568us; 2us; 567us; 568us; 2us; 567us; 568us; 2us; 567us; 568us; 1us; 567us; 1us; 568us; 1us; 569us; 1us; 569us; 1us; 569us; 1us; 569us; 1us; 569us; 1us; 570us; 1us; 570us; 1us; 570us; 1us; 571us; 1us; 571us; 1us; 572us; 48us; 572us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 1us; 573us; 1us; 573us; 48us; 574us; 575us; 576us; 577us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 637us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 641us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 645us; 652us; 653us; 49us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 648us; 649us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 650us; 652us; 653us; 47us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 653us; 50us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 701us; 702us; 705us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 701us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 703us; 51us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 756us; 757us; 758us; 760us; 51us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 756us; 757us; 758us; 764us; 49us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 756us; 757us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 757us; 48us; 574us; 575us; 576us; 577us; 580us; 581us; 582us; 583us; 584us; 585us; 586us; 587us; 588us; 589us; 590us; 591us; 592us; 593us; 594us; 595us; 596us; 597us; 598us; 599us; 600us; 601us; 602us; 603us; 604us; 605us; 606us; 607us; 608us; 609us; 610us; 611us; 612us; 613us; 614us; 615us; 616us; 617us; 618us; 619us; 620us; 652us; 653us; 764us; 1us; 574us; 1us; 574us; 1us; 575us; 1us; 575us; 1us; 576us; 1us; 576us; 1us; 577us; 2us; 578us; 621us; 1us; 578us; 1us; 578us; 3us; 579us; 650us; 651us; 5us; 579us; 650us; 651us; 684us; 685us; 2us; 580us; 601us; 2us; 581us; 602us; 2us; 582us; 603us; 2us; 583us; 604us; 2us; 584us; 605us; 2us; 585us; 606us; 2us; 586us; 607us; 2us; 587us; 608us; 2us; 588us; 609us; 2us; 589us; 610us; 3us; 590us; 591us; 611us; 1us; 591us; 2us; 592us; 612us; 2us; 593us; 613us; 2us; 594us; 614us; 2us; 595us; 615us; 2us; 596us; 616us; 2us; 597us; 617us; 2us; 598us; 618us; 2us; 599us; 619us; 2us; 600us; 620us; 1us; 601us; 1us; 602us; 1us; 603us; 1us; 604us; 1us; 605us; 1us; 606us; 1us; 607us; 1us; 608us; 1us; 609us; 1us; 610us; 1us; 611us; 1us; 612us; 1us; 613us; 1us; 614us; 1us; 615us; 1us; 616us; 1us; 617us; 1us; 618us; 1us; 619us; 1us; 620us; 1us; 622us; 1us; 623us; 1us; 623us; 1us; 623us; 1us; 624us; 1us; 624us; 2us; 625us; 626us; 2us; 625us; 626us; 1us; 625us; 1us; 626us; 1us; 627us; 2us; 628us; 629us; 1us; 628us; 1us; 629us; 1us; 630us; 1us; 631us; 5us; 632us; 633us; 634us; 635us; 636us; 4us; 632us; 633us; 634us; 635us; 2us; 633us; 634us; 1us; 633us; 1us; 634us; 1us; 635us; 1us; 636us; 1us; 637us; 1us; 639us; 1us; 639us; 1us; 640us; 1us; 640us; 1us; 641us; 2us; 642us; 643us; 2us; 642us; 643us; 2us; 642us; 643us; 1us; 642us; 1us; 643us; 1us; 645us; 2us; 646us; 647us; 2us; 646us; 647us; 2us; 646us; 647us; 1us; 646us; 1us; 647us; 2us; 648us; 649us; 1us; 648us; 1us; 649us; 2us; 650us; 651us; 1us; 651us; 2us; 652us; 653us; 1us; 652us; 1us; 654us; 2us; 654us; 960us; 1us; 654us; 1us; 655us; 2us; 655us; 956us; 1us; 655us; 1us; 656us; 2us; 656us; 959us; 1us; 656us; 1us; 657us; 2us; 657us; 972us; 1us; 657us; 1us; 658us; 2us; 658us; 967us; 1us; 658us; 1us; 659us; 2us; 659us; 968us; 1us; 659us; 3us; 660us; 661us; 662us; 7us; 660us; 661us; 662us; 804us; 805us; 806us; 807us; 2us; 660us; 661us; 6us; 660us; 661us; 804us; 805us; 806us; 807us; 2us; 660us; 661us; 4us; 660us; 661us; 805us; 806us; 1us; 660us; 3us; 660us; 805us; 806us; 1us; 661us; 1us; 662us; 1us; 663us; 1us; 663us; 1us; 664us; 1us; 664us; 2us; 665us; 666us; 6us; 665us; 666us; 780us; 784us; 785us; 786us; 5us; 666us; 780us; 784us; 785us; 786us; 1us; 666us; 6us; 667us; 670us; 671us; 672us; 674us; 677us; 1us; 668us; 6us; 668us; 670us; 671us; 672us; 674us; 677us; 6us; 669us; 670us; 671us; 672us; 674us; 677us; 6us; 670us; 670us; 671us; 672us; 674us; 677us; 6us; 670us; 671us; 671us; 672us; 674us; 677us; 6us; 670us; 671us; 672us; 673us; 674us; 677us; 6us; 670us; 671us; 672us; 674us; 677us; 900us; 1us; 670us; 1us; 671us; 1us; 672us; 1us; 672us; 1us; 673us; 2us; 673us; 950us; 1us; 674us; 1us; 674us; 1us; 675us; 1us; 675us; 1us; 675us; 1us; 676us; 2us; 676us; 966us; 1us; 676us; 1us; 677us; 1us; 677us; 1us; 678us; 1us; 679us; 4us; 680us; 681us; 682us; 683us; 2us; 680us; 681us; 1us; 680us; 1us; 681us; 1us; 682us; 1us; 683us; 3us; 684us; 685us; 818us; 2us; 684us; 685us; 1us; 684us; 1us; 685us; 1us; 686us; 1us; 687us; 1us; 688us; 1us; 690us; 6us; 691us; 692us; 945us; 946us; 948us; 949us; 1us; 691us; 1us; 691us; 1us; 691us; 1us; 691us; 1us; 692us; 1us; 692us; 6us; 693us; 694us; 695us; 696us; 697us; 698us; 2us; 693us; 694us; 1us; 693us; 1us; 694us; 2us; 695us; 696us; 1us; 695us; 1us; 696us; 1us; 697us; 1us; 698us; 2us; 699us; 700us; 1us; 699us; 1us; 699us; 2us; 701us; 702us; 1us; 703us; 1us; 704us; 1us; 706us; 1us; 707us; 1us; 708us; 1us; 709us; 1us; 710us; 1us; 711us; 1us; 712us; 1us; 713us; 1us; 714us; 1us; 715us; 4us; 716us; 717us; 718us; 719us; 2us; 716us; 717us; 1us; 716us; 1us; 717us; 1us; 718us; 1us; 718us; 1us; 719us; 4us; 720us; 721us; 722us; 723us; 5us; 720us; 721us; 722us; 723us; 975us; 2us; 720us; 721us; 1us; 720us; 1us; 721us; 1us; 722us; 1us; 723us; 4us; 724us; 725us; 726us; 727us; 2us; 724us; 725us; 1us; 724us; 1us; 725us; 1us; 726us; 1us; 727us; 9us; 728us; 729us; 730us; 731us; 732us; 733us; 734us; 735us; 736us; 14us; 728us; 729us; 730us; 731us; 732us; 733us; 734us; 735us; 736us; 741us; 945us; 946us; 948us; 949us; 13us; 728us; 729us; 730us; 731us; 732us; 733us; 734us; 735us; 736us; 945us; 946us; 948us; 949us; 1us; 728us; 2us; 729us; 730us; 1us; 729us; 1us; 730us; 1us; 731us; 2us; 731us; 946us; 1us; 732us; 1us; 733us; 1us; 734us; 1us; 735us; 1us; 736us; 1us; 737us; 1us; 737us; 1us; 737us; 1us; 737us; 1us; 737us; 1us; 737us; 1us; 738us; 1us; 739us; 1us; 740us; 2us; 740us; 743us; 2us; 741us; 742us; 1us; 741us; 1us; 742us; 1us; 742us; 5us; 744us; 745us; 746us; 747us; 748us; 2us; 744us; 745us; 1us; 744us; 1us; 745us; 1us; 746us; 1us; 747us; 1us; 748us; 1us; 749us; 1us; 750us; 1us; 751us; 1us; 752us; 1us; 754us; 1us; 755us; 3us; 756us; 757us; 758us; 1us; 757us; 1us; 758us; 1us; 759us; 1us; 759us; 3us; 760us; 761us; 762us; 1us; 761us; 1us; 762us; 1us; 763us; 2us; 764us; 765us; 1us; 764us; 1us; 765us; 1us; 766us; 1us; 767us; 1us; 768us; 1us; 768us; 1us; 768us; 2us; 768us; 769us; 1us; 768us; 1us; 768us; 1us; 769us; 1us; 772us; 1us; 774us; 1us; 774us; 1us; 774us; 1us; 774us; 2us; 776us; 777us; 1us; 776us; 5us; 777us; 870us; 891us; 892us; 903us; 1us; 777us; 1us; 778us; 1us; 778us; 1us; 778us; 1us; 778us; 2us; 778us; 795us; 1us; 778us; 1us; 779us; 1us; 780us; 1us; 780us; 2us; 780us; 795us; 1us; 780us; 3us; 781us; 782us; 783us; 2us; 782us; 783us; 1us; 783us; 2us; 783us; 795us; 1us; 783us; 1us; 784us; 1us; 784us; 2us; 784us; 795us; 1us; 784us; 2us; 785us; 786us; 1us; 785us; 1us; 785us; 1us; 786us; 2us; 786us; 795us; 1us; 786us; 1us; 786us; 1us; 787us; 2us; 787us; 795us; 2us; 789us; 792us; 2us; 790us; 791us; 1us; 791us; 1us; 792us; 3us; 793us; 943us; 944us; 1us; 794us; 1us; 795us; 5us; 797us; 798us; 799us; 800us; 801us; 3us; 797us; 798us; 799us; 1us; 797us; 1us; 799us; 1us; 801us; 2us; 802us; 803us; 1us; 802us; 1us; 802us; 1us; 802us; 1us; 803us; 1us; 803us; 1us; 805us; 1us; 808us; 2us; 810us; 812us; 1us; 810us; 1us; 811us; 1us; 811us; 1us; 811us; 1us; 812us; 1us; 812us; 1us; 813us; 1us; 813us; 1us; 815us; 1us; 815us; 1us; 816us; 1us; 816us; 1us; 817us; 4us; 817us; 867us; 868us; 869us; 1us; 817us; 1us; 817us; 1us; 817us; 1us; 818us; 1us; 818us; 1us; 819us; 5us; 820us; 821us; 822us; 823us; 824us; 2us; 820us; 821us; 1us; 820us; 1us; 821us; 1us; 822us; 1us; 823us; 1us; 824us; 2us; 825us; 826us; 2us; 825us; 826us; 2us; 825us; 826us; 1us; 825us; 1us; 826us; 6us; 827us; 828us; 829us; 830us; 831us; 832us; 5us; 827us; 828us; 829us; 830us; 831us; 4us; 827us; 828us; 829us; 830us; 2us; 827us; 828us; 1us; 827us; 1us; 828us; 1us; 829us; 1us; 829us; 1us; 830us; 1us; 831us; 1us; 831us; 1us; 832us; 1us; 832us; 1us; 833us; 1us; 833us; 1us; 834us; 1us; 834us; 1us; 834us; 2us; 835us; 836us; 1us; 836us; 2us; 837us; 838us; 1us; 838us; 1us; 840us; 1us; 840us; 2us; 841us; 842us; 1us; 841us; 1us; 841us; 2us; 843us; 844us; 1us; 843us; 1us; 843us; 2us; 845us; 846us; 1us; 845us; 1us; 845us; 3us; 847us; 848us; 849us; 5us; 847us; 849us; 867us; 868us; 869us; 1us; 847us; 4us; 847us; 867us; 868us; 869us; 1us; 848us; 1us; 848us; 1us; 848us; 4us; 848us; 867us; 868us; 869us; 5us; 850us; 852us; 867us; 868us; 869us; 1us; 850us; 4us; 850us; 867us; 868us; 869us; 1us; 851us; 1us; 851us; 1us; 851us; 4us; 851us; 867us; 868us; 869us; 2us; 853us; 854us; 1us; 853us; 1us; 853us; 1us; 855us; 1us; 855us; 6us; 856us; 858us; 859us; 867us; 868us; 869us; 1us; 856us; 1us; 856us; 1us; 857us; 1us; 857us; 1us; 858us; 1us; 858us; 6us; 860us; 861us; 862us; 867us; 868us; 869us; 1us; 860us; 1us; 860us; 1us; 861us; 1us; 861us; 3us; 863us; 943us; 944us; 1us; 864us; 2us; 864us; 872us; 2us; 865us; 866us; 4us; 865us; 866us; 904us; 907us; 1us; 865us; 1us; 865us; 7us; 867us; 868us; 869us; 893us; 894us; 895us; 896us; 1us; 867us; 1us; 868us; 1us; 868us; 1us; 869us; 4us; 870us; 891us; 892us; 903us; 1us; 870us; 1us; 870us; 1us; 870us; 1us; 871us; 1us; 872us; 1us; 872us; 2us; 873us; 890us; 1us; 873us; 1us; 873us; 4us; 874us; 875us; 876us; 877us; 1us; 874us; 3us; 875us; 876us; 877us; 1us; 875us; 2us; 876us; 877us; 1us; 876us; 1us; 877us; 1us; 877us; 1us; 878us; 1us; 878us; 1us; 878us; 3us; 878us; 879us; 880us; 4us; 879us; 880us; 910us; 911us; 2us; 879us; 880us; 1us; 879us; 1us; 880us; 2us; 882us; 883us; 1us; 883us; 1us; 883us; 4us; 884us; 891us; 892us; 903us; 1us; 884us; 1us; 884us; 1us; 884us; 3us; 885us; 905us; 906us; 3us; 886us; 905us; 906us; 1us; 887us; 1us; 888us; 3us; 888us; 905us; 906us; 1us; 889us; 1us; 890us; 3us; 891us; 892us; 903us; 2us; 891us; 892us; 5us; 891us; 892us; 917us; 918us; 919us; 1us; 891us; 1us; 892us; 5us; 893us; 894us; 895us; 896us; 897us; 5us; 893us; 894us; 895us; 896us; 897us; 3us; 893us; 894us; 895us; 2us; 893us; 894us; 1us; 893us; 1us; 894us; 1us; 895us; 1us; 896us; 1us; 897us; 1us; 898us; 1us; 899us; 1us; 900us; 1us; 901us; 1us; 902us; 1us; 903us; 1us; 903us; 1us; 904us; 2us; 905us; 906us; 4us; 905us; 906us; 943us; 944us; 1us; 906us; 1us; 907us; 1us; 907us; 1us; 908us; 1us; 909us; 1us; 909us; 7us; 910us; 911us; 912us; 913us; 914us; 915us; 916us; 3us; 910us; 911us; 912us; 3us; 910us; 911us; 912us; 2us; 910us; 911us; 1us; 910us; 1us; 911us; 1us; 912us; 3us; 913us; 914us; 920us; 1us; 913us; 1us; 914us; 1us; 915us; 1us; 916us; 3us; 917us; 918us; 919us; 2us; 918us; 919us; 1us; 918us; 1us; 920us; 1us; 921us; 2us; 923us; 924us; 3us; 923us; 934us; 935us; 1us; 923us; 1us; 924us; 1us; 924us; 3us; 925us; 943us; 944us; 1us; 926us; 1us; 927us; 3us; 927us; 934us; 935us; 1us; 927us; 2us; 928us; 929us; 1us; 929us; 1us; 929us; 1us; 930us; 2us; 931us; 932us; 1us; 932us; 1us; 933us; 3us; 934us; 934us; 935us; 3us; 934us; 935us; 935us; 3us; 934us; 935us; 936us; 1us; 934us; 1us; 935us; 1us; 936us; 1us; 937us; 1us; 937us; 1us; 938us; 1us; 939us; 2us; 939us; 953us; 1us; 939us; 1us; 940us; 1us; 941us; 1us; 942us; 2us; 943us; 944us; 1us; 943us; 1us; 944us; 4us; 945us; 946us; 948us; 949us; 1us; 945us; 1us; 945us; 1us; 946us; 1us; 946us; 1us; 947us; 3us; 948us; 949us; 978us; 3us; 948us; 949us; 978us; 1us; 948us; 1us; 949us; 1us; 949us; 1us; 949us; 1us; 950us; 1us; 951us; 1us; 952us; 1us; 953us; 1us; 954us; 1us; 955us; 1us; 956us; 1us; 957us; 1us; 958us; 1us; 959us; 1us; 960us; 1us; 961us; 1us; 962us; 1us; 963us; 1us; 964us; 1us; 965us; 1us; 966us; 1us; 967us; 1us; 968us; 1us; 969us; 1us; 970us; 1us; 971us; 1us; 972us; 2us; 973us; 974us; 1us; 974us; 1us; 975us; 1us; 975us; 1us; 976us; 1us; 977us; 1us; 977us; 1us; 978us; 1us; 979us; 1us; 980us; 3us; 981us; 983us; 984us; 1us; 982us; 2us; 983us; 984us; 1us; 983us; 1us; 984us; 1us; 985us; 1us; 986us; 1us; 987us; 1us; 988us; 2us; 989us; 990us; 1us; 990us; 1us; 991us; 1us; 991us; 2us; 993us; 995us; 2us; 994us; 996us; 1us; 995us; 1us; 996us; 1us; 997us; 1us; 998us; 1us; 999us; 1us; 1000us; 1us; 1001us; 1us; 1002us; 1us; 1004us; 1us; 1006us; 1us; 1008us; 1us; 1010us; 1us; 1012us; 1us; 1016us; 1us; 1018us; 1us; 1020us; 1us; 1021us; 1us; 1022us; 1us; 1023us; 1us; 1024us; 1us; 1025us; 1us; 1026us; 1us; 1027us; 1us; 1028us; 1us; 1029us; 1us; 1030us; 1us; 1031us; 1us; 1032us; 1us; 1033us; 1us; 1035us; 1us; 1037us; 2us; 1037us; 1058us; 1us; 1037us; 1us; 1038us; 1us; 1039us; 1us; 1040us; 2us; 1040us; 1059us; 1us; 1040us; 1us; 1041us; 1us; 1042us; 1us; 1043us; 1us; 1043us; 1us; 1044us; 1us; 1045us; 1us; 1046us; 1us; 1047us; 1us; 1047us; 1us; 1048us; 1us; 1049us; 1us; 1050us; 1us; 1050us; 1us; 1051us; 1us; 1052us; 1us; 1053us; 1us; 1054us; 1us; 1055us; 1us; 1056us; 1us; 1057us; 1us; 1058us; 1us; 1059us; 1us; 1060us; 1us; 1061us; 1us; 1062us; 1us; 1063us; |]
let _fsyacc_stateToProdIdxsTableRowOffsets = [|0us; 2us; 4us; 6us; 8us; 10us; 12us; 14us; 16us; 18us; 20us; 22us; 24us; 26us; 28us; 30us; 32us; 35us; 37us; 40us; 42us; 45us; 47us; 49us; 51us; 53us; 55us; 57us; 59us; 62us; 64us; 72us; 80us; 129us; 131us; 134us; 136us; 138us; 140us; 142us; 144us; 147us; 149us; 151us; 154us; 156us; 158us; 160us; 164us; 166us; 168us; 170us; 172us; 176us; 178us; 180us; 184us; 187us; 189us; 192us; 194us; 196us; 198us; 200us; 207us; 214us; 218us; 220us; 222us; 224us; 228us; 231us; 233us; 235us; 237us; 241us; 243us; 245us; 248us; 251us; 254us; 256us; 258us; 260us; 262us; 264us; 266us; 272us; 278us; 281us; 284us; 286us; 288us; 290us; 292us; 294us; 298us; 300us; 302us; 304us; 306us; 308us; 310us; 312us; 314us; 316us; 318us; 321us; 370us; 372us; 421us; 423us; 427us; 429us; 431us; 433us; 435us; 437us; 439us; 441us; 443us; 445us; 447us; 449us; 452us; 454us; 456us; 459us; 461us; 463us; 465us; 469us; 471us; 473us; 475us; 477us; 479us; 481us; 483us; 485us; 487us; 489us; 491us; 493us; 495us; 497us; 501us; 504us; 506us; 508us; 510us; 512us; 515us; 518us; 520us; 522us; 525us; 528us; 530us; 532us; 535us; 538us; 540us; 542us; 544us; 546us; 548us; 550us; 552us; 560us; 573us; 581us; 594us; 596us; 598us; 600us; 602us; 604us; 606us; 608us; 610us; 612us; 614us; 619us; 621us; 626us; 628us; 630us; 634us; 636us; 638us; 640us; 642us; 644us; 646us; 648us; 650us; 652us; 655us; 658us; 660us; 662us; 665us; 667us; 669us; 671us; 674us; 676us; 678us; 680us; 682us; 684us; 686us; 689us; 691us; 693us; 695us; 698us; 700us; 703us; 705us; 708us; 710us; 712us; 714us; 716us; 728us; 739us; 742us; 744us; 746us; 750us; 753us; 755us; 757us; 759us; 762us; 764us; 766us; 768us; 779us; 789us; 840us; 843us; 845us; 847us; 849us; 854us; 856us; 859us; 861us; 863us; 866us; 869us; 871us; 873us; 875us; 877us; 884us; 891us; 893us; 897us; 899us; 905us; 907us; 909us; 911us; 913us; 915us; 917us; 919us; 921us; 924us; 926us; 928us; 932us; 934us; 938us; 944us; 947us; 949us; 951us; 954us; 956us; 958us; 960us; 962us; 966us; 970us; 973us; 975us; 977us; 979us; 981us; 983us; 985us; 987us; 990us; 992us; 997us; 1001us; 1004us; 1006us; 1008us; 1011us; 1013us; 1015us; 1017us; 1019us; 1021us; 1024us; 1026us; 1030us; 1032us; 1034us; 1037us; 1041us; 1043us; 1045us; 1047us; 1051us; 1053us; 1055us; 1057us; 1059us; 1061us; 1063us; 1065us; 1068us; 1070us; 1072us; 1074us; 1079us; 1081us; 1083us; 1085us; 1087us; 1089us; 1091us; 1093us; 1095us; 1097us; 1099us; 1104us; 1106us; 1108us; 1110us; 1112us; 1114us; 1116us; 1118us; 1120us; 1122us; 1124us; 1129us; 1132us; 1135us; 1138us; 1141us; 1143us; 1145us; 1147us; 1149us; 1151us; 1153us; 1155us; 1157us; 1159us; 1161us; 1163us; 1167us; 1170us; 1172us; 1174us; 1177us; 1179us; 1182us; 1185us; 1187us; 1189us; 1192us; 1195us; 1197us; 1199us; 1201us; 1203us; 1205us; 1207us; 1209us; 1211us; 1213us; 1215us; 1217us; 1220us; 1223us; 1225us; 1227us; 1230us; 1232us; 1234us; 1236us; 1238us; 1240us; 1242us; 1244us; 1246us; 1249us; 1252us; 1255us; 1257us; 1259us; 1261us; 1264us; 1266us; 1278us; 1295us; 1307us; 1324us; 1326us; 1328us; 1331us; 1333us; 1335us; 1337us; 1342us; 1344us; 1346us; 1348us; 1350us; 1352us; 1354us; 1356us; 1358us; 1360us; 1362us; 1364us; 1366us; 1368us; 1370us; 1372us; 1374us; 1376us; 1378us; 1380us; 1382us; 1384us; 1386us; 1388us; 1390us; 1392us; 1394us; 1396us; 1398us; 1400us; 1402us; 1404us; 1406us; 1408us; 1410us; 1412us; 1414us; 1416us; 1418us; 1420us; 1422us; 1424us; 1426us; 1428us; 1430us; 1432us; 1434us; 1436us; 1438us; 1440us; 1442us; 1444us; 1446us; 1448us; 1450us; 1452us; 1454us; 1456us; 1460us; 1463us; 1465us; 1467us; 1469us; 1471us; 1473us; 1475us; 1477us; 1479us; 1481us; 1484us; 1486us; 1488us; 1491us; 1494us; 1496us; 1498us; 1500us; 1503us; 1506us; 1508us; 1513us; 1519us; 1523us; 1525us; 1527us; 1529us; 1531us; 1533us; 1535us; 1537us; 1539us; 1541us; 1543us; 1549us; 1555us; 1560us; 1562us; 1564us; 1566us; 1568us; 1570us; 1572us; 1578us; 1580us; 1582us; 1586us; 1589us; 1591us; 1593us; 1595us; 1597us; 1604us; 1606us; 1608us; 1612us; 1615us; 1617us; 1619us; 1621us; 1623us; 1626us; 1629us; 1631us; 1633us; 1635us; 1637us; 1639us; 1641us; 1645us; 1650us; 1652us; 1656us; 1658us; 1660us; 1662us; 1665us; 1667us; 1670us; 1674us; 1676us; 1679us; 1681us; 1683us; 1685us; 1687us; 1689us; 1691us; 1693us; 1695us; 1697us; 1699us; 1701us; 1703us; 1705us; 1707us; 1709us; 1712us; 1714us; 1717us; 1720us; 1723us; 1725us; 1727us; 1729us; 1731us; 1733us; 1735us; 1737us; 1746us; 1748us; 1750us; 1758us; 1760us; 1764us; 1766us; 1768us; 1770us; 1772us; 1774us; 1776us; 1779us; 1781us; 1783us; 1785us; 1787us; 1789us; 1791us; 1793us; 1795us; 1797us; 1802us; 1807us; 1809us; 1811us; 1813us; 1815us; 1817us; 1820us; 1822us; 1825us; 1827us; 1829us; 1834us; 1839us; 1844us; 1846us; 1848us; 1850us; 1852us; 1854us; 1856us; 1858us; 1860us; 1862us; 1864us; 1866us; 1873us; 1875us; 1877us; 1879us; 1881us; 1883us; 1889us; 1891us; 1894us; 1897us; 1900us; 1902us; 1904us; 1906us; 1909us; 1911us; 1913us; 1916us; 1918us; 1923us; 1928us; 1930us; 1932us; 1935us; 1938us; 1940us; 1942us; 1944us; 1946us; 1948us; 1950us; 1952us; 1954us; 1956us; 1958us; 1960us; 1962us; 1964us; 1966us; 1968us; 1970us; 1972us; 1975us; 1977us; 1979us; 1981us; 1985us; 1987us; 1991us; 1993us; 1995us; 1997us; 1999us; 2001us; 2003us; 2005us; 2007us; 2009us; 2011us; 2013us; 2015us; 2017us; 2019us; 2021us; 2023us; 2025us; 2027us; 2029us; 2031us; 2033us; 2035us; 2037us; 2039us; 2041us; 2043us; 2045us; 2048us; 2051us; 2053us; 2055us; 2057us; 2059us; 2062us; 2068us; 2070us; 2074us; 2079us; 2081us; 2083us; 2085us; 2087us; 2089us; 2091us; 2094us; 2096us; 2099us; 2101us; 2103us; 2105us; 2107us; 2109us; 2111us; 2113us; 2115us; 2119us; 2123us; 2127us; 2131us; 2134us; 2136us; 2138us; 2140us; 2143us; 2146us; 2148us; 2150us; 2152us; 2154us; 2157us; 2159us; 2161us; 2164us; 2166us; 2168us; 2170us; 2172us; 2174us; 2177us; 2179us; 2181us; 2183us; 2185us; 2187us; 2189us; 2191us; 2193us; 2195us; 2197us; 2199us; 2201us; 2203us; 2205us; 2207us; 2209us; 2212us; 2214us; 2216us; 2218us; 2220us; 2223us; 2225us; 2227us; 2230us; 2233us; 2235us; 2237us; 2239us; 2241us; 2243us; 2245us; 2247us; 2249us; 2251us; 2254us; 2256us; 2258us; 2265us; 2267us; 2269us; 2271us; 2274us; 2278us; 2280us; 2282us; 2284us; 2286us; 2288us; 2294us; 2297us; 2299us; 2301us; 2303us; 2306us; 2308us; 2310us; 2317us; 2324us; 2331us; 2338us; 2345us; 2352us; 2359us; 2367us; 2369us; 2371us; 2373us; 2375us; 2378us; 2381us; 2383us; 2385us; 2387us; 2389us; 2391us; 2394us; 2396us; 2399us; 2401us; 2403us; 2408us; 2410us; 2418us; 2424us; 2428us; 2430us; 2432us; 2434us; 2436us; 2438us; 2440us; 2442us; 2444us; 2454us; 2456us; 2458us; 2460us; 2465us; 2467us; 2469us; 2471us; 2473us; 2475us; 2477us; 2479us; 2481us; 2483us; 2485us; 2487us; 2489us; 2491us; 2493us; 2495us; 2497us; 2499us; 2501us; 2503us; 2506us; 2508us; 2510us; 2512us; 2514us; 2516us; 2518us; 2527us; 2530us; 2532us; 2534us; 2538us; 2541us; 2543us; 2548us; 2553us; 2558us; 2560us; 2562us; 2565us; 2567us; 2569us; 2577us; 2585us; 2593us; 2601us; 2609us; 2617us; 2625us; 2632us; 2640us; 2648us; 2657us; 2672us; 2680us; 2682us; 2684us; 2686us; 2689us; 2692us; 2694us; 2696us; 2698us; 2700us; 2702us; 2704us; 2706us; 2708us; 2710us; 2713us; 2715us; 2718us; 2720us; 2724us; 2726us; 2728us; 2731us; 2733us; 2736us; 2739us; 2741us; 2743us; 2745us; 2747us; 2749us; 2751us; 2800us; 2803us; 2805us; 2808us; 2810us; 2812us; 2814us; 2816us; 2869us; 2925us; 2981us; 2984us; 2986us; 2988us; 2990us; 2992us; 2994us; 2996us; 2998us; 3004us; 3006us; 3009us; 3012us; 3015us; 3018us; 3021us; 3024us; 3027us; 3030us; 3033us; 3036us; 3040us; 3043us; 3046us; 3048us; 3051us; 3054us; 3056us; 3058us; 3063us; 3065us; 3067us; 3070us; 3072us; 3074us; 3076us; 3078us; 3080us; 3083us; 3086us; 3088us; 3090us; 3093us; 3096us; 3098us; 3100us; 3104us; 3108us; 3110us; 3112us; 3114us; 3116us; 3120us; 3170us; 3172us; 3174us; 3176us; 3178us; 3227us; 3230us; 3279us; 3281us; 3283us; 3286us; 3288us; 3295us; 3347us; 3351us; 3354us; 3356us; 3358us; 3360us; 3362us; 3364us; 3366us; 3368us; 3384us; 3391us; 3396us; 3399us; 3401us; 3403us; 3405us; 3407us; 3409us; 3415us; 3420us; 3423us; 3425us; 3427us; 3429us; 3431us; 3433us; 3435us; 3437us; 3439us; 3441us; 3443us; 3446us; 3448us; 3497us; 3499us; 3548us; 3550us; 3552us; 3554us; 3556us; 3558us; 3560us; 3563us; 3566us; 3569us; 3572us; 3575us; 3577us; 3579us; 3581us; 3583us; 3585us; 3587us; 3589us; 3591us; 3593us; 3595us; 3597us; 3599us; 3601us; 3650us; 3652us; 3654us; 3703us; 3752us; 3801us; 3850us; 3899us; 3948us; 3997us; 4046us; 4095us; 4144us; 4193us; 4242us; 4291us; 4340us; 4389us; 4438us; 4487us; 4536us; 4585us; 4634us; 4683us; 4732us; 4781us; 4830us; 4880us; 4929us; 4977us; 5026us; 5077us; 5126us; 5175us; 5227us; 5279us; 5329us; 5378us; 5427us; 5429us; 5431us; 5433us; 5435us; 5437us; 5439us; 5441us; 5444us; 5446us; 5448us; 5452us; 5458us; 5461us; 5464us; 5467us; 5470us; 5473us; 5476us; 5479us; 5482us; 5485us; 5488us; 5492us; 5494us; 5497us; 5500us; 5503us; 5506us; 5509us; 5512us; 5515us; 5518us; 5521us; 5523us; 5525us; 5527us; 5529us; 5531us; 5533us; 5535us; 5537us; 5539us; 5541us; 5543us; 5545us; 5547us; 5549us; 5551us; 5553us; 5555us; 5557us; 5559us; 5561us; 5563us; 5565us; 5567us; 5569us; 5571us; 5573us; 5576us; 5579us; 5581us; 5583us; 5585us; 5588us; 5590us; 5592us; 5594us; 5596us; 5602us; 5607us; 5610us; 5612us; 5614us; 5616us; 5618us; 5620us; 5622us; 5624us; 5626us; 5628us; 5630us; 5633us; 5636us; 5639us; 5641us; 5643us; 5645us; 5648us; 5651us; 5654us; 5656us; 5658us; 5661us; 5663us; 5665us; 5668us; 5670us; 5673us; 5675us; 5677us; 5680us; 5682us; 5684us; 5687us; 5689us; 5691us; 5694us; 5696us; 5698us; 5701us; 5703us; 5705us; 5708us; 5710us; 5712us; 5715us; 5717us; 5721us; 5729us; 5732us; 5739us; 5742us; 5747us; 5749us; 5753us; 5755us; 5757us; 5759us; 5761us; 5763us; 5765us; 5768us; 5775us; 5781us; 5783us; 5790us; 5792us; 5799us; 5806us; 5813us; 5820us; 5827us; 5834us; 5836us; 5838us; 5840us; 5842us; 5844us; 5847us; 5849us; 5851us; 5853us; 5855us; 5857us; 5859us; 5862us; 5864us; 5866us; 5868us; 5870us; 5872us; 5877us; 5880us; 5882us; 5884us; 5886us; 5888us; 5892us; 5895us; 5897us; 5899us; 5901us; 5903us; 5905us; 5907us; 5914us; 5916us; 5918us; 5920us; 5922us; 5924us; 5926us; 5933us; 5936us; 5938us; 5940us; 5943us; 5945us; 5947us; 5949us; 5951us; 5954us; 5956us; 5958us; 5961us; 5963us; 5965us; 5967us; 5969us; 5971us; 5973us; 5975us; 5977us; 5979us; 5981us; 5983us; 5985us; 5990us; 5993us; 5995us; 5997us; 5999us; 6001us; 6003us; 6008us; 6014us; 6017us; 6019us; 6021us; 6023us; 6025us; 6030us; 6033us; 6035us; 6037us; 6039us; 6041us; 6051us; 6066us; 6080us; 6082us; 6085us; 6087us; 6089us; 6091us; 6094us; 6096us; 6098us; 6100us; 6102us; 6104us; 6106us; 6108us; 6110us; 6112us; 6114us; 6116us; 6118us; 6120us; 6122us; 6125us; 6128us; 6130us; 6132us; 6134us; 6140us; 6143us; 6145us; 6147us; 6149us; 6151us; 6153us; 6155us; 6157us; 6159us; 6161us; 6163us; 6165us; 6169us; 6171us; 6173us; 6175us; 6177us; 6181us; 6183us; 6185us; 6187us; 6190us; 6192us; 6194us; 6196us; 6198us; 6200us; 6202us; 6204us; 6207us; 6209us; 6211us; 6213us; 6215us; 6217us; 6219us; 6221us; 6223us; 6226us; 6228us; 6234us; 6236us; 6238us; 6240us; 6242us; 6244us; 6247us; 6249us; 6251us; 6253us; 6255us; 6258us; 6260us; 6264us; 6267us; 6269us; 6272us; 6274us; 6276us; 6278us; 6281us; 6283us; 6286us; 6288us; 6290us; 6292us; 6295us; 6297us; 6299us; 6301us; 6304us; 6307us; 6310us; 6312us; 6314us; 6318us; 6320us; 6322us; 6328us; 6332us; 6334us; 6336us; 6338us; 6341us; 6343us; 6345us; 6347us; 6349us; 6351us; 6353us; 6355us; 6358us; 6360us; 6362us; 6364us; 6366us; 6368us; 6370us; 6372us; 6374us; 6376us; 6378us; 6380us; 6382us; 6384us; 6389us; 6391us; 6393us; 6395us; 6397us; 6399us; 6401us; 6407us; 6410us; 6412us; 6414us; 6416us; 6418us; 6420us; 6423us; 6426us; 6429us; 6431us; 6433us; 6440us; 6446us; 6451us; 6454us; 6456us; 6458us; 6460us; 6462us; 6464us; 6466us; 6468us; 6470us; 6472us; 6474us; 6476us; 6478us; 6480us; 6482us; 6485us; 6487us; 6490us; 6492us; 6494us; 6496us; 6499us; 6501us; 6503us; 6506us; 6508us; 6510us; 6513us; 6515us; 6517us; 6521us; 6527us; 6529us; 6534us; 6536us; 6538us; 6540us; 6545us; 6551us; 6553us; 6558us; 6560us; 6562us; 6564us; 6569us; 6572us; 6574us; 6576us; 6578us; 6580us; 6587us; 6589us; 6591us; 6593us; 6595us; 6597us; 6599us; 6606us; 6608us; 6610us; 6612us; 6614us; 6618us; 6620us; 6623us; 6626us; 6631us; 6633us; 6635us; 6643us; 6645us; 6647us; 6649us; 6651us; 6656us; 6658us; 6660us; 6662us; 6664us; 6666us; 6668us; 6671us; 6673us; 6675us; 6680us; 6682us; 6686us; 6688us; 6691us; 6693us; 6695us; 6697us; 6699us; 6701us; 6703us; 6707us; 6712us; 6715us; 6717us; 6719us; 6722us; 6724us; 6726us; 6731us; 6733us; 6735us; 6737us; 6741us; 6745us; 6747us; 6749us; 6753us; 6755us; 6757us; 6761us; 6764us; 6770us; 6772us; 6774us; 6780us; 6786us; 6790us; 6793us; 6795us; 6797us; 6799us; 6801us; 6803us; 6805us; 6807us; 6809us; 6811us; 6813us; 6815us; 6817us; 6819us; 6822us; 6827us; 6829us; 6831us; 6833us; 6835us; 6837us; 6839us; 6847us; 6851us; 6855us; 6858us; 6860us; 6862us; 6864us; 6868us; 6870us; 6872us; 6874us; 6876us; 6880us; 6883us; 6885us; 6887us; 6889us; 6892us; 6896us; 6898us; 6900us; 6902us; 6906us; 6908us; 6910us; 6914us; 6916us; 6919us; 6921us; 6923us; 6925us; 6928us; 6930us; 6932us; 6936us; 6940us; 6944us; 6946us; 6948us; 6950us; 6952us; 6954us; 6956us; 6958us; 6961us; 6963us; 6965us; 6967us; 6969us; 6972us; 6974us; 6976us; 6981us; 6983us; 6985us; 6987us; 6989us; 6991us; 6995us; 6999us; 7001us; 7003us; 7005us; 7007us; 7009us; 7011us; 7013us; 7015us; 7017us; 7019us; 7021us; 7023us; 7025us; 7027us; 7029us; 7031us; 7033us; 7035us; 7037us; 7039us; 7041us; 7043us; 7045us; 7047us; 7049us; 7051us; 7053us; 7056us; 7058us; 7060us; 7062us; 7064us; 7066us; 7068us; 7070us; 7072us; 7074us; 7078us; 7080us; 7083us; 7085us; 7087us; 7089us; 7091us; 7093us; 7095us; 7098us; 7100us; 7102us; 7104us; 7107us; 7110us; 7112us; 7114us; 7116us; 7118us; 7120us; 7122us; 7124us; 7126us; 7128us; 7130us; 7132us; 7134us; 7136us; 7138us; 7140us; 7142us; 7144us; 7146us; 7148us; 7150us; 7152us; 7154us; 7156us; 7158us; 7160us; 7162us; 7164us; 7166us; 7168us; 7170us; 7172us; 7175us; 7177us; 7179us; 7181us; 7183us; 7186us; 7188us; 7190us; 7192us; 7194us; 7196us; 7198us; 7200us; 7202us; 7204us; 7206us; 7208us; 7210us; 7212us; 7214us; 7216us; 7218us; 7220us; 7222us; 7224us; 7226us; 7228us; 7230us; 7232us; 7234us; 7236us; 7238us; |]
let _fsyacc_action_rows = 1831
let _fsyacc_actionTableElements = [|16us; 16431us; 22us; 69us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 73us; 298us; 88us; 38us; 101us; 94us; 108us; 16542us; 109us; 16542us; 121us; 16542us; 149us; 16542us; 194us; 47us; 0us; 49152us; 86us; 16507us; 13us; 16542us; 22us; 230us; 24us; 16542us; 25us; 16542us; 29us; 16542us; 30us; 16542us; 31us; 16542us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 55us; 16542us; 62us; 16542us; 70us; 16542us; 71us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 75us; 16542us; 86us; 16542us; 88us; 38us; 89us; 16542us; 90us; 16542us; 92us; 16542us; 98us; 16542us; 100us; 16542us; 101us; 686us; 106us; 16542us; 107us; 16542us; 108us; 16542us; 114us; 16542us; 115us; 16542us; 116us; 16542us; 117us; 16542us; 119us; 16542us; 121us; 16542us; 122us; 16542us; 123us; 16542us; 124us; 16542us; 125us; 16542us; 126us; 16542us; 130us; 16542us; 133us; 16542us; 134us; 16542us; 136us; 16542us; 137us; 16542us; 145us; 16542us; 146us; 16542us; 147us; 16542us; 149us; 16542us; 153us; 16542us; 154us; 16542us; 157us; 16542us; 158us; 16542us; 161us; 16542us; 162us; 16542us; 163us; 16542us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 181us; 16542us; 182us; 16542us; 185us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 194us; 216us; 0us; 49152us; 7us; 16542us; 10us; 14us; 21us; 12us; 67us; 13us; 73us; 298us; 84us; 11us; 88us; 38us; 101us; 686us; 0us; 49152us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 49152us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 49152us; 0us; 16389us; 0us; 16390us; 0us; 16391us; 0us; 16392us; 0us; 16393us; 0us; 16394us; 4us; 32768us; 10us; 14us; 21us; 37us; 67us; 13us; 84us; 36us; 0us; 16395us; 4us; 32768us; 10us; 14us; 21us; 37us; 67us; 13us; 84us; 36us; 0us; 16396us; 4us; 32768us; 10us; 14us; 21us; 37us; 67us; 13us; 84us; 36us; 0us; 16397us; 5us; 16542us; 10us; 14us; 67us; 13us; 73us; 298us; 88us; 38us; 101us; 686us; 0us; 16398us; 5us; 16542us; 10us; 14us; 67us; 13us; 73us; 298us; 88us; 38us; 101us; 686us; 0us; 16399us; 5us; 16542us; 10us; 14us; 67us; 13us; 73us; 298us; 88us; 38us; 101us; 686us; 0us; 16400us; 16us; 16401us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 73us; 298us; 101us; 686us; 108us; 16542us; 121us; 16542us; 137us; 16542us; 149us; 16542us; 161us; 16542us; 0us; 16402us; 3us; 16622us; 42us; 472us; 43us; 471us; 44us; 473us; 78us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 36us; 1797us; 37us; 1800us; 38us; 1802us; 39us; 1805us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 108us; 1801us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 121us; 675us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 137us; 692us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 149us; 1806us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 25us; 16403us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 0us; 16404us; 2us; 16405us; 21us; 37us; 84us; 36us; 0us; 16406us; 0us; 16407us; 0us; 16408us; 1us; 32768us; 190us; 39us; 0us; 16410us; 2us; 16409us; 191us; 1793us; 192us; 1792us; 0us; 16411us; 0us; 16412us; 2us; 32768us; 10us; 44us; 194us; 45us; 0us; 16413us; 1us; 32768us; 10us; 46us; 0us; 16414us; 4us; 16430us; 10us; 48us; 21us; 1760us; 67us; 1759us; 84us; 1758us; 0us; 16415us; 3us; 16616us; 42us; 472us; 43us; 471us; 44us; 473us; 1us; 17397us; 103us; 1779us; 2us; 32768us; 45us; 1702us; 190us; 1701us; 1us; 16416us; 77us; 1704us; 1us; 17397us; 103us; 1779us; 2us; 32768us; 45us; 1702us; 190us; 1701us; 1us; 16417us; 77us; 1704us; 1us; 16418us; 150us; 53us; 0us; 16419us; 1us; 16421us; 150us; 53us; 0us; 16420us; 1us; 17391us; 69us; 1776us; 16us; 16431us; 22us; 69us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 73us; 298us; 88us; 38us; 101us; 94us; 108us; 16542us; 109us; 16542us; 121us; 16542us; 149us; 16542us; 194us; 77us; 0us; 16422us; 3us; 16622us; 42us; 472us; 43us; 471us; 44us; 473us; 8us; 32768us; 36us; 1797us; 37us; 1800us; 38us; 1802us; 39us; 1805us; 108us; 1801us; 109us; 96us; 121us; 675us; 149us; 1806us; 18us; 16431us; 22us; 69us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 69us; 1791us; 73us; 298us; 78us; 1790us; 88us; 38us; 101us; 94us; 108us; 16542us; 109us; 16542us; 121us; 16542us; 149us; 16542us; 194us; 77us; 0us; 16423us; 0us; 16424us; 0us; 16425us; 15us; 16431us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 73us; 298us; 88us; 38us; 101us; 94us; 108us; 16542us; 109us; 16542us; 121us; 16542us; 149us; 16542us; 194us; 74us; 5us; 32768us; 10us; 985us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 194us; 971us; 1us; 17393us; 21us; 1777us; 0us; 16426us; 0us; 16427us; 6us; 16430us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 21us; 1760us; 67us; 1759us; 84us; 1758us; 0us; 16428us; 0us; 16429us; 3us; 16430us; 21us; 1760us; 67us; 1759us; 84us; 1758us; 3us; 17376us; 21us; 1760us; 67us; 1759us; 84us; 1758us; 15us; 16434us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 73us; 298us; 88us; 38us; 101us; 94us; 108us; 16542us; 109us; 16542us; 121us; 16542us; 149us; 16542us; 194us; 81us; 0us; 16432us; 3us; 32768us; 21us; 1760us; 67us; 1759us; 84us; 1758us; 4us; 16542us; 73us; 298us; 88us; 38us; 101us; 94us; 194us; 81us; 0us; 16433us; 0us; 16435us; 0us; 16436us; 3us; 16622us; 42us; 472us; 43us; 471us; 44us; 473us; 8us; 32768us; 36us; 1797us; 37us; 1800us; 38us; 1802us; 39us; 1805us; 108us; 1801us; 109us; 96us; 121us; 675us; 149us; 1806us; 2us; 32768us; 69us; 1791us; 78us; 1790us; 5us; 32768us; 22us; 111us; 45us; 1702us; 56us; 1788us; 136us; 1789us; 190us; 1701us; 0us; 16437us; 0us; 16438us; 0us; 16439us; 0us; 16440us; 2us; 32768us; 45us; 1702us; 190us; 1701us; 1us; 16441us; 77us; 1704us; 1us; 16542us; 73us; 298us; 1us; 17401us; 110us; 1780us; 1us; 17403us; 118us; 1781us; 3us; 16616us; 42us; 472us; 43us; 471us; 44us; 473us; 3us; 32768us; 92us; 1707us; 100us; 1712us; 190us; 1701us; 2us; 16681us; 33us; 1796us; 159us; 17420us; 1us; 32768us; 78us; 103us; 33us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 73us; 298us; 75us; 1552us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 16443us; 69us; 106us; 0us; 16442us; 71us; 32768us; 13us; 1087us; 22us; 108us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 25us; 16444us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 28us; 32768us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 0us; 16445us; 8us; 16542us; 45us; 1702us; 56us; 1788us; 73us; 298us; 88us; 38us; 101us; 94us; 136us; 1789us; 190us; 1701us; 194us; 81us; 3us; 32768us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 0us; 16446us; 15us; 16431us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 73us; 298us; 88us; 38us; 101us; 94us; 108us; 16542us; 109us; 16542us; 121us; 16542us; 149us; 16542us; 194us; 77us; 1us; 32768us; 142us; 116us; 3us; 32768us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 0us; 16447us; 15us; 16431us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 73us; 298us; 88us; 38us; 101us; 94us; 108us; 16542us; 109us; 16542us; 121us; 16542us; 149us; 16542us; 194us; 77us; 1us; 32768us; 142us; 120us; 0us; 16448us; 1us; 16542us; 73us; 298us; 0us; 16449us; 1us; 16451us; 131us; 124us; 1us; 16542us; 73us; 298us; 0us; 16450us; 2us; 16491us; 69us; 127us; 87us; 209us; 7us; 16542us; 22us; 130us; 48us; 546us; 55us; 548us; 73us; 298us; 111us; 547us; 136us; 155us; 151us; 141us; 0us; 16452us; 0us; 16453us; 52us; 16471us; 14us; 16542us; 22us; 151us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 46us; 16542us; 47us; 16542us; 48us; 546us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 55us; 548us; 57us; 16542us; 66us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 88us; 16542us; 91us; 16542us; 92us; 16542us; 106us; 16542us; 109us; 16542us; 111us; 547us; 113us; 16542us; 119us; 16542us; 122us; 16542us; 136us; 155us; 147us; 16542us; 151us; 141us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 184us; 16542us; 187us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 1us; 17393us; 21us; 1777us; 14us; 16471us; 14us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 46us; 16542us; 47us; 16542us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 73us; 298us; 109us; 16542us; 111us; 16542us; 119us; 16542us; 1us; 16491us; 87us; 209us; 3us; 32768us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 1us; 16491us; 87us; 209us; 0us; 16454us; 1us; 16491us; 87us; 209us; 0us; 16455us; 0us; 16456us; 0us; 16457us; 1us; 32768us; 120us; 142us; 33us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 73us; 298us; 75us; 1552us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16458us; 0us; 16459us; 16us; 16471us; 14us; 16542us; 22us; 159us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 46us; 16542us; 47us; 16542us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 73us; 298us; 109us; 16542us; 111us; 16542us; 119us; 16542us; 194us; 149us; 3us; 32768us; 10us; 985us; 142us; 147us; 194us; 971us; 0us; 16460us; 0us; 16461us; 1us; 32768us; 142us; 150us; 0us; 16462us; 14us; 16471us; 14us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 46us; 16542us; 47us; 16542us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 73us; 298us; 109us; 16542us; 111us; 16542us; 119us; 16542us; 5us; 32768us; 10us; 985us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 194us; 971us; 0us; 16463us; 0us; 16464us; 15us; 16471us; 14us; 16542us; 22us; 159us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 46us; 16542us; 47us; 16542us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 73us; 298us; 109us; 16542us; 111us; 16542us; 119us; 16542us; 3us; 32768us; 10us; 985us; 142us; 157us; 194us; 971us; 0us; 16465us; 0us; 16466us; 14us; 16471us; 14us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 46us; 16542us; 47us; 16542us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 73us; 298us; 109us; 16542us; 111us; 16542us; 119us; 16542us; 5us; 32768us; 10us; 985us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 194us; 971us; 0us; 16467us; 0us; 16468us; 0us; 16469us; 0us; 16470us; 2us; 17395us; 21us; 1765us; 84us; 1766us; 14us; 16471us; 14us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 46us; 16542us; 47us; 16542us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 73us; 298us; 109us; 16542us; 111us; 16542us; 119us; 16542us; 0us; 16472us; 3us; 16622us; 42us; 472us; 43us; 471us; 44us; 473us; 3us; 16622us; 42us; 472us; 43us; 471us; 44us; 473us; 10us; 32768us; 14us; 550us; 46us; 187us; 47us; 333us; 49us; 205us; 50us; 334us; 51us; 335us; 53us; 183us; 109us; 185us; 111us; 549us; 119us; 192us; 44us; 32768us; 14us; 550us; 45us; 1702us; 46us; 187us; 47us; 333us; 49us; 205us; 50us; 334us; 51us; 335us; 53us; 183us; 55us; 534us; 57us; 621us; 66us; 1592us; 72us; 537us; 74us; 528us; 88us; 1621us; 91us; 1695us; 92us; 525us; 106us; 1643us; 109us; 185us; 111us; 549us; 113us; 1641us; 119us; 192us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 17401us; 110us; 1780us; 3us; 16616us; 42us; 472us; 43us; 471us; 44us; 473us; 3us; 32768us; 92us; 1707us; 100us; 1712us; 190us; 1701us; 2us; 16681us; 33us; 1796us; 159us; 17420us; 1us; 32768us; 78us; 177us; 33us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 73us; 298us; 75us; 1552us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 2us; 16480us; 26us; 197us; 87us; 195us; 1us; 16443us; 69us; 106us; 0us; 16473us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 6us; 16474us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 6us; 16475us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 1us; 17403us; 118us; 1781us; 0us; 16476us; 5us; 32768us; 36us; 1797us; 37us; 1800us; 47us; 332us; 108us; 1801us; 109us; 188us; 1us; 17403us; 118us; 1781us; 0us; 16477us; 1us; 16542us; 73us; 298us; 0us; 16478us; 1us; 32768us; 78us; 193us; 33us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 73us; 298us; 75us; 1552us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16479us; 3us; 32768us; 92us; 1707us; 100us; 1712us; 190us; 1701us; 0us; 16481us; 3us; 32768us; 92us; 1707us; 100us; 1712us; 190us; 1701us; 2us; 32768us; 20us; 199us; 194us; 200us; 0us; 16482us; 0us; 16483us; 1us; 16484us; 97us; 202us; 3us; 32768us; 92us; 1707us; 100us; 1712us; 190us; 1701us; 0us; 16485us; 0us; 16486us; 1us; 16487us; 47us; 206us; 0us; 16488us; 1us; 16491us; 87us; 209us; 0us; 16489us; 15us; 16471us; 14us; 16542us; 22us; 159us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 46us; 16542us; 47us; 16542us; 49us; 16542us; 50us; 16542us; 51us; 16542us; 53us; 16542us; 73us; 298us; 109us; 16542us; 111us; 16542us; 119us; 16542us; 3us; 32768us; 19us; 1769us; 20us; 1770us; 142us; 1771us; 0us; 16490us; 2us; 32768us; 10us; 213us; 194us; 214us; 0us; 16492us; 1us; 32768us; 10us; 215us; 0us; 16493us; 4us; 32768us; 10us; 217us; 21us; 1760us; 67us; 1759us; 84us; 1758us; 0us; 16494us; 1us; 16495us; 150us; 53us; 0us; 16496us; 1us; 16498us; 150us; 53us; 0us; 16497us; 1us; 17391us; 69us; 1776us; 86us; 16507us; 13us; 16542us; 22us; 230us; 24us; 16542us; 25us; 16542us; 29us; 16542us; 30us; 16542us; 31us; 16542us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 55us; 16542us; 62us; 16542us; 70us; 16542us; 71us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 75us; 16542us; 86us; 16542us; 88us; 38us; 89us; 16542us; 90us; 16542us; 92us; 16542us; 98us; 16542us; 100us; 16542us; 101us; 686us; 106us; 16542us; 107us; 16542us; 108us; 16542us; 114us; 16542us; 115us; 16542us; 116us; 16542us; 117us; 16542us; 119us; 16542us; 121us; 16542us; 122us; 16542us; 123us; 16542us; 124us; 16542us; 125us; 16542us; 126us; 16542us; 130us; 16542us; 133us; 16542us; 134us; 16542us; 136us; 16542us; 137us; 16542us; 145us; 16542us; 146us; 16542us; 147us; 16542us; 149us; 16542us; 153us; 16542us; 154us; 16542us; 157us; 16542us; 158us; 16542us; 161us; 16542us; 162us; 16542us; 163us; 16542us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 181us; 16542us; 182us; 16542us; 185us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 194us; 250us; 0us; 16499us; 4us; 16622us; 42us; 472us; 43us; 471us; 44us; 473us; 194us; 245us; 78us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 36us; 1797us; 37us; 1800us; 38us; 1802us; 39us; 1805us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 108us; 1801us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 121us; 675us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 137us; 692us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 149us; 1806us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 87us; 16507us; 13us; 16542us; 22us; 230us; 24us; 16542us; 25us; 16542us; 29us; 16542us; 30us; 16542us; 31us; 16542us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 55us; 16542us; 62us; 16542us; 69us; 269us; 70us; 16542us; 71us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 75us; 16542us; 86us; 16542us; 88us; 38us; 89us; 16542us; 90us; 16542us; 92us; 16542us; 98us; 16542us; 100us; 16542us; 101us; 686us; 106us; 16542us; 107us; 16542us; 108us; 16542us; 114us; 16542us; 115us; 16542us; 116us; 16542us; 117us; 16542us; 119us; 16542us; 121us; 16542us; 122us; 16542us; 123us; 16542us; 124us; 16542us; 125us; 16542us; 126us; 16542us; 130us; 16542us; 133us; 16542us; 134us; 16542us; 136us; 16542us; 137us; 16542us; 145us; 16542us; 146us; 16542us; 147us; 16542us; 149us; 16542us; 153us; 16542us; 154us; 16542us; 157us; 16542us; 158us; 16542us; 161us; 16542us; 162us; 16542us; 163us; 16542us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 181us; 16542us; 182us; 16542us; 185us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 194us; 250us; 0us; 16500us; 0us; 16501us; 85us; 16507us; 13us; 16542us; 24us; 16542us; 25us; 16542us; 29us; 16542us; 30us; 16542us; 31us; 16542us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 55us; 16542us; 62us; 16542us; 70us; 16542us; 71us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 75us; 16542us; 86us; 16542us; 88us; 38us; 89us; 16542us; 90us; 16542us; 92us; 16542us; 98us; 16542us; 100us; 16542us; 101us; 686us; 106us; 16542us; 107us; 16542us; 108us; 16542us; 114us; 16542us; 115us; 16542us; 116us; 16542us; 117us; 16542us; 119us; 16542us; 121us; 16542us; 122us; 16542us; 123us; 16542us; 124us; 16542us; 125us; 16542us; 126us; 16542us; 130us; 16542us; 133us; 16542us; 134us; 16542us; 136us; 16542us; 137us; 16542us; 145us; 16542us; 146us; 16542us; 147us; 16542us; 149us; 16542us; 153us; 16542us; 154us; 16542us; 157us; 16542us; 158us; 16542us; 161us; 16542us; 162us; 16542us; 163us; 16542us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 181us; 16542us; 182us; 16542us; 185us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 194us; 235us; 5us; 32768us; 10us; 985us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 194us; 971us; 1us; 17393us; 21us; 1777us; 0us; 16502us; 0us; 16503us; 6us; 32768us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 21us; 1760us; 67us; 1759us; 84us; 1758us; 0us; 16504us; 0us; 16505us; 0us; 16506us; 4us; 16622us; 42us; 472us; 43us; 471us; 44us; 473us; 194us; 245us; 78us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 36us; 1797us; 37us; 1800us; 38us; 1802us; 39us; 1805us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 108us; 1801us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 121us; 675us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 137us; 692us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 149us; 1806us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 28us; 16510us; 21us; 1760us; 62us; 1156us; 63us; 1148us; 67us; 1759us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 84us; 1758us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 85us; 16509us; 13us; 16542us; 24us; 16542us; 25us; 16542us; 29us; 16542us; 30us; 16542us; 31us; 16542us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 55us; 16542us; 62us; 16542us; 70us; 16542us; 71us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 75us; 16542us; 86us; 16542us; 88us; 38us; 89us; 16542us; 90us; 16542us; 92us; 16542us; 98us; 16542us; 100us; 16542us; 101us; 686us; 106us; 16542us; 107us; 16542us; 108us; 16542us; 114us; 16542us; 115us; 16542us; 116us; 16542us; 117us; 16542us; 119us; 16542us; 121us; 16542us; 122us; 16542us; 123us; 16542us; 124us; 16542us; 125us; 16542us; 126us; 16542us; 130us; 16542us; 133us; 16542us; 134us; 16542us; 136us; 16542us; 137us; 16542us; 145us; 16542us; 146us; 16542us; 147us; 16542us; 149us; 16542us; 153us; 16542us; 154us; 16542us; 157us; 16542us; 158us; 16542us; 161us; 16542us; 162us; 16542us; 163us; 16542us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 181us; 16542us; 182us; 16542us; 185us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 194us; 250us; 0us; 16508us; 0us; 16511us; 0us; 16512us; 21us; 16515us; 21us; 1760us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 67us; 1759us; 73us; 298us; 84us; 1758us; 88us; 38us; 101us; 686us; 108us; 16542us; 121us; 16542us; 137us; 16542us; 149us; 16542us; 161us; 16542us; 194us; 250us; 0us; 16513us; 85us; 16516us; 13us; 16542us; 24us; 16542us; 25us; 16542us; 29us; 16542us; 30us; 16542us; 31us; 16542us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 55us; 16542us; 62us; 16542us; 70us; 16542us; 71us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 75us; 16542us; 86us; 16542us; 88us; 38us; 89us; 16542us; 90us; 16542us; 92us; 16542us; 98us; 16542us; 100us; 16542us; 101us; 686us; 106us; 16542us; 107us; 16542us; 108us; 16542us; 114us; 16542us; 115us; 16542us; 116us; 16542us; 117us; 16542us; 119us; 16542us; 121us; 16542us; 122us; 16542us; 123us; 16542us; 124us; 16542us; 125us; 16542us; 126us; 16542us; 130us; 16542us; 133us; 16542us; 134us; 16542us; 136us; 16542us; 137us; 16542us; 145us; 16542us; 146us; 16542us; 147us; 16542us; 149us; 16542us; 153us; 16542us; 154us; 16542us; 157us; 16542us; 158us; 16542us; 161us; 16542us; 162us; 16542us; 163us; 16542us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 181us; 16542us; 182us; 16542us; 185us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 194us; 250us; 0us; 16514us; 3us; 32768us; 21us; 1760us; 67us; 1759us; 84us; 1758us; 6us; 32768us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 21us; 1760us; 67us; 1759us; 84us; 1758us; 4us; 32768us; 21us; 1760us; 67us; 1759us; 84us; 1758us; 142us; 291us; 4us; 16542us; 73us; 298us; 88us; 38us; 101us; 686us; 194us; 250us; 0us; 16517us; 0us; 16518us; 0us; 16519us; 3us; 16622us; 42us; 472us; 43us; 471us; 44us; 473us; 11us; 32768us; 32us; 694us; 36us; 1797us; 37us; 1800us; 38us; 1802us; 39us; 1805us; 40us; 707us; 108us; 1801us; 121us; 675us; 137us; 692us; 149us; 1806us; 161us; 688us; 0us; 16520us; 1us; 16520us; 127us; 987us; 0us; 16521us; 71us; 16521us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 992us; 0us; 16522us; 1us; 16542us; 73us; 298us; 1us; 16564us; 131us; 339us; 0us; 16523us; 0us; 16524us; 1us; 32768us; 69us; 269us; 5us; 32768us; 22us; 277us; 45us; 1702us; 55us; 1786us; 136us; 1787us; 190us; 1701us; 0us; 16525us; 2us; 16541us; 10us; 985us; 194us; 971us; 0us; 16526us; 0us; 16527us; 4us; 32768us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 77us; 1704us; 0us; 16528us; 1us; 16529us; 77us; 1704us; 6us; 16542us; 55us; 1786us; 73us; 298us; 88us; 38us; 101us; 686us; 136us; 1787us; 194us; 251us; 5us; 32768us; 10us; 985us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 194us; 971us; 0us; 16530us; 0us; 16531us; 5us; 32768us; 10us; 985us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 194us; 971us; 0us; 16532us; 0us; 16533us; 0us; 16534us; 0us; 16535us; 1us; 16536us; 77us; 1704us; 85us; 16507us; 13us; 16542us; 24us; 16542us; 25us; 16542us; 29us; 16542us; 30us; 16542us; 31us; 16542us; 32us; 16542us; 36us; 16542us; 37us; 16542us; 38us; 16542us; 39us; 16542us; 40us; 16542us; 42us; 16542us; 43us; 16542us; 44us; 16542us; 45us; 16542us; 55us; 16542us; 62us; 16542us; 70us; 16542us; 71us; 16542us; 72us; 16542us; 73us; 298us; 74us; 16542us; 75us; 16542us; 86us; 16542us; 88us; 38us; 89us; 16542us; 90us; 16542us; 92us; 16542us; 98us; 16542us; 100us; 16542us; 101us; 686us; 106us; 16542us; 107us; 16542us; 108us; 16542us; 114us; 16542us; 115us; 16542us; 116us; 16542us; 117us; 16542us; 119us; 16542us; 121us; 16542us; 122us; 16542us; 123us; 16542us; 124us; 16542us; 125us; 16542us; 126us; 16542us; 130us; 16542us; 133us; 16542us; 134us; 16542us; 136us; 16542us; 137us; 16542us; 145us; 16542us; 146us; 16542us; 147us; 16542us; 149us; 16542us; 153us; 16542us; 154us; 16542us; 157us; 16542us; 158us; 16542us; 161us; 16542us; 162us; 16542us; 163us; 16542us; 164us; 16542us; 165us; 16542us; 166us; 16542us; 167us; 16542us; 168us; 16542us; 169us; 16542us; 170us; 16542us; 171us; 16542us; 172us; 16542us; 173us; 16542us; 174us; 16542us; 175us; 16542us; 176us; 16542us; 178us; 16542us; 179us; 16542us; 181us; 16542us; 182us; 16542us; 185us; 16542us; 190us; 16542us; 191us; 16542us; 192us; 16542us; 193us; 16542us; 194us; 252us; 3us; 32768us; 10us; 985us; 142us; 289us; 194us; 971us; 0us; 16537us; 0us; 16538us; 0us; 16539us; 6us; 16542us; 19us; 16586us; 20us; 16586us; 22us; 379us; 73us; 298us; 142us; 16586us; 194us; 385us; 3us; 32768us; 19us; 1769us; 20us; 1770us; 142us; 1771us; 0us; 16540us; 0us; 16541us; 1us; 16543us; 73us; 298us; 0us; 16544us; 14us; 32768us; 10us; 985us; 16us; 1829us; 36us; 1798us; 37us; 1800us; 38us; 1803us; 39us; 1805us; 45us; 1702us; 60us; 1827us; 94us; 1828us; 108us; 1801us; 149us; 1806us; 162us; 329us; 190us; 1701us; 194us; 303us; 2us; 17395us; 21us; 1765us; 84us; 1766us; 8us; 32768us; 10us; 985us; 16us; 1829us; 36us; 1825us; 38us; 1826us; 54us; 301us; 60us; 1827us; 94us; 1828us; 194us; 971us; 1us; 17393us; 21us; 1777us; 0us; 16545us; 1us; 16901us; 54us; 304us; 1us; 17393us; 21us; 1777us; 0us; 16546us; 0us; 16547us; 0us; 16548us; 0us; 16549us; 9us; 17394us; 36us; 1797us; 37us; 1800us; 38us; 1802us; 39us; 1805us; 45us; 1702us; 108us; 1801us; 149us; 1806us; 162us; 329us; 190us; 1701us; 0us; 16550us; 3us; 17418us; 34us; 1795us; 35us; 1794us; 77us; 1704us; 28us; 17155us; 55us; 1493us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 92us; 1355us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16551us; 3us; 32768us; 22us; 318us; 45us; 1702us; 190us; 1701us; 3us; 17418us; 34us; 1795us; 35us; 1794us; 77us; 1704us; 28us; 17155us; 55us; 1493us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 92us; 1355us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16552us; 2us; 32768us; 45us; 1702us; 190us; 1701us; 4us; 32768us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 77us; 1704us; 2us; 17418us; 34us; 1795us; 35us; 1794us; 28us; 17155us; 55us; 1493us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 92us; 1355us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16553us; 1us; 32768us; 78us; 324us; 0us; 16554us; 1us; 32768us; 78us; 326us; 0us; 16555us; 1us; 17326us; 78us; 328us; 0us; 16556us; 1us; 32768us; 78us; 330us; 0us; 16557us; 10us; 32768us; 30us; 698us; 32us; 694us; 36us; 1797us; 37us; 1800us; 40us; 707us; 47us; 332us; 108us; 1801us; 109us; 448us; 137us; 692us; 161us; 688us; 0us; 16558us; 0us; 16559us; 0us; 16560us; 0us; 16561us; 3us; 16616us; 42us; 472us; 43us; 471us; 44us; 473us; 1us; 16684us; 85us; 580us; 0us; 16562us; 1us; 16542us; 73us; 298us; 1us; 16564us; 131us; 339us; 0us; 16563us; 40us; 16542us; 10us; 16565us; 14us; 16565us; 15us; 16565us; 16us; 16565us; 17us; 16565us; 19us; 16565us; 20us; 16565us; 21us; 16565us; 30us; 16565us; 32us; 16565us; 36us; 16565us; 37us; 16565us; 38us; 16565us; 39us; 16565us; 40us; 16565us; 46us; 16565us; 47us; 16565us; 49us; 16565us; 50us; 16565us; 51us; 16565us; 53us; 16565us; 67us; 16565us; 69us; 343us; 73us; 298us; 84us; 16565us; 87us; 292us; 88us; 16565us; 101us; 16565us; 108us; 16565us; 109us; 16565us; 111us; 16565us; 119us; 16565us; 121us; 16565us; 131us; 16565us; 137us; 16565us; 142us; 16565us; 149us; 16565us; 150us; 16565us; 161us; 16565us; 194us; 16565us; 6us; 16542us; 22us; 353us; 48us; 546us; 55us; 548us; 73us; 298us; 111us; 547us; 151us; 365us; 0us; 16566us; 0us; 16567us; 3us; 16622us; 42us; 472us; 43us; 471us; 44us; 473us; 2us; 17418us; 34us; 1795us; 35us; 1794us; 1us; 32768us; 92us; 816us; 1us; 16631us; 132us; 489us; 1us; 32768us; 69us; 351us; 6us; 16542us; 22us; 353us; 48us; 546us; 55us; 548us; 73us; 298us; 111us; 547us; 151us; 365us; 0us; 16568us; 11us; 16542us; 10us; 16586us; 15us; 16586us; 16us; 16586us; 17us; 16586us; 22us; 375us; 48us; 546us; 55us; 548us; 73us; 298us; 111us; 547us; 151us; 365us; 194us; 385us; 1us; 17393us; 21us; 1777us; 7us; 16542us; 10us; 16586us; 15us; 16586us; 16us; 16586us; 17us; 16586us; 73us; 298us; 87us; 16586us; 194us; 385us; 1us; 16626us; 87us; 478us; 5us; 32768us; 10us; 985us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 194us; 971us; 1us; 16626us; 87us; 478us; 0us; 16569us; 0us; 16570us; 1us; 16626us; 87us; 478us; 0us; 16571us; 0us; 16572us; 0us; 16573us; 1us; 32768us; 120us; 366us; 33us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 73us; 298us; 75us; 1552us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16574us; 0us; 16575us; 5us; 16542us; 10us; 16586us; 22us; 379us; 73us; 298us; 142us; 16586us; 194us; 373us; 3us; 32768us; 10us; 985us; 142us; 371us; 194us; 971us; 0us; 16576us; 0us; 16577us; 4us; 16542us; 10us; 16586us; 73us; 298us; 142us; 374us; 194us; 385us; 0us; 16578us; 6us; 16542us; 10us; 16586us; 15us; 16586us; 16us; 16586us; 17us; 16586us; 73us; 298us; 194us; 385us; 5us; 32768us; 10us; 985us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 194us; 971us; 0us; 16579us; 0us; 16580us; 6us; 16542us; 10us; 16586us; 15us; 16586us; 16us; 16586us; 17us; 16586us; 73us; 298us; 194us; 385us; 5us; 32768us; 10us; 985us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 194us; 971us; 0us; 16581us; 0us; 16582us; 0us; 16583us; 0us; 16584us; 10us; 16542us; 10us; 16586us; 15us; 16586us; 16us; 16586us; 17us; 16586us; 19us; 16586us; 20us; 16586us; 73us; 298us; 87us; 16586us; 142us; 16586us; 194us; 385us; 0us; 16585us; 2us; 17395us; 21us; 1765us; 84us; 1766us; 10us; 16542us; 10us; 16586us; 15us; 16586us; 16us; 16586us; 17us; 16586us; 19us; 16586us; 20us; 16586us; 73us; 298us; 87us; 16586us; 142us; 16586us; 194us; 385us; 0us; 16587us; 1us; 17401us; 110us; 1780us; 0us; 16588us; 1us; 17401us; 110us; 1780us; 2us; 32768us; 20us; 394us; 194us; 395us; 0us; 16589us; 0us; 16590us; 1us; 16591us; 131us; 397us; 1us; 17401us; 110us; 1780us; 0us; 16592us; 1us; 16542us; 73us; 298us; 36us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 17223us; 78us; 1530us; 1us; 32768us; 69us; 403us; 71us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16593us; 36us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 17223us; 78us; 1530us; 3us; 32768us; 26us; 392us; 69us; 408us; 87us; 390us; 71us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16594us; 0us; 16595us; 1us; 16596us; 47us; 412us; 0us; 16597us; 3us; 16622us; 42us; 472us; 43us; 471us; 44us; 473us; 3us; 16622us; 42us; 472us; 43us; 471us; 44us; 473us; 15us; 32768us; 14us; 550us; 30us; 698us; 32us; 694us; 40us; 707us; 46us; 331us; 47us; 333us; 49us; 411us; 50us; 334us; 51us; 335us; 53us; 481us; 109us; 448us; 111us; 549us; 119us; 440us; 137us; 692us; 161us; 688us; 49us; 32768us; 14us; 550us; 30us; 698us; 32us; 694us; 40us; 707us; 45us; 1702us; 46us; 331us; 47us; 333us; 49us; 411us; 50us; 334us; 51us; 335us; 53us; 481us; 55us; 534us; 57us; 621us; 66us; 1592us; 72us; 537us; 74us; 528us; 88us; 1621us; 91us; 1695us; 92us; 525us; 106us; 1643us; 109us; 448us; 111us; 549us; 113us; 1641us; 119us; 440us; 122us; 1642us; 137us; 692us; 147us; 1640us; 161us; 688us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16598us; 0us; 16599us; 2us; 17401us; 109us; 454us; 110us; 1780us; 1us; 17389us; 19us; 1775us; 0us; 16600us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 7us; 16624us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 87us; 475us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 0us; 16601us; 1us; 17401us; 110us; 1780us; 3us; 32768us; 92us; 1707us; 100us; 1712us; 190us; 1701us; 2us; 16681us; 33us; 1796us; 159us; 17420us; 1us; 32768us; 78us; 429us; 33us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 73us; 298us; 75us; 1552us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 2us; 16480us; 26us; 197us; 87us; 195us; 1us; 17389us; 19us; 1775us; 0us; 16602us; 0us; 16603us; 1us; 17389us; 19us; 1775us; 0us; 16604us; 1us; 17389us; 19us; 1775us; 0us; 16605us; 1us; 17389us; 19us; 1775us; 0us; 16606us; 35us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 16631us; 132us; 489us; 1us; 32768us; 69us; 443us; 71us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 17389us; 19us; 1775us; 0us; 16607us; 1us; 16542us; 73us; 298us; 0us; 16608us; 1us; 17403us; 118us; 1781us; 3us; 16616us; 42us; 472us; 43us; 471us; 44us; 473us; 1us; 32768us; 190us; 1701us; 1us; 32768us; 78us; 452us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16609us; 1us; 17403us; 118us; 1781us; 3us; 16616us; 42us; 472us; 43us; 471us; 44us; 473us; 1us; 32768us; 190us; 1701us; 1us; 16611us; 78us; 462us; 1us; 32768us; 69us; 459us; 71us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 2us; 16480us; 26us; 197us; 87us; 195us; 0us; 16610us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16612us; 1us; 32768us; 77us; 465us; 3us; 32768us; 92us; 1707us; 100us; 1712us; 190us; 1701us; 0us; 16613us; 0us; 16614us; 3us; 32768us; 92us; 1707us; 100us; 1712us; 190us; 1701us; 0us; 16615us; 0us; 16617us; 0us; 16618us; 0us; 16619us; 0us; 16620us; 0us; 16621us; 2us; 16542us; 22us; 495us; 73us; 298us; 3us; 32768us; 19us; 1769us; 20us; 1770us; 142us; 1771us; 0us; 16623us; 6us; 16542us; 19us; 16586us; 20us; 16586us; 22us; 379us; 73us; 298us; 142us; 16586us; 194us; 385us; 3us; 32768us; 19us; 1769us; 20us; 1770us; 142us; 1771us; 0us; 16625us; 37us; 32768us; 10us; 985us; 16us; 1829us; 36us; 1825us; 38us; 1826us; 45us; 1702us; 55us; 1630us; 60us; 1827us; 66us; 1624us; 88us; 1621us; 91us; 1695us; 92us; 1614us; 94us; 1828us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 971us; 31us; 16634us; 34us; 1795us; 35us; 1794us; 55us; 17418us; 71us; 17418us; 72us; 17418us; 74us; 17418us; 92us; 17418us; 106us; 17418us; 122us; 17418us; 132us; 492us; 136us; 17418us; 147us; 17418us; 154us; 17418us; 164us; 17418us; 165us; 17418us; 166us; 17418us; 167us; 17418us; 168us; 17418us; 169us; 17418us; 170us; 17418us; 171us; 17418us; 172us; 17418us; 173us; 17418us; 174us; 17418us; 175us; 17418us; 176us; 17418us; 178us; 17418us; 179us; 17418us; 191us; 17418us; 192us; 17418us; 193us; 17418us; 0us; 16627us; 28us; 32768us; 55us; 1493us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 92us; 1355us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 16634us; 132us; 492us; 0us; 16628us; 0us; 16629us; 0us; 16630us; 1us; 32768us; 190us; 1701us; 0us; 16632us; 0us; 16633us; 2us; 32768us; 153us; 494us; 190us; 1701us; 0us; 16635us; 0us; 16636us; 1us; 16542us; 73us; 298us; 5us; 32768us; 10us; 985us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 194us; 971us; 0us; 16637us; 0us; 16638us; 0us; 16639us; 2us; 17395us; 21us; 1765us; 84us; 1766us; 14us; 16542us; 10us; 16641us; 14us; 16641us; 15us; 16641us; 16us; 16641us; 17us; 16641us; 19us; 16641us; 20us; 16641us; 21us; 16641us; 59us; 16641us; 60us; 16641us; 61us; 16641us; 73us; 298us; 111us; 16641us; 142us; 16641us; 0us; 16640us; 3us; 32768us; 47us; 514us; 50us; 515us; 194us; 511us; 4us; 17401us; 47us; 514us; 50us; 515us; 110us; 1780us; 194us; 511us; 3us; 17401us; 109us; 454us; 110us; 1780us; 194us; 510us; 1us; 17389us; 19us; 1775us; 0us; 16642us; 1us; 17389us; 19us; 1775us; 0us; 16643us; 0us; 16644us; 1us; 17401us; 110us; 1780us; 1us; 17389us; 19us; 1775us; 0us; 16645us; 0us; 16646us; 0us; 16647us; 3us; 16622us; 42us; 472us; 43us; 471us; 44us; 473us; 34us; 32768us; 45us; 1702us; 55us; 534us; 57us; 621us; 66us; 1592us; 72us; 537us; 74us; 528us; 88us; 1621us; 91us; 1695us; 92us; 525us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 2us; 17247us; 77us; 1704us; 154us; 519us; 1us; 32768us; 192us; 520us; 2us; 32768us; 10us; 985us; 194us; 971us; 0us; 16648us; 0us; 16649us; 0us; 16650us; 0us; 16651us; 33us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 543us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1644us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 16652us; 2us; 16542us; 73us; 298us; 194us; 532us; 5us; 32768us; 10us; 985us; 59us; 1810us; 60us; 1807us; 61us; 1809us; 194us; 971us; 0us; 16653us; 0us; 16654us; 3us; 32768us; 59us; 1810us; 60us; 1807us; 61us; 1809us; 0us; 16655us; 2us; 32768us; 72us; 537us; 92us; 1631us; 0us; 16656us; 0us; 16657us; 2us; 16542us; 73us; 298us; 194us; 541us; 3us; 32768us; 10us; 985us; 65us; 1811us; 194us; 971us; 0us; 16658us; 0us; 16659us; 1us; 32768us; 65us; 1811us; 0us; 16660us; 30us; 32768us; 45us; 1702us; 55us; 1630us; 66us; 1624us; 88us; 1621us; 91us; 1695us; 92us; 1625us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 16796us; 88us; 545us; 0us; 16661us; 0us; 16662us; 0us; 16663us; 0us; 16664us; 0us; 16665us; 0us; 16666us; 5us; 32768us; 45us; 1702us; 91us; 1695us; 92us; 557us; 187us; 1698us; 190us; 1701us; 3us; 16667us; 33us; 1796us; 77us; 1704us; 159us; 17420us; 2us; 32768us; 45us; 1702us; 190us; 1701us; 1us; 16668us; 77us; 1704us; 0us; 16669us; 0us; 16670us; 1us; 16542us; 73us; 298us; 4us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 97us; 562us; 0us; 16671us; 2us; 16684us; 85us; 580us; 97us; 562us; 1us; 16677us; 97us; 563us; 1us; 16542us; 73us; 298us; 2us; 16542us; 73us; 298us; 143us; 572us; 0us; 16672us; 0us; 16673us; 2us; 32768us; 91us; 1695us; 187us; 1698us; 0us; 16674us; 1us; 32768us; 159us; 569us; 1us; 16542us; 73us; 298us; 1us; 32768us; 160us; 571us; 0us; 16675us; 0us; 16676us; 1us; 32768us; 159us; 574us; 3us; 16542us; 73us; 298us; 85us; 16678us; 160us; 16678us; 1us; 16684us; 85us; 580us; 1us; 32768us; 160us; 577us; 0us; 16679us; 0us; 16680us; 27us; 16682us; 10us; 16833us; 16us; 16833us; 21us; 16833us; 26us; 16833us; 36us; 16833us; 38us; 16833us; 57us; 16833us; 58us; 16833us; 59us; 16833us; 60us; 16833us; 61us; 16833us; 64us; 16833us; 69us; 16833us; 78us; 16833us; 79us; 16833us; 84us; 16833us; 85us; 16833us; 87us; 16833us; 89us; 16833us; 93us; 16833us; 94us; 16833us; 95us; 16833us; 97us; 16833us; 98us; 16833us; 127us; 16833us; 132us; 16833us; 194us; 16833us; 4us; 32768us; 51us; 587us; 91us; 1695us; 92us; 602us; 187us; 1698us; 1us; 16685us; 131us; 584us; 1us; 17220us; 131us; 584us; 1us; 17222us; 131us; 584us; 4us; 32768us; 51us; 587us; 91us; 1695us; 92us; 602us; 187us; 1698us; 0us; 16686us; 0us; 16687us; 2us; 32768us; 91us; 1695us; 187us; 1698us; 1us; 32768us; 78us; 589us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16688us; 2us; 32768us; 78us; 594us; 80us; 592us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16689us; 5us; 32768us; 55us; 595us; 92us; 599us; 147us; 598us; 151us; 609us; 190us; 596us; 0us; 16690us; 3us; 16697us; 33us; 1653us; 55us; 597us; 159us; 1655us; 0us; 16691us; 0us; 16692us; 1us; 16542us; 73us; 298us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 16693us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 4us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 102us; 612us; 1us; 32768us; 78us; 605us; 1us; 32768us; 92us; 606us; 1us; 16542us; 73us; 298us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 16694us; 2us; 32768us; 33us; 1653us; 159us; 1655us; 0us; 16695us; 0us; 16696us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 6us; 16698us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 6us; 16699us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 1us; 16542us; 73us; 298us; 0us; 16700us; 1us; 32768us; 57us; 621us; 1us; 16542us; 73us; 298us; 0us; 16701us; 2us; 16702us; 21us; 1777us; 57us; 17393us; 0us; 16703us; 1us; 16705us; 57us; 621us; 1us; 16542us; 73us; 298us; 0us; 16704us; 3us; 16616us; 42us; 472us; 43us; 471us; 44us; 473us; 3us; 32768us; 92us; 639us; 100us; 1712us; 190us; 1701us; 4us; 17393us; 21us; 1777us; 69us; 635us; 78us; 632us; 120us; 629us; 0us; 16706us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 74us; 528us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 17393us; 21us; 1777us; 0us; 16707us; 33us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 73us; 298us; 75us; 1552us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 17393us; 21us; 1777us; 0us; 16708us; 18us; 32768us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 17393us; 21us; 1777us; 0us; 16709us; 0us; 16710us; 29us; 32768us; 57us; 1747us; 62us; 1729us; 63us; 1727us; 69us; 1731us; 70us; 642us; 75us; 1735us; 79us; 640us; 83us; 1739us; 89us; 1736us; 90us; 1737us; 96us; 1730us; 102us; 1732us; 143us; 1742us; 144us; 1738us; 154us; 1744us; 157us; 1741us; 159us; 1733us; 160us; 1734us; 180us; 1740us; 181us; 1728us; 182us; 1725us; 183us; 1724us; 184us; 1726us; 185us; 1719us; 186us; 1723us; 187us; 1722us; 188us; 1721us; 189us; 1720us; 194us; 1710us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 16711us; 1us; 32768us; 58us; 643us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 16712us; 4us; 17326us; 21us; 1777us; 57us; 17393us; 69us; 647us; 120us; 651us; 0us; 16713us; 18us; 32768us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 17393us; 21us; 1777us; 45us; 16714us; 10us; 16717us; 14us; 16717us; 15us; 16717us; 16us; 16717us; 17us; 16717us; 19us; 16717us; 20us; 16717us; 21us; 16717us; 30us; 16717us; 32us; 16717us; 36us; 16717us; 37us; 16717us; 38us; 16717us; 39us; 16717us; 40us; 16717us; 42us; 16717us; 43us; 16717us; 44us; 16717us; 46us; 16717us; 47us; 16717us; 49us; 16717us; 50us; 16717us; 51us; 16717us; 53us; 16717us; 67us; 16717us; 73us; 16717us; 84us; 16717us; 87us; 16717us; 88us; 16717us; 93us; 16717us; 94us; 16717us; 95us; 16717us; 101us; 16717us; 108us; 16717us; 109us; 16717us; 111us; 16717us; 119us; 16717us; 121us; 16717us; 131us; 16717us; 137us; 16717us; 142us; 16717us; 149us; 16717us; 150us; 16717us; 161us; 16717us; 194us; 16717us; 0us; 16715us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 74us; 528us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16716us; 1us; 16719us; 96us; 654us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16718us; 1us; 17326us; 78us; 657us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 6us; 16720us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 6us; 16721us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 0us; 16722us; 0us; 16723us; 2us; 17395us; 21us; 1765us; 84us; 1766us; 7us; 16542us; 10us; 17394us; 59us; 17394us; 60us; 17394us; 61us; 17394us; 65us; 17394us; 73us; 298us; 194us; 17394us; 0us; 16724us; 0us; 16725us; 1us; 17403us; 118us; 1781us; 0us; 16726us; 3us; 16616us; 42us; 472us; 43us; 471us; 44us; 473us; 1us; 32768us; 190us; 1701us; 1us; 32768us; 78us; 671us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16727us; 1us; 16626us; 87us; 478us; 0us; 16728us; 0us; 16729us; 1us; 16542us; 73us; 298us; 3us; 16616us; 42us; 472us; 43us; 471us; 44us; 473us; 1us; 32768us; 190us; 1701us; 1us; 16733us; 69us; 684us; 0us; 16730us; 1us; 16731us; 120us; 682us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 74us; 528us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16732us; 2us; 32768us; 45us; 1702us; 190us; 1701us; 1us; 16734us; 77us; 1704us; 2us; 32768us; 45us; 1702us; 190us; 1701us; 1us; 16735us; 77us; 1704us; 1us; 17397us; 103us; 1779us; 2us; 16542us; 73us; 298us; 194us; 742us; 0us; 16736us; 0us; 16737us; 71us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16738us; 1us; 17397us; 103us; 1779us; 2us; 16542us; 73us; 298us; 194us; 742us; 3us; 32768us; 10us; 985us; 19us; 705us; 194us; 971us; 0us; 16739us; 71us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 3us; 32768us; 10us; 985us; 19us; 705us; 194us; 971us; 0us; 16740us; 0us; 16741us; 0us; 16742us; 0us; 16743us; 0us; 16744us; 0us; 16745us; 0us; 16746us; 1us; 16542us; 73us; 298us; 3us; 16616us; 42us; 472us; 43us; 471us; 44us; 473us; 1us; 32768us; 190us; 1701us; 2us; 17418us; 34us; 1795us; 35us; 1794us; 1us; 32768us; 92us; 712us; 4us; 16542us; 73us; 298us; 93us; 16750us; 94us; 16750us; 95us; 16750us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 16747us; 1us; 16748us; 97us; 717us; 1us; 16749us; 97us; 719us; 1us; 16542us; 73us; 298us; 0us; 16751us; 1us; 16542us; 73us; 298us; 0us; 16752us; 3us; 32768us; 41us; 731us; 45us; 1702us; 190us; 1701us; 6us; 16753us; 34us; 1795us; 35us; 1794us; 70us; 17418us; 89us; 730us; 96us; 729us; 190us; 1701us; 0us; 16754us; 1us; 16755us; 77us; 1704us; 5us; 16760us; 34us; 1795us; 35us; 1794us; 70us; 17418us; 89us; 730us; 96us; 729us; 1us; 32768us; 70us; 727us; 1us; 32768us; 58us; 728us; 0us; 16756us; 0us; 16757us; 0us; 16758us; 1us; 32768us; 96us; 733us; 1us; 16761us; 96us; 733us; 0us; 16759us; 3us; 32768us; 41us; 732us; 45us; 1702us; 190us; 1701us; 1us; 16764us; 131us; 737us; 0us; 16762us; 2us; 16542us; 73us; 298us; 194us; 742us; 1us; 16764us; 131us; 737us; 0us; 16763us; 1us; 17401us; 110us; 1780us; 0us; 16765us; 0us; 16766us; 1us; 17403us; 118us; 1781us; 36us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 17223us; 78us; 1530us; 3us; 32768us; 10us; 985us; 69us; 747us; 194us; 971us; 72us; 32768us; 13us; 1087us; 22us; 751us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 749us; 0us; 16767us; 0us; 16768us; 0us; 16769us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 5us; 32768us; 10us; 985us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 194us; 971us; 0us; 16770us; 0us; 16771us; 0us; 16772us; 0us; 16775us; 1us; 16773us; 85us; 759us; 0us; 16774us; 2us; 32768us; 91us; 1695us; 187us; 1698us; 2us; 32768us; 69us; 761us; 131us; 763us; 71us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16776us; 2us; 32768us; 91us; 1695us; 187us; 1698us; 0us; 16777us; 0us; 16778us; 2us; 32768us; 55us; 769us; 78us; 767us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16779us; 0us; 16780us; 0us; 16781us; 0us; 16782us; 0us; 16783us; 0us; 16784us; 0us; 16785us; 0us; 16786us; 0us; 16787us; 0us; 16788us; 0us; 16789us; 0us; 16790us; 0us; 16791us; 0us; 16792us; 0us; 16793us; 1us; 16793us; 143us; 872us; 0us; 16794us; 0us; 16795us; 0us; 16796us; 0us; 16797us; 1us; 16800us; 184us; 789us; 1us; 32768us; 176us; 790us; 0us; 16798us; 1us; 32768us; 176us; 792us; 1us; 16801us; 184us; 793us; 1us; 32768us; 176us; 794us; 0us; 16799us; 0us; 16802us; 2us; 32768us; 62us; 791us; 176us; 788us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 16803us; 0us; 16804us; 2us; 32768us; 92us; 796us; 176us; 795us; 0us; 16805us; 1us; 16806us; 33us; 803us; 1us; 32768us; 159us; 1672us; 0us; 16807us; 5us; 16808us; 57us; 834us; 79us; 835us; 89us; 842us; 97us; 840us; 132us; 832us; 0us; 16809us; 1us; 32768us; 190us; 1701us; 0us; 16810us; 1us; 16812us; 78us; 811us; 2us; 16813us; 78us; 811us; 97us; 814us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16811us; 3us; 32768us; 73us; 298us; 75us; 807us; 190us; 1701us; 3us; 32768us; 73us; 298us; 75us; 807us; 190us; 1701us; 0us; 16814us; 8us; 32768us; 10us; 985us; 73us; 298us; 75us; 807us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 190us; 1701us; 194us; 821us; 5us; 32768us; 10us; 985us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 194us; 971us; 0us; 16815us; 0us; 16816us; 0us; 16817us; 3us; 16901us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 16818us; 0us; 16819us; 3us; 16821us; 79us; 835us; 89us; 842us; 97us; 840us; 1us; 16822us; 79us; 835us; 2us; 16826us; 79us; 835us; 89us; 842us; 2us; 16827us; 79us; 835us; 89us; 842us; 1us; 16828us; 79us; 835us; 1us; 16829us; 79us; 835us; 6us; 32768us; 57us; 834us; 69us; 1065us; 79us; 835us; 89us; 842us; 97us; 840us; 132us; 832us; 6us; 32768us; 57us; 834us; 69us; 1071us; 79us; 835us; 89us; 842us; 97us; 840us; 132us; 832us; 1us; 32768us; 190us; 1701us; 0us; 16820us; 36us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 36us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 16823us; 97us; 839us; 0us; 16824us; 0us; 16825us; 36us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 36us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 36us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 36us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 2us; 17395us; 21us; 1765us; 84us; 1766us; 0us; 16830us; 1us; 17394us; 190us; 1701us; 0us; 16831us; 1us; 32768us; 69us; 849us; 2us; 17365us; 69us; 849us; 77us; 1754us; 37us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 6us; 16832us; 57us; 922us; 78us; 925us; 79us; 928us; 89us; 933us; 97us; 931us; 132us; 920us; 29us; 16683us; 10us; 16852us; 16us; 16852us; 21us; 16852us; 26us; 16852us; 33us; 1796us; 36us; 16852us; 38us; 16852us; 57us; 16852us; 58us; 16852us; 59us; 16852us; 60us; 16852us; 61us; 16852us; 64us; 16852us; 69us; 16852us; 78us; 16852us; 79us; 16852us; 84us; 16852us; 85us; 16852us; 87us; 16852us; 89us; 16852us; 93us; 16852us; 94us; 16852us; 95us; 16852us; 97us; 16852us; 98us; 16852us; 127us; 16852us; 132us; 16852us; 159us; 17420us; 194us; 16852us; 37us; 32768us; 34us; 854us; 35us; 856us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 92us; 861us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16834us; 35us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 92us; 861us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16835us; 35us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 92us; 861us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16836us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1624us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1625us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16837us; 0us; 16838us; 63us; 16866us; 10us; 985us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 57us; 1747us; 62us; 1729us; 63us; 1727us; 66us; 883us; 69us; 1731us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 885us; 82us; 858us; 83us; 1739us; 89us; 1736us; 90us; 1737us; 92us; 892us; 96us; 1730us; 100us; 1712us; 102us; 1732us; 106us; 890us; 122us; 889us; 143us; 1742us; 144us; 1738us; 147us; 891us; 154us; 1343us; 157us; 1741us; 159us; 1733us; 160us; 1734us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 180us; 1740us; 181us; 1728us; 182us; 1725us; 183us; 1724us; 184us; 1726us; 185us; 1719us; 186us; 1723us; 187us; 1722us; 188us; 1721us; 189us; 1720us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 896us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 16839us; 0us; 16840us; 37us; 16844us; 34us; 869us; 35us; 867us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16841us; 35us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16842us; 35us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16843us; 0us; 16845us; 1us; 32768us; 166us; 873us; 0us; 16846us; 2us; 32768us; 45us; 1702us; 190us; 1701us; 3us; 32768us; 59us; 1810us; 60us; 1807us; 61us; 1809us; 0us; 16847us; 37us; 16882us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 32768us; 58us; 879us; 0us; 16848us; 37us; 16882us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 32768us; 64us; 882us; 0us; 16849us; 0us; 16850us; 1us; 32768us; 190us; 1701us; 1us; 17350us; 190us; 1701us; 0us; 16851us; 0us; 16852us; 0us; 16853us; 0us; 16854us; 0us; 16855us; 0us; 16856us; 63us; 16866us; 10us; 985us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 57us; 1747us; 62us; 1729us; 63us; 1727us; 66us; 883us; 69us; 1731us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 885us; 82us; 858us; 83us; 1739us; 89us; 1736us; 90us; 1737us; 92us; 892us; 96us; 1730us; 100us; 1712us; 102us; 1732us; 106us; 890us; 122us; 889us; 143us; 1742us; 144us; 1738us; 147us; 891us; 154us; 1343us; 157us; 1741us; 159us; 1733us; 160us; 1734us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 180us; 1740us; 181us; 1728us; 182us; 1725us; 183us; 1724us; 184us; 1726us; 185us; 1719us; 186us; 1723us; 187us; 1722us; 188us; 1721us; 189us; 1720us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 896us; 5us; 32768us; 10us; 985us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 194us; 971us; 0us; 16857us; 0us; 16858us; 3us; 16901us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 2us; 16859us; 33us; 17330us; 159us; 17330us; 0us; 16860us; 1us; 32768us; 92us; 900us; 39us; 32768us; 10us; 985us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 904us; 6us; 16869us; 10us; 985us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 97us; 930us; 194us; 971us; 0us; 16861us; 0us; 16862us; 3us; 16901us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 16863us; 0us; 16864us; 6us; 16865us; 57us; 922us; 78us; 925us; 79us; 928us; 89us; 933us; 97us; 931us; 132us; 920us; 4us; 16868us; 78us; 925us; 79us; 928us; 89us; 933us; 97us; 931us; 3us; 16872us; 78us; 925us; 79us; 928us; 89us; 933us; 2us; 16873us; 78us; 925us; 79us; 928us; 3us; 16875us; 78us; 925us; 79us; 928us; 89us; 933us; 3us; 16876us; 78us; 925us; 79us; 928us; 89us; 933us; 2us; 16877us; 78us; 925us; 79us; 928us; 6us; 32768us; 57us; 922us; 78us; 925us; 79us; 928us; 89us; 933us; 97us; 931us; 132us; 920us; 2us; 16878us; 78us; 925us; 79us; 928us; 6us; 16881us; 57us; 922us; 78us; 925us; 79us; 928us; 89us; 933us; 97us; 931us; 132us; 920us; 8us; 17395us; 21us; 1765us; 57us; 922us; 78us; 925us; 79us; 928us; 84us; 1766us; 89us; 933us; 97us; 931us; 132us; 920us; 15us; 32768us; 10us; 985us; 16us; 1829us; 36us; 1825us; 38us; 1826us; 57us; 922us; 60us; 1827us; 69us; 1405us; 78us; 925us; 79us; 928us; 89us; 933us; 94us; 1828us; 97us; 931us; 127us; 1401us; 132us; 920us; 194us; 976us; 7us; 17022us; 57us; 922us; 78us; 925us; 79us; 928us; 85us; 1203us; 89us; 933us; 97us; 931us; 132us; 920us; 1us; 32768us; 190us; 1701us; 0us; 16867us; 37us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 16869us; 97us; 930us; 1us; 16870us; 89us; 932us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16871us; 37us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 37us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16874us; 37us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 37us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 37us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 37us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 2us; 17395us; 21us; 1765us; 84us; 1766us; 0us; 16879us; 2us; 17394us; 45us; 1702us; 190us; 1701us; 0us; 16880us; 2us; 32768us; 69us; 939us; 77us; 1704us; 37us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16883us; 37us; 16882us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16884us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 5us; 32768us; 10us; 985us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 194us; 971us; 0us; 16885us; 0us; 16886us; 0us; 16887us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 3us; 32768us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 0us; 16888us; 25us; 16889us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 1us; 16891us; 18us; 953us; 0us; 16890us; 1us; 16893us; 78us; 955us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16892us; 1us; 32768us; 10us; 958us; 0us; 16894us; 29us; 16897us; 21us; 1765us; 28us; 966us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 84us; 1766us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 104us; 964us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 30us; 16897us; 21us; 1765us; 28us; 966us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 84us; 1766us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 17089us; 102us; 1142us; 104us; 964us; 128us; 1139us; 143us; 1322us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 30us; 16897us; 21us; 1765us; 28us; 966us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 84us; 1766us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 104us; 964us; 128us; 1139us; 143us; 1396us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 70us; 16896us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16895us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16898us; 1us; 32768us; 22us; 967us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 3us; 32768us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 0us; 16899us; 73us; 16900us; 13us; 1087us; 21us; 993us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 992us; 0us; 16901us; 2us; 16901us; 19us; 1785us; 138us; 1784us; 2us; 16901us; 19us; 1785us; 138us; 1784us; 2us; 16901us; 19us; 1785us; 138us; 1784us; 2us; 16901us; 30us; 1783us; 137us; 1782us; 2us; 16901us; 19us; 1785us; 138us; 1784us; 1us; 16901us; 58us; 1293us; 1us; 16901us; 58us; 1317us; 1us; 16901us; 155us; 1347us; 1us; 16901us; 64us; 1353us; 3us; 16901us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 3us; 16901us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 3us; 16901us; 59us; 1810us; 60us; 1807us; 61us; 1809us; 1us; 16901us; 65us; 1811us; 0us; 16902us; 1us; 32768us; 127us; 987us; 71us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 989us; 0us; 16903us; 0us; 16904us; 73us; 32768us; 13us; 1087us; 21us; 993us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 992us; 0us; 16905us; 0us; 16906us; 72us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 995us; 0us; 16907us; 0us; 16908us; 0us; 16909us; 0us; 16910us; 0us; 16911us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 4us; 32768us; 10us; 985us; 26us; 1186us; 87us; 1184us; 194us; 971us; 0us; 16912us; 0us; 16913us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 4us; 32768us; 10us; 985us; 26us; 1186us; 87us; 1184us; 194us; 971us; 0us; 16914us; 0us; 16915us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 5us; 32768us; 10us; 985us; 26us; 1186us; 87us; 1184us; 129us; 1011us; 194us; 971us; 0us; 16916us; 0us; 16917us; 71us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16918us; 72us; 32768us; 10us; 985us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 971us; 29us; 32768us; 10us; 985us; 28us; 1209us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 104us; 1208us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 194us; 971us; 0us; 16919us; 0us; 16920us; 0us; 16921us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16922us; 62us; 16924us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 158us; 1064us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16923us; 71us; 32768us; 13us; 1087us; 22us; 948us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16925us; 63us; 16927us; 13us; 1087us; 22us; 948us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 158us; 1064us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16926us; 72us; 32768us; 10us; 985us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 972us; 29us; 32768us; 10us; 985us; 30us; 1783us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 137us; 1782us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 194us; 971us; 72us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1032us; 4us; 32768us; 10us; 985us; 19us; 1785us; 138us; 1784us; 194us; 971us; 0us; 16928us; 0us; 16929us; 2us; 32768us; 19us; 1785us; 138us; 1784us; 0us; 16930us; 0us; 16931us; 0us; 16932us; 0us; 16933us; 44us; 32768us; 10us; 985us; 16us; 1829us; 36us; 1825us; 38us; 1826us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 60us; 1827us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 94us; 1828us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 975us; 10us; 17393us; 10us; 985us; 16us; 1829us; 21us; 1777us; 30us; 1783us; 36us; 1825us; 38us; 1826us; 60us; 1827us; 94us; 1828us; 137us; 1782us; 194us; 971us; 78us; 32768us; 10us; 985us; 13us; 1087us; 16us; 1829us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 36us; 1825us; 38us; 1826us; 40us; 707us; 45us; 1287us; 55us; 1295us; 60us; 1827us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 94us; 1828us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 973us; 9us; 32768us; 10us; 985us; 16us; 1829us; 19us; 1785us; 36us; 1825us; 38us; 1826us; 60us; 1827us; 94us; 1828us; 138us; 1784us; 194us; 971us; 0us; 16934us; 0us; 16935us; 0us; 16936us; 0us; 16937us; 0us; 16938us; 4us; 32768us; 10us; 985us; 30us; 1783us; 137us; 1782us; 194us; 971us; 73us; 32768us; 10us; 985us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 974us; 4us; 32768us; 10us; 985us; 19us; 1785us; 138us; 1784us; 194us; 971us; 0us; 16939us; 0us; 16940us; 0us; 16941us; 0us; 16942us; 0us; 16943us; 71us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 2us; 32768us; 19us; 1785us; 138us; 1784us; 0us; 16944us; 0us; 16945us; 0us; 16946us; 0us; 16947us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 25us; 16948us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 25us; 16949us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 36us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 32768us; 127us; 1067us; 1us; 17393us; 21us; 1777us; 71us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16950us; 36us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 3us; 32768us; 10us; 985us; 19us; 705us; 194us; 971us; 1us; 17393us; 21us; 1777us; 72us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1076us; 0us; 16951us; 0us; 16952us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 32768us; 127us; 1079us; 1us; 17393us; 21us; 1777us; 71us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16953us; 71us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 3us; 32768us; 10us; 985us; 19us; 705us; 194us; 971us; 0us; 16954us; 1us; 32768us; 98us; 1399us; 0us; 16955us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 25us; 16956us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16957us; 25us; 16961us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 20us; 16964us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 20us; 16965us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 9us; 16966us; 62us; 1156us; 79us; 1154us; 82us; 1127us; 96us; 1157us; 157us; 1153us; 182us; 1155us; 184us; 1158us; 187us; 1152us; 189us; 1159us; 20us; 16967us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 18us; 16968us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 96us; 1157us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 18us; 16969us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 96us; 1157us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 9us; 16970us; 62us; 1156us; 79us; 1154us; 82us; 1127us; 96us; 1157us; 157us; 1153us; 182us; 1155us; 184us; 1158us; 187us; 1152us; 189us; 1159us; 9us; 16971us; 62us; 1156us; 79us; 1154us; 82us; 1127us; 96us; 1157us; 157us; 1153us; 182us; 1155us; 184us; 1158us; 187us; 1152us; 189us; 1159us; 9us; 16972us; 62us; 1156us; 79us; 1154us; 82us; 1127us; 96us; 1157us; 157us; 1153us; 182us; 1155us; 184us; 1158us; 187us; 1152us; 189us; 1159us; 9us; 16973us; 62us; 1156us; 79us; 1154us; 82us; 1127us; 96us; 1157us; 157us; 1153us; 182us; 1155us; 184us; 1158us; 187us; 1152us; 189us; 1159us; 9us; 16974us; 62us; 1156us; 79us; 1154us; 82us; 1127us; 96us; 1157us; 157us; 1153us; 182us; 1155us; 184us; 1158us; 187us; 1152us; 189us; 1159us; 9us; 16976us; 62us; 1156us; 79us; 1154us; 82us; 1127us; 96us; 1157us; 157us; 1153us; 182us; 1155us; 184us; 1158us; 187us; 1152us; 189us; 1159us; 9us; 16977us; 62us; 1156us; 79us; 1154us; 82us; 1127us; 96us; 1157us; 157us; 1153us; 182us; 1155us; 184us; 1158us; 187us; 1152us; 189us; 1159us; 1us; 16978us; 189us; 1159us; 8us; 16979us; 62us; 1156us; 79us; 1154us; 82us; 1127us; 96us; 1157us; 157us; 1153us; 182us; 1155us; 184us; 1158us; 189us; 1159us; 4us; 16980us; 96us; 1157us; 157us; 1153us; 184us; 1158us; 189us; 1159us; 4us; 16981us; 96us; 1157us; 157us; 1153us; 184us; 1158us; 189us; 1159us; 1us; 16982us; 189us; 1159us; 1us; 16983us; 189us; 1159us; 1us; 16984us; 189us; 1159us; 25us; 17021us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 25us; 17025us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 25us; 17029us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 29us; 32768us; 10us; 985us; 28us; 1209us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 104us; 1208us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 194us; 971us; 23us; 17034us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 25us; 32768us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 23us; 17037us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 25us; 17089us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 102us; 1142us; 128us; 1139us; 143us; 1322us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 24us; 17085us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 24us; 17087us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 26us; 17144us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 143us; 1396us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 28us; 32768us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 105us; 1408us; 128us; 1139us; 139us; 1409us; 143us; 1396us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 26us; 17140us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 143us; 1397us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 25us; 17141us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 25us; 17148us; 62us; 1156us; 63us; 1148us; 69us; 1146us; 79us; 1154us; 80us; 1129us; 81us; 1131us; 82us; 1127us; 83us; 1133us; 89us; 1143us; 90us; 1144us; 96us; 1157us; 97us; 1225us; 102us; 1142us; 128us; 1139us; 144us; 1140us; 157us; 1153us; 159us; 1149us; 160us; 1151us; 182us; 1155us; 183us; 1145us; 184us; 1158us; 186us; 1141us; 187us; 1152us; 188us; 1147us; 189us; 1159us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16958us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16959us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16960us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 17005us; 68us; 1135us; 71us; 32768us; 13us; 1087us; 22us; 948us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16962us; 1us; 16963us; 97us; 1223us; 6us; 16963us; 10us; 985us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 97us; 1223us; 194us; 971us; 71us; 32768us; 13us; 1087us; 16us; 1160us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1161us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1162us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1163us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1164us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1165us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1166us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1167us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1168us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1169us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 73us; 32768us; 10us; 985us; 13us; 1087us; 16us; 1170us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 971us; 0us; 16975us; 71us; 32768us; 13us; 1087us; 16us; 1171us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1172us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1173us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1174us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1175us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1176us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1177us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1178us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 71us; 32768us; 13us; 1087us; 16us; 1179us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 16985us; 0us; 16986us; 0us; 16987us; 0us; 16988us; 0us; 16989us; 0us; 16990us; 0us; 16991us; 0us; 16992us; 0us; 16993us; 0us; 16994us; 0us; 16995us; 0us; 16996us; 0us; 16997us; 0us; 16998us; 0us; 16999us; 0us; 17000us; 0us; 17001us; 0us; 17002us; 0us; 17003us; 0us; 17004us; 0us; 17006us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 17007us; 39us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 57us; 1191us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1194us; 0us; 17008us; 39us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 57us; 1191us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1194us; 3us; 32768us; 10us; 985us; 20us; 1188us; 194us; 971us; 0us; 17009us; 0us; 17010us; 0us; 17011us; 38us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1193us; 0us; 17012us; 0us; 17013us; 0us; 17014us; 0us; 17015us; 2us; 32768us; 98us; 1204us; 194us; 1202us; 2us; 17016us; 57us; 1198us; 194us; 1201us; 38us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1200us; 0us; 17017us; 0us; 17018us; 0us; 17019us; 0us; 17020us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17023us; 3us; 17028us; 27us; 1215us; 140us; 1214us; 141us; 1220us; 0us; 17024us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 32768us; 22us; 1210us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 5us; 32768us; 10us; 985us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 194us; 971us; 0us; 17026us; 0us; 17027us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 32768us; 22us; 1216us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 5us; 32768us; 10us; 985us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 194us; 971us; 0us; 17030us; 0us; 17031us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17032us; 0us; 17033us; 77us; 32768us; 10us; 985us; 13us; 1087us; 16us; 1829us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 36us; 1825us; 38us; 1826us; 40us; 707us; 45us; 1287us; 55us; 1295us; 60us; 1827us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 94us; 1828us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 971us; 0us; 17035us; 77us; 32768us; 10us; 985us; 13us; 1087us; 16us; 1829us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 36us; 1825us; 38us; 1826us; 40us; 707us; 45us; 1287us; 55us; 1295us; 60us; 1827us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 94us; 1828us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 971us; 0us; 17036us; 44us; 32768us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 119us; 1245us; 122us; 1330us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 44us; 17344us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 119us; 1245us; 122us; 1330us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17038us; 44us; 32768us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 119us; 1245us; 122us; 1330us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 44us; 17340us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 119us; 1245us; 122us; 1330us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17039us; 44us; 32768us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 119us; 1245us; 122us; 1330us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 44us; 17343us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 119us; 1245us; 122us; 1330us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17040us; 44us; 32768us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 119us; 1245us; 122us; 1330us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 44us; 17356us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 119us; 1245us; 122us; 1330us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17041us; 44us; 32768us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 119us; 1245us; 122us; 1330us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 44us; 17351us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 119us; 1245us; 122us; 1330us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17042us; 44us; 32768us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 119us; 1245us; 122us; 1330us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 44us; 17352us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 119us; 1245us; 122us; 1330us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17043us; 31us; 32768us; 45us; 1702us; 55us; 1630us; 66us; 1624us; 88us; 1621us; 91us; 1695us; 92us; 1614us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1254us; 31us; 32768us; 45us; 1702us; 55us; 1630us; 66us; 1624us; 88us; 1621us; 91us; 1695us; 92us; 1614us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1254us; 2us; 17418us; 34us; 1795us; 35us; 1794us; 35us; 17188us; 14us; 17191us; 21us; 17191us; 26us; 17191us; 34us; 1795us; 35us; 1794us; 55us; 17418us; 71us; 17418us; 72us; 17418us; 74us; 17418us; 87us; 17191us; 92us; 17418us; 106us; 17418us; 111us; 17191us; 122us; 17418us; 136us; 17418us; 147us; 17418us; 154us; 17418us; 164us; 17418us; 165us; 17418us; 166us; 17418us; 167us; 17418us; 168us; 17418us; 169us; 17418us; 170us; 17418us; 171us; 17418us; 172us; 17418us; 173us; 17418us; 174us; 17418us; 175us; 17418us; 176us; 17418us; 178us; 17418us; 179us; 17418us; 191us; 17418us; 192us; 17418us; 193us; 17418us; 29us; 32768us; 55us; 1493us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 92us; 1355us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1253us; 29us; 32768us; 55us; 1493us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 92us; 1355us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1253us; 0us; 17044us; 5us; 17044us; 14us; 17190us; 26us; 17190us; 87us; 17190us; 111us; 17190us; 132us; 492us; 0us; 17045us; 0us; 17046us; 44us; 32768us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 119us; 1245us; 122us; 1330us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17047us; 44us; 32768us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 119us; 1245us; 122us; 1330us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17048us; 36us; 17049us; 45us; 1287us; 55us; 1295us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1264us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 39us; 17049us; 26us; 1446us; 45us; 1287us; 55us; 1295us; 69us; 1433us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 87us; 1442us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1264us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 39us; 32768us; 26us; 1446us; 45us; 1287us; 55us; 1295us; 69us; 1433us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 87us; 1442us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1264us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17050us; 5us; 17051us; 33us; 1273us; 34us; 1272us; 35us; 1271us; 75us; 1285us; 77us; 1277us; 35us; 32768us; 45us; 1287us; 55us; 1295us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 5us; 17052us; 33us; 1273us; 34us; 1272us; 35us; 1271us; 75us; 1285us; 77us; 1277us; 5us; 17053us; 33us; 1273us; 34us; 1272us; 35us; 1271us; 75us; 1285us; 77us; 1277us; 2us; 17054us; 33us; 1273us; 34us; 1272us; 1us; 17055us; 33us; 1273us; 5us; 17057us; 33us; 1273us; 34us; 1272us; 35us; 1271us; 75us; 1285us; 77us; 1277us; 5us; 17284us; 33us; 1273us; 34us; 1272us; 35us; 1271us; 75us; 1285us; 77us; 1277us; 35us; 32768us; 45us; 1287us; 55us; 1295us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 35us; 32768us; 45us; 1287us; 55us; 1295us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 32768us; 159us; 1655us; 0us; 17056us; 35us; 32768us; 45us; 1287us; 55us; 1295us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 35us; 17334us; 45us; 1287us; 55us; 1295us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 7us; 17073us; 10us; 985us; 45us; 1301us; 70us; 1310us; 92us; 1303us; 100us; 1712us; 190us; 1701us; 194us; 971us; 0us; 17058us; 1us; 32768us; 77us; 1280us; 7us; 17073us; 10us; 985us; 45us; 1301us; 70us; 1310us; 92us; 1303us; 100us; 1712us; 190us; 1701us; 194us; 971us; 0us; 17059us; 3us; 32768us; 92us; 1707us; 100us; 1712us; 190us; 1701us; 3us; 17350us; 92us; 1707us; 100us; 1712us; 190us; 1701us; 0us; 17060us; 2us; 32768us; 92us; 1181us; 190us; 1180us; 0us; 17061us; 0us; 17062us; 0us; 17063us; 72us; 17137us; 10us; 985us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 977us; 3us; 32768us; 10us; 985us; 58us; 1291us; 194us; 971us; 0us; 17064us; 0us; 17065us; 0us; 17066us; 0us; 17067us; 2us; 32768us; 72us; 1496us; 92us; 1296us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17068us; 0us; 17069us; 0us; 17070us; 0us; 17071us; 0us; 17072us; 0us; 17074us; 89us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 57us; 1747us; 62us; 1228us; 63us; 1727us; 69us; 1731us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1283us; 79us; 1304us; 83us; 1739us; 86us; 1026us; 89us; 1240us; 90us; 1243us; 92us; 1357us; 96us; 1730us; 98us; 1089us; 100us; 1712us; 102us; 1732us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 143us; 1742us; 144us; 1738us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1343us; 157us; 1237us; 158us; 1064us; 159us; 1733us; 160us; 1734us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 180us; 1740us; 181us; 1234us; 182us; 1231us; 183us; 1724us; 184us; 1726us; 185us; 1276us; 186us; 1723us; 187us; 1722us; 188us; 1721us; 189us; 1720us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1710us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 1us; 32768us; 77us; 1306us; 1us; 32768us; 176us; 1307us; 0us; 17075us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 17076us; 74us; 32768us; 10us; 985us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 96us; 1324us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 143us; 1323us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 978us; 3us; 32768us; 10us; 985us; 58us; 1312us; 194us; 971us; 0us; 17077us; 0us; 17078us; 3us; 32768us; 10us; 985us; 58us; 1315us; 194us; 971us; 0us; 17079us; 0us; 17080us; 0us; 17081us; 0us; 17082us; 1us; 17084us; 97us; 1320us; 72us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 96us; 1324us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 143us; 1323us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17083us; 70us; 17086us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17088us; 0us; 17090us; 0us; 17091us; 0us; 17092us; 0us; 17093us; 0us; 17094us; 0us; 17095us; 0us; 17096us; 0us; 17097us; 0us; 17098us; 0us; 17099us; 72us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 142us; 1341us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1339us; 3us; 32768us; 10us; 985us; 142us; 1337us; 194us; 971us; 0us; 17100us; 0us; 17101us; 1us; 32768us; 142us; 1340us; 0us; 17102us; 0us; 17103us; 72us; 32768us; 10us; 985us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 979us; 73us; 32768us; 10us; 985us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 155us; 1745us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 979us; 3us; 32768us; 10us; 985us; 155us; 1345us; 194us; 971us; 0us; 17104us; 0us; 17105us; 0us; 17106us; 0us; 17107us; 72us; 17137us; 10us; 985us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 980us; 3us; 32768us; 10us; 985us; 64us; 1351us; 194us; 971us; 0us; 17108us; 0us; 17109us; 0us; 17110us; 0us; 17111us; 81us; 32768us; 10us; 985us; 13us; 1087us; 16us; 1367us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 36us; 1364us; 38us; 1365us; 40us; 707us; 45us; 1287us; 55us; 1295us; 60us; 1366us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 88us; 1410us; 89us; 1239us; 90us; 1242us; 92us; 1356us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 981us; 97us; 32768us; 10us; 985us; 13us; 1087us; 16us; 1367us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 36us; 1364us; 38us; 1365us; 40us; 707us; 45us; 1287us; 55us; 1295us; 57us; 1747us; 60us; 1366us; 62us; 1228us; 63us; 1727us; 69us; 1731us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1283us; 83us; 1739us; 86us; 1026us; 88us; 1410us; 89us; 1240us; 90us; 1243us; 92us; 1356us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 96us; 1730us; 98us; 1089us; 100us; 1712us; 102us; 1732us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 143us; 1742us; 144us; 1738us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1343us; 157us; 1237us; 158us; 1064us; 159us; 1733us; 160us; 1734us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 180us; 1740us; 181us; 1234us; 182us; 1231us; 183us; 1724us; 184us; 1726us; 185us; 1276us; 186us; 1723us; 187us; 1699us; 188us; 1721us; 189us; 1720us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 982us; 97us; 32768us; 10us; 985us; 13us; 1087us; 16us; 1367us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 36us; 1364us; 38us; 1365us; 40us; 707us; 45us; 1287us; 55us; 1295us; 57us; 1747us; 60us; 1366us; 62us; 1228us; 63us; 1727us; 69us; 1731us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1283us; 83us; 1739us; 86us; 1026us; 88us; 1410us; 89us; 1240us; 90us; 1243us; 92us; 1356us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 96us; 1730us; 98us; 1089us; 100us; 1712us; 102us; 1732us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 143us; 1742us; 144us; 1738us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1343us; 157us; 1237us; 158us; 1064us; 159us; 1733us; 160us; 1734us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 180us; 1740us; 181us; 1234us; 182us; 1231us; 183us; 1724us; 184us; 1726us; 185us; 1276us; 186us; 1723us; 187us; 1699us; 188us; 1721us; 189us; 1720us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 982us; 0us; 17112us; 9us; 32768us; 10us; 985us; 16us; 1823us; 36us; 1820us; 38us; 1821us; 60us; 1822us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 194us; 971us; 0us; 17113us; 0us; 17114us; 0us; 17115us; 0us; 17115us; 0us; 17116us; 0us; 17117us; 0us; 17118us; 0us; 17119us; 0us; 17120us; 1us; 32768us; 78us; 1370us; 1us; 32768us; 92us; 1371us; 1us; 16542us; 73us; 298us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17121us; 0us; 17122us; 0us; 17123us; 0us; 17124us; 4us; 17124us; 93us; 17127us; 94us; 17127us; 95us; 17127us; 102us; 17127us; 4us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 102us; 1381us; 0us; 17125us; 1us; 32768us; 187us; 1698us; 0us; 17126us; 77us; 32768us; 10us; 985us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 53us; 1426us; 55us; 1295us; 59us; 1810us; 60us; 1807us; 61us; 1809us; 62us; 1227us; 66us; 1437us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1246us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 983us; 5us; 32768us; 10us; 985us; 59us; 1810us; 60us; 1807us; 61us; 1809us; 194us; 971us; 0us; 17128us; 0us; 17129us; 0us; 17130us; 0us; 17131us; 0us; 17132us; 0us; 17133us; 0us; 17134us; 0us; 17135us; 0us; 17136us; 0us; 17138us; 0us; 17139us; 72us; 32768us; 10us; 985us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 971us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17142us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17143us; 77us; 32768us; 10us; 985us; 13us; 1087us; 16us; 1829us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 36us; 1825us; 38us; 1826us; 40us; 707us; 45us; 1287us; 55us; 1295us; 60us; 1827us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 94us; 1828us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 971us; 0us; 17145us; 0us; 17146us; 0us; 17147us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 70us; 32768us; 13us; 1087us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17149us; 0us; 17150us; 0us; 17151us; 2us; 32768us; 191us; 1793us; 192us; 1792us; 3us; 17157us; 36us; 1797us; 37us; 1800us; 108us; 1801us; 0us; 17154us; 37us; 17159us; 45us; 1287us; 55us; 1295us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 78us; 1422us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1264us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 32768us; 88us; 1415us; 0us; 17152us; 0us; 17153us; 0us; 17156us; 1us; 32768us; 92us; 1419us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 17158us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1424us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17160us; 36us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1644us; 0us; 17161us; 30us; 32768us; 45us; 1702us; 55us; 1630us; 66us; 1624us; 88us; 1621us; 91us; 1695us; 92us; 1614us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 2us; 17418us; 34us; 1795us; 35us; 1794us; 28us; 17155us; 55us; 1493us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 92us; 1355us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17180us; 2us; 17172us; 21us; 1455us; 84us; 1456us; 0us; 17162us; 0us; 17163us; 71us; 32768us; 13us; 1087us; 22us; 948us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17180us; 2us; 17172us; 21us; 1455us; 84us; 1456us; 0us; 17164us; 1us; 17165us; 69us; 1438us; 71us; 17166us; 13us; 1087us; 22us; 948us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17180us; 2us; 17172us; 21us; 1455us; 84us; 1456us; 0us; 17167us; 3us; 32768us; 45us; 1702us; 66us; 1460us; 190us; 1701us; 0us; 17180us; 2us; 17172us; 21us; 1455us; 84us; 1456us; 0us; 17168us; 5us; 17172us; 21us; 1455us; 45us; 1702us; 66us; 1460us; 84us; 1456us; 190us; 1701us; 1us; 32768us; 20us; 1448us; 0us; 17169us; 0us; 17180us; 2us; 17172us; 21us; 1455us; 84us; 1456us; 1us; 32768us; 20us; 1452us; 0us; 17170us; 0us; 17171us; 3us; 17171us; 45us; 1702us; 66us; 1460us; 190us; 1701us; 1us; 17173us; 84us; 1458us; 1us; 17174us; 21us; 1457us; 0us; 17175us; 0us; 17176us; 1us; 17177us; 77us; 1704us; 0us; 17178us; 0us; 17179us; 8us; 17184us; 10us; 985us; 16us; 1829us; 36us; 1825us; 38us; 1826us; 60us; 1827us; 69us; 1463us; 94us; 1828us; 194us; 971us; 78us; 17182us; 10us; 985us; 13us; 1087us; 16us; 1829us; 22us; 948us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 36us; 1825us; 38us; 1826us; 40us; 707us; 45us; 1287us; 55us; 1295us; 60us; 1827us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 94us; 1828us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 971us; 0us; 17181us; 0us; 17183us; 0us; 17185us; 3us; 17393us; 21us; 1777us; 26us; 1477us; 87us; 1475us; 1us; 17393us; 21us; 1777us; 3us; 17198us; 14us; 550us; 111us; 549us; 194us; 1486us; 0us; 17186us; 2us; 32768us; 14us; 550us; 111us; 549us; 0us; 17187us; 0us; 17189us; 0us; 17192us; 3us; 16542us; 22us; 495us; 73us; 298us; 194us; 742us; 0us; 17194us; 2us; 16542us; 73us; 298us; 194us; 742us; 1us; 32768us; 20us; 1479us; 0us; 17195us; 3us; 17387us; 19us; 1772us; 20us; 1773us; 142us; 1774us; 0us; 17196us; 3us; 17198us; 14us; 550us; 111us; 549us; 194us; 1486us; 0us; 17197us; 3us; 17198us; 14us; 550us; 111us; 549us; 194us; 1486us; 0us; 17199us; 3us; 17198us; 14us; 550us; 111us; 549us; 194us; 1486us; 0us; 17200us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 8us; 17193us; 26us; 1477us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 87us; 1475us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 3us; 17387us; 19us; 1772us; 20us; 1773us; 142us; 1774us; 1us; 17393us; 21us; 1777us; 0us; 17201us; 1us; 32768us; 72us; 1496us; 0us; 17202us; 0us; 17203us; 39us; 32768us; 10us; 985us; 45us; 1287us; 55us; 1295us; 65us; 1811us; 66us; 1437us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 984us; 3us; 32768us; 10us; 985us; 65us; 1811us; 194us; 971us; 0us; 17204us; 0us; 17205us; 0us; 17206us; 0us; 17207us; 0us; 17208us; 35us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 32768us; 98us; 1505us; 72us; 32768us; 13us; 1087us; 22us; 943us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1507us; 0us; 17209us; 0us; 17210us; 36us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 66us; 883us; 70us; 877us; 71us; 880us; 74us; 874us; 75us; 884us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1519us; 2us; 32768us; 98us; 1510us; 194us; 1517us; 73us; 32768us; 10us; 985us; 13us; 1087us; 18us; 1514us; 24us; 1508us; 25us; 1523us; 29us; 1082us; 30us; 698us; 31us; 1070us; 32us; 694us; 40us; 707us; 45us; 1287us; 55us; 1295us; 62us; 1227us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 86us; 1026us; 89us; 1239us; 90us; 1242us; 92us; 1357us; 98us; 1089us; 100us; 1712us; 106us; 1331us; 107us; 1007us; 114us; 1018us; 115us; 1022us; 116us; 999us; 117us; 1003us; 119us; 1245us; 122us; 1330us; 123us; 1037us; 124us; 1503us; 125us; 1521us; 126us; 1013us; 130us; 1077us; 133us; 1020us; 134us; 1024us; 136us; 1335us; 145us; 1255us; 146us; 1257us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 157us; 1236us; 158us; 1064us; 161us; 688us; 162us; 1060us; 163us; 1062us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 181us; 1233us; 182us; 1230us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 971us; 3us; 32768us; 10us; 985us; 20us; 1512us; 194us; 971us; 0us; 17211us; 0us; 17212us; 1us; 32768us; 20us; 1515us; 0us; 17213us; 0us; 17214us; 1us; 32768us; 20us; 1518us; 0us; 17215us; 1us; 32768us; 20us; 1520us; 0us; 17216us; 39us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 57us; 1191us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1194us; 0us; 17217us; 39us; 32768us; 42us; 472us; 43us; 471us; 44us; 473us; 45us; 464us; 55us; 899us; 57us; 1191us; 66us; 883us; 70us; 877us; 71us; 880us; 73us; 298us; 74us; 874us; 75us; 884us; 82us; 858us; 92us; 892us; 100us; 1712us; 106us; 890us; 122us; 889us; 147us; 891us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 783us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1194us; 1us; 32768us; 20us; 1525us; 0us; 17218us; 1us; 17219us; 85us; 1527us; 4us; 32768us; 51us; 587us; 91us; 1695us; 92us; 602us; 187us; 1698us; 1us; 17221us; 85us; 1529us; 4us; 32768us; 51us; 587us; 91us; 1695us; 92us; 602us; 187us; 1698us; 33us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 73us; 298us; 75us; 1552us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17224us; 1us; 17226us; 98us; 1533us; 33us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 73us; 298us; 75us; 1552us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17225us; 1us; 17228us; 96us; 1536us; 33us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 73us; 298us; 75us; 1552us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17227us; 1us; 17230us; 96us; 1539us; 33us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 73us; 298us; 75us; 1552us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17229us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 75us; 1545us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 7us; 17233us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 78us; 1543us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 6us; 17231us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 1us; 32768us; 190us; 1701us; 1us; 32768us; 78us; 1547us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 6us; 17232us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 7us; 17236us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 78us; 1550us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 6us; 17234us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 1us; 32768us; 190us; 1701us; 1us; 32768us; 78us; 1554us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 6us; 17235us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 1us; 17238us; 98us; 1557us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17237us; 1us; 32768us; 10us; 1560us; 0us; 17239us; 8us; 17243us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 91us; 1695us; 96us; 1562us; 184us; 1566us; 187us; 1698us; 190us; 1701us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17240us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17241us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17242us; 8us; 17246us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 91us; 1695us; 96us; 1569us; 184us; 1571us; 187us; 1698us; 190us; 1701us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17244us; 31us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17245us; 1us; 17247us; 77us; 1704us; 0us; 17248us; 1us; 17248us; 80us; 1590us; 1us; 17250us; 187us; 1578us; 4us; 17250us; 33us; 1653us; 77us; 1650us; 159us; 1655us; 187us; 1578us; 3us; 32768us; 62us; 800us; 92us; 796us; 176us; 795us; 0us; 17249us; 9us; 32768us; 10us; 985us; 35us; 1582us; 45us; 1702us; 70us; 1595us; 91us; 1695us; 96us; 1632us; 187us; 1698us; 190us; 1701us; 194us; 971us; 0us; 17251us; 1us; 32768us; 70us; 1595us; 0us; 17252us; 0us; 17253us; 33us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1644us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 4us; 32768us; 45us; 1702us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 0us; 17254us; 0us; 17255us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17256us; 1us; 17274us; 80us; 1593us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17257us; 2us; 32768us; 58us; 1596us; 97us; 1597us; 0us; 17258us; 2us; 32768us; 58us; 1598us; 97us; 1599us; 0us; 17259us; 2us; 32768us; 58us; 1600us; 97us; 1601us; 0us; 17260us; 1us; 32768us; 58us; 1602us; 0us; 17261us; 1us; 32768us; 97us; 1604us; 32us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17265us; 1us; 17262us; 97us; 1608us; 4us; 32768us; 10us; 985us; 97us; 1608us; 160us; 1659us; 194us; 971us; 32us; 17306us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17263us; 0us; 17264us; 1us; 17266us; 187us; 1612us; 3us; 32768us; 62us; 800us; 92us; 796us; 176us; 795us; 0us; 17267us; 33us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1644us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 4us; 32768us; 45us; 1702us; 91us; 1695us; 187us; 1698us; 190us; 1701us; 0us; 17268us; 1us; 17269us; 77us; 1647us; 1us; 17270us; 77us; 1647us; 0us; 17271us; 30us; 32768us; 45us; 1702us; 55us; 1630us; 66us; 1624us; 88us; 1621us; 91us; 1695us; 92us; 1625us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 1us; 17272us; 77us; 1647us; 0us; 17273us; 0us; 17274us; 33us; 32768us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 1644us; 5us; 32768us; 10us; 985us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 194us; 971us; 6us; 17301us; 10us; 985us; 69us; 1668us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 194us; 971us; 0us; 17275us; 0us; 17276us; 1us; 32768us; 92us; 1631us; 33us; 32768us; 10us; 985us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 971us; 33us; 32768us; 10us; 985us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 971us; 5us; 32768us; 10us; 985us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 194us; 971us; 0us; 17277us; 0us; 17278us; 0us; 17279us; 0us; 17280us; 0us; 17281us; 0us; 17282us; 0us; 17283us; 35us; 32768us; 45us; 1287us; 55us; 1295us; 70us; 1289us; 71us; 1349us; 72us; 1496us; 74us; 1383us; 75us; 1282us; 92us; 1357us; 100us; 1712us; 106us; 1331us; 122us; 1330us; 136us; 1335us; 147us; 1329us; 153us; 1279us; 154us; 1342us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 185us; 1275us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17285us; 0us; 17286us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 17287us; 0us; 17288us; 2us; 32768us; 45us; 1702us; 190us; 1701us; 3us; 17289us; 33us; 1653us; 77us; 1704us; 159us; 1655us; 0us; 17290us; 7us; 32768us; 10us; 985us; 16us; 1829us; 36us; 1825us; 38us; 1826us; 60us; 1827us; 94us; 1828us; 194us; 971us; 0us; 17291us; 0us; 17292us; 1us; 32768us; 159us; 1655us; 0us; 17293us; 35us; 17306us; 10us; 985us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 160us; 1665us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 971us; 1us; 32768us; 97us; 1657us; 39us; 17306us; 10us; 985us; 16us; 1829us; 36us; 1825us; 38us; 1826us; 45us; 1702us; 55us; 534us; 60us; 1827us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 94us; 1828us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 194us; 971us; 0us; 17265us; 0us; 17294us; 0us; 17295us; 0us; 17296us; 8us; 17304us; 10us; 985us; 16us; 1829us; 36us; 1825us; 38us; 1826us; 60us; 1827us; 94us; 1828us; 160us; 1663us; 194us; 971us; 0us; 17297us; 0us; 17298us; 0us; 17299us; 0us; 17300us; 1us; 17301us; 69us; 1668us; 32us; 17303us; 45us; 1702us; 55us; 534us; 66us; 1592us; 72us; 537us; 88us; 1621us; 91us; 1695us; 92us; 1585us; 106us; 1643us; 113us; 1641us; 122us; 1642us; 147us; 1640us; 164us; 785us; 165us; 784us; 166us; 782us; 167us; 781us; 168us; 780us; 169us; 778us; 170us; 779us; 171us; 777us; 172us; 775us; 173us; 773us; 174us; 771us; 175us; 776us; 176us; 774us; 178us; 772us; 179us; 770us; 184us; 1564us; 187us; 1698us; 190us; 1701us; 191us; 1793us; 192us; 1792us; 193us; 787us; 0us; 17302us; 0us; 17304us; 0us; 17305us; 8us; 32768us; 45us; 1702us; 66us; 1675us; 91us; 1695us; 92us; 1679us; 176us; 1685us; 184us; 1694us; 187us; 1698us; 190us; 1701us; 3us; 32768us; 96us; 1692us; 160us; 1674us; 184us; 1693us; 0us; 17307us; 1us; 32768us; 160us; 1676us; 0us; 17308us; 1us; 17309us; 77us; 1704us; 0us; 17310us; 7us; 32768us; 45us; 1702us; 91us; 1695us; 92us; 1679us; 176us; 1685us; 184us; 1694us; 187us; 1698us; 190us; 1701us; 5us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 96us; 1692us; 184us; 1693us; 0us; 17311us; 1us; 17312us; 187us; 1683us; 3us; 32768us; 62us; 800us; 92us; 796us; 176us; 795us; 0us; 17313us; 0us; 17314us; 6us; 17315us; 45us; 1702us; 91us; 1695us; 92us; 1679us; 176us; 1685us; 187us; 1698us; 190us; 1701us; 0us; 17316us; 0us; 17317us; 0us; 17318us; 0us; 17319us; 0us; 17320us; 7us; 32768us; 45us; 1702us; 91us; 1695us; 92us; 1679us; 176us; 1685us; 184us; 1694us; 187us; 1698us; 190us; 1701us; 7us; 32768us; 45us; 1702us; 91us; 1695us; 92us; 1679us; 176us; 1685us; 184us; 1694us; 187us; 1698us; 190us; 1701us; 7us; 32768us; 45us; 1702us; 91us; 1695us; 92us; 1679us; 176us; 1685us; 184us; 1694us; 187us; 1698us; 190us; 1701us; 1us; 32768us; 190us; 1701us; 0us; 17321us; 0us; 17322us; 1us; 32768us; 190us; 1701us; 1us; 17337us; 190us; 1701us; 0us; 17323us; 0us; 17324us; 0us; 17325us; 0us; 17326us; 8us; 32768us; 10us; 985us; 16us; 1829us; 36us; 1825us; 38us; 1826us; 60us; 1827us; 94us; 1828us; 190us; 1701us; 194us; 971us; 0us; 17327us; 0us; 17328us; 27us; 32768us; 57us; 1747us; 62us; 1729us; 63us; 1727us; 69us; 1731us; 75us; 1735us; 83us; 1739us; 89us; 1736us; 90us; 1737us; 96us; 1730us; 102us; 1732us; 143us; 1742us; 144us; 1738us; 154us; 1744us; 157us; 1741us; 159us; 1733us; 160us; 1734us; 180us; 1740us; 181us; 1728us; 182us; 1725us; 183us; 1724us; 184us; 1726us; 185us; 1719us; 186us; 1723us; 187us; 1722us; 188us; 1721us; 189us; 1720us; 194us; 1710us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 17329us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 17330us; 0us; 17331us; 1us; 32768us; 57us; 1714us; 5us; 32768us; 66us; 1716us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 190us; 1746us; 0us; 17332us; 1us; 32768us; 57us; 1717us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 17333us; 0us; 17334us; 0us; 17335us; 0us; 17336us; 0us; 17337us; 0us; 17338us; 0us; 17339us; 0us; 17340us; 0us; 17341us; 0us; 17342us; 0us; 17343us; 0us; 17344us; 0us; 17345us; 0us; 17346us; 0us; 17347us; 0us; 17348us; 0us; 17349us; 0us; 17350us; 0us; 17351us; 0us; 17352us; 0us; 17353us; 0us; 17354us; 0us; 17355us; 0us; 17356us; 1us; 17357us; 143us; 1743us; 0us; 17358us; 1us; 32768us; 155us; 1745us; 0us; 17359us; 0us; 17360us; 1us; 32768us; 190us; 1746us; 0us; 17361us; 0us; 17362us; 0us; 17363us; 0us; 17364us; 1us; 17365us; 77us; 1754us; 0us; 17366us; 4us; 32768us; 92us; 1707us; 100us; 1712us; 190us; 1701us; 194us; 1756us; 0us; 17367us; 0us; 17368us; 0us; 17369us; 0us; 17370us; 0us; 17371us; 0us; 17372us; 3us; 17373us; 21us; 1760us; 67us; 1759us; 84us; 1758us; 0us; 17374us; 3us; 17376us; 21us; 1760us; 67us; 1759us; 84us; 1758us; 0us; 17375us; 1us; 17377us; 84us; 1767us; 1us; 17378us; 21us; 1768us; 0us; 17379us; 0us; 17380us; 0us; 17381us; 0us; 17382us; 0us; 17383us; 0us; 17384us; 0us; 17385us; 0us; 17386us; 0us; 17388us; 0us; 17390us; 0us; 17392us; 0us; 17394us; 0us; 17396us; 0us; 17400us; 0us; 17402us; 0us; 17404us; 0us; 17405us; 0us; 17406us; 0us; 17407us; 0us; 17408us; 0us; 17409us; 0us; 17410us; 0us; 17411us; 0us; 17412us; 0us; 17413us; 0us; 17414us; 0us; 17415us; 0us; 17416us; 0us; 17417us; 0us; 17419us; 3us; 32768us; 36us; 1797us; 37us; 1800us; 108us; 1801us; 3us; 17442us; 36us; 1797us; 37us; 1800us; 108us; 1801us; 0us; 17421us; 0us; 17422us; 0us; 17423us; 3us; 32768us; 38us; 1802us; 39us; 1805us; 149us; 1806us; 3us; 17443us; 38us; 1802us; 39us; 1805us; 149us; 1806us; 0us; 17424us; 0us; 17425us; 0us; 17426us; 3us; 32768us; 59us; 1810us; 60us; 1807us; 61us; 1809us; 0us; 17427us; 0us; 17428us; 0us; 17429us; 0us; 17430us; 3us; 32768us; 93us; 1815us; 94us; 1812us; 95us; 1814us; 0us; 17431us; 0us; 17432us; 0us; 17433us; 3us; 32768us; 15us; 1819us; 16us; 1816us; 17us; 1818us; 0us; 17434us; 0us; 17435us; 0us; 17436us; 0us; 17437us; 0us; 17438us; 0us; 17439us; 0us; 17440us; 0us; 17441us; 0us; 17442us; 0us; 17443us; 0us; 17444us; 0us; 17445us; 0us; 17446us; 0us; 17447us; |]
let _fsyacc_actionTableRowOffsets = [|0us; 17us; 18us; 105us; 106us; 114us; 115us; 186us; 187us; 220us; 221us; 222us; 223us; 224us; 225us; 226us; 227us; 232us; 233us; 238us; 239us; 244us; 245us; 251us; 252us; 258us; 259us; 265us; 266us; 283us; 284us; 288us; 367us; 393us; 394us; 397us; 398us; 399us; 400us; 402us; 403us; 406us; 407us; 408us; 411us; 412us; 414us; 415us; 420us; 421us; 425us; 427us; 430us; 432us; 434us; 437us; 439us; 441us; 442us; 444us; 445us; 447us; 464us; 465us; 469us; 478us; 497us; 498us; 499us; 500us; 516us; 522us; 524us; 525us; 526us; 533us; 534us; 535us; 539us; 543us; 559us; 560us; 564us; 569us; 570us; 571us; 572us; 576us; 585us; 588us; 594us; 595us; 596us; 597us; 598us; 601us; 603us; 605us; 607us; 609us; 613us; 617us; 620us; 622us; 656us; 658us; 659us; 731us; 757us; 828us; 857us; 858us; 867us; 871us; 872us; 888us; 890us; 894us; 895us; 911us; 913us; 914us; 916us; 917us; 919us; 921us; 922us; 925us; 933us; 934us; 935us; 988us; 990us; 1005us; 1007us; 1011us; 1013us; 1014us; 1016us; 1017us; 1018us; 1019us; 1021us; 1055us; 1056us; 1057us; 1074us; 1078us; 1079us; 1080us; 1082us; 1083us; 1098us; 1104us; 1105us; 1106us; 1122us; 1126us; 1127us; 1128us; 1143us; 1149us; 1150us; 1151us; 1152us; 1153us; 1156us; 1171us; 1172us; 1176us; 1180us; 1191us; 1236us; 1238us; 1242us; 1246us; 1249us; 1251us; 1285us; 1288us; 1290us; 1291us; 1323us; 1330us; 1362us; 1369us; 1371us; 1372us; 1378us; 1380us; 1381us; 1383us; 1384us; 1386us; 1420us; 1421us; 1425us; 1426us; 1430us; 1433us; 1434us; 1435us; 1437us; 1441us; 1442us; 1443us; 1445us; 1446us; 1448us; 1449us; 1465us; 1469us; 1470us; 1473us; 1474us; 1476us; 1477us; 1482us; 1483us; 1485us; 1486us; 1488us; 1489us; 1491us; 1578us; 1579us; 1584us; 1663us; 1751us; 1752us; 1753us; 1839us; 1845us; 1847us; 1848us; 1849us; 1856us; 1857us; 1858us; 1859us; 1864us; 1943us; 1972us; 2058us; 2059us; 2060us; 2061us; 2083us; 2084us; 2170us; 2171us; 2175us; 2182us; 2187us; 2192us; 2193us; 2194us; 2195us; 2199us; 2211us; 2212us; 2214us; 2215us; 2287us; 2288us; 2290us; 2292us; 2293us; 2294us; 2296us; 2302us; 2303us; 2306us; 2307us; 2308us; 2313us; 2314us; 2316us; 2323us; 2329us; 2330us; 2331us; 2337us; 2338us; 2339us; 2340us; 2341us; 2343us; 2429us; 2433us; 2434us; 2435us; 2436us; 2443us; 2447us; 2448us; 2449us; 2451us; 2452us; 2467us; 2470us; 2479us; 2481us; 2482us; 2484us; 2486us; 2487us; 2488us; 2489us; 2490us; 2500us; 2501us; 2505us; 2534us; 2535us; 2539us; 2543us; 2572us; 2573us; 2576us; 2581us; 2584us; 2613us; 2614us; 2616us; 2617us; 2619us; 2620us; 2622us; 2623us; 2625us; 2626us; 2637us; 2638us; 2639us; 2640us; 2641us; 2645us; 2647us; 2648us; 2650us; 2652us; 2653us; 2694us; 2701us; 2702us; 2703us; 2707us; 2710us; 2712us; 2714us; 2716us; 2723us; 2724us; 2736us; 2738us; 2746us; 2748us; 2754us; 2756us; 2757us; 2758us; 2760us; 2761us; 2762us; 2763us; 2765us; 2799us; 2800us; 2801us; 2807us; 2811us; 2812us; 2813us; 2818us; 2819us; 2826us; 2832us; 2833us; 2834us; 2841us; 2847us; 2848us; 2849us; 2850us; 2851us; 2862us; 2863us; 2866us; 2877us; 2878us; 2880us; 2881us; 2883us; 2886us; 2887us; 2888us; 2890us; 2892us; 2893us; 2895us; 2932us; 2934us; 2936us; 3008us; 3009us; 3046us; 3048us; 3052us; 3124us; 3125us; 3126us; 3128us; 3129us; 3133us; 3137us; 3153us; 3203us; 3204us; 3205us; 3208us; 3210us; 3211us; 3243us; 3251us; 3252us; 3254us; 3258us; 3261us; 3263us; 3297us; 3300us; 3302us; 3303us; 3304us; 3306us; 3307us; 3309us; 3310us; 3312us; 3313us; 3349us; 3351us; 3353us; 3425us; 3427us; 3428us; 3430us; 3431us; 3433us; 3437us; 3439us; 3441us; 3474us; 3475us; 3477us; 3481us; 3483us; 3485us; 3487us; 3559us; 3562us; 3563us; 3596us; 3597us; 3599us; 3603us; 3604us; 3605us; 3609us; 3610us; 3611us; 3612us; 3613us; 3614us; 3615us; 3618us; 3622us; 3623us; 3630us; 3634us; 3635us; 3673us; 3705us; 3706us; 3735us; 3737us; 3738us; 3739us; 3740us; 3742us; 3743us; 3744us; 3747us; 3748us; 3749us; 3751us; 3757us; 3758us; 3759us; 3760us; 3763us; 3778us; 3779us; 3783us; 3788us; 3792us; 3794us; 3795us; 3797us; 3798us; 3799us; 3801us; 3803us; 3804us; 3805us; 3806us; 3810us; 3845us; 3848us; 3850us; 3853us; 3854us; 3855us; 3856us; 3857us; 3891us; 3895us; 3896us; 3899us; 3905us; 3906us; 3907us; 3911us; 3912us; 3915us; 3916us; 3917us; 3920us; 3924us; 3925us; 3926us; 3928us; 3929us; 3960us; 3962us; 3963us; 3964us; 3965us; 3966us; 3967us; 3968us; 3974us; 3978us; 3981us; 3983us; 3984us; 3985us; 3987us; 3992us; 3993us; 3996us; 3998us; 4000us; 4003us; 4004us; 4005us; 4008us; 4009us; 4011us; 4013us; 4015us; 4016us; 4017us; 4019us; 4023us; 4025us; 4027us; 4028us; 4029us; 4057us; 4062us; 4064us; 4066us; 4068us; 4073us; 4074us; 4075us; 4078us; 4080us; 4113us; 4114us; 4117us; 4150us; 4151us; 4157us; 4158us; 4162us; 4163us; 4164us; 4166us; 4170us; 4171us; 4203us; 4208us; 4210us; 4212us; 4214us; 4218us; 4219us; 4222us; 4223us; 4224us; 4256us; 4263us; 4270us; 4272us; 4273us; 4275us; 4277us; 4278us; 4281us; 4282us; 4284us; 4286us; 4287us; 4291us; 4295us; 4300us; 4301us; 4334us; 4336us; 4337us; 4371us; 4373us; 4374us; 4393us; 4395us; 4396us; 4397us; 4427us; 4431us; 4432us; 4434us; 4438us; 4439us; 4444us; 4445us; 4464us; 4466us; 4512us; 4513us; 4546us; 4547us; 4549us; 4581us; 4582us; 4584us; 4616us; 4623us; 4630us; 4631us; 4632us; 4635us; 4643us; 4644us; 4645us; 4647us; 4648us; 4652us; 4654us; 4656us; 4689us; 4690us; 4692us; 4693us; 4694us; 4696us; 4700us; 4702us; 4704us; 4705us; 4707us; 4740us; 4741us; 4744us; 4746us; 4749us; 4751us; 4753us; 4756us; 4757us; 4758us; 4830us; 4831us; 4833us; 4836us; 4840us; 4841us; 4913us; 4917us; 4918us; 4919us; 4920us; 4921us; 4922us; 4923us; 4924us; 4926us; 4930us; 4932us; 4935us; 4937us; 4942us; 4946us; 4947us; 4949us; 4951us; 4953us; 4954us; 4956us; 4957us; 4961us; 4968us; 4969us; 4971us; 4977us; 4979us; 4981us; 4982us; 4983us; 4984us; 4986us; 4988us; 4989us; 4993us; 4995us; 4996us; 4999us; 5001us; 5002us; 5004us; 5005us; 5006us; 5008us; 5045us; 5047us; 5051us; 5124us; 5125us; 5126us; 5127us; 5198us; 5204us; 5205us; 5206us; 5207us; 5208us; 5210us; 5211us; 5214us; 5217us; 5289us; 5290us; 5293us; 5294us; 5295us; 5298us; 5331us; 5332us; 5333us; 5334us; 5335us; 5336us; 5337us; 5338us; 5339us; 5340us; 5341us; 5342us; 5343us; 5344us; 5345us; 5346us; 5348us; 5349us; 5350us; 5351us; 5352us; 5354us; 5356us; 5357us; 5359us; 5361us; 5363us; 5364us; 5365us; 5368us; 5372us; 5373us; 5374us; 5377us; 5378us; 5380us; 5382us; 5383us; 5389us; 5390us; 5392us; 5393us; 5395us; 5398us; 5431us; 5432us; 5436us; 5440us; 5441us; 5450us; 5456us; 5457us; 5458us; 5459us; 5463us; 5464us; 5465us; 5469us; 5471us; 5474us; 5477us; 5479us; 5481us; 5488us; 5495us; 5497us; 5498us; 5535us; 5572us; 5574us; 5575us; 5576us; 5613us; 5650us; 5687us; 5724us; 5727us; 5728us; 5730us; 5731us; 5733us; 5736us; 5774us; 5781us; 5811us; 5849us; 5850us; 5886us; 5887us; 5923us; 5924us; 5956us; 5957us; 5958us; 6022us; 6026us; 6027us; 6028us; 6066us; 6067us; 6103us; 6104us; 6140us; 6141us; 6142us; 6144us; 6145us; 6148us; 6152us; 6153us; 6191us; 6193us; 6194us; 6232us; 6234us; 6235us; 6236us; 6238us; 6240us; 6241us; 6242us; 6243us; 6244us; 6245us; 6246us; 6310us; 6316us; 6317us; 6318us; 6322us; 6325us; 6326us; 6328us; 6368us; 6375us; 6376us; 6377us; 6381us; 6382us; 6383us; 6390us; 6395us; 6399us; 6402us; 6406us; 6410us; 6413us; 6420us; 6423us; 6430us; 6439us; 6455us; 6463us; 6465us; 6466us; 6504us; 6506us; 6508us; 6541us; 6542us; 6580us; 6618us; 6619us; 6657us; 6695us; 6733us; 6771us; 6774us; 6775us; 6778us; 6779us; 6782us; 6820us; 6821us; 6859us; 6860us; 6931us; 6937us; 6938us; 6939us; 6940us; 7011us; 7015us; 7016us; 7042us; 7044us; 7045us; 7047us; 7080us; 7081us; 7083us; 7084us; 7114us; 7145us; 7176us; 7247us; 7248us; 7319us; 7320us; 7322us; 7393us; 7397us; 7398us; 7472us; 7473us; 7476us; 7479us; 7482us; 7485us; 7488us; 7490us; 7492us; 7494us; 7496us; 7500us; 7504us; 7508us; 7510us; 7511us; 7513us; 7585us; 7586us; 7587us; 7661us; 7662us; 7663us; 7736us; 7737us; 7738us; 7739us; 7740us; 7741us; 7812us; 7817us; 7818us; 7819us; 7890us; 7895us; 7896us; 7897us; 7968us; 7974us; 7975us; 7976us; 8048us; 8049us; 8122us; 8152us; 8153us; 8154us; 8155us; 8226us; 8227us; 8290us; 8291us; 8363us; 8364us; 8428us; 8429us; 8502us; 8532us; 8605us; 8610us; 8611us; 8612us; 8615us; 8616us; 8617us; 8618us; 8619us; 8664us; 8675us; 8754us; 8764us; 8765us; 8766us; 8767us; 8768us; 8769us; 8774us; 8848us; 8853us; 8854us; 8855us; 8856us; 8857us; 8858us; 8930us; 8933us; 8934us; 8935us; 8936us; 8937us; 9008us; 9034us; 9105us; 9131us; 9168us; 9240us; 9242us; 9244us; 9316us; 9317us; 9354us; 9426us; 9430us; 9432us; 9505us; 9506us; 9507us; 9578us; 9580us; 9582us; 9654us; 9655us; 9727us; 9731us; 9732us; 9734us; 9735us; 9806us; 9832us; 9903us; 9904us; 9930us; 9951us; 9972us; 9982us; 10003us; 10022us; 10041us; 10051us; 10061us; 10071us; 10081us; 10091us; 10101us; 10111us; 10113us; 10122us; 10127us; 10132us; 10134us; 10136us; 10138us; 10164us; 10190us; 10216us; 10246us; 10270us; 10296us; 10320us; 10346us; 10371us; 10396us; 10423us; 10452us; 10479us; 10505us; 10531us; 10564us; 10565us; 10598us; 10599us; 10632us; 10633us; 10704us; 10706us; 10778us; 10779us; 10781us; 10788us; 10860us; 10932us; 11004us; 11076us; 11148us; 11220us; 11292us; 11364us; 11436us; 11508us; 11582us; 11583us; 11655us; 11727us; 11799us; 11871us; 11943us; 12015us; 12087us; 12159us; 12231us; 12232us; 12233us; 12234us; 12235us; 12236us; 12237us; 12238us; 12239us; 12240us; 12241us; 12242us; 12243us; 12244us; 12245us; 12246us; 12247us; 12248us; 12249us; 12250us; 12251us; 12252us; 12323us; 12327us; 12328us; 12368us; 12369us; 12409us; 12413us; 12414us; 12415us; 12416us; 12455us; 12456us; 12457us; 12458us; 12459us; 12462us; 12465us; 12504us; 12505us; 12506us; 12507us; 12508us; 12579us; 12650us; 12651us; 12655us; 12656us; 12727us; 12729us; 12800us; 12806us; 12807us; 12808us; 12879us; 12881us; 12952us; 12958us; 12959us; 12960us; 13031us; 13032us; 13033us; 13111us; 13112us; 13190us; 13191us; 13236us; 13281us; 13282us; 13327us; 13372us; 13373us; 13418us; 13463us; 13464us; 13509us; 13554us; 13555us; 13600us; 13645us; 13646us; 13691us; 13736us; 13737us; 13769us; 13801us; 13804us; 13840us; 13870us; 13900us; 13901us; 13907us; 13908us; 13909us; 13954us; 13955us; 14000us; 14001us; 14038us; 14078us; 14118us; 14119us; 14125us; 14161us; 14167us; 14173us; 14176us; 14178us; 14184us; 14190us; 14226us; 14262us; 14264us; 14265us; 14301us; 14337us; 14345us; 14346us; 14348us; 14356us; 14357us; 14361us; 14365us; 14366us; 14369us; 14370us; 14371us; 14372us; 14445us; 14449us; 14450us; 14451us; 14452us; 14453us; 14456us; 14527us; 14528us; 14529us; 14530us; 14531us; 14532us; 14533us; 14623us; 14627us; 14629us; 14631us; 14632us; 14636us; 14637us; 14712us; 14716us; 14717us; 14718us; 14722us; 14723us; 14724us; 14725us; 14726us; 14728us; 14801us; 14802us; 14873us; 14944us; 14945us; 14946us; 14947us; 14948us; 14949us; 14950us; 14951us; 14952us; 14953us; 14954us; 14955us; 15028us; 15032us; 15033us; 15034us; 15036us; 15037us; 15038us; 15111us; 15185us; 15189us; 15190us; 15191us; 15192us; 15193us; 15266us; 15270us; 15271us; 15272us; 15273us; 15274us; 15356us; 15454us; 15552us; 15553us; 15563us; 15564us; 15565us; 15566us; 15567us; 15568us; 15569us; 15570us; 15571us; 15572us; 15574us; 15576us; 15578us; 15582us; 15653us; 15654us; 15655us; 15656us; 15657us; 15662us; 15667us; 15668us; 15670us; 15671us; 15749us; 15755us; 15756us; 15757us; 15758us; 15759us; 15760us; 15761us; 15762us; 15763us; 15764us; 15765us; 15766us; 15839us; 15910us; 15911us; 15982us; 15983us; 16061us; 16062us; 16063us; 16064us; 16135us; 16206us; 16207us; 16208us; 16209us; 16212us; 16216us; 16217us; 16255us; 16257us; 16258us; 16259us; 16260us; 16262us; 16295us; 16299us; 16300us; 16333us; 16334us; 16371us; 16372us; 16403us; 16406us; 16435us; 16436us; 16439us; 16440us; 16441us; 16513us; 16514us; 16517us; 16518us; 16520us; 16592us; 16593us; 16596us; 16597us; 16601us; 16602us; 16605us; 16606us; 16612us; 16614us; 16615us; 16616us; 16619us; 16621us; 16622us; 16623us; 16627us; 16629us; 16631us; 16632us; 16633us; 16635us; 16636us; 16637us; 16646us; 16725us; 16726us; 16727us; 16728us; 16732us; 16734us; 16738us; 16739us; 16742us; 16743us; 16744us; 16745us; 16749us; 16750us; 16753us; 16755us; 16756us; 16760us; 16761us; 16765us; 16766us; 16770us; 16771us; 16775us; 16776us; 16808us; 16817us; 16821us; 16823us; 16824us; 16826us; 16827us; 16828us; 16868us; 16872us; 16873us; 16874us; 16875us; 16876us; 16877us; 16913us; 16915us; 16988us; 16989us; 16990us; 17027us; 17030us; 17104us; 17108us; 17109us; 17110us; 17112us; 17113us; 17114us; 17116us; 17117us; 17119us; 17120us; 17160us; 17161us; 17201us; 17203us; 17204us; 17206us; 17211us; 17213us; 17218us; 17252us; 17253us; 17255us; 17289us; 17290us; 17292us; 17326us; 17327us; 17329us; 17363us; 17364us; 17397us; 17405us; 17437us; 17444us; 17446us; 17448us; 17480us; 17487us; 17495us; 17527us; 17534us; 17536us; 17538us; 17570us; 17577us; 17579us; 17612us; 17613us; 17615us; 17616us; 17625us; 17657us; 17658us; 17690us; 17691us; 17723us; 17724us; 17733us; 17765us; 17766us; 17798us; 17799us; 17801us; 17802us; 17804us; 17806us; 17811us; 17815us; 17816us; 17826us; 17827us; 17829us; 17830us; 17831us; 17865us; 17869us; 17874us; 17875us; 17876us; 17909us; 17910us; 17912us; 17945us; 17946us; 17949us; 17950us; 17953us; 17954us; 17957us; 17958us; 17960us; 17961us; 17963us; 17996us; 17997us; 17999us; 18004us; 18037us; 18038us; 18039us; 18041us; 18045us; 18046us; 18080us; 18084us; 18089us; 18090us; 18092us; 18094us; 18095us; 18126us; 18128us; 18129us; 18130us; 18164us; 18170us; 18177us; 18178us; 18179us; 18181us; 18215us; 18249us; 18255us; 18256us; 18257us; 18258us; 18259us; 18260us; 18261us; 18262us; 18298us; 18299us; 18300us; 18304us; 18305us; 18306us; 18309us; 18313us; 18314us; 18322us; 18323us; 18324us; 18326us; 18327us; 18363us; 18365us; 18405us; 18406us; 18407us; 18408us; 18409us; 18418us; 18419us; 18420us; 18421us; 18422us; 18424us; 18457us; 18458us; 18459us; 18460us; 18469us; 18473us; 18474us; 18476us; 18477us; 18479us; 18480us; 18488us; 18494us; 18495us; 18497us; 18501us; 18502us; 18503us; 18510us; 18511us; 18512us; 18513us; 18514us; 18515us; 18523us; 18531us; 18539us; 18541us; 18542us; 18543us; 18545us; 18547us; 18548us; 18549us; 18550us; 18551us; 18560us; 18561us; 18562us; 18590us; 18594us; 18595us; 18599us; 18600us; 18601us; 18603us; 18609us; 18610us; 18612us; 18616us; 18617us; 18618us; 18619us; 18620us; 18621us; 18622us; 18623us; 18624us; 18625us; 18626us; 18627us; 18628us; 18629us; 18630us; 18631us; 18632us; 18633us; 18634us; 18635us; 18636us; 18637us; 18638us; 18639us; 18640us; 18642us; 18643us; 18645us; 18646us; 18647us; 18649us; 18650us; 18651us; 18652us; 18653us; 18655us; 18656us; 18661us; 18662us; 18663us; 18664us; 18665us; 18666us; 18667us; 18671us; 18672us; 18676us; 18677us; 18679us; 18681us; 18682us; 18683us; 18684us; 18685us; 18686us; 18687us; 18688us; 18689us; 18690us; 18691us; 18692us; 18693us; 18694us; 18695us; 18696us; 18697us; 18698us; 18699us; 18700us; 18701us; 18702us; 18703us; 18704us; 18705us; 18706us; 18707us; 18708us; 18709us; 18710us; 18711us; 18715us; 18719us; 18720us; 18721us; 18722us; 18726us; 18730us; 18731us; 18732us; 18733us; 18737us; 18738us; 18739us; 18740us; 18741us; 18745us; 18746us; 18747us; 18748us; 18752us; 18753us; 18754us; 18755us; 18756us; 18757us; 18758us; 18759us; 18760us; 18761us; 18762us; 18763us; 18764us; 18765us; |]
let _fsyacc_reductionSymbolCounts = [|1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 2us; 2us; 2us; 3us; 3us; 3us; 1us; 2us; 3us; 1us; 1us; 2us; 1us; 1us; 3us; 0us; 2us; 1us; 2us; 3us; 2us; 4us; 3us; 1us; 2us; 2us; 1us; 3us; 4us; 1us; 1us; 4us; 3us; 3us; 1us; 1us; 0us; 3us; 3us; 2us; 1us; 1us; 5us; 5us; 3us; 3us; 2us; 12us; 0us; 2us; 4us; 3us; 5us; 3us; 2us; 3us; 1us; 3us; 2us; 7us; 2us; 1us; 1us; 3us; 1us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 1us; 1us; 0us; 3us; 11us; 4us; 4us; 4us; 5us; 5us; 5us; 0us; 2us; 3us; 3us; 1us; 3us; 1us; 1us; 2us; 2us; 3us; 0us; 2us; 3us; 2us; 1us; 2us; 2us; 1us; 3us; 4us; 1us; 4us; 3us; 3us; 1us; 1us; 0us; 5us; 4us; 3us; 1us; 2us; 2us; 3us; 1us; 2us; 3us; 1us; 1us; 3us; 3us; 3us; 5us; 3us; 5us; 2us; 1us; 3us; 1us; 3us; 3us; 3us; 3us; 3us; 1us; 1us; 3us; 3us; 3us; 3us; 1us; 0us; 1us; 2us; 5us; 4us; 4us; 2us; 1us; 3us; 3us; 4us; 6us; 2us; 2us; 2us; 2us; 2us; 1us; 1us; 1us; 3us; 3us; 0us; 1us; 3us; 2us; 8us; 7us; 6us; 2us; 1us; 1us; 3us; 1us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 1us; 1us; 2us; 0us; 3us; 2us; 3us; 3us; 1us; 3us; 6us; 5us; 4us; 1us; 2us; 3us; 4us; 5us; 5us; 10us; 3us; 4us; 5us; 5us; 8us; 5us; 6us; 8us; 0us; 2us; 3us; 1us; 2us; 0us; 1us; 1us; 1us; 1us; 1us; 0us; 3us; 0us; 3us; 0us; 3us; 5us; 2us; 1us; 0us; 2us; 1us; 0us; 2us; 2us; 3us; 3us; 1us; 3us; 2us; 4us; 4us; 3us; 4us; 1us; 1us; 6us; 3us; 3us; 3us; 5us; 3us; 3us; 3us; 2us; 1us; 3us; 3us; 3us; 3us; 1us; 1us; 1us; 1us; 1us; 2us; 3us; 3us; 1us; 3us; 3us; 1us; 2us; 5us; 3us; 1us; 0us; 5us; 1us; 0us; 1us; 0us; 0us; 2us; 3us; 1us; 4us; 3us; 3us; 4us; 3us; 5us; 7us; 4us; 4us; 3us; 3us; 1us; 2us; 3us; 1us; 1us; 3us; 1us; 4us; 6us; 6us; 6us; 1us; 3us; 4us; 2us; 4us; 2us; 3us; 4us; 3us; 1us; 3us; 1us; 1us; 1us; 3us; 2us; 2us; 5us; 2us; 1us; 5us; 1us; 3us; 0us; 2us; 2us; 3us; 1us; 2us; 4us; 3us; 1us; 1us; 1us; 1us; 1us; 1us; 8us; 1us; 1us; 0us; 3us; 3us; 2us; 3us; 1us; 4us; 2us; 2us; 2us; 2us; 2us; 2us; 3us; 0us; 2us; 1us; 6us; 6us; 5us; 3us; 3us; 1us; 2us; 2us; 0us; 4us; 3us; 1us; 3us; 2us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 3us; 4us; 1us; 2us; 1us; 3us; 1us; 2us; 1us; 3us; 1us; 1us; 2us; 3us; 2us; 1us; 3us; 3us; 2us; 3us; 3us; 2us; 3us; 3us; 3us; 1us; 1us; 1us; 3us; 3us; 3us; 3us; 2us; 3us; 3us; 2us; 3us; 4us; 4us; 2us; 1us; 3us; 1us; 2us; 3us; 3us; 1us; 1us; 3us; 3us; 3us; 3us; 1us; 2us; 1us; 1us; 1us; 1us; 1us; 3us; 3us; 3us; 2us; 4us; 4us; 4us; 3us; 1us; 0us; 3us; 3us; 1us; 1us; 3us; 2us; 3us; 1us; 3us; 3us; 3us; 3us; 2us; 3us; 3us; 0us; 2us; 3us; 3us; 3us; 1us; 3us; 1us; 2us; 1us; 3us; 1us; 2us; 3us; 2us; 1us; 3us; 5us; 1us; 1us; 1us; 3us; 3us; 2us; 2us; 3us; 3us; 1us; 1us; 1us; 3us; 3us; 3us; 3us; 3us; 3us; 4us; 3us; 3us; 2us; 2us; 2us; 1us; 2us; 2us; 1us; 5us; 5us; 5us; 3us; 2us; 3us; 5us; 5us; 5us; 4us; 3us; 5us; 5us; 5us; 4us; 3us; 5us; 2us; 4us; 3us; 2us; 2us; 7us; 7us; 7us; 5us; 3us; 4us; 2us; 2us; 3us; 3us; 3us; 3us; 3us; 1us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 1us; 1us; 3us; 2us; 3us; 3us; 1us; 2us; 2us; 1us; 2us; 2us; 4us; 4us; 3us; 2us; 2us; 0us; 2us; 2us; 2us; 4us; 4us; 0us; 2us; 4us; 4us; 3us; 3us; 3us; 3us; 3us; 3us; 2us; 2us; 2us; 2us; 2us; 2us; 4us; 4us; 2us; 2us; 2us; 1us; 2us; 1us; 2us; 1us; 3us; 3us; 3us; 2us; 3us; 3us; 2us; 3us; 1us; 1us; 3us; 3us; 3us; 2us; 4us; 4us; 1us; 1us; 1us; 0us; 1us; 5us; 3us; 3us; 3us; 3us; 3us; 3us; 2us; 3us; 1us; 3us; 2us; 2us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 3us; 3us; 3us; 2us; 3us; 3us; 3us; 2us; 3us; 3us; 3us; 2us; 2us; 3us; 3us; 3us; 2us; 2us; 2us; 2us; 2us; 6us; 1us; 1us; 1us; 3us; 3us; 1us; 3us; 3us; 3us; 2us; 2us; 1us; 1us; 1us; 1us; 0us; 1us; 1us; 3us; 5us; 3us; 2us; 3us; 3us; 3us; 2us; 5us; 3us; 1us; 1us; 6us; 2us; 0us; 0us; 1us; 0us; 4us; 0us; 2us; 3us; 6us; 1us; 5us; 1us; 2us; 5us; 5us; 4us; 6us; 1us; 0us; 1us; 1us; 2us; 2us; 1us; 1us; 3us; 0us; 3us; 2us; 3us; 1us; 2us; 4us; 3us; 2us; 5us; 4us; 2us; 1us; 0us; 2us; 3us; 3us; 2us; 0us; 2us; 2us; 5us; 2us; 1us; 3us; 3us; 3us; 2us; 2us; 4us; 4us; 5us; 5us; 5us; 4us; 4us; 3us; 2us; 3us; 1us; 3us; 1us; 3us; 0us; 2us; 3us; 1us; 3us; 1us; 3us; 1us; 4us; 5us; 2us; 3us; 4us; 1us; 3us; 1us; 2us; 3us; 2us; 3us; 1us; 3us; 3us; 1us; 1us; 1us; 3us; 1us; 2us; 3us; 2us; 4us; 1us; 3us; 3us; 2us; 3us; 4us; 5us; 4us; 3us; 3us; 0us; 1us; 3us; 4us; 1us; 1us; 1us; 2us; 1us; 1us; 3us; 3us; 6us; 6us; 5us; 4us; 3us; 1us; 1us; 2us; 1us; 1us; 3us; 2us; 3us; 4us; 3us; 1us; 2us; 6us; 6us; 4us; 3us; 3us; 2us; 2us; 1us; 3us; 2us; 1us; 1us; 0us; 3us; 3us; 1us; 1us; 3us; 1us; 3us; 1us; 1us; 2us; 1us; 3us; 3us; 2us; 2us; 1us; 2us; 1us; 1us; 1us; 3us; 3us; 3us; 3us; 1us; 4us; 6us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 2us; 2us; 1us; 2us; 3us; 1us; 1us; 1us; 1us; 3us; 3us; 1us; 1us; 1us; 1us; 1us; 2us; 2us; 0us; 1us; 1us; 2us; 2us; 1us; 1us; 1us; 1us; 1us; 1us; 0us; 1us; 0us; 1us; 0us; 1us; 0us; 1us; 0us; 1us; 0us; 1us; 0us; 1us; 0us; 1us; 0us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 0us; 1us; 0us; 2us; 1us; 1us; 2us; 1us; 1us; 2us; 1us; 1us; 1us; 2us; 1us; 1us; 2us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; |]
let _fsyacc_productionToNonTerminalTable = [|0us; 1us; 2us; 3us; 4us; 5us; 5us; 5us; 6us; 6us; 7us; 7us; 7us; 7us; 7us; 7us; 7us; 8us; 8us; 9us; 10us; 11us; 11us; 12us; 12us; 13us; 14us; 14us; 15us; 16us; 16us; 16us; 17us; 18us; 19us; 19us; 20us; 20us; 21us; 22us; 22us; 23us; 23us; 23us; 23us; 24us; 24us; 24us; 25us; 25us; 25us; 26us; 26us; 26us; 26us; 26us; 26us; 26us; 27us; 28us; 28us; 28us; 29us; 29us; 29us; 30us; 31us; 31us; 32us; 32us; 33us; 33us; 34us; 34us; 34us; 35us; 35us; 35us; 35us; 36us; 36us; 36us; 36us; 37us; 37us; 37us; 38us; 38us; 39us; 40us; 40us; 40us; 40us; 40us; 40us; 40us; 41us; 41us; 41us; 41us; 42us; 42us; 43us; 43us; 43us; 44us; 45us; 45us; 46us; 46us; 46us; 47us; 47us; 48us; 48us; 49us; 50us; 50us; 51us; 51us; 51us; 51us; 52us; 52us; 53us; 53us; 53us; 53us; 53us; 54us; 54us; 54us; 54us; 54us; 55us; 55us; 56us; 56us; 56us; 56us; 56us; 56us; 56us; 56us; 57us; 57us; 58us; 58us; 58us; 58us; 58us; 58us; 58us; 59us; 59us; 59us; 60us; 61us; 61us; 62us; 62us; 63us; 63us; 63us; 63us; 64us; 64us; 65us; 65us; 65us; 66us; 66us; 66us; 66us; 67us; 67us; 67us; 67us; 68us; 69us; 69us; 70us; 70us; 70us; 70us; 71us; 71us; 71us; 72us; 72us; 72us; 73us; 73us; 73us; 73us; 74us; 74us; 75us; 75us; 75us; 76us; 76us; 76us; 77us; 78us; 78us; 78us; 79us; 79us; 80us; 81us; 81us; 82us; 82us; 83us; 83us; 83us; 83us; 83us; 83us; 83us; 83us; 83us; 83us; 83us; 84us; 85us; 86us; 86us; 87us; 87us; 87us; 88us; 88us; 89us; 89us; 89us; 90us; 90us; 91us; 91us; 92us; 92us; 93us; 93us; 93us; 94us; 94us; 95us; 96us; 96us; 97us; 97us; 98us; 98us; 98us; 99us; 99us; 100us; 100us; 100us; 100us; 101us; 101us; 102us; 102us; 102us; 102us; 102us; 103us; 103us; 103us; 104us; 104us; 105us; 105us; 105us; 106us; 107us; 107us; 107us; 108us; 108us; 109us; 109us; 109us; 110us; 110us; 111us; 111us; 112us; 113us; 114us; 114us; 114us; 115us; 116us; 116us; 117us; 117us; 118us; 118us; 119us; 119us; 120us; 120us; 120us; 120us; 120us; 120us; 120us; 120us; 120us; 120us; 121us; 121us; 122us; 122us; 122us; 123us; 124us; 124us; 125us; 125us; 125us; 125us; 126us; 126us; 126us; 127us; 127us; 127us; 128us; 128us; 129us; 129us; 130us; 130us; 131us; 131us; 132us; 132us; 133us; 134us; 135us; 136us; 137us; 138us; 138us; 139us; 139us; 140us; 141us; 141us; 142us; 143us; 144us; 145us; 145us; 145us; 145us; 146us; 146us; 147us; 148us; 148us; 148us; 149us; 149us; 150us; 150us; 151us; 151us; 151us; 151us; 151us; 152us; 152us; 153us; 154us; 154us; 155us; 155us; 156us; 156us; 156us; 157us; 157us; 157us; 158us; 159us; 159us; 160us; 161us; 161us; 162us; 162us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 163us; 164us; 164us; 164us; 164us; 165us; 165us; 166us; 166us; 167us; 167us; 168us; 169us; 169us; 169us; 169us; 170us; 170us; 171us; 171us; 171us; 171us; 171us; 172us; 172us; 172us; 172us; 172us; 172us; 173us; 173us; 174us; 174us; 175us; 175us; 176us; 177us; 177us; 177us; 177us; 177us; 177us; 178us; 178us; 179us; 179us; 179us; 179us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 180us; 181us; 181us; 182us; 182us; 182us; 182us; 182us; 182us; 182us; 182us; 183us; 183us; 184us; 184us; 185us; 185us; 186us; 187us; 187us; 187us; 188us; 188us; 188us; 189us; 189us; 190us; 190us; 191us; 191us; 192us; 193us; 193us; 193us; 193us; 193us; 193us; 194us; 194us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 195us; 196us; 196us; 197us; 197us; 197us; 198us; 198us; 198us; 198us; 199us; 200us; 200us; 200us; 200us; 200us; 201us; 201us; 202us; 203us; 204us; 204us; 204us; 205us; 205us; 205us; 205us; 205us; 205us; 206us; 206us; 206us; 206us; 207us; 207us; 207us; 207us; 207us; 207us; 207us; 207us; 207us; 207us; 207us; 207us; 208us; 208us; 209us; 209us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 210us; 211us; 211us; 211us; 211us; 211us; 211us; 211us; 211us; 211us; 211us; 211us; 211us; 212us; 212us; 213us; 213us; 213us; 213us; 213us; 214us; 214us; 214us; 214us; 214us; 214us; 214us; 214us; 214us; 214us; 215us; 215us; 215us; 215us; 216us; 216us; 216us; 216us; 217us; 217us; 217us; 217us; 218us; 218us; 218us; 218us; 218us; 218us; 218us; 218us; 218us; 219us; 219us; 219us; 220us; 220us; 221us; 221us; 222us; 222us; 222us; 222us; 222us; 223us; 223us; 223us; 224us; 224us; 225us; 225us; 226us; 226us; 226us; 227us; 228us; 228us; 228us; 228us; 229us; 229us; 230us; 230us; 231us; 232us; 232us; 233us; 233us; 234us; 234us; 235us; 235us; 235us; 236us; 236us; 237us; 237us; 237us; 237us; 237us; 237us; 237us; 238us; 238us; 239us; 239us; 239us; 239us; 240us; 240us; 241us; 241us; 242us; 242us; 242us; 242us; 242us; 243us; 243us; 243us; 244us; 244us; 244us; 245us; 245us; 246us; 246us; 246us; 247us; 248us; 248us; 248us; 249us; 250us; 250us; 251us; 251us; 251us; 251us; 251us; 252us; 252us; 252us; 252us; 252us; 252us; 252us; 252us; 253us; 253us; 254us; 254us; 255us; 255us; 256us; 256us; 257us; 257us; 258us; 258us; 259us; 259us; 260us; 260us; 260us; 260us; 260us; 260us; 261us; 261us; 262us; 263us; 263us; 263us; 263us; 264us; 264us; 264us; 265us; 265us; 266us; 266us; 267us; 267us; 267us; 267us; 267us; 267us; 267us; 268us; 268us; 268us; 268us; 269us; 270us; 270us; 270us; 271us; 271us; 272us; 272us; 273us; 273us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 274us; 275us; 275us; 276us; 276us; 276us; 276us; 276us; 276us; 276us; 277us; 277us; 277us; 278us; 278us; 279us; 280us; 280us; 281us; 281us; 281us; 282us; 282us; 282us; 283us; 283us; 284us; 284us; 284us; 284us; 285us; 285us; 286us; 287us; 288us; 288us; 288us; 288us; 289us; 289us; 289us; 289us; 289us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 290us; 291us; 292us; 292us; 293us; 293us; 294us; 294us; 294us; 294us; 295us; 296us; 296us; 296us; 297us; 297us; 298us; 298us; 299us; 299us; 299us; 299us; 300us; 300us; 300us; 301us; 301us; 301us; 301us; 302us; 302us; 303us; 303us; 304us; 304us; 305us; 305us; 306us; 306us; 307us; 307us; 308us; 308us; 309us; 309us; 310us; 310us; 311us; 311us; 312us; 312us; 313us; 313us; 314us; 314us; 315us; 315us; 316us; 316us; 316us; 317us; 317us; 318us; 318us; 318us; 319us; 319us; 319us; 320us; 320us; 320us; 321us; 322us; 322us; 322us; 323us; 323us; 323us; 324us; 324us; 324us; 324us; 324us; 325us; 325us; 325us; 325us; 325us; 325us; |]
let _fsyacc_immediateActions = [|65535us; 49152us; 65535us; 49152us; 65535us; 49152us; 65535us; 49152us; 65535us; 49152us; 16389us; 16390us; 16391us; 16392us; 16393us; 16394us; 65535us; 16395us; 65535us; 16396us; 65535us; 16397us; 65535us; 16398us; 65535us; 16399us; 65535us; 16400us; 65535us; 16402us; 65535us; 65535us; 65535us; 16404us; 65535us; 16406us; 16407us; 16408us; 65535us; 65535us; 65535us; 16411us; 16412us; 65535us; 16413us; 65535us; 16414us; 65535us; 16415us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16419us; 65535us; 16420us; 65535us; 65535us; 16422us; 65535us; 65535us; 65535us; 16423us; 16424us; 16425us; 65535us; 65535us; 65535us; 16426us; 16427us; 65535us; 16428us; 16429us; 65535us; 65535us; 65535us; 16432us; 65535us; 65535us; 16433us; 16435us; 16436us; 65535us; 65535us; 65535us; 65535us; 16437us; 16438us; 16439us; 16440us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16442us; 65535us; 65535us; 65535us; 65535us; 16445us; 65535us; 65535us; 16446us; 65535us; 65535us; 65535us; 16447us; 65535us; 65535us; 16448us; 65535us; 16449us; 65535us; 65535us; 16450us; 65535us; 65535us; 16452us; 16453us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16454us; 65535us; 16455us; 16456us; 16457us; 65535us; 65535us; 16458us; 16459us; 65535us; 65535us; 16460us; 16461us; 65535us; 16462us; 65535us; 65535us; 16463us; 16464us; 65535us; 65535us; 16465us; 16466us; 65535us; 65535us; 16467us; 16468us; 16469us; 16470us; 65535us; 65535us; 16472us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16473us; 65535us; 65535us; 65535us; 65535us; 65535us; 16476us; 65535us; 65535us; 16477us; 65535us; 16478us; 65535us; 65535us; 16479us; 65535us; 16481us; 65535us; 65535us; 16482us; 16483us; 65535us; 65535us; 16485us; 16486us; 65535us; 16488us; 65535us; 16489us; 65535us; 65535us; 16490us; 65535us; 16492us; 65535us; 16493us; 65535us; 16494us; 65535us; 16496us; 65535us; 16497us; 65535us; 65535us; 16499us; 65535us; 65535us; 65535us; 16500us; 16501us; 65535us; 65535us; 65535us; 16502us; 16503us; 65535us; 16504us; 16505us; 16506us; 65535us; 65535us; 65535us; 65535us; 16508us; 16511us; 16512us; 65535us; 16513us; 65535us; 16514us; 65535us; 65535us; 65535us; 65535us; 16517us; 16518us; 16519us; 65535us; 65535us; 16520us; 65535us; 16521us; 65535us; 16522us; 65535us; 65535us; 16523us; 16524us; 65535us; 65535us; 16525us; 65535us; 16526us; 16527us; 65535us; 16528us; 65535us; 65535us; 65535us; 16530us; 16531us; 65535us; 16532us; 16533us; 16534us; 16535us; 65535us; 65535us; 65535us; 16537us; 16538us; 16539us; 65535us; 65535us; 16540us; 16541us; 65535us; 16544us; 65535us; 65535us; 65535us; 65535us; 16545us; 65535us; 65535us; 16546us; 16547us; 16548us; 16549us; 65535us; 16550us; 65535us; 65535us; 16551us; 65535us; 65535us; 65535us; 16552us; 65535us; 65535us; 65535us; 65535us; 16553us; 65535us; 16554us; 65535us; 16555us; 65535us; 16556us; 65535us; 16557us; 65535us; 16558us; 16559us; 16560us; 16561us; 65535us; 65535us; 16562us; 65535us; 65535us; 16563us; 65535us; 65535us; 16566us; 16567us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16568us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16569us; 16570us; 65535us; 16571us; 16572us; 16573us; 65535us; 65535us; 16574us; 16575us; 65535us; 65535us; 16576us; 16577us; 65535us; 16578us; 65535us; 65535us; 16579us; 16580us; 65535us; 65535us; 16581us; 16582us; 16583us; 16584us; 65535us; 16585us; 65535us; 65535us; 16587us; 65535us; 16588us; 65535us; 65535us; 16589us; 16590us; 65535us; 65535us; 16592us; 65535us; 65535us; 65535us; 65535us; 65535us; 16593us; 65535us; 65535us; 65535us; 65535us; 16594us; 16595us; 65535us; 16597us; 65535us; 65535us; 65535us; 65535us; 16598us; 16599us; 65535us; 65535us; 16600us; 65535us; 65535us; 16601us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16602us; 16603us; 65535us; 16604us; 65535us; 16605us; 65535us; 16606us; 65535us; 65535us; 65535us; 65535us; 65535us; 16607us; 65535us; 16608us; 65535us; 65535us; 65535us; 65535us; 65535us; 16609us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16610us; 65535us; 16612us; 65535us; 65535us; 16613us; 16614us; 65535us; 16615us; 16617us; 16618us; 16619us; 16620us; 16621us; 65535us; 65535us; 16623us; 65535us; 65535us; 16625us; 65535us; 65535us; 16627us; 65535us; 65535us; 16628us; 16629us; 16630us; 65535us; 16632us; 16633us; 65535us; 16635us; 16636us; 65535us; 65535us; 16637us; 16638us; 16639us; 65535us; 65535us; 16640us; 65535us; 65535us; 65535us; 65535us; 16642us; 65535us; 16643us; 16644us; 65535us; 65535us; 16645us; 16646us; 16647us; 65535us; 65535us; 65535us; 65535us; 65535us; 16648us; 16649us; 16650us; 16651us; 65535us; 65535us; 16652us; 65535us; 65535us; 16653us; 16654us; 65535us; 16655us; 65535us; 16656us; 16657us; 65535us; 65535us; 16658us; 16659us; 65535us; 16660us; 65535us; 65535us; 16661us; 16662us; 16663us; 16664us; 16665us; 16666us; 65535us; 65535us; 65535us; 65535us; 16669us; 16670us; 65535us; 65535us; 16671us; 65535us; 65535us; 65535us; 65535us; 16672us; 16673us; 65535us; 16674us; 65535us; 65535us; 65535us; 16675us; 16676us; 65535us; 65535us; 65535us; 65535us; 16679us; 16680us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16686us; 16687us; 65535us; 65535us; 65535us; 16688us; 65535us; 65535us; 16689us; 65535us; 16690us; 65535us; 16691us; 16692us; 65535us; 65535us; 16693us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16694us; 65535us; 16695us; 16696us; 65535us; 65535us; 65535us; 65535us; 16700us; 65535us; 65535us; 16701us; 65535us; 16703us; 65535us; 65535us; 16704us; 65535us; 65535us; 65535us; 16706us; 65535us; 65535us; 16707us; 65535us; 65535us; 16708us; 65535us; 65535us; 16709us; 16710us; 65535us; 65535us; 16711us; 65535us; 65535us; 16712us; 65535us; 16713us; 65535us; 65535us; 65535us; 16715us; 65535us; 16716us; 65535us; 65535us; 16718us; 65535us; 65535us; 65535us; 65535us; 16722us; 16723us; 65535us; 65535us; 16724us; 16725us; 65535us; 16726us; 65535us; 65535us; 65535us; 65535us; 16727us; 65535us; 16728us; 16729us; 65535us; 65535us; 65535us; 65535us; 16730us; 65535us; 65535us; 16732us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16736us; 16737us; 65535us; 16738us; 65535us; 65535us; 65535us; 16739us; 65535us; 65535us; 16740us; 16741us; 16742us; 16743us; 16744us; 16745us; 16746us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16747us; 65535us; 65535us; 65535us; 16751us; 65535us; 16752us; 65535us; 65535us; 16754us; 65535us; 65535us; 65535us; 65535us; 16756us; 16757us; 16758us; 65535us; 65535us; 16759us; 65535us; 65535us; 16762us; 65535us; 65535us; 16763us; 65535us; 16765us; 16766us; 65535us; 65535us; 65535us; 65535us; 65535us; 16767us; 16768us; 16769us; 65535us; 65535us; 16770us; 16771us; 16772us; 65535us; 65535us; 16774us; 65535us; 65535us; 65535us; 16776us; 65535us; 16777us; 16778us; 65535us; 65535us; 16779us; 16780us; 16781us; 16782us; 16783us; 16784us; 16785us; 16786us; 16787us; 16788us; 16789us; 16790us; 16791us; 16792us; 16793us; 65535us; 16794us; 16795us; 16796us; 16797us; 65535us; 65535us; 16798us; 65535us; 65535us; 65535us; 16799us; 16802us; 65535us; 65535us; 16803us; 16804us; 65535us; 16805us; 65535us; 65535us; 16807us; 65535us; 16809us; 65535us; 16810us; 65535us; 65535us; 65535us; 16811us; 65535us; 65535us; 16814us; 65535us; 65535us; 16815us; 16816us; 16817us; 65535us; 16818us; 16819us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16820us; 65535us; 65535us; 65535us; 65535us; 16825us; 65535us; 65535us; 65535us; 65535us; 65535us; 16830us; 65535us; 16831us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16834us; 65535us; 16835us; 65535us; 16836us; 65535us; 16837us; 16838us; 65535us; 65535us; 16839us; 16840us; 65535us; 16841us; 65535us; 16842us; 65535us; 16843us; 16845us; 65535us; 16846us; 65535us; 65535us; 16847us; 65535us; 65535us; 16848us; 65535us; 65535us; 16849us; 16850us; 65535us; 65535us; 16851us; 16852us; 16853us; 16854us; 16855us; 16856us; 65535us; 65535us; 16857us; 16858us; 65535us; 65535us; 16860us; 65535us; 65535us; 65535us; 16861us; 16862us; 65535us; 16863us; 16864us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16867us; 65535us; 65535us; 65535us; 65535us; 16871us; 65535us; 65535us; 16874us; 65535us; 65535us; 65535us; 65535us; 65535us; 16879us; 65535us; 16880us; 65535us; 65535us; 16883us; 65535us; 16884us; 65535us; 65535us; 16885us; 16886us; 16887us; 65535us; 65535us; 16888us; 65535us; 65535us; 16890us; 65535us; 65535us; 16892us; 65535us; 16894us; 65535us; 65535us; 65535us; 65535us; 16895us; 65535us; 16898us; 65535us; 65535us; 65535us; 16899us; 65535us; 16901us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16902us; 65535us; 65535us; 16903us; 16904us; 65535us; 16905us; 16906us; 65535us; 16907us; 16908us; 16909us; 16910us; 16911us; 65535us; 65535us; 16912us; 16913us; 65535us; 65535us; 16914us; 16915us; 65535us; 65535us; 16916us; 16917us; 65535us; 16918us; 65535us; 65535us; 16919us; 16920us; 16921us; 65535us; 65535us; 65535us; 65535us; 65535us; 16925us; 65535us; 16926us; 65535us; 65535us; 65535us; 65535us; 16928us; 16929us; 65535us; 16930us; 16931us; 16932us; 16933us; 65535us; 65535us; 65535us; 65535us; 16934us; 16935us; 16936us; 16937us; 16938us; 65535us; 65535us; 65535us; 16939us; 16940us; 16941us; 16942us; 16943us; 65535us; 65535us; 16944us; 16945us; 16946us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16950us; 65535us; 65535us; 65535us; 65535us; 65535us; 16951us; 16952us; 65535us; 65535us; 65535us; 65535us; 16953us; 65535us; 65535us; 16954us; 65535us; 16955us; 65535us; 65535us; 65535us; 16957us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16958us; 65535us; 16959us; 65535us; 16960us; 65535us; 65535us; 65535us; 16962us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16975us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16985us; 16986us; 16987us; 16988us; 16989us; 16990us; 16991us; 16992us; 16993us; 16994us; 16995us; 16996us; 16997us; 16998us; 16999us; 17000us; 17001us; 17002us; 17003us; 17004us; 17006us; 65535us; 65535us; 17007us; 65535us; 17008us; 65535us; 65535us; 17009us; 17010us; 17011us; 65535us; 17012us; 17013us; 17014us; 17015us; 65535us; 65535us; 65535us; 17017us; 17018us; 17019us; 17020us; 65535us; 65535us; 17023us; 65535us; 17024us; 65535us; 65535us; 65535us; 65535us; 17026us; 17027us; 65535us; 65535us; 65535us; 65535us; 17030us; 17031us; 65535us; 17032us; 17033us; 65535us; 17035us; 65535us; 17036us; 65535us; 65535us; 17038us; 65535us; 65535us; 17039us; 65535us; 65535us; 17040us; 65535us; 65535us; 17041us; 65535us; 65535us; 17042us; 65535us; 65535us; 17043us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 17044us; 65535us; 17045us; 17046us; 65535us; 17047us; 65535us; 17048us; 65535us; 65535us; 65535us; 17050us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 17056us; 65535us; 65535us; 65535us; 17058us; 65535us; 65535us; 17059us; 65535us; 65535us; 17060us; 65535us; 17061us; 17062us; 17063us; 65535us; 65535us; 17064us; 17065us; 17066us; 17067us; 65535us; 65535us; 17068us; 17069us; 17070us; 17071us; 17072us; 17074us; 65535us; 65535us; 65535us; 65535us; 17075us; 65535us; 17076us; 65535us; 65535us; 17077us; 17078us; 65535us; 17079us; 17080us; 17081us; 17082us; 65535us; 65535us; 17083us; 65535us; 65535us; 17088us; 17090us; 17091us; 17092us; 17093us; 17094us; 17095us; 17096us; 17097us; 17098us; 17099us; 65535us; 65535us; 17100us; 17101us; 65535us; 17102us; 17103us; 65535us; 65535us; 65535us; 17104us; 17105us; 17106us; 17107us; 65535us; 65535us; 17108us; 17109us; 17110us; 17111us; 65535us; 65535us; 65535us; 17112us; 65535us; 17113us; 17114us; 17115us; 65535us; 17116us; 17117us; 17118us; 17119us; 17120us; 65535us; 65535us; 65535us; 65535us; 65535us; 17121us; 17122us; 17123us; 17124us; 65535us; 65535us; 17125us; 65535us; 17126us; 65535us; 65535us; 17128us; 17129us; 17130us; 17131us; 17132us; 17133us; 17134us; 17135us; 17136us; 17138us; 17139us; 65535us; 65535us; 17142us; 65535us; 17143us; 65535us; 17145us; 17146us; 17147us; 65535us; 65535us; 17149us; 17150us; 17151us; 65535us; 65535us; 65535us; 65535us; 65535us; 17152us; 17153us; 17156us; 65535us; 65535us; 65535us; 17158us; 65535us; 17160us; 65535us; 17161us; 65535us; 65535us; 65535us; 65535us; 65535us; 17162us; 17163us; 65535us; 65535us; 65535us; 17164us; 65535us; 65535us; 65535us; 65535us; 17167us; 65535us; 65535us; 65535us; 17168us; 65535us; 65535us; 17169us; 65535us; 65535us; 65535us; 17170us; 17171us; 65535us; 65535us; 65535us; 17175us; 17176us; 65535us; 17178us; 17179us; 65535us; 65535us; 17181us; 17183us; 17185us; 65535us; 65535us; 65535us; 17186us; 65535us; 17187us; 17189us; 17192us; 65535us; 17194us; 65535us; 65535us; 17195us; 65535us; 17196us; 65535us; 17197us; 65535us; 17199us; 65535us; 17200us; 65535us; 65535us; 65535us; 65535us; 17201us; 65535us; 17202us; 17203us; 65535us; 65535us; 17204us; 17205us; 17206us; 17207us; 17208us; 65535us; 65535us; 65535us; 17209us; 17210us; 65535us; 65535us; 65535us; 65535us; 17211us; 17212us; 65535us; 17213us; 17214us; 65535us; 17215us; 65535us; 17216us; 65535us; 17217us; 65535us; 65535us; 17218us; 65535us; 65535us; 65535us; 65535us; 65535us; 17224us; 65535us; 65535us; 17225us; 65535us; 65535us; 17227us; 65535us; 65535us; 17229us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 17237us; 65535us; 17239us; 65535us; 65535us; 17240us; 65535us; 17241us; 65535us; 17242us; 65535us; 65535us; 17244us; 65535us; 17245us; 65535us; 17248us; 65535us; 65535us; 65535us; 65535us; 17249us; 65535us; 17251us; 65535us; 17252us; 17253us; 65535us; 65535us; 65535us; 17254us; 17255us; 65535us; 17256us; 65535us; 65535us; 17257us; 65535us; 17258us; 65535us; 17259us; 65535us; 17260us; 65535us; 17261us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 17263us; 17264us; 65535us; 65535us; 17267us; 65535us; 65535us; 65535us; 17268us; 65535us; 65535us; 17271us; 65535us; 65535us; 17273us; 17274us; 65535us; 65535us; 65535us; 17275us; 17276us; 65535us; 65535us; 65535us; 65535us; 17277us; 17278us; 17279us; 17280us; 17281us; 17282us; 17283us; 65535us; 17285us; 17286us; 65535us; 17287us; 17288us; 65535us; 65535us; 17290us; 65535us; 17291us; 17292us; 65535us; 17293us; 65535us; 65535us; 65535us; 65535us; 17294us; 17295us; 17296us; 65535us; 17297us; 17298us; 17299us; 17300us; 65535us; 65535us; 17302us; 17304us; 17305us; 65535us; 65535us; 17307us; 65535us; 17308us; 65535us; 17310us; 65535us; 65535us; 17311us; 65535us; 65535us; 17313us; 17314us; 65535us; 17316us; 17317us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 17321us; 17322us; 65535us; 65535us; 17323us; 17324us; 17325us; 17326us; 65535us; 17327us; 17328us; 65535us; 65535us; 17329us; 65535us; 17330us; 17331us; 65535us; 65535us; 17332us; 65535us; 65535us; 17333us; 17334us; 17335us; 17336us; 17337us; 17338us; 17339us; 17340us; 17341us; 17342us; 17343us; 17344us; 17345us; 17346us; 17347us; 17348us; 17349us; 17350us; 17351us; 17352us; 17353us; 17354us; 17355us; 17356us; 65535us; 17358us; 65535us; 17359us; 17360us; 65535us; 17361us; 17362us; 17363us; 17364us; 65535us; 17366us; 65535us; 17367us; 17368us; 17369us; 17370us; 17371us; 17372us; 65535us; 17374us; 65535us; 17375us; 65535us; 65535us; 17379us; 17380us; 17381us; 17382us; 17383us; 17384us; 17385us; 17386us; 17388us; 17390us; 17392us; 17394us; 17396us; 17400us; 17402us; 17404us; 17405us; 17406us; 17407us; 17408us; 17409us; 17410us; 17411us; 17412us; 17413us; 17414us; 17415us; 17416us; 17417us; 17419us; 65535us; 65535us; 17421us; 17422us; 17423us; 65535us; 65535us; 17424us; 17425us; 17426us; 65535us; 17427us; 17428us; 17429us; 17430us; 65535us; 17431us; 17432us; 17433us; 65535us; 17434us; 17435us; 17436us; 17437us; 17438us; 17439us; 17440us; 17441us; 17442us; 17443us; 17444us; 17445us; 17446us; 17447us; |]
let _fsyacc_reductions ()  =    [| 
//# 2762 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.ParsedSigFile)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Internal.Utilities.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startsignatureFile));
//# 2771 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.ParsedImplFile)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Internal.Utilities.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startimplementationFile));
//# 2780 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.ParsedFsiInteraction)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Internal.Utilities.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startinteraction));
//# 2789 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Internal.Utilities.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_starttypedSeqExprEOF));
//# 2798 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Internal.Utilities.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_starttypEOF));
//# 2807 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveItemsTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 493 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            IDefns (_1,lhs parseState) 
                   )
//# 493 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedFsiInteraction));
//# 2818 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 496 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            warning(Error(FSComp.SR.parsUnexpectedSemicolon(),rhs parseState 1))
                            IDefns ([],lhs parseState) 
                   )
//# 496 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedFsiInteraction));
//# 2829 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 500 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            IDefns ([],lhs parseState) 
                   )
//# 500 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedFsiInteraction));
//# 2839 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 504 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              
                   )
//# 504 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveTerminator));
//# 2849 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 505 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   checkEndOfFileError _1 
                   )
//# 505 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveTerminator));
//# 2860 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 519 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 519 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveItemsTerminator));
//# 2871 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveDefns)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 522 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 522 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveItemsTerminator));
//# 2883 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 525 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 525 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveItemsTerminator));
//# 2895 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveHash)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 528 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 528 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveItemsTerminator));
//# 2907 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveDefns)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveSeparators)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveItemsTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 531 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 @ _3 
                   )
//# 531 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveItemsTerminator));
//# 2920 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveSeparators)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveItemsTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 534 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 @ _3 
                   )
//# 534 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveItemsTerminator));
//# 2933 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveHash)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveSeparators)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveItemsTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 537 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 @ _3 
                   )
//# 537 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveItemsTerminator));
//# 2946 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 543 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 543 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveDefns));
//# 2957 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefn)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveDefns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 546 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 @ _2 
                   )
//# 546 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveDefns));
//# 2969 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 552 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             match _2 with
                             | Some vis -> errorR(Error(FSComp.SR.parsUnexpectedVisibilityDeclaration(vis.ToString()),rhs parseState 3))
                             | _ -> ()
                             let attrDecls = if not (isNil _1) then [ SynModuleDecl.Attributes (_1, rangeOfNonNilAttrs _1) ] else [] in 
                             attrDecls @ [ mkSynDoDecl(_3)] 
                   )
//# 552 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveExpr));
//# 2986 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hashDirective)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 562 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [SynModuleDecl.HashDirective(_1,rhs parseState 1)] 
                   )
//# 562 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveHash));
//# 2997 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveSeparator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 567 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    
                   )
//# 567 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveSeparators));
//# 3008 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveSeparator)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'interactiveSeparators)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 568 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                      
                   )
//# 568 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveSeparators));
//# 3020 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 573 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 573 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveSeparator));
//# 3030 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 574 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 574 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interactiveSeparator));
//# 3040 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'hashDirectiveArgs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 584 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            ParsedHashDirective (_2,_3,lhs parseState) 
                   )
//# 584 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hashDirective));
//# 3052 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 590 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 590 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hashDirectiveArgs));
//# 3062 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hashDirectiveArgs)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'hashDirectiveArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 593 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 @ [_2] 
                   )
//# 593 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hashDirectiveArgs));
//# 3074 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'stringOrKeywordString)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 599 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 599 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hashDirectiveArg));
//# 3085 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceSpecs)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 608 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            checkEndOfFileError _2; _1 
                   )
//# 608 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedSigFile));
//# 3097 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceSpecs)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 611 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 611 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedSigFile));
//# 3109 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 617 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let emptySigFileFrag = ParsedSigFileFragment.AnonModule([],rhs parseState 1) in 
                            ParsedSigFile ([],[emptySigFileFrag]) 
                   )
//# 617 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedSigFile));
//# 3121 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleKeyword)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_rec)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 625 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3, _4.Lid, grabXmlDoc(parseState,1), _2 
                   )
//# 625 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleIntro));
//# 3135 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_rec)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 631 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2, _3.Lid, grabXmlDoc(parseState,1)  
                   )
//# 631 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namespaceIntro));
//# 3147 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileModuleSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 637 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             ParsedSigFile ([],[ (_1 (false,[],PreXmlDoc.Empty)) ]) 
                   )
//# 637 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceSpecs));
//# 3158 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileModuleSpec)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceSpecList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 640 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // If there are namespaces, the first fileModuleImpl may only contain # directives 
                             let decls = 
                                 match (_1 (false,[],PreXmlDoc.Empty)) with 
                                 | ParsedSigFileFragment.AnonModule(decls,m) -> decls  
                                 | ParsedSigFileFragment.NamespaceFragment(_,_,_, decls, _,_,_) -> decls 
                                 | ParsedSigFileFragment.NamedModule(SynModuleOrNamespaceSig(_,_,_,_,_,_,_,m)) ->
                                     raiseParseErrorAt m (FSComp.SR.parsOnlyHashDirectivesAllowed())
                             let decls = 
                                 decls |> List.collect (function 
                                     | (SynModuleSigDecl.HashDirective (hd,_)) -> [hd]
                                     | d ->  
                                          reportParseErrorAt d.Range (FSComp.SR.parsOnlyHashDirectivesAllowed())
                                          [])
                             ParsedSigFile (decls, _2) 
                   )
//# 640 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceSpecs));
//# 3183 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceSpec)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceSpecList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 658 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _2 
                   )
//# 658 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceSpecList));
//# 3195 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 661 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 661 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceSpecList));
//# 3206 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'namespaceIntro)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'deprecated_opt_equals)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileModuleSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 665 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let isRec,path,xml = _1 in (_3 (isRec,path,xml)) 
                   )
//# 665 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceSpec));
//# 3219 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleIntro)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfnsPossiblyEmptyBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 671 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                           let m2 = rhs parseState 3
                           let m = (rhs2 parseState 3 4)
                           let isRec,path2,xml,vis = _3 
                           (fun (isRec2,path,_) -> 
                             if not (isNil path) then errorR(Error(FSComp.SR.parsNamespaceOrModuleNotBoth(),m2))
                             let lid = path@path2 
                             ParsedSigFileFragment.NamedModule(SynModuleOrNamespaceSig(lid, (isRec || isRec2), NamedModule, _4, xml,_1,vis,m)))  
                   )
//# 671 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileModuleSpec));
//# 3240 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfnsPossiblyEmptyBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 681 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           let m = (rhs parseState 1) 
                           (fun (isRec, path, xml) -> 
                             match path with 
                             | [] -> ParsedSigFileFragment.AnonModule(_1, m)  
                             | _ -> ParsedSigFileFragment.NamespaceFragment(path, isRec, DeclaredNamespace, _1, xml,[],m))  
                   )
//# 681 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileModuleSpec));
//# 3255 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfnsPossiblyEmpty)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 690 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 690 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfnsPossiblyEmptyBlock));
//# 3266 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfnsPossiblyEmpty)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 693 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 693 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfnsPossiblyEmptyBlock));
//# 3279 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfnsPossiblyEmpty)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 696 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              // The lex filter ensures we can only get a mismatch in OBLOCKBEGIN/OBLOCKEND tokens if there was some other kind of error, hence we don't need to report this error
                              // reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnClosedBlockInHashLight())   
                              _2 
                            
                   )
//# 696 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfnsPossiblyEmptyBlock));
//# 3294 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 702 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              [] 
                   )
//# 702 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfnsPossiblyEmptyBlock));
//# 3305 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 707 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 707 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfnsPossiblyEmpty));
//# 3316 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 710 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 710 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfnsPossiblyEmpty));
//# 3326 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 713 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 713 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfnsPossiblyEmpty));
//# 3336 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfn)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topSeparators)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 718 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _3 
                   )
//# 718 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfns));
//# 3349 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparators)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 721 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (* silent recovery *) _3 
                   )
//# 721 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfns));
//# 3361 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfn)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topSeparators)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 724 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 724 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfns));
//# 3373 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hashDirective)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 729 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynModuleSigDecl.HashDirective (_1,rhs2 parseState 1 1)  
                   )
//# 729 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfn));
//# 3384 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'valSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 732 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 732 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfn));
//# 3395 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleIntro)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'colonOrEquals)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'namedModuleAbbrevBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 735 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let isRec, path, xml, vis = _3 
                             if isRec then raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsInvalidUseOfRec())
                             if not (isSingleton path) then raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsModuleAbbreviationMustBeSimpleName())
                             if not (isNil _1) then raiseParseErrorAt (rhs parseState 1) (FSComp.SR.parsIgnoreAttributesOnModuleAbbreviation())
                             match vis with
                             | Some vis -> raiseParseErrorAt (rhs parseState 1) (FSComp.SR.parsIgnoreVisibilityOnModuleAbbreviationAlwaysPrivate(vis.ToString()))
                             | _ -> SynModuleSigDecl.ModuleAbbrev(List.head path,_5,rhs2 parseState 3 5) 
                   )
//# 735 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfn));
//# 3417 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleIntro)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'colonOrEquals)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpecBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 745 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let isRec, path, xml, vis = _3 
                             if not (isSingleton path) then raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsModuleDefnMustBeSimpleName())
                             if isRec then raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsInvalidUseOfRec())
                             let info = ComponentInfo(_1,[],[],path,xml,false,vis,rhs parseState 3)
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             SynModuleSigDecl.NestedModule(info, isRec, _5, rhs2 parseState 3 5) 
                   )
//# 745 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfn));
//# 3437 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypeDefnSig list)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 753 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let (TypeDefnSig(ComponentInfo(cas,a,cs,b,c,d,d2,d3),e,f,g)),rest = 
                                match _3 with
                                | [] -> raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEmptyModuleDefn()) 
                                | h :: t -> h,t 
                             let tc = (TypeDefnSig(ComponentInfo(_1@cas,a,cs,b,c,d,d2,d3),e,f,g))in 
                             SynModuleSigDecl.Types (tc :: rest,rhs parseState 3) 
                   )
//# 753 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfn));
//# 3456 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'exconSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 762 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let (SynExceptionSig(SynExceptionDefnRepr(cas,a,b,c,d,d2),e,f)) = _3 
                             let ec = (SynExceptionSig(SynExceptionDefnRepr(_1@cas,a,b,c,d,d2),e,f)) 
                             SynModuleSigDecl.Exception(ec, rhs parseState 3) 
                   )
//# 762 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfn));
//# 3472 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 768 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynModuleSigDecl.Open (_2.Lid, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 768 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpfn));
//# 3483 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_mutable)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _8 = (let data = parseState.GetInput(8) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            let _9 = (let data = parseState.GetInput(9) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_explicitValTyparDecls)) in
            let _11 = (let data = parseState.GetInput(11) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTypeWithTypeConstraints)) in
            let _12 = (let data = parseState.GetInput(12) in (Microsoft.FSharp.Core.Operators.unbox data : 'optLiteralValueSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 772 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let attr1,attr2,isInline,isMutable,vis2,id,doc,explicitValTyparDecls,(ty,arity),konst = (_1),(_4),(_5),(_6),(_7),(_8),grabXmlDoc(parseState,3),(_9),(_11),(_12) 
                             if not (isNil attr2) then errorR(Deprecated(FSComp.SR.parsAttributesMustComeBeforeVal(),rhs parseState 4))
                             let m = rhs2 parseState 3 11 
                             let valSpfn = ValSpfn((attr1@attr2),id,explicitValTyparDecls,ty,arity,isInline,isMutable,doc, vis2,konst,m) 
                             SynModuleSigDecl.Val(valSpfn,m)
                           
                   )
//# 772 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'valSpfn));
//# 3509 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 783 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             None 
                   )
//# 783 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optLiteralValueSpfn));
//# 3519 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 786 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some(_2) 
                   )
//# 786 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optLiteralValueSpfn));
//# 3530 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 789 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some(_3) 
                   )
//# 789 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optLiteralValueSpfn));
//# 3542 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfns)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 797 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 797 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpecBlock));
//# 3554 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'sigOrBegin)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfnsPossiblyEmpty)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 801 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 
                   )
//# 801 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpecBlock));
//# 3567 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'sigOrBegin)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleSpfnsPossiblyEmpty)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 805 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 805 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleSpecBlock));
//# 3579 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeKeyword)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfnList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 811 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 811 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypeDefnSig list));
//# 3591 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfn)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfnList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 816 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _3 
                   )
//# 816 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfnList));
//# 3603 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 819 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 819 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfnList));
//# 3614 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeNameInfo)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfnRhsBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 825 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let lhsm = rhs parseState 1 
                             _3 lhsm _1 
                   )
//# 825 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfn));
//# 3627 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeNameInfo)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 828 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             TypeDefnSig(_1,SynTypeDefnSigRepr.Simple (SynTypeDefnSimpleRepr.None (lhs parseState),lhs parseState),_2,lhs parseState) 
                   )
//# 828 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfn));
//# 3639 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfnRhs)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembers)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classSpfn)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 842 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            (fun lhsm nameInfo -> 
                                _2 lhsm nameInfo (checkForMultipleAugmentations m (_4 @ _5) _7)) 
                   )
//# 842 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfnRhsBlock));
//# 3657 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfnRhs)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 847 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            (fun lhsm nameInfo -> 
                                _1 lhsm nameInfo _2) 
                   )
//# 847 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfnRhsBlock));
//# 3671 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypeDefnSimpleRepr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 855 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = _1.Range 
                            (fun lhsm nameInfo augmentation -> 
                                TypeDefnSig(nameInfo,SynTypeDefnSigRepr.Simple (_1,m),augmentation,m)) 
                   )
//# 855 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfnRhs));
//# 3684 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconClassSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 860 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            let needsCheck,(kind,decls) = _1
                            (fun nameRange nameInfo augmentation -> 
                                if needsCheck && isNil decls then
                                   reportParseErrorAt nameRange (FSComp.SR.parsEmptyTypeDefinition())
                                TypeDefnSig(nameInfo,SynTypeDefnSigRepr.ObjectModel (kind,decls,m),augmentation,m)) 
                   )
//# 860 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfnRhs));
//# 3700 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'topType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 868 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            let ty,arity = _3
                            let invoke = SynMemberSig.Member(ValSpfn([],mkSynId m "Invoke",inferredTyparDecls,ty,arity,false,false,PreXmlDoc.Empty,None,None,m),AbstractMemberFlags MemberKind.Member,m) 
                            (fun nameRange nameInfo augmentation -> 
                                if not (isNil augmentation) then raiseParseErrorAt m (FSComp.SR.parsAugmentationsIllegalOnDelegateType())
                                TypeDefnSig(nameInfo,SynTypeDefnSigRepr.ObjectModel (TyconDelegate (ty,arity),[invoke],m),[],m)) 
                   )
//# 868 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconSpfnRhs));
//# 3716 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnBlockKindUnspecified)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 879 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let needsCheck,decls = _1 
                            needsCheck,(TyconUnspecified, decls) 
                   )
//# 879 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassSpfn));
//# 3728 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classOrInterfaceOrStruct)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 883 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            false,(_1,_2) 
                   )
//# 883 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassSpfn));
//# 3740 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classOrInterfaceOrStruct)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 886 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedClassInterfaceOrStruct())
                            false,(_1,_2) 
                   )
//# 886 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassSpfn));
//# 3754 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classOrInterfaceOrStruct)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 890 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // silent recovery 
                            false,(_1,[]) 
                   )
//# 890 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassSpfn));
//# 3766 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 897 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            true, _2 
                   )
//# 897 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnBlockKindUnspecified));
//# 3778 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 900 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFileTypeSignature())
                            false, _2 
                   )
//# 900 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnBlockKindUnspecified));
//# 3791 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 905 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            false, _2 
                   )
//# 905 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnBlockKindUnspecified));
//# 3802 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 908 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            false, _2 
                   )
//# 908 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnBlockKindUnspecified));
//# 3814 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 914 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 914 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnBlock));
//# 3826 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 917 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFileTypeSignature())
                             _2 
                   )
//# 917 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnBlock));
//# 3839 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembers)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 920 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 920 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnBlock));
//# 3850 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembersAtLeastOne)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 925 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 925 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnMembers));
//# 3861 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 928 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 928 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnMembers));
//# 3871 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfn)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnMembers)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 934 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _3 
                   )
//# 934 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classSpfnMembersAtLeastOne));
//# 3884 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberSpecFlags)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_explicitValTyparDecls)) in
            let _9 = (let data = parseState.GetInput(9) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTypeWithTypeConstraints)) in
            let _10 = (let data = parseState.GetInput(10) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfnGetSet)) in
            let _11 = (let data = parseState.GetInput(11) in (Microsoft.FSharp.Core.Operators.unbox data : 'optLiteralValueSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 940 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            let isInline,doc,vis2,id,explicitValTyparDecls,(ty,arity),optLiteralValue = _4,grabXmlDoc(parseState,3),_5,_6,_7,_9,_11
                            let getSetRangeOpt, getSet = _10 
                            let getSetAdjuster arity = match arity,getSet with SynValInfo([],_),MemberKind.Member -> MemberKind.PropertyGet | _ -> getSet
                            let wholeRange = 
                                let m = rhs parseState 3 
                                match getSetRangeOpt with 
                                | None -> unionRanges m ty.Range
                                | Some m2 -> unionRanges m m2
                            let valSpfn = ValSpfn(_1,id,explicitValTyparDecls,ty,arity, isInline,false,doc, vis2,optLiteralValue,wholeRange)
                            let _,flags = _3 
                            SynMemberSig.Member(valSpfn, flags (getSetAdjuster arity),wholeRange) 
                   )
//# 940 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfn));
//# 3915 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'interfaceMember)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 954 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            SynMemberSig.Interface (_4,unionRanges (rhs parseState 3) (_4).Range) 
                   )
//# 954 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfn));
//# 3930 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 958 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            SynMemberSig.Inherit (_4,unionRanges (rhs parseState 3) (_4).Range) 
                   )
//# 958 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfn));
//# 3944 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'fieldDecl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 962 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            let fld = _4 _1 false 
                            SynMemberSig.ValField(fld,rhs2 parseState 3 4) 
                   )
//# 962 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfn));
//# 3959 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'fieldDecl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 967 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            SynMemberSig.ValField(_5 _1 true,rhs2 parseState 3 5) 
                   )
//# 967 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfn));
//# 3973 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeKeyword)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 971 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            SynMemberSig.NestedType(_5,rhs2 parseState 3 5) 
                   )
//# 971 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfn));
//# 3988 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTypeWithTypeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 975 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let vis,doc,(ty,valSynInfo) = _2,grabXmlDoc(parseState,3),_5 
                            let m = unionRanges (rhs parseState 3) ty.Range 
                            let isInline = false 
                            let valSpfn = ValSpfn (_1, mkSynId (rhs parseState 3) "new", noInferredTypars, ty, valSynInfo, isInline, false, doc, vis, None, m)
                            SynMemberSig.Member(valSpfn, CtorMemberFlags,m) 
                   )
//# 975 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfn));
//# 4005 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 985 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           None, MemberKind.Member 
                   )
//# 985 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfnGetSet));
//# 4015 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfnGetSetElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 988 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           Some (rhs2 parseState 1 2), _2 
                   )
//# 988 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfnGetSet));
//# 4026 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfnGetSetElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 991 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           Some (rhs2 parseState 1 2), _2 
                   )
//# 991 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfnGetSet));
//# 4037 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfnGetSetElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 994 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedWith())
                            Some (rhs2 parseState 1 2), _2 
                   )
//# 994 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfnGetSet));
//# 4049 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1001 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           (let (id:Ident) = _1 
                            if id.idText = "get" then MemberKind.PropertyGet 
                            else if id.idText = "set" then MemberKind.PropertySet 
                            else raiseParseErrorAt (rhs parseState 1) (FSComp.SR.parsGetOrSetRequired())) 
                   )
//# 1001 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfnGetSetElements));
//# 4063 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1007 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           let (id:Ident) = _1 
                           if not ((id.idText = "get" && _3.idText = "set") ||
                                   (id.idText = "set" && _3.idText = "get")) then 
                              raiseParseErrorAt (rhs2 parseState 1 3) (FSComp.SR.parsGetOrSetRequired())
                           MemberKind.PropertyGetSet 
                   )
//# 1007 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classMemberSpfnGetSetElements));
//# 4079 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberFlags)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1014 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       _1 
                   )
//# 1014 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberSpecFlags));
//# 4090 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1015 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           (false,AbstractMemberFlags) 
                   )
//# 1015 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberSpecFlags));
//# 4100 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1016 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           (false,AbstractMemberFlags) 
                   )
//# 1016 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberSpecFlags));
//# 4110 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExceptionDefnRepr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classSpfn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1022 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExceptionSig(_1,_2,lhs parseState) 
                   )
//# 1022 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'exconSpfn));
//# 4122 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classSpfnBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'declEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1028 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 1028 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_classSpfn));
//# 4134 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1031 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 1031 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_classSpfn));
//# 4144 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceImpls)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1040 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            checkEndOfFileError _2; _1 
                   )
//# 1040 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedImplFile));
//# 4156 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceImpls)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1043 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 1043 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedImplFile));
//# 4168 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1049 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let emptyImplFileFrag = ParsedImplFileFragment.AnonModule([],rhs parseState 1) in 
                            ParsedImplFile ([],[emptyImplFileFrag]) 
                   )
//# 1049 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.ParsedImplFile));
//# 4180 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileModuleImpl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1056 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             ParsedImplFile ([], [ (_1 (false,[],PreXmlDoc.Empty)) ]) 
                   )
//# 1056 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceImpls));
//# 4191 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileModuleImpl)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceImplList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1059 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // If there are namespaces, the first fileModuleImpl may only contain # directives 
                             let decls = 
                                 match (_1 (false,[],PreXmlDoc.Empty)) with 
                                 | ParsedImplFileFragment.AnonModule(decls,m) -> decls  
                                 | ParsedImplFileFragment.NamespaceFragment(_,_,_, decls, _,_,_) -> decls 
                                 | ParsedImplFileFragment.NamedModule(SynModuleOrNamespace(_,_,_,_,_,_,_,m)) ->
                                     raiseParseErrorAt m (FSComp.SR.parsOnlyHashDirectivesAllowed())
                             let decls = 
                                 decls |> List.collect (function 
                                     | (SynModuleDecl.HashDirective (hd,_)) -> [hd]
                                     | d ->  
                                          reportParseErrorAt d.Range (FSComp.SR.parsOnlyHashDirectivesAllowed())
                                          [])
                             ParsedImplFile (decls, _2) 
                   )
//# 1059 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceImpls));
//# 4216 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceImpl)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceImplList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1078 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _2 
                   )
//# 1078 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceImplList));
//# 4228 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileNamespaceImpl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1081 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 1081 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceImplList));
//# 4239 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'namespaceIntro)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'deprecated_opt_equals)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'fileModuleImpl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1087 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let isRec, path, xml = _1 in (_3 (isRec, path, xml)) 
                   )
//# 1087 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileNamespaceImpl));
//# 4252 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleIntro)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynModuleDecl list)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1093 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                           let m2 = rhs parseState 3
                           let m = (m2, _4) ||> unionRangeWithListBy (fun modu -> modu.Range)
                           let isRec2,path2,xml,vis = _3 
                           (fun (isRec, path, _) -> 
                             if not (isNil path) then errorR(Error(FSComp.SR.parsNamespaceOrModuleNotBoth(),m2))
                             let lid = path@path2 
                             ParsedImplFileFragment.NamedModule(SynModuleOrNamespace(lid, (isRec || isRec2), NamedModule, _4, xml,_1,vis,m))) 
                   )
//# 1093 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileModuleImpl));
//# 4273 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynModuleDecl list)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1103 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           let m = (rhs parseState 1) 
                           (fun (isRec, path, xml) -> 
                             match path with 
                             | [] -> ParsedImplFileFragment.AnonModule(_1,m)  
                             | _ -> ParsedImplFileFragment.NamespaceFragment(path, isRec, DeclaredNamespace, _1, xml,[],m)) 
                   )
//# 1103 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fileModuleImpl));
//# 4288 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExprPossiblyEmpty)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1113 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 1113 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynModuleDecl list));
//# 4301 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExprPossiblyEmpty)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1116 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // The lex filter ensures we can only get a mismatch in OBLOCKBEGIN/OBLOCKEND tokens if there was some other kind of error, hence we don't need to report this error
                            // reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnClosedBlockInHashLight())   
                            _2 
                   )
//# 1116 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynModuleDecl list));
//# 4315 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1121 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            []  
                   )
//# 1121 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynModuleDecl list));
//# 4326 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExprPossiblyEmpty)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1124 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 1124 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynModuleDecl list));
//# 4337 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1130 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 1130 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnsOrExprPossiblyEmpty));
//# 4348 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1133 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 1133 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnsOrExprPossiblyEmpty));
//# 4358 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparators)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1140 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             match _2 with
                             | Some vis -> errorR(Error(FSComp.SR.parsUnexpectedVisibilityDeclaration(vis.ToString()),rhs parseState 3))
                             | _ -> ()
                             let attrDecls = if not (isNil _1) then [ SynModuleDecl.Attributes (_1, rangeOfNonNilAttrs _1) ] else [] 
                             attrDecls @ mkSynDoDecl (_3) :: _5 
                   )
//# 1140 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnsOrExpr));
//# 4377 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparators)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1147 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             match _2 with
                             | Some vis -> errorR(Error(FSComp.SR.parsUnexpectedVisibilityDeclaration(vis.ToString()),rhs parseState 3))
                             | _ -> ()
                             let attrDecls = if not (isNil _1) then [ SynModuleDecl.Attributes (_1, rangeOfNonNilAttrs _1) ] else [] 
                             attrDecls @ [ mkSynDoDecl(_3) ] 
                   )
//# 1147 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnsOrExpr));
//# 4395 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1154 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             match _2 with
                             | Some vis -> errorR(Error(FSComp.SR.parsUnexpectedVisibilityDeclaration(vis.ToString()),rhs parseState 3))
                             | _ -> ()
                             let attrDecls = if not (isNil _1) then [ SynModuleDecl.Attributes (_1, rangeOfNonNilAttrs _1) ] else [] 
                             attrDecls @ [ mkSynDoDecl(_3) ] 
                   )
//# 1154 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnsOrExpr));
//# 4412 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1161 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 1161 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnsOrExpr));
//# 4423 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1164 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not (isNil _1) then [ SynModuleDecl.Attributes (_1, rangeOfNonNilAttrs _1) ] else [] 
                   )
//# 1164 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnsOrExpr));
//# 4434 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnOrDirective)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1170 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 @ _2 
                   )
//# 1170 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefns));
//# 4446 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnOrDirective)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparators)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1173 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 @ _3 
                   )
//# 1173 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefns));
//# 4459 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnOrDirective)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1176 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 1176 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefns));
//# 4470 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnOrDirective)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparators)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1179 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 1179 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefns));
//# 4482 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparators)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1182 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 
                   )
//# 1182 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefns));
//# 4494 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1188 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1  
                   )
//# 1188 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnOrDirective));
//# 4505 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hashDirective)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1191 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [ SynModuleDecl.HashDirective (_1,rhs2 parseState 1 1) ] 
                   )
//# 1191 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefnOrDirective));
//# 4516 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'defnBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1200 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             parseState.ResetSynArgNameGenerator()
                             let (BindingSetPreAttrs(_,_,_,_,mWhole)) = _3 
                             mkDefnBindings (mWhole,_3,_1,_2,mWhole)  
                   )
//# 1200 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4532 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteLetBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1207 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let hwlb,m = _3
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             parseState.ResetSynArgNameGenerator()
                             mkDefnBindings (m,hwlb,_1,_2,m)  
                   )
//# 1207 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4548 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doBinding)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1214 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let mWhole = rhs parseState 3 
                             mkDefnBindings (mWhole,_3,_1,_2,mWhole) 
                   )
//# 1214 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4563 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeKeyword)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefn)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefnList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1220 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let      (TypeDefn(ComponentInfo(cas,a,cs,b,c,d,d2,d3),e,f,g)) = _4
                             let tc = (TypeDefn(ComponentInfo(_1@cas,a,cs,b,c,d,d2,d3),e,f,g))
                             let types = tc :: _5
                             [ SynModuleDecl.Types(types, (rhs parseState 3, types) ||> unionRangeWithListBy (fun t -> t.Range) ) ] 
                   )
//# 1220 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4582 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExceptionDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1228 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let (SynExceptionDefn(SynExceptionDefnRepr(cas,a,b,c,d,d2),e,f)) = _3 
                             let f = (f, _1) ||> unionRangeWithListBy (fun a -> a.Range)
                             let ec = (SynExceptionDefn(SynExceptionDefnRepr(_1@cas,a,b,c,d,d2),e,f)) 
                             [ SynModuleDecl.Exception(ec, f) ] 
                   )
//# 1228 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4599 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleIntro)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'namedModuleDefnBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1236 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let attribs, (isRec, path, xml, vis) = _1,_3 
                             match _5 with 
                             | Choice1Of2 eqn -> 
                                 if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                                 if isRec then raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsInvalidUseOfRec())
                                 if not (isSingleton path) then raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsModuleAbbreviationMustBeSimpleName())
                                 if not (isNil _1) then raiseParseErrorAt (rhs parseState 1) (FSComp.SR.parsIgnoreAttributesOnModuleAbbreviation())
                                 match vis with
                                 | Some vis -> raiseParseErrorAt (rhs parseState 1) (FSComp.SR.parsIgnoreAttributesOnModuleAbbreviationAlwaysPrivate(vis.ToString()))
                                 | _ -> ()
                                 [ SynModuleDecl.ModuleAbbrev(List.head path,eqn,(rhs parseState 3, eqn) ||> unionRangeWithListBy (fun id -> id.idRange) ) ]
                             | Choice2Of2 def -> 
                                 if not (isSingleton path) then raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsModuleAbbreviationMustBeSimpleName())
                                 let info = ComponentInfo(attribs,[],[],path,xml,false,vis,rhs parseState 3)
                                 [ SynModuleDecl.NestedModule(info, isRec, def, false,(rhs2 parseState 3 4, def) ||> unionRangeWithListBy (fun d -> d.Range) ) ] 
                   )
//# 1236 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4628 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1255 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             errorR(Error(FSComp.SR.parsAttributeOnIncompleteCode(),rhs parseState 1))
                             [] 
                   )
//# 1255 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4641 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1260 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [SynModuleDecl.Open(_1, _1.Range)] 
                   )
//# 1260 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleDefn));
//# 4652 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1268 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2.Lid 
                   )
//# 1268 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleAbbrevBlock));
//# 4664 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1271 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1.Lid  
                   )
//# 1271 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleAbbrevBlock));
//# 4675 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'wrappedNamedModuleDefn)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1277 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            Choice2Of2 _2  
                   )
//# 1277 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleDefnBlock));
//# 4687 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'wrappedNamedModuleDefn)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1280 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // The lex filter ensures we can only get a mismatch in OBLOCKBEGIN/OBLOCKEND tokens if there was some other kind of error, hence we don't need to report this error
                            Choice2Of2 _2 
                   )
//# 1280 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleDefnBlock));
//# 4700 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1284 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              // There is an ambiguity here 
                              // In particular, consider the following two:
                              //
                              // module M2 = 
                              //    System.DateTime.Now
                              // module M2 = 
                              //    Microsoft.FSharp.Core.List
                              // The second is a module abbreviation, the first a module containing a single expression.
                              // The resolution is in favour of the module abbreviation, i.e. anything of the form 
                              //    module M2 = ID.ID.ID.ID
                              // will be taken as a module abbreviation, regardles of the identifiers themselves.
                              //
                              // This is similar to the ambiguitty between 
                              //    type X = int
                              // and 
                              //    type X = OneValue
                              // However in that case we do use type name lookup to make the resolution.
                              match _2 with 
                              | [ SynModuleDecl.DoExpr (_,LongOrSingleIdent(false,LongIdentWithDots(path,_),None,_),_) ] -> 
                                  Choice1Of2  path
                              | _ -> 
                                  Choice2Of2 _2 
                            
                   )
//# 1284 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleDefnBlock));
//# 4734 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1310 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // The lex filter ensures we can only get a mismatch in OBLOCKBEGIN/OBLOCKEND tokens if there was some other kind of error, hence we don't need to report this error
                            // reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnClosedBlockInHashLight())   
                            Choice2Of2 _2 
                   )
//# 1310 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleDefnBlock));
//# 4748 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1315 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            Choice2Of2 [] 
                   )
//# 1315 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleDefnBlock));
//# 4759 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'wrappedNamedModuleDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1318 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            Choice2Of2 _1 
                   )
//# 1318 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleDefnBlock));
//# 4770 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1321 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            Choice1Of2 _1.Lid 
                   )
//# 1321 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namedModuleDefnBlock));
//# 4781 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'structOrBegin)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExprPossiblyEmpty)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1327 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 1327 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'wrappedNamedModuleDefn));
//# 4793 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'structOrBegin)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleDefnsOrExprPossiblyEmpty)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1330 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBeginOrStruct())  
                            _2 
                   )
//# 1330 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'wrappedNamedModuleDefn));
//# 4807 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'structOrBegin)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1334 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 1334 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'wrappedNamedModuleDefn));
//# 4818 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'declEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1339 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 1339 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynMemberDefns));
//# 4830 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1345 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 1345 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_attributes));
//# 4841 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1348 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 1348 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_attributes));
//# 4851 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributeList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1353 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 1353 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributes));
//# 4862 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributeList)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1356 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 @ _2 
                   )
//# 1356 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributes));
//# 4874 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributeListElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1362 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              _2 
                   )
//# 1362 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeList));
//# 4887 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1365 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              [] 
                   )
//# 1365 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeList));
//# 4898 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributeListElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1368 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _4 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedLBrackLess())
                             _2 
                   )
//# 1368 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeList));
//# 4912 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1372 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _2 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedLBrackLess())
                             [] 
                   )
//# 1372 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeList));
//# 4924 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attribute)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1379 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 1379 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeListElements));
//# 4935 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributeListElements)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'attribute)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1382 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 @ [_3] 
                   )
//# 1382 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeListElements));
//# 4948 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_atomicExprAfterType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1389 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let arg = match _3 with None -> mkSynUnit _1.Range | Some e -> e 
                            ({ TypeName=_1; ArgExpr=arg; Target=None; AppliesToGetterAndSetter=false; Range=_1.Range } : SynAttribute) 
                   )
//# 1389 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attribute));
//# 4962 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributeTarget)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_atomicExprAfterType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1394 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let arg = match _4 with None -> mkSynUnit _2.Range | Some e -> e 
                            ({ TypeName=_2; ArgExpr=arg; Target=_1; AppliesToGetterAndSetter=false; Range=_2.Range } : SynAttribute) 
                   )
//# 1394 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attribute));
//# 4977 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributeTarget)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_atomicExprAfterType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1399 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let arg = match _6 with None -> mkSynUnit _3.Range | Some e -> e 
                            ({ TypeName=_3; ArgExpr=arg; Target=_1; AppliesToGetterAndSetter=false; Range=_3.Range } : SynAttribute) 
                   )
//# 1399 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attribute));
//# 4993 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleKeyword)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1406 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some(ident("module",(rhs parseState 1))) 
                   )
//# 1406 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeTarget));
//# 5004 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeKeyword)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1409 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some(ident("type",(rhs parseState 1))) 
                   )
//# 1409 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeTarget));
//# 5015 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1411 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       Some(_1) 
                   )
//# 1411 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeTarget));
//# 5026 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1415 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if _1 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsSyntaxError())
                             Some(ident("return",(rhs parseState 1))) 
                   )
//# 1415 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attributeTarget));
//# 5038 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1420 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           (true,StaticMemberFlags) 
                   )
//# 1420 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberFlags));
//# 5048 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1421 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           (false,NonVirtualMemberFlags) 
                   )
//# 1421 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberFlags));
//# 5058 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1422 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           (false,OverrideMemberFlags) 
                   )
//# 1422 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberFlags));
//# 5068 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1423 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          (false,OverrideMemberFlags) 
                   )
//# 1423 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberFlags));
//# 5078 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconNameAndTyparDecls)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_typeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1428 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let typars,lid,fixity,tpcs1,vis,xmlDoc = _2 
                            let tpcs2 = _3 
                            ComponentInfo(_1,typars,(tpcs1 @ tpcs2),lid,xmlDoc,fixity,vis,rangeOfLid lid)  
                   )
//# 1428 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeNameInfo));
//# 5093 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefn)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefnList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1435 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 :: _3 
                   )
//# 1435 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnList));
//# 5105 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1437 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 1437 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnList));
//# 5115 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeNameInfo)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1442 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            TypeDefn(_1,SynTypeDefnRepr.Simple(SynTypeDefnSimpleRepr.None(_1.Range),_1.Range),[],_1.Range) 
                   )
//# 1442 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefn));
//# 5126 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeNameInfo)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefnRhsBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1445 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let nameRange = rhs parseState 1
                            let (tcDefRepr:SynTypeDefnRepr),members = _3 nameRange
                            let declRange = unionRanges (rhs parseState 1) tcDefRepr.Range
                            let mWhole = (declRange, members) ||> unionRangeWithListBy (fun (mem:SynMemberDefn) -> mem.Range)    
                            TypeDefn(_1, tcDefRepr, members, mWhole) 
                   )
//# 1445 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefn));
//# 5142 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeNameInfo)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynMemberDefns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1452 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = (rhs parseState 1, _2) ||> unionRangeWithListBy (fun mem -> mem.Range)
                            TypeDefn(_1,SynTypeDefnRepr.ObjectModel(TyconAugmentation,[],m),_2,m) 
                   )
//# 1452 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefn));
//# 5155 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeNameInfo)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePatterns)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'optAsSpec)) in
            let _8 = (let data = parseState.GetInput(8) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefnRhsBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1456 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let vis,spats, az = _3,_5,_6
                            let nameRange = rhs parseState 1
                            let (tcDefRepr,members) = _8 nameRange
                            let (ComponentInfo(_,_,_,lid,_,_,_,_)) = _1 
                            let memberCtorPattern = SynMemberDefn.ImplicitCtor (vis,_2,spats,az,rangeOfLid lid)
                            let tcDefRepr = 
                              match tcDefRepr with
                              | SynTypeDefnRepr.ObjectModel (k,cspec,m) -> SynTypeDefnRepr.ObjectModel (k,memberCtorPattern :: cspec,m)
                              | _ -> reportParseErrorAt (rhs2 parseState 1 5) (FSComp.SR.parsOnlyClassCanTakeValueArguments()); tcDefRepr
                            let declRange = unionRanges (rhs parseState 1) tcDefRepr.Range
                            let mWhole = (declRange, members) ||> unionRangeWithListBy (fun (mem:SynMemberDefn) -> mem.Range)
                            
                            TypeDefn(_1,tcDefRepr,members,mWhole) 
                   )
//# 1456 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefn));
//# 5184 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefnRhs)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classDefn)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1482 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = unionRanges (rhs parseState 1) (match _7 with [] -> (match _5 with [] -> (rhs parseState 4) | _ -> (rhs parseState 5)) | _ -> (rhs parseState 7))
                            (fun nameRange -> _2 nameRange (checkForMultipleAugmentations m (_4 @ _5) _7)) 
                   )
//# 1482 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnRhsBlock));
//# 5201 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefnRhs)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classDefn)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1486 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _6 then reportParseErrorAt (rhs parseState 6) (FSComp.SR.parsUnexpectedEndOfFileTypeDefinition())
                            let m = unionRanges (rhs parseState 1) (match _5 with [] -> (rhs parseState 4) | _ -> (rhs parseState 5))
                            (fun nameRange -> _2 nameRange (checkForMultipleAugmentations m (_4 @ _5) [])) 
                   )
//# 1486 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnRhsBlock));
//# 5218 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefnRhs)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1491 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = rhs parseState 1
                            (fun nameRange -> _1 nameRange _2) 
                   )
//# 1491 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnRhsBlock));
//# 5231 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypeDefnSimpleRepr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1500 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = _1.Range
                            (fun nameRange augmentation -> SynTypeDefnRepr.Simple (_1,m),augmentation) 
                   )
//# 1500 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnRhs));
//# 5243 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconClassDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1505 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let needsCheck,(kind,decls),mopt = _1 
                            let m = match mopt with 
                                    | None -> (lhs parseState).StartRange // create a zero-width range
                                    | Some m -> m
                            (fun nameRange augmentation -> 
                                if needsCheck && isNil decls then 
                                    reportParseErrorAt nameRange (FSComp.SR.parsEmptyTypeDefinition())
                                SynTypeDefnRepr.ObjectModel (kind,decls,m),augmentation) 
                   )
//# 1505 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnRhs));
//# 5261 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'topType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1516 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            let ty,arity = _3
                            (fun nameRange augmentation -> 
                                let valSpfn = ValSpfn([],mkSynId m "Invoke",inferredTyparDecls,ty,arity,false,false,PreXmlDoc.Empty,None,None,m) 
                                let invoke = SynMemberDefn.AbstractSlot(valSpfn,AbstractMemberFlags MemberKind.Member,m) 
                                if not (isNil augmentation) then raiseParseErrorAt m (FSComp.SR.parsAugmentationsIllegalOnDelegateType())
                                SynTypeDefnRepr.ObjectModel (TyconDelegate (ty,arity),[invoke],m),[]) 
                   )
//# 1516 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconDefnRhs));
//# 5278 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnBlockKindUnspecified)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1528 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let needsCheck,decls,mopt = _1 
                            needsCheck,(TyconUnspecified, decls),mopt 
                   )
//# 1528 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassDefn));
//# 5290 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classOrInterfaceOrStruct)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1532 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = (rhs parseState 1, _2) ||> unionRangeWithListBy (fun (d:SynMemberDefn) -> d.Range)
                            false,(_1,_2),Some(m) 
                   )
//# 1532 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassDefn));
//# 5303 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classOrInterfaceOrStruct)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1536 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedClassInterfaceOrStruct())
                            let m = (rhs parseState 1, _2) ||> unionRangeWithListBy (fun (d:SynMemberDefn) -> d.Range)
                            false,(_1,_2),Some(m) 
                   )
//# 1536 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassDefn));
//# 5318 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classOrInterfaceOrStruct)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1541 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // silent recovery 
                            false,(_1,[]),Some(rhs parseState 1) 
                   )
//# 1541 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconClassDefn));
//# 5330 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1548 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFileTypeDefinition())
                            let mopt =
                                match _2 with
                                | _ :: _ -> Some( (rhs parseState 1, _2) ||> unionRangeWithListBy (fun (d:SynMemberDefn) -> d.Range) )
                                | _ -> None
                            false,_2,mopt 
                   )
//# 1548 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBlockKindUnspecified));
//# 5347 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1556 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mopt =
                                match _2 with
                                | _ :: _ -> Some( (rhs parseState 1, _2) ||> unionRangeWithListBy (fun (d:SynMemberDefn) -> d.Range) )
                                | _ -> None
                            true, _2, mopt 
                   )
//# 1556 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBlockKindUnspecified));
//# 5363 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1566 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFileTypeDefinition())
                             _2 
                   )
//# 1566 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBlock));
//# 5376 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1570 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 1570 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBlock));
//# 5388 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1573 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 1573 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBlock));
//# 5399 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembersAtLeastOne)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1579 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 1579 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMembers));
//# 5410 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1583 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 1583 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMembers));
//# 5421 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1586 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 1586 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMembers));
//# 5431 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMember)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMembers)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1592 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 @  _3 
                   )
//# 1592 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMembersAtLeastOne));
//# 5444 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMemberGetSetElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1598 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2  
                   )
//# 1598 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMemberGetSet));
//# 5455 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMemberGetSetElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1601 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2  
                   )
//# 1601 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMemberGetSet));
//# 5466 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMemberGetSetElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1604 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedWith())
                            _2  
                   )
//# 1604 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMemberGetSet));
//# 5478 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMemberGetSetElement)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1610 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1]  
                   )
//# 1610 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMemberGetSetElements));
//# 5489 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMemberGetSetElement)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMemberGetSetElement)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1612 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1;_3] 
                   )
//# 1612 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMemberGetSetElements));
//# 5501 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bindingPattern)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topReturnTypeWithTypeConstraints)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1616 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mRhs = (_6 : SynExpr).Range 
                            (_1,_2,_3,_4,_6,mRhs) 
                   )
//# 1616 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMemberGetSetElement));
//# 5517 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'bindingPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topReturnTypeWithTypeConstraints)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1624 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mRhs = _5.Range 
                             let mWhole = unionRanges (rhs2 parseState 3 4) mRhs 
                             let optReturnType = _3 
                             let bindingBuilder,mBindLhs = _2 
                             (fun vis memFlagsBuilder attrs -> 
                                  [ SynMemberDefn.Member (bindingBuilder (vis,_1,false,mBindLhs,NoSequencePointAtInvisibleBinding,optReturnType,_5,mRhs,[],attrs,Some(memFlagsBuilder MemberKind.Member)),unionRanges mWhole mBindLhs) ]) 
                   )
//# 1624 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberCore));
//# 5536 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'bindingPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topReturnTypeWithTypeConstraints)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnMemberGetSet)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1633 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mWhole = (rhs parseState 2, _4) ||> unionRangeWithListBy (fun (_,_,_,_,_,m2) -> m2) 
                            let propertyNameBindingBuilder,_ = _2 
                            let optPropertyType = _3 
                            let isMutable = false
                            (fun visNoLongerUsed memFlagsBuilder attrs -> 
                                  let hasGet = ref false
                                  let hasSet = ref false
                                  // Iterate over 1 or 2 'get'/'set' entries
                                  _4 |> List.choose (fun (optInline,optAttrs,(bindingBuilder,mBindLhs),optReturnType,expr,exprm) ->
                                        let optInline = _1 || optInline 
                                        // optional attributes are only applied to getters and setters
                                        // the "top level" attrs will be applied to both
                                        let optAttrs = optAttrs |> List.map (fun (a:SynAttribute) -> { a with AppliesToGetterAndSetter=true })
                                        let attrs = attrs @ optAttrs
                                        
                                        let binding = bindingBuilder (visNoLongerUsed,optInline,isMutable,mBindLhs,NoSequencePointAtInvisibleBinding,optReturnType,expr,exprm,[],attrs,Some (memFlagsBuilder MemberKind.Member))
                                        let (Binding (vis, _, isInline, _, attrs, doc, valSynData, pv, _, _, mBindLhs, spBind)) = binding 
                                        let memberKind = 
                                              let getset = 
                                                    let rec go p = 
                                                        match p with 
                                                        | SynPat.LongIdent (LongIdentWithDots([id],_),_,_,_,_,_) ->  id.idText
                                                        | SynPat.Named (_,nm,_,_,_) ->  nm.idText
                                                        | SynPat.Typed (p,_,_) ->  go p
                                                        | SynPat.Attrib (p,_,_) ->  go p
                                                        | _ -> raiseParseErrorAt mBindLhs (FSComp.SR.parsInvalidDeclarationSyntax()) 
                                                    go pv 
                                              if getset = "get" then (
                                                  if !hasGet then 
                                                      reportParseErrorAt mBindLhs (FSComp.SR.parsGetAndOrSetRequired())
                                                      None
                                                  else
                                                      hasGet := true
                                                      Some MemberKind.PropertyGet
                                              ) else if getset = "set" then (
                                                  if !hasSet then 
                                                      reportParseErrorAt mBindLhs (FSComp.SR.parsGetAndOrSetRequired())
                                                      None
                                                  else
                                                      hasSet := true
                                                      Some MemberKind.PropertySet
                                              ) else 
                                                  raiseParseErrorAt mBindLhs (FSComp.SR.parsGetAndOrSetRequired())
                                        match memberKind with
                                        | None -> None
                                        | Some memberKind ->
                                        // REVIEW: It's hard not to ignore the optPropertyType type annotation for 'set' properties. To apply it, 
                                        // we should apply it to the last argument, but at this point we've already pushed the patterns that 
                                        // make up the arguments onto the RHS. So we just always give a warning. 
                                        begin match optPropertyType with 
                                        | Some _ -> errorR(Error(FSComp.SR.parsTypeAnnotationsOnGetSet(),mBindLhs))
                                        | None -> ()
                                        end
                                        
                                        let optReturnType = 
                                            match (memberKind, optReturnType) with 
                                            | MemberKind.PropertySet,_ -> optReturnType
                                            | _, None -> optPropertyType
                                            | _ -> optReturnType 
                                        // REDO with the correct member kind 
                                        let binding = bindingBuilder(vis,isInline,isMutable,mBindLhs,NoSequencePointAtInvisibleBinding,optReturnType,expr,exprm,[],attrs,Some(memFlagsBuilder memberKind)) 
                                        let (Binding (vis, _, isInline, _, attrs, doc, valSynData, pv, rhsRetInfo, rhsExpr, mBindLhs, spBind)) = binding 
                                     
                                        let (SynValData(_,valSynInfo,_)) = valSynData 
                                        // Setters have all arguments tupled in their internal TAST form, though they don't appear to be 
                                        // tupled from the syntax
                                        let memFlags = memFlagsBuilder memberKind
                                        let valSynInfo = 
                                            let adjustValueArg valueArg = 
                                                match valueArg with
                                                | [_] -> valueArg
                                                | _ -> SynInfo.unnamedTopArg
                                            match memberKind, valSynInfo, memFlags.IsInstance with 
                                            | MemberKind.PropertyGet,SynValInfo ([],_ret),         false
                                            | MemberKind.PropertyGet,SynValInfo ([_],_ret), true  -> 
                                                raiseParseErrorAt mBindLhs (FSComp.SR.parsGetterMustHaveAtLeastOneArgument()) 
                                            | MemberKind.PropertyGet,SynValInfo (thisArg :: indexOrUnitArgs :: rest,ret), true  -> 
                                                if not rest.IsEmpty then reportParseErrorAt mBindLhs (FSComp.SR.parsGetterAtMostOneArgument())
                                                SynValInfo ([thisArg; indexOrUnitArgs],ret)
                                            | MemberKind.PropertyGet,SynValInfo (indexOrUnitArgs :: rest,ret),          false ->
                                                if not rest.IsEmpty then reportParseErrorAt mBindLhs (FSComp.SR.parsGetterAtMostOneArgument())
                                                SynValInfo ([indexOrUnitArgs],ret)
                                            | MemberKind.PropertySet,SynValInfo ([thisArg;valueArg],ret),                 true  -> 
                                                SynValInfo ([thisArg; adjustValueArg valueArg],ret)
                                            | MemberKind.PropertySet,SynValInfo (thisArg :: indexArgs :: valueArg :: rest,ret), true  -> 
                                                if not rest.IsEmpty then reportParseErrorAt mBindLhs (FSComp.SR.parsSetterAtMostTwoArguments())
                                                SynValInfo ([thisArg; indexArgs @ adjustValueArg valueArg],ret)
                                            | MemberKind.PropertySet,SynValInfo ([valueArg],ret),                         false -> 
                                                SynValInfo ([adjustValueArg valueArg],ret)
                                            | MemberKind.PropertySet,SynValInfo (indexArgs :: valueArg :: rest,ret),          _     -> 
                                                if not rest.IsEmpty then reportParseErrorAt mBindLhs (FSComp.SR.parsSetterAtMostTwoArguments())
                                                SynValInfo ([indexArgs @ adjustValueArg valueArg],ret)
                                            | _ -> 
                                                // should be unreachable, cover just in case
                                                raiseParseErrorAt mBindLhs (FSComp.SR.parsInvalidProperty())
                                        let valSynData = SynValData(Some(memFlags), valSynInfo,None) 
                                        // Fold together the information from the first lambda pattern and the get/set binding
                                        // This uses the 'this' variable from the first and the patterns for the get/set binding, 
                                        // replacing the get/set identifier. A little gross. 
                                        let bindingPatAdjusted, xmlDocAdjusted = 
                                            let bindingOuter = propertyNameBindingBuilder(vis,optInline,isMutable,mBindLhs,spBind,optReturnType,expr,exprm,[],attrs,Some(memFlagsBuilder MemberKind.Member))
                                            let (Binding (_,_,_,_,_,doc2,_,bindingPatOuter,_,_,_,_)) = bindingOuter 
                                            
                                        
                                            let lidOuter,lidVisOuter = 
                                                match bindingPatOuter with 
                                                | SynPat.LongIdent (lid,None,None, SynConstructorArgs.Pats [],lidVisOuter,m) ->  lid,lidVisOuter
                                                | SynPat.Named (_,id,_,visOuter,m) -> LongIdentWithDots([id],[]),visOuter
                                                | p -> raiseParseErrorAt mBindLhs (FSComp.SR.parsInvalidDeclarationSyntax()) 
                                            // Merge the visibility from the outer point with the inner point, e.g.
                                            //    member <VIS1>  this.Size with <VIS2> get ()      = m_size
                                            
                                            let mergeLidVisOuter lidVisInner =
                                                match lidVisInner,lidVisOuter with 
                                                | None,None -> None
                                                | Some lidVisInner,None | None,Some lidVisInner -> Some lidVisInner
                                                | Some _, Some _ ->  
                                                    errorR(Error(FSComp.SR.parsMultipleAccessibilitiesForGetSet(),mBindLhs))
                                                    lidVisInner
                                        
                                            // Replace the "get" or the "set" with the right name
                                            let rec go p = 
                                                match p with 
                                                | SynPat.LongIdent (LongIdentWithDots([id],_),_,tyargs,SynConstructorArgs.Pats args,lidVisInner,m) ->  
                                                    // Setters have all arguments tupled in their internal form, though they don't 
                                                    // appear to be tupled from the syntax. Somewhat unfortunate
                                                    let args = 
                                                        if id.idText = "set" then 
                                                            match args with 
                                                            | [SynPat.Paren(SynPat.Tuple (false,indexPats,_),indexPatRange);valuePat] when id.idText = "set" -> 
                                                                [SynPat.Tuple(false,indexPats@[valuePat],unionRanges indexPatRange valuePat.Range)] 
                                                            | [indexPat;valuePat] -> 
                                                                [SynPat.Tuple(false,args,unionRanges indexPat.Range valuePat.Range)] 
                                                            | [valuePat] -> 
                                                                [valuePat] 
                                                            | _ -> 
                                                                raiseParseErrorAt m (FSComp.SR.parsSetSyntax())
                                                        else 
                                                            args
                     //                               let idTool : Ident list = lidOuter |> List.map (fun (li:Ident) -> ident(li.idText,id.idRange)) |> List.rev |> List.take 1
                                                    SynPat.LongIdent (lidOuter,Some(id),tyargs, SynConstructorArgs.Pats args,mergeLidVisOuter lidVisInner,m)
                                                | SynPat.Named (_,nm,_,lidVisInner,m) ->  SynPat.LongIdent (lidOuter,None,None, SynConstructorArgs.Pats [], mergeLidVisOuter lidVisInner,m)
                                                | SynPat.Typed (p,ty,m) ->  SynPat.Typed(go p,ty,m)
                                                | SynPat.Attrib (p,attribs,m) ->  SynPat.Attrib(go p,attribs,m)
                                                | SynPat.Wild(m) ->  SynPat.Wild(m)
                                                | _ -> raiseParseErrorAt mBindLhs (FSComp.SR.parsInvalidDeclarationSyntax()) 
                                            go pv,PreXmlDoc.Merge doc2 doc
                                        Some <| SynMemberDefn.Member (Binding (vis, NormalBinding, isInline, isMutable, attrs, xmlDocAdjusted, valSynData, bindingPatAdjusted, rhsRetInfo, rhsExpr, mBindLhs, spBind),mWhole)))
                            
                   )
//# 1633 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberCore));
//# 5698 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1810 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   
                   )
//# 1810 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'abstractMemberFlags));
//# 5708 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1811 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          
                   )
//# 1811 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'abstractMemberFlags));
//# 5718 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1817 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            [mkClassMemberLocalBindings(false,None,_1,_2,_3)] 
                   )
//# 1817 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5732 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1821 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            [mkClassMemberLocalBindings(true,Some (rhs parseState 3),_1,_2,_4)] 
                   )
//# 1821 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5746 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberFlags)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberCore)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1825 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                            let _,flags = _3
                            _4 _2 flags _1 
                   )
//# 1825 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5763 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'interfaceMember)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_interfaceImplDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1830 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not (isNil _1) then errorR(Error(FSComp.SR.parsAttributesAreNotPermittedOnInterfaceImplementations(),rhs parseState 1))
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsInterfacesHaveSameVisibilityAsEnclosingType(),rhs parseState 3))
                             let mWhole = 
                                 match _5 with
                                 | None -> rhs2 parseState 3 4
                                 | Some(mems) -> (rhs2 parseState 3 4, mems) ||> unionRangeWithListBy (fun (mem:SynMemberDefn) -> mem.Range)
                             [ SynMemberDefn.Interface (_4, _5, mWhole) ] 
                   )
//# 1830 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5784 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'abstractMemberFlags)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_explicitValTyparDecls)) in
            let _8 = (let data = parseState.GetInput(8) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTypeWithTypeConstraints)) in
            let _9 = (let data = parseState.GetInput(9) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfnGetSet)) in
            let _10 = (let data = parseState.GetInput(10) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1839 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let ty,arity = _8
                            let isInline,doc,id,explicitValTyparDecls = _4,grabXmlDoc(parseState,3),_5,_6
                            let getSetRangeOpt, getSet = _9
                            let getSetAdjuster arity = match arity,getSet with SynValInfo([],_),MemberKind.Member -> MemberKind.PropertyGet | _ -> getSet
                            let wholeRange = 
                                let m = rhs parseState 3
                                match getSetRangeOpt with 
                                | None -> unionRanges m ty.Range
                                | Some m2 -> unionRanges m m2
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsAccessibilityModsIllegalForAbstract(),wholeRange))
                            let valSpfn = ValSpfn(_1,id,explicitValTyparDecls,ty,arity, isInline,false,doc, None,None,wholeRange)
                            [ SynMemberDefn.AbstractSlot(valSpfn,AbstractMemberFlags (getSetAdjuster arity), wholeRange) ] 
                   )
//# 1839 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5814 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'inheritsDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1853 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not (isNil _1) then errorR(Error(FSComp.SR.parsAttributesIllegalOnInherit(),rhs parseState 1))
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityIllegalOnInherit(),rhs parseState 1))
                             [ _3 ] 
                   )
//# 1853 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5829 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'valDefnDecl)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1858 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             _3 None _1 false 
                   )
//# 1858 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5844 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'valDefnDecl)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1862 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             _4 (Some (rhs parseState 3)) _1 true  
                   )
//# 1862 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5859 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberFlags)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'autoPropsDefnDecl)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1866 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             let isStatic, flags = _3
                             _4 _1 isStatic flags 
                   )
//# 1866 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5876 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'optAsSpec)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _8 = (let data = parseState.GetInput(8) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1871 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let m = unionRanges (rhs2 parseState 3 6) _7.Range 
                             let expr = _7
                             let valSynData = SynValData (Some CtorMemberFlags, SynValInfo([SynInfo.InferSynArgInfoFromPat _4],SynInfo.unnamedRetVal), _5) 
                             let vis = _2 
                             let declPat = SynPat.LongIdent (LongIdentWithDots([mkSynId (rhs parseState 3) "new"],[]),None,Some noInferredTypars, SynConstructorArgs.Pats [_4],vis,rhs parseState 3)
                             // Check that 'SynPatForConstructorDecl' matches this correctly
                             assert (match declPat with SynPatForConstructorDecl _ -> true | _ -> false)
                             [ SynMemberDefn.Member(Binding (None,NormalBinding,false,false,_1,grabXmlDoc(parseState,3),valSynData, declPat,None,expr,m,NoSequencePointAtInvisibleBinding),m) ] 
                   )
//# 1871 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5899 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeKeyword)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1881 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsVisibilityDeclarationsShouldComePriorToIdentifier(),rhs parseState 2))
                             [ SynMemberDefn.NestedType(_5,None,rhs2 parseState 3 5) ] 
                   )
//# 1881 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnMember));
//# 5914 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_mutable)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1888 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mRhs = rhs2 parseState 4 6
                             let doc = grabXmlDoc(parseState,4)
                             let mValDecl = rhs2 parseState 1 6
                             (fun mLeft attribs isStatic -> 
                                 let mValDecl = match mLeft with None -> mValDecl | Some m -> unionRanges m mValDecl
                                 let fld = Field(attribs,isStatic,Some _4,_6,_2,doc,_3,mRhs)
                                 [ SynMemberDefn.ValField(fld, mValDecl) ]) 
                   )
//# 1888 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'valDefnDecl));
//# 5934 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_mutable)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_typ)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _8 = (let data = parseState.GetInput(8) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfnGetSet)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1900 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let doc = grabXmlDoc(parseState,5)
                             let mValDecl = unionRanges (rhs parseState 1) _7.Range
                             let mGetSetOpt, getSet = _8
                             if _2 then errorR(Error(FSComp.SR.parsMutableOnAutoPropertyShouldBeGetSet(),rhs parseState 3))
                             (fun attribs isStatic flags -> 
                                 [ SynMemberDefn.AutoProperty(attribs, isStatic, _4, _5, getSet, flags, doc, _3, _7, mGetSetOpt, mValDecl) ]) 
                   )
//# 1900 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'autoPropsDefnDecl));
//# 5955 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1910 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        None 
                   )
//# 1910 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_typ));
//# 5965 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1911 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                      Some _2 
                   )
//# 1911 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_typ));
//# 5976 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1915 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              let (LongIdentWithDots(lid,dotms)) = _3 in (None,LongIdentWithDots(ident(MangledGlobalName,rhs parseState 1) :: lid, rhs parseState 2 :: dotms)) 
                   )
//# 1915 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatternLongIdent));
//# 5987 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1916 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  (None,_1) 
                   )
//# 1916 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatternLongIdent));
//# 5998 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'access)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1917 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                         (Some(_1), _2) 
                   )
//# 1917 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatternLongIdent));
//# 6010 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1921 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       None 
                   )
//# 1921 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_access));
//# 6020 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'access)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1922 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  Some(_1) 
                   )
//# 1922 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_access));
//# 6031 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1926 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    SynAccess.Private 
                   )
//# 1926 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'access));
//# 6041 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1927 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    SynAccess.Public 
                   )
//# 1927 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'access));
//# 6051 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1928 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    SynAccess.Internal 
                   )
//# 1928 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'access));
//# 6061 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'access)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1932 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       Some(_1) 
                   )
//# 1932 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_declVisibility));
//# 6072 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1933 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       None 
                   )
//# 1933 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_declVisibility));
//# 6082 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'declEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1937 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                  Some(_2) 
                   )
//# 1937 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_interfaceImplDefn));
//# 6094 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1938 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                  None 
                   )
//# 1938 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_interfaceImplDefn));
//# 6104 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'classDefnBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'declEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1942 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                       _2 
                   )
//# 1942 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_classDefn));
//# 6116 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1943 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                       [] 
                   )
//# 1943 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_classDefn));
//# 6126 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'optBaseSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1949 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mDecl = unionRanges (rhs parseState 1) ((_2): SynType).Range 
                            SynMemberDefn.Inherit(_2,_3,mDecl) 
                   )
//# 1949 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'inheritsDefn));
//# 6139 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'optBaseSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1953 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mDecl = unionRanges (rhs parseState 1) _4.Range 
                            SynMemberDefn.ImplicitInherit(_2,_4,_5,mDecl) 
                   )
//# 1953 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'inheritsDefn));
//# 6154 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1957 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mDecl = (rhs parseState 1)
                            if not _2 then errorR(Error(FSComp.SR.parsTypeNameCannotBeEmpty(), mDecl))
                            SynMemberDefn.Inherit(SynType.LongIdent(LongIdentWithDots([], [])), None,mDecl) 
                   )
//# 1957 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'inheritsDefn));
//# 6167 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'asSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1962 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  Some(_1) 
                   )
//# 1962 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optAsSpec));
//# 6178 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1963 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  None 
                   )
//# 1963 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optAsSpec));
//# 6188 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1966 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    _2 
                   )
//# 1966 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'asSpec));
//# 6199 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'baseSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1970 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    Some(_1) 
                   )
//# 1970 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optBaseSpec));
//# 6210 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1971 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  None 
                   )
//# 1971 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optBaseSpec));
//# 6220 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1976 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if (_2).idText <> "base" then 
                                  errorR(Error(FSComp.SR.parsInheritDeclarationsCannotHaveAsBindings(),rhs2 parseState 1 2)) 
                             ident("base",rhs parseState 2) 
                   )
//# 1976 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'baseSpec));
//# 6233 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1981 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             errorR(Error(FSComp.SR.parsInheritDeclarationsCannotHaveAsBindings(),rhs2 parseState 1 2)) 
                             ident("base",rhs parseState 2) 
                   )
//# 1981 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'baseSpec));
//# 6244 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1988 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 1988 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationBlock));
//# 6256 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationMembers)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1991 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFileObjectMembers())
                             _2 
                   )
//# 1991 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationBlock));
//# 6269 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationMembers)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 1995 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 1995 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationBlock));
//# 6280 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationMember)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationMembers)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2001 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 @  _3 
                   )
//# 2001 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationMembers));
//# 6293 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationMember)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2004 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2004 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationMembers));
//# 6305 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberOrOverride)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberCore)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2010 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _3 None OverrideMemberFlags _1 
                   )
//# 2010 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationMember));
//# 6319 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberOrOverride)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'autoPropsDefnDecl)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2013 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _3 _1 false OverrideMemberFlags 
                   )
//# 2013 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationMember));
//# 6333 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberOrOverride)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2016 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 2016 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationMember));
//# 6345 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'memberCore)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_ODECLEND)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2019 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 2019 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objectImplementationMember));
//# 6358 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2023 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    
                   )
//# 2023 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberOrOverride));
//# 6368 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2024 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                      
                   )
//# 2024 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'memberOrOverride));
//# 6378 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2032 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            errorR(Error(FSComp.SR.parsUnexpectedQuotationOperatorInTypeAliasDidYouMeanVerbatimString(), rhs parseState 4)) 
                            SynTypeDefnSimpleRepr.TypeAbbrev (ParserDetail.ThereWereSignificantParseErrorsSoDoNotTypecheckThisNode, SynType.LongIdent(_3), unionRanges (rhs parseState 1) _3.Range)  
                   )
//# 2032 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypeDefnSimpleRepr));
//# 6395 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2037 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not (isNil _1) then errorR(Error(FSComp.SR.parsAttributesIllegalHere(),rhs parseState 1))
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsTypeAbbreviationsCannotHaveVisibilityDeclarations(),rhs parseState 2))
                            SynTypeDefnSimpleRepr.TypeAbbrev (ParserDetail.Ok, _3, unionRanges (rhs parseState 1) _3.Range) 
                   )
//# 2037 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypeDefnSimpleRepr));
//# 6410 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Choice<Ast.SynEnumCase, Ast.SynUnionCase> list)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2043 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not (isNil _1) then errorR(Error(FSComp.SR.parsAttributesIllegalHere(),rhs parseState 1))
                            let rangesOf3 = _3 |> List.map (function |Choice1Of2(ec)->ec.Range | Choice2Of2(uc)->uc.Range)
                            let mWhole = (rhs2 parseState 1 2, rangesOf3) ||> List.fold unionRanges 
                            if _3 |> List.exists (function Choice1Of2 _ -> true | _ -> false) then (
                                if Option.isSome _2 then errorR(Error(FSComp.SR.parsEnumTypesCannotHaveVisibilityDeclarations(),rhs parseState 2));
                                SynTypeDefnSimpleRepr.Enum (_3 |> List.choose (function 
                                                                   | Choice1Of2 data ->  
                                                                     Some(data) 
                                                                   | Choice2Of2(UnionCase(_,_,_,_,_,m)) -> 
                                                                     errorR(Error(FSComp.SR.parsAllEnumFieldsRequireValues(),m)); None),
                                                mWhole)
                            ) else 
                                SynTypeDefnSimpleRepr.Union (_2, 
                                                 _3 |> List.choose (function Choice2Of2 data -> Some(data) | Choice1Of2 _ -> failwith "huh?"),
                                                 mWhole) 
                   )
//# 2043 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypeDefnSimpleRepr));
//# 6437 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceFieldDeclList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2061 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not (isNil _1) then errorR(Error(FSComp.SR.parsAttributesIllegalHere(),rhs parseState 1))
                            SynTypeDefnSimpleRepr.Record (_2,_3,lhs parseState) 
                   )
//# 2061 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypeDefnSimpleRepr));
//# 6451 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declVisibility)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'inlineAssemblyTyconRepr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2066 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not (isNil _1) then errorR(Error(FSComp.SR.parsAttributesIllegalHere(),rhs parseState 1))
                            libraryOnlyError (lhs parseState)
                            if Option.isSome _2 then errorR(Error(FSComp.SR.parsInlineAssemblyCannotHaveVisibilityDeclarations(),rhs parseState 2))
                            _4 
                   )
//# 2066 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypeDefnSimpleRepr));
//# 6468 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdFieldDeclList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2075 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 2075 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceFieldDeclList));
//# 6480 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdFieldDeclList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2078 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBrace()) 
                            _2 
                   )
//# 2078 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceFieldDeclList));
//# 6493 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2082 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 2082 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceFieldDeclList));
//# 6504 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceBarFieldDeclListCore)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2086 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               _2,true 
                   )
//# 2086 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonRecdType));
//# 6515 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceBarFieldDeclListCore)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2088 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               _1,false 
                   )
//# 2088 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonRecdType));
//# 6526 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdFieldDeclList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bar_rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2093 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 2093 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarFieldDeclListCore));
//# 6538 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdFieldDeclList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2096 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBraceBar()) 
                            _2 
                   )
//# 2096 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarFieldDeclListCore));
//# 6551 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bar_rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2100 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 2100 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarFieldDeclListCore));
//# 6562 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'stringOrKeywordString)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2104 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            libraryOnlyError (lhs parseState)
                            let lhsm = lhs parseState 
                            SynTypeDefnSimpleRepr.LibraryOnlyILAssembly (ParseAssemblyCodeType _2 (rhs parseState 2),lhsm) 
                   )
//# 2104 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'inlineAssemblyTyconRepr));
//# 6575 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2109 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     TyconClass 
                   )
//# 2109 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classOrInterfaceOrStruct));
//# 6585 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2110 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     TyconInterface 
                   )
//# 2110 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classOrInterfaceOrStruct));
//# 6595 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2111 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     TyconStruct 
                   )
//# 2111 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classOrInterfaceOrStruct));
//# 6605 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2114 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 2114 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interfaceMember));
//# 6615 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2115 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                
                   )
//# 2115 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'interfaceMember));
//# 6625 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2119 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [], _2.Lid,false,[],_1,grabXmlDoc(parseState,2) 
                   )
//# 2119 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconNameAndTyparDecls));
//# 6637 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'prefixTyparDecls)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2122 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2, _3.Lid,false,[],_1,grabXmlDoc(parseState,2) 
                   )
//# 2122 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconNameAndTyparDecls));
//# 6650 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'postfixTyparDecls)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2125 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let tps,tpcs = _3 
                             tps, _2.Lid,true,tpcs,_1,grabXmlDoc(parseState,2) 
                   )
//# 2125 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tyconNameAndTyparDecls));
//# 6664 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2129 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 [ TyparDecl([],_1) ] 
                   )
//# 2129 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'prefixTyparDecls));
//# 6675 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarDeclList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2130 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                        List.rev _2 
                   )
//# 2130 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'prefixTyparDecls));
//# 6687 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarDeclList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarDecl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2133 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                         _3 :: _1 
                   )
//# 2133 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typarDeclList));
//# 6699 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarDecl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2134 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     [_1] 
                   )
//# 2134 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typarDeclList));
//# 6710 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2138 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             TyparDecl(_1,_2) 
                   )
//# 2138 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typarDecl));
//# 6722 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_TYAPP)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarDeclList)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_typeConstraints)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2144 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _2 then warning(Error(FSComp.SR.parsNonAdjacentTypars(),rhs2 parseState 2 5))
                             List.rev _3, _4 
                   )
//# 2144 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'postfixTyparDecls));
//# 6738 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarDeclList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2151 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (List.rev _1,true) 
                   )
//# 2151 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'explicitValTyparDeclsCore));
//# 6749 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarDeclList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2153 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (List.rev _1,false) 
                   )
//# 2153 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'explicitValTyparDeclsCore));
//# 6760 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2155 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             ([],false) 
                   )
//# 2155 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'explicitValTyparDeclsCore));
//# 6770 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_TYAPP)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'explicitValTyparDeclsCore)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_typeConstraints)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2159 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _2 then warning(Error(FSComp.SR.parsNonAdjacentTypars(),rhs2 parseState 2 5))
                             let tps,flex = _3 
                             SynValTyparDecls(tps,flex,_4) 
                   )
//# 2159 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'explicitValTyparDecls));
//# 6787 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'explicitValTyparDecls)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2165 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2165 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_explicitValTyparDecls));
//# 6798 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2167 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynValTyparDecls([],true,[]) 
                   )
//# 2167 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_explicitValTyparDecls));
//# 6808 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'explicitValTyparDecls)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2171 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some _1 
                   )
//# 2171 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_explicitValTyparDecls2));
//# 6819 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2173 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             None 
                   )
//# 2173 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_explicitValTyparDecls2));
//# 6829 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2179 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 2179 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_typeConstraints));
//# 6839 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2181 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            List.rev _2 
                   )
//# 2181 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_typeConstraints));
//# 6850 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeConstraints)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeConstraint)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2186 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                              _3 :: _1 
                   )
//# 2186 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraints));
//# 6862 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeConstraint)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2187 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          [_1] 
                   )
//# 2187 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraints));
//# 6873 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2193 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             libraryOnlyError (lhs parseState); WhereTyparDefaultsToType(_2,_4,lhs parseState) 
                   )
//# 2193 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6885 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2196 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             WhereTyparSubtypeOfType(_1,_3,lhs parseState) 
                   )
//# 2196 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6897 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2199 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             WhereTyparIsValueType(_1,lhs parseState) 
                   )
//# 2199 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6908 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2202 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if _3 <> "not" then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedIdentifier(_3))  
                             WhereTyparIsReferenceType(_1,lhs parseState) 
                   )
//# 2202 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6921 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2206 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             WhereTyparSupportsNull(_1,lhs parseState) 
                   )
//# 2206 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6932 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfn)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2209 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let tp = _1
                             WhereTyparSupportsMember([ SynType.Var(tp, tp.Range) ],_4,lhs parseState) 
                   )
//# 2209 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6946 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarAlts)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfn)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2213 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             WhereTyparSupportsMember(List.rev(_2),_6,lhs parseState) 
                   )
//# 2213 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6960 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : range * range option * Ast.SynType list * range list * range)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2216 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let _ltm,_gtm,args,_commas,mWhole = _4 in WhereTyparIsDelegate(_1, args, unionRanges _1.Range mWhole) 
                   )
//# 2216 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6972 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : range * range option * Ast.SynType list * range list * range)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2219 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             match _3 with 
                             | "enum" -> let _ltm,_gtm,args,_commas,mWhole = _4 in WhereTyparIsEnum(_1, args, unionRanges _1.Range mWhole)
                             | nm -> raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedIdentifier(nm)) 
                   )
//# 2219 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 6987 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2224 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             match _3 with 
                             | "comparison" -> WhereTyparIsComparable(_1,lhs parseState)
                             | "equality" -> WhereTyparIsEquatable(_1,lhs parseState)
                             | "unmanaged" -> WhereTyparIsUnmanaged(_1,lhs parseState)
                             | nm -> raiseParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedIdentifier(nm)) 
                   )
//# 2224 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeConstraint));
//# 7003 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typarAlts)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2231 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                  _3 :: _1 
                   )
//# 2231 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typarAlts));
//# 7015 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2232 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     [_1] 
                   )
//# 2232 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typarAlts));
//# 7026 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'barAndgrabXmlDoc)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'attrUnionCaseDecls)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2239 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 _1 
                   )
//# 2239 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Choice<Ast.SynEnumCase, Ast.SynUnionCase> list));
//# 7038 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'firstUnionCaseDeclOfMany)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'barAndgrabXmlDoc)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'attrUnionCaseDecls)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2242 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _3 _2 
                   )
//# 2242 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Choice<Ast.SynEnumCase, Ast.SynUnionCase> list));
//# 7051 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'firstUnionCaseDecl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2245 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 2245 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Choice<Ast.SynEnumCase, Ast.SynUnionCase> list));
//# 7062 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2248 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               grabXmlDoc(parseState,1) 
                   )
//# 2248 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'barAndgrabXmlDoc));
//# 7072 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attrUnionCaseDecl)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'barAndgrabXmlDoc)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'attrUnionCaseDecls)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2251 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                  (fun xmlDoc -> _1 xmlDoc  :: _3 _2) 
                   )
//# 2251 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attrUnionCaseDecls));
//# 7085 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attrUnionCaseDecl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2252 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                             (fun xmlDoc -> [ _1 xmlDoc ]) 
                   )
//# 2252 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attrUnionCaseDecls));
//# 7096 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseName)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2257 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsUnionCasesCannotHaveVisibilityDeclarations(),rhs parseState 2))
                             let mDecl = rhs parseState 3
                             (fun xmlDoc -> Choice2Of2 (UnionCase ( _1, _3,UnionCaseFields [],xmlDoc,None,mDecl))) 
                           
                   )
//# 2257 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attrUnionCaseDecl));
//# 7113 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseName)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseRepr)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2263 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsUnionCasesCannotHaveVisibilityDeclarations(),rhs parseState 2))
                             let mDecl = rhs2 parseState 3 5
                             (fun xmlDoc -> Choice2Of2 (UnionCase ( _1, _3,UnionCaseFields _5,xmlDoc,None,mDecl))) 
                           
                   )
//# 2263 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attrUnionCaseDecl));
//# 7131 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseName)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'topType)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2269 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsUnionCasesCannotHaveVisibilityDeclarations(),rhs parseState 2))
                             libraryOnlyWarning(lhs parseState)
                             let mDecl = rhs2 parseState 3 5
                             (fun xmlDoc -> Choice2Of2 (UnionCase ( _1, _3,UnionCaseFullType _5,xmlDoc,None,mDecl))) 
                           
                   )
//# 2269 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attrUnionCaseDecl));
//# 7150 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseName)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'constant)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2276 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if Option.isSome _2 then errorR(Error(FSComp.SR.parsEnumFieldsCannotHaveVisibilityDeclarations(),rhs parseState 2))
                             let mDecl = rhs2 parseState 3 5
                             (fun xmlDoc -> Choice1Of2 (EnumCase ( _1, _3,_5,xmlDoc,mDecl))) 
                           
                   )
//# 2276 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attrUnionCaseDecl));
//# 7168 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2284 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2284 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseName));
//# 7179 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2287 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              ident(opNameCons,rhs parseState 2) 
                   )
//# 2287 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseName));
//# 7190 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2290 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              ident(opNameNil,rhs2 parseState 2 3) 
                   )
//# 2290 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseName));
//# 7201 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2294 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Choice2Of2 (UnionCase ( [], _1,UnionCaseFields [],PreXmlDoc.Empty,None,rhs parseState 1)) 
                   )
//# 2294 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'firstUnionCaseDeclOfMany));
//# 7213 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'constant)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2297 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Choice1Of2 (EnumCase ([],_1,_3,PreXmlDoc.Empty,rhs2 parseState 1 3)) 
                   )
//# 2297 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'firstUnionCaseDeclOfMany));
//# 7226 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'firstUnionCaseDecl)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2300 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2300 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'firstUnionCaseDeclOfMany));
//# 7238 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseRepr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2304 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            Choice2Of2 (UnionCase ( [],_1,UnionCaseFields _3,PreXmlDoc.Empty,None,rhs2 parseState 1 3)) 
                   )
//# 2304 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'firstUnionCaseDecl));
//# 7250 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'constant)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2307 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Choice1Of2 (EnumCase ([],_1,_3,PreXmlDoc.Empty,rhs2 parseState 1 3))  
                   )
//# 2307 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'firstUnionCaseDecl));
//# 7263 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseReprElement)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseReprElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2310 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                           _1 :: _3 
                   )
//# 2310 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseReprElements));
//# 7275 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseReprElement)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2311 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                [_1] 
                   )
//# 2311 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseReprElements));
//# 7286 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2314 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               mkNamedField(_1, _3) 
                   )
//# 2314 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseReprElement));
//# 7298 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2315 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   mkAnonField _1 
                   )
//# 2315 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseReprElement));
//# 7309 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceFieldDeclList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2319 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            errorR(Deprecated(FSComp.SR.parsConsiderUsingSeparateRecordType(),lhs parseState)) 
                            _1 
                   )
//# 2319 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseRepr));
//# 7321 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseReprElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2323 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 2323 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'unionCaseRepr));
//# 7332 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdFieldDecl)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdFieldDeclList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2328 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _3 
                   )
//# 2328 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdFieldDeclList));
//# 7345 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdFieldDecl)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2331 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 2331 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdFieldDeclList));
//# 7357 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'fieldDecl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2336 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let fld = _2 _1 false 
                            let (Field(a,b,c,d,e,f,vis,g)) = fld 
                            if Option.isSome vis then errorR(Error(FSComp.SR.parsRecordFieldsCannotHaveVisibilityDeclarations(),rhs parseState 2))
                            Field(a,b,c,d,e,f,None,g)  
                   )
//# 2336 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdFieldDecl));
//# 7372 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_mutable)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2344 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mRhs = rhs2 parseState 3 5 
                            let xmlDoc = grabXmlDoc(parseState,3)
                            (fun attrs stat -> Field(attrs, stat,Some _3,_5,_1,xmlDoc,_2,mRhs)) 
                   )
//# 2344 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'fieldDecl));
//# 7388 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExceptionDefnRepr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_classDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2352 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExceptionDefn(_1,_2, (_1.Range,_2) ||> unionRangeWithListBy (fun cd -> cd.Range) ) 
                   )
//# 2352 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExceptionDefn));
//# 7400 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2356 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     grabXmlDoc(parseState,1) 
                   )
//# 2356 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'exceptionAndGrabDoc));
//# 7410 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'exceptionAndGrabDoc)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'exconIntro)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'exconRepr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2361 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExceptionDefnRepr(_2,_4,_5,_1,_3,(match _5 with None -> rhs2 parseState 1 4 | Some p -> unionRanges (rangeOfLongIdent p) (rhs2 parseState 1 4))) 
                   )
//# 2361 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExceptionDefnRepr));
//# 7425 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2366 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             UnionCase ( [], _1,UnionCaseFields [],PreXmlDoc.Empty,None,lhs parseState) 
                   )
//# 2366 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'exconIntro));
//# 7436 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'unionCaseRepr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2369 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             UnionCase ( [], _1,UnionCaseFields _3,PreXmlDoc.Empty,None,lhs parseState) 
                   )
//# 2369 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'exconIntro));
//# 7448 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2372 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       None 
                   )
//# 2372 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'exconRepr));
//# 7458 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2373 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       Some (_2.Lid) 
                   )
//# 2373 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'exconRepr));
//# 7469 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2376 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     _2 
                   )
//# 2376 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 7480 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_rec)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'localBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2385 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mLetKwd = rhs parseState 1 
                             let isUse = _1
                             let isRec = _2 
                             let localBindingsLastRangeOpt, localBindingsBuilder = _3
                             
                             // Calculate the precise range of the binding set, up to the end of the last r.h.s. expression
                             let bindingSetRange = 
                                 match localBindingsLastRangeOpt with 
                                 | None -> rhs2 parseState 1 2 (* there was some error - this will be an approximate range *)
                                 | Some lastRange -> unionRanges mLetKwd lastRange
                             // The first binding swallows any attributes prior to the 'let'
                             BindingSetPreAttrs(mLetKwd,isRec,isUse,
                                 (fun attrs vis -> 
                                     // apply the builder
                                     let binds = localBindingsBuilder attrs vis mLetKwd
                                     if not isRec && not (isNilOrSingleton binds) then 
                                           reportParseErrorAt mLetKwd (FSComp.SR.parsLetAndForNonRecBindings())
                                     [],binds), 
                                 bindingSetRange) 
                   )
//# 2385 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'defnBindings));
//# 7511 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cPrototype)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2407 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let bindRange = lhs parseState
                             BindingSetPreAttrs(bindRange, false,false,_1,bindRange)  
                   )
//# 2407 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'defnBindings));
//# 7523 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2414 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mDoKwd = rhs parseState 1 
                             let mWhole = unionRanges mDoKwd _2.Range
                             // any attributes prior to the 'let' are left free, e.g. become top-level attributes 
                             // associated with the module, 'main' function or assembly depending on their target 
                             BindingSetPreAttrs(mDoKwd,false,false,(fun attrs vis -> attrs,[mkSynDoBinding (vis,true,_2,mWhole)]), mWhole) 
                   )
//# 2414 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'doBinding));
//# 7538 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_rec)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'localBindings)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteDefnBindingsTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2424 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mLetKwd = rhs parseState 1 
                             let isUse = _1
                             let isRec = _2
                             _4 (if isUse then "use" else "let") mLetKwd  // report unterminated error 
                             
                             let localBindingsLastRangeOpt, localBindingsBuilder = _3
                             
                             // Calculate the precise range of the binding set, up to the end of the last r.h.s. expression
                             let bindingSetRange = 
                                 match localBindingsLastRangeOpt with 
                                 | None -> rhs parseState 1 (* there was some error - this will be an approximate range *)
                                 | Some lastRange -> unionRanges mLetKwd lastRange
                             // the first binding swallow any attributes prior to the 'let' 
                             BindingSetPreAttrs(mLetKwd,isRec,isUse,
                               (fun attrs vis ->
                                 let binds = localBindingsBuilder attrs vis mLetKwd
                                 if not isRec && not (isNilOrSingleton binds) then
                                     reportParseErrorAt mLetKwd (FSComp.SR.parsLetAndForNonRecBindings())
                                 [],binds),
                               bindingSetRange), (unionRanges mLetKwd bindingSetRange) 
                   )
//# 2424 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hardwhiteLetBindings));
//# 7571 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteDefnBindingsTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2450 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mLetKwd = rhs parseState 1 
                             let bindingSetRange = unionRanges mLetKwd _2.Range 
                             let seqPt = NoSequencePointAtDoBinding 
                             // any attributes prior to the 'let' are left free, e.g. become top-level attributes 
                             // associated with the module, 'main' function or assembly depending on their target 
                             BindingSetPreAttrs(mLetKwd,false,false,(fun attrs vis -> attrs,[mkSynDoBinding (vis,true,_2,bindingSetRange)]),bindingSetRange), _2 
                   )
//# 2450 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hardwhiteDoBinding));
//# 7588 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'defnBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2460 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        _1 
                   )
//# 2460 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBindings));
//# 7599 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'doBinding)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2461 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     _1 
                   )
//# 2461 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBindings));
//# 7610 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteLetBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2462 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                let b,m = _1 in b 
                   )
//# 2462 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBindings));
//# 7621 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteDoBinding)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2463 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               fst _1 
                   )
//# 2463 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'classDefnBindings));
//# 7632 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2469 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (fun _ m -> ()) 
                   )
//# 2469 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hardwhiteDefnBindingsTerminator));
//# 7642 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2471 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (fun kwd m -> reportParseErrorAt m (match kwd with 
                                                                | "let!" -> FSComp.SR.parsUnmatchedLetBang() 
                                                                | "use!" -> FSComp.SR.parsUnmatchedUseBang() 
                                                                | "use" -> FSComp.SR.parsUnmatchedUse() 
                                                                | _ (*"let" *) -> FSComp.SR.parsUnmatchedLet()))  
                   )
//# 2471 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'hardwhiteDefnBindingsTerminator));
//# 7657 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'cRetType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_access)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : 'cArgs)) in
            let _8 = (let data = parseState.GetInput(8) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2480 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let rty,vis,nm,args  = _2,_3,_4,_7 
                             let xmlDoc = grabXmlDoc(parseState,1) 
                             let nmm = rhs parseState 3 
                             let argsm = rhs parseState 6 
                             let mBindLhs = lhs parseState
                             let mWhole = lhs parseState
                             let mRhs = lhs parseState 
                             let rhsExpr = SynExpr.App (ExprAtomicFlag.NonAtomic,
                                                       false, 
                                                       SynExpr.Ident (ident("failwith",rhs parseState 6)),
                                                       SynExpr.Const (SynConst.String("extern was not given a DllImport attribute",rhs parseState 8),rhs parseState 8),
                                                       mRhs)
                             (fun attrs vis -> 
                                 let bindingId = SynPat.LongIdent (LongIdentWithDots([nm],[]), None, Some noInferredTypars, SynConstructorArgs.Pats [SynPat.Tuple(false,args,argsm)], vis, nmm)
                                 let binding = mkSynBinding 
                                                   (xmlDoc, bindingId) 
                                                   (vis, false, false, mBindLhs, NoSequencePointAtInvisibleBinding, Some rty, rhsExpr, mRhs, [], attrs, None)
                                 [], [binding]) 
                   )
//# 2480 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cPrototype));
//# 7690 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cMoreArgs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2502 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            List.rev _1 
                   )
//# 2502 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cArgs));
//# 7701 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2505 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 2505 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cArgs));
//# 7712 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2507 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 2507 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cArgs));
//# 7722 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cMoreArgs)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'cArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2513 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _3 :: _1 
                   )
//# 2513 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cMoreArgs));
//# 7734 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cArg)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'cArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2516 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_3; _1] 
                   )
//# 2516 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cMoreArgs));
//# 7746 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'cType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2522 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState in SynPat.Typed(SynPat.Wild m,_2,m) |> addAttribs _1 
                   )
//# 2522 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cArg));
//# 7758 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'cType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2525 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState in SynPat.Typed(SynPat.Named (SynPat.Wild m,_3,false,None,m),_2,m) |> addAttribs _1 
                   )
//# 2525 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cArg));
//# 7771 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2530 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = _1.Range
                            SynType.App(SynType.LongIdent(_1),None,[],[],None,false,m) 
                   )
//# 2530 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cType));
//# 7783 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cType)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2534 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            SynType.App(SynType.LongIdent(LongIdentWithDots([ident("[]",m)],[])),None,[_1],[],None,true,m) 
                   )
//# 2534 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cType));
//# 7796 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2538 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            SynType.App(SynType.LongIdent(LongIdentWithDots([ident("nativeptr",m)],[])),None,[_1],[],None,true,m) 
                   )
//# 2538 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cType));
//# 7808 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2542 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            SynType.App(SynType.LongIdent(LongIdentWithDots([ident("byref",m)],[])),None,[_1],[],None,true,m) 
                   )
//# 2542 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cType));
//# 7820 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2546 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = lhs parseState 
                            SynType.App(SynType.LongIdent(LongIdentWithDots([ident("nativeint",m)],[])),None,[],[],None,true,m) 
                   )
//# 2546 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cType));
//# 7831 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'cType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2553 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynReturnInfo((_2,SynArgInfo(_1,false,None)),rhs parseState 2) 
                   )
//# 2553 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cRetType));
//# 7843 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2556 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = rhs parseState 2 
                            SynReturnInfo((SynType.App(SynType.LongIdent(LongIdentWithDots([ident("unit",m)],[])),None,[],[],None,false,m),SynArgInfo(_1,false,None)),m) 
                   )
//# 2556 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'cRetType));
//# 7855 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attr_localBinding)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moreLocalBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2562 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let (moreBindings, moreBindingRanges) = List.unzip _2
                             let moreLocalBindingsLastRange = if moreBindingRanges.IsEmpty then None else Some (List.last moreBindingRanges)
                             match _1 with 
                             | Some (localBindingRange,attrLocalBindingBuilder) -> 
                                let lastRange = 
                                    match moreLocalBindingsLastRange with 
                                    | None -> localBindingRange 
                                    | Some m -> m
                                Some lastRange, (fun attrs vis mLetKwd -> attrLocalBindingBuilder attrs vis mLetKwd true ::  moreBindings)
                             | None -> 
                                moreLocalBindingsLastRange, (fun _attrs _vis _letm -> moreBindings) 
                   )
//# 2562 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'localBindings));
//# 7877 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'attr_localBinding)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moreLocalBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2577 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mLetKwd = rhs parseState 1
                             (match _2 with 
                              | Some (localBindingRange,attrLocalBindingBuilder) -> (attrLocalBindingBuilder [] None mLetKwd false,localBindingRange) :: _3 
                              | None -> _3) 
                   )
//# 2577 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moreLocalBindings));
//# 7892 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2583 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 2583 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moreLocalBindings));
//# 7902 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'localBinding)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2589 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let attrs2 = _1
                             let localBindingRange,localBindingBuilder = _2
                             let attrLocalBindingBuilder = (fun attrs vis mLetKwd _ -> localBindingBuilder (attrs@attrs2) vis mLetKwd)
                             Some(localBindingRange,attrLocalBindingBuilder) 
                   )
//# 2589 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attr_localBinding));
//# 7917 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2595 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             None 
                   )
//# 2595 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'attr_localBinding));
//# 7927 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_mutable)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bindingPattern)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topReturnTypeWithTypeConstraints)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedExprWithStaticOptimizationsBlock)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2601 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let (expr:SynExpr),opts = _6
                             let eqm = rhs parseState 5 
                             let mRhs = expr.Range 
                             let optReturnType = _4 
                             let bindingBuilder, mBindLhs = _3 
                             let localBindingRange = unionRanges (rhs2 parseState 3 5) mRhs
                             let localBindingBuilder = 
                               (fun attrs vis mLetKwd -> 
                                 let mWhole = unionRanges mLetKwd mRhs
                                 let spBind = if IsControlFlowExpression expr then NoSequencePointAtLetBinding else SequencePointAtBinding(mWhole)
                                 bindingBuilder (vis,_1,_2,mBindLhs,spBind,optReturnType,expr,mRhs,opts,attrs,None))
                             localBindingRange,localBindingBuilder 
                   )
//# 2601 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'localBinding));
//# 7953 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_mutable)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bindingPattern)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topReturnTypeWithTypeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2615 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mWhole = rhs2 parseState 3 5 
                             let mRhs = rhs parseState 5
                             let optReturnType = _4 
                             let bindingBuilder,mBindLhs = _3 
                             let localBindingBuilder = 
                               (fun attrs vis mLetKwd -> 
                                 let spBind = SequencePointAtBinding(unionRanges mLetKwd mRhs)
                                 let eqm = rhs parseState 5
                                 let zeroWidthAtEnd = eqm.EndRange
                                 bindingBuilder (vis,_1,_2,mBindLhs,spBind,optReturnType,arbExpr("localBinding1",zeroWidthAtEnd),mRhs,[],attrs,None))  
                             mWhole,localBindingBuilder 
                   )
//# 2615 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'localBinding));
//# 7977 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inline)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_mutable)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bindingPattern)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topReturnTypeWithTypeConstraints)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2628 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _5 then reportParseErrorAt (rhs parseState 5) (FSComp.SR.parsUnexpectedEndOfFileDefinition())
                             let optReturnType = _4 
                             let mWhole = match optReturnType with None -> rhs parseState 3 | Some _ -> rhs2 parseState 3 4
                             let mRhs = mWhole.EndRange  // zero-width range at end of last good token
                             let bindingBuilder,mBindLhs = _3 
                             let localBindingBuilder = 
                               (fun attrs vis mLetKwd -> 
                                 let spBind = SequencePointAtBinding(unionRanges mLetKwd mRhs)
                                 bindingBuilder (vis,_1,_2,mBindLhs,spBind,optReturnType,arbExpr("localBinding2",mRhs),mRhs,[],attrs,None))  
                             mWhole,localBindingBuilder 
                   )
//# 2628 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'localBinding));
//# 8001 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedExprWithStaticOptimizations)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2643 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 2643 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedExprWithStaticOptimizationsBlock));
//# 8013 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedExprWithStaticOptimizations)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2646 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFile())
                             let a,b = _2
                             (exprFromParseError a, b) 
                   )
//# 2646 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedExprWithStaticOptimizationsBlock));
//# 8027 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedExprWithStaticOptimizations)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2651 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2651 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedExprWithStaticOptimizationsBlock));
//# 8038 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_staticOptimizations)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2654 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                _1, List.rev _2 
                   )
//# 2654 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedExprWithStaticOptimizations));
//# 8050 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_staticOptimizations)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticOptimization)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2657 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                      _2 :: _1 
                   )
//# 2657 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_staticOptimizations));
//# 8062 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2658 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           [] 
                   )
//# 2658 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_staticOptimizations));
//# 8072 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticOptimizationConditions)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2661 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                      (_2,_4) 
                   )
//# 2661 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticOptimization));
//# 8084 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticOptimizationConditions)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticOptimizationCondition)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2664 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                        _3 :: _1 
                   )
//# 2664 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticOptimizationConditions));
//# 8096 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticOptimizationCondition)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2665 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                       [_1 ] 
                   )
//# 2665 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticOptimizationConditions));
//# 8107 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2668 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           WhenTyparTyconEqualsTycon(_1,_3,lhs parseState) 
                   )
//# 2668 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticOptimizationCondition));
//# 8119 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2669 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        WhenTyparIsStruct(_1,lhs parseState) 
                   )
//# 2669 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticOptimizationCondition));
//# 8130 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : sbyte * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2672 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                if snd _1 then errorR(Error(FSComp.SR.lexOutsideEightBitSigned(), lhs parseState))
                                SynConst.SByte (fst _1) 
                   )
//# 2672 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8142 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : byte)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2674 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 SynConst.Byte _1 
                   )
//# 2674 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8153 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int16 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2675 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 if snd _1 then errorR(Error(FSComp.SR.lexOutsideSixteenBitSigned(), lhs parseState))
                                 SynConst.Int16 (fst _1) 
                   )
//# 2675 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8165 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : uint16)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2677 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  SynConst.UInt16 _1 
                   )
//# 2677 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8176 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2678 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 if snd _1 then errorR(Error(FSComp.SR.lexOutsideThirtyTwoBitSigned(), lhs parseState))
                                 SynConst.Int32 (fst _1) 
                   )
//# 2678 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8188 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : uint32)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2680 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  SynConst.UInt32 _1 
                   )
//# 2680 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8199 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int64 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2681 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 if snd _1 then errorR(Error(FSComp.SR.lexOutsideSixtyFourBitSigned(), lhs parseState))
                                 SynConst.Int64 (fst _1) 
                   )
//# 2681 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8211 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : uint64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2683 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  SynConst.UInt64 _1 
                   )
//# 2683 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8222 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2684 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     SynConst.IntPtr _1 
                   )
//# 2684 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8233 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : uint64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2685 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                      SynConst.UIntPtr _1 
                   )
//# 2685 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8244 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : single)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2686 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  SynConst.Single _1 
                   )
//# 2686 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8255 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : double)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2687 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  SynConst.Double _1 
                   )
//# 2687 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8266 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : char)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2688 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                SynConst.Char _1 
                   )
//# 2688 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8277 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : System.Decimal)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2689 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   SynConst.Decimal _1 
                   )
//# 2689 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8288 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : (string * string))) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2690 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  SynConst.UserNum _1 
                   )
//# 2690 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8299 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'stringOrKeywordString)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2691 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                 SynConst.String (_1,lhs parseState) 
                   )
//# 2691 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8310 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : byte[])) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2692 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     SynConst.Bytes (_1,lhs parseState) 
                   )
//# 2692 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rawConstant));
//# 8321 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2696 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if _2 <> "/" then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnexpectedOperatorForUnitOfMeasure())
                           if fst _3 = 0 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsIllegalDenominatorForMeasureExponent())
                           if (snd _1) || (snd _3) then errorR(Error(FSComp.SR.lexOutsideThirtyTwoBitSigned(), lhs parseState))
                           SynRationalConst.Rational(fst _1, fst _3, lhs parseState) 
                   )
//# 2696 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rationalConstant));
//# 8337 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2702 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if _3 <> "/" then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedOperatorForUnitOfMeasure())
                           if fst _4 = 0 then reportParseErrorAt (rhs parseState 4) (FSComp.SR.parsIllegalDenominatorForMeasureExponent())
                           if (snd _2) || (snd _4) then errorR(Error(FSComp.SR.lexOutsideThirtyTwoBitSigned(), lhs parseState))
                           SynRationalConst.Negate(SynRationalConst.Rational(fst _2, fst _4, lhs parseState)) 
                   )
//# 2702 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rationalConstant));
//# 8353 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2707 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 if snd _1 then errorR(Error(FSComp.SR.lexOutsideThirtyTwoBitSigned(), lhs parseState))
                                 SynRationalConst.Integer(fst _1) 
                   )
//# 2707 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rationalConstant));
//# 8365 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2710 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       if snd _2 then errorR(Error(FSComp.SR.lexOutsideThirtyTwoBitSigned(), lhs parseState))
                                       SynRationalConst.Negate(SynRationalConst.Integer(fst _2)) 
                   )
//# 2710 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rationalConstant));
//# 8377 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2714 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 if snd _1 then errorR(Error(FSComp.SR.lexOutsideThirtyTwoBitSigned(), lhs parseState))
                                 SynRationalConst.Integer(fst _1) 
                   )
//# 2714 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicUnsignedRationalConstant));
//# 8389 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'rationalConstant)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2718 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           _2 
                   )
//# 2718 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicUnsignedRationalConstant));
//# 8401 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicUnsignedRationalConstant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2721 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                          _1 
                   )
//# 2721 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicRationalConstant));
//# 8412 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicUnsignedRationalConstant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2724 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           SynRationalConst.Negate(_2) 
                   )
//# 2724 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicRationalConstant));
//# 8423 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'rawConstant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2727 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       _1 
                   )
//# 2727 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constant));
//# 8434 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'rawConstant)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2728 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                            SynConst.Measure(_1, _3) 
                   )
//# 2728 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constant));
//# 8446 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2732 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              let xmlDoc = grabXmlDoc(parseState,1)
                              mkSynBinding (xmlDoc,_1), rhs parseState 1 
                   )
//# 2732 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'bindingPattern));
//# 8458 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2738 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynSimplePat.Id (_1,None,false,false,false,rhs parseState 1) 
                   )
//# 2738 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePattern));
//# 8469 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2740 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynSimplePat.Id (_2,None,false,false,true,rhs parseState 2) 
                   )
//# 2740 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePattern));
//# 8480 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeWithTypeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2742 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let lhsm = lhs parseState 
                             SynSimplePat.Typed(_1,_3,lhsm) 
                   )
//# 2742 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePattern));
//# 8493 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2745 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let lhsm = lhs parseState 
                             SynSimplePat.Attrib(_2,_1,lhsm) 
                   )
//# 2745 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePattern));
//# 8506 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2750 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [_1] 
                   )
//# 2750 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePatternCommaList));
//# 8517 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePatternCommaList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2752 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 :: _3 
                   )
//# 2752 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePatternCommaList));
//# 8529 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePatternCommaList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2756 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 2756 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePatterns));
//# 8541 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2758 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 2758 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePatterns));
//# 8552 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'simplePatternCommaList)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2760 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen()) 
                             [] 
                   )
//# 2760 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePatterns));
//# 8565 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2763 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (* silent recovery *) [] 
                   )
//# 2763 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePatterns));
//# 8576 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2765 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen()) 
                             [] 
                   )
//# 2765 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'simplePatterns));
//# 8588 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2771 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Named (_1,_3,false,None,rhs2 parseState 1 3) 
                   )
//# 2771 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynPat));
//# 8600 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2773 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Or(_1,_3,rhs2 parseState 1 3) 
                   )
//# 2773 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynPat));
//# 8612 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2775 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.LongIdent (LongIdentWithDots(mkSynCaseName (rhs parseState 2) opNameCons,[]), None, None, SynConstructorArgs.Pats [SynPat.Tuple (false,[_1;_3],rhs2 parseState 1 3)],None,lhs parseState) 
                   )
//# 2775 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynPat));
//# 8624 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tuplePatternElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2777 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Tuple(false,List.rev _1, lhs parseState) 
                   )
//# 2777 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynPat));
//# 8635 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'conjPatternElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2779 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Ands(List.rev _1, lhs parseState) 
                   )
//# 2779 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynPat));
//# 8646 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'constrPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2781 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2781 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynPat));
//# 8657 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tuplePatternElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2785 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 
                   )
//# 2785 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tuplePatternElements));
//# 8669 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2787 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 :: [] 
                   )
//# 2787 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tuplePatternElements));
//# 8681 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'conjPatternElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2791 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 
                   )
//# 2791 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'conjPatternElements));
//# 8693 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2793 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 :: [] 
                   )
//# 2793 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'conjPatternElements));
//# 8705 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'namePatPair)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2796 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                 [_1], lhs parseState 
                   )
//# 2796 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namePatPairs));
//# 8717 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'namePatPair)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'namePatPairs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2797 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                          let (rs, _) = _3 in (_1 :: rs), lhs parseState 
                   )
//# 2797 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namePatPairs));
//# 8730 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2800 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                      (_1, _3) 
                   )
//# 2800 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'namePatPair));
//# 8742 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatternLongIdent)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'explicitValTyparDecls)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2804 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let vis,lid = _1 in SynPat.LongIdent (lid,None,Some _2, SynConstructorArgs.Pats [],vis,lhs parseState) 
                   )
//# 2804 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constrPattern));
//# 8754 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatternLongIdent)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_explicitValTyparDecls2)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatsOrNamePatPairs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2806 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let vis,lid = _1 in SynPat.LongIdent (lid,None,_2, _3,vis,lhs parseState) 
                   )
//# 2806 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constrPattern));
//# 8767 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatternLongIdent)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_explicitValTyparDecls2)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatsOrNamePatPairs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2808 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let vis,lid = _1 in SynPat.LongIdent (lid,None,_2, _4,vis,lhs parseState) 
                   )
//# 2808 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constrPattern));
//# 8780 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatternLongIdent)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_explicitValTyparDecls2)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatsOrNamePatPairs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2810 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let vis,lid = _1 in SynPat.LongIdent (lid,None,_2, _4,vis,lhs parseState) 
                   )
//# 2810 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constrPattern));
//# 8793 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeOrAnonRecdType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2812 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.IsInst(_2,lhs parseState) 
                   )
//# 2812 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constrPattern));
//# 8804 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2814 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2814 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'constrPattern));
//# 8815 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'namePatPairs)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2817 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                      SynConstructorArgs.NamePatPairs _2 
                   )
//# 2817 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatsOrNamePatPairs));
//# 8827 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2818 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          SynConstructorArgs.Pats _1 
                   )
//# 2818 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatsOrNamePatPairs));
//# 8838 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2822 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 :: _2 
                   )
//# 2822 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatterns));
//# 8850 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2824 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsSuccessivePatternsShouldBeSpacedOrTupled())
                             _1 :: _3 
                   )
//# 2824 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatterns));
//# 8863 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2827 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsSuccessivePatternsShouldBeSpacedOrTupled())
                             _1 :: _3 
                   )
//# 2827 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatterns));
//# 8876 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2829 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                         [_1] 
                   )
//# 2829 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPatterns));
//# 8887 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'quoteExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2834 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.QuoteExpr(_1,lhs parseState) 
                   )
//# 2834 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8898 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : char)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : char)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2835 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                             SynPat.DeprecatedCharRange (_1,_3,rhs2 parseState 1 3) 
                   )
//# 2835 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8910 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordPatternElementsAux)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2837 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let rs,m = _2 in SynPat.Record (rs,m) 
                   )
//# 2837 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8922 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'listPatternElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2839 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.ArrayOrList(false,_2,lhs parseState) 
                   )
//# 2839 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8933 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'listPatternElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2841 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.ArrayOrList(true,_2, lhs parseState) 
                   )
//# 2841 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8944 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2843 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Wild (lhs parseState) 
                   )
//# 2843 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8954 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2845 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.OptionalVal(_2,lhs parseState) 
                   )
//# 2845 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8965 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatternLongIdent)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2847 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let vis,lidwd = _1 
                             if not (isNilOrSingleton lidwd.Lid) || (String.isUpper (List.head lidwd.Lid).idText) 
                             then mkSynPatMaybeVar lidwd vis (lhs parseState)
                             else mkSynPatVar vis (List.head lidwd.Lid) 
                   )
//# 2847 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8979 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'constant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2852 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Const (_1,_1.Range (lhs parseState)) 
                   )
//# 2852 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 8990 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2854 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Const(SynConst.Bool false,lhs parseState) 
                   )
//# 2854 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9000 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2856 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Const(SynConst.Bool true,lhs parseState) 
                   )
//# 2856 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9010 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2858 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Null(lhs parseState) 
                   )
//# 2858 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9020 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPatternBody)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2860 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let m = (lhs parseState)
                             SynPat.Paren(_2 m,m) 
                   )
//# 2860 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9033 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPatternBody)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2863 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen()) 
                             patFromParseError (_2 (rhs2 parseState 1 2)) 
                   )
//# 2863 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9046 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2866 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (* silent recovery *) SynPat.Wild (lhs parseState) 
                   )
//# 2866 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9057 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2868 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen()) 
                              SynPat.Wild (lhs parseState)
                   )
//# 2868 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9069 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleParenPatternElements)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2871 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Tuple(true, List.rev _3,lhs parseState) 
                   )
//# 2871 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9081 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleParenPatternElements)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2873 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnmatchedParen()); 
                             SynPat.Tuple(true, List.rev _3,lhs parseState) 
                   )
//# 2873 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9094 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2876 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (* silent recovery *) SynPat.Wild (lhs parseState) 
                   )
//# 2876 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9105 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2878 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnmatchedParen()); 
                              SynPat.Wild (lhs parseState)
                   )
//# 2878 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicPattern));
//# 9117 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2885 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun m -> _1) 
                   )
//# 2885 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPatternBody));
//# 9128 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2887 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun m -> SynPat.Const(SynConst.Unit,m)) 
                   )
//# 2887 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPatternBody));
//# 9138 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2916 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Named (_1,_3,false,None,rhs2 parseState 1 3) 
                   )
//# 2916 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9150 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2918 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Or(_1,_3,rhs2 parseState 1 3) 
                   )
//# 2918 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9162 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleParenPatternElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2920 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Tuple(false,List.rev _1,lhs parseState) 
                   )
//# 2920 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9173 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'conjParenPatternElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2922 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.Ands(List.rev _1,rhs2 parseState 1 3) 
                   )
//# 2922 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9184 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeWithTypeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2924 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let lhsm = lhs parseState 
                             SynPat.Typed(_1,_3,lhsm) 
                   )
//# 2924 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9197 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2927 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let lhsm = lhs parseState 
                             SynPat.Attrib(_2,_1,lhsm) 
                   )
//# 2927 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9210 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2930 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynPat.LongIdent (LongIdentWithDots(mkSynCaseName (rhs parseState 2) opNameCons,[]), None, None, SynConstructorArgs.Pats [ SynPat.Tuple (false,[_1;_3],rhs2 parseState 1 3) ],None,lhs parseState) 
                   )
//# 2930 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9222 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'constrPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2931 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                         _1 
                   )
//# 2931 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenPattern));
//# 9233 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleParenPatternElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2935 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 
                   )
//# 2935 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleParenPatternElements));
//# 9245 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2937 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 :: [] 
                   )
//# 2937 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleParenPatternElements));
//# 9257 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'conjParenPatternElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2941 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 
                   )
//# 2941 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'conjParenPatternElements));
//# 9269 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2943 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 :: [] 
                   )
//# 2943 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'conjParenPatternElements));
//# 9281 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordPatternElement)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2947 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [_1],lhs parseState 
                   )
//# 2947 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recordPatternElementsAux));
//# 9293 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordPatternElement)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordPatternElementsAux)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2949 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let r = _1 in let (rs,dropMark) = _3 in (r :: rs),lhs parseState 
                   )
//# 2949 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recordPatternElementsAux));
//# 9306 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2952 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                    (List.frontAndBack _1.Lid,_3) 
                   )
//# 2952 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recordPatternElement));
//# 9318 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2956 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 2956 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'listPatternElements));
//# 9328 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2958 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [_1] 
                   )
//# 2958 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'listPatternElements));
//# 9340 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'listPatternElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2960 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 :: _3 
                   )
//# 2960 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'listPatternElements));
//# 9353 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2965 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 2965 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9365 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2967 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFileExpression())
                             exprFromParseError _2 
                   )
//# 2967 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9378 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2970 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2970 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9389 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2975 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 2975 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9401 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2977 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2977 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9412 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2982 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                         _1 
                   )
//# 2982 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedSeqExprBlockR));
//# 9423 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2983 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        _1 
                   )
//# 2983 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedSeqExprBlockR));
//# 9434 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'seqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeWithTypeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2986 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                               SynExpr.Typed (_1,_3, unionRanges _1.Range _3.Range) 
                   )
//# 2986 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedSeqExpr));
//# 9446 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'seqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2987 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   _1 
                   )
//# 2987 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typedSeqExpr));
//# 9457 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2990 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                            checkEndOfFileError _2; _1 
                   )
//# 2990 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9469 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'seqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2994 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Sequential (SequencePointsAtSeq,true,_1,_3,unionRanges _1.Range _3.Range) 
                   )
//# 2994 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seqExpr));
//# 9482 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2996 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2996 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seqExpr));
//# 9494 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 2998 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 2998 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seqExpr));
//# 9505 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'seqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3000 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Sequential (SequencePointsAtSeq,false,_1,_3,unionRanges _1.Range _3.Range ) 
                   )
//# 3000 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seqExpr));
//# 9517 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3002 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Sequential (SequencePointsAtSeq,false,_1,_4,unionRanges _1.Range _4.Range) 
                   )
//# 3002 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seqExpr));
//# 9530 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteLetBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3004 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let hwlb,m = _1
                            let mLetKwd,isUse = match hwlb with (BindingSetPreAttrs(m,_,isUse,_,_))  -> m,isUse
                            let usedKeyword = if isUse then "use" else "let"
                            reportParseErrorAt mLetKwd (FSComp.SR.parsExpectedExpressionAfterLet(usedKeyword,usedKeyword))
                            let fauxRange = m.EndRange // zero width range at end of m
                            mkLocalBindings (m,hwlb,arbExpr("seqExpr",fauxRange)) 
                   )
//# 3004 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seqExpr));
//# 9546 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3016 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  debugPrint("recovering via error"); true 
                   )
//# 3016 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recover));
//# 9556 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3017 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                debugPrint("recovering via EOF"); false 
                   )
//# 3017 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recover));
//# 9567 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'defnBindings)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3022 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            mkLocalBindings (unionRanges (rhs2 parseState 1 2) _3.Range,_1,_3) 
                   )
//# 3022 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9579 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'defnBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3025 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            mkLocalBindings (rhs2 parseState 1 2,_1,arbExpr("declExpr1",(rhs parseState 3))) 
                   )
//# 3025 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9590 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteLetBindings)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3031 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let hwlb,m = _1
                            mkLocalBindings (unionRanges m _2.Range,hwlb,_2) 
                   )
//# 3031 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9603 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteLetBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3035 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let hwlb,m = _1
                            reportParseErrorAt (match hwlb with (BindingSetPreAttrs(m,_,_,_,_))  -> m) (FSComp.SR.parsErrorInReturnForLetIncorrectIndentation())
                            mkLocalBindings (m,hwlb,arbExpr("declExpr2",(rhs parseState 2))) 
                   )
//# 3035 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9616 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteLetBindings)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3040 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let hwlb,m = _1
                            mkLocalBindings (unionRanges m _3.Range, hwlb, _3) 
                   )
//# 3040 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9629 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteLetBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3044 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let hwlb,m = _1
                            //reportParseErrorAt (match hwlb with (BindingSetPreAttrs(m,_,_,_,_))  -> m) (FSComp.SR.parsErrorInReturnForLetIncorrectIndentation())
                            mkLocalBindings (unionRanges m (rhs parseState 3),hwlb,arbExpr("declExpr3",(rhs parseState 3))) 
                   )
//# 3044 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9642 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteDoBinding)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3049 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let e = snd _1
                            SynExpr.Do (e,e.Range) 
                   )
//# 3049 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9654 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'anonMatchingExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3053 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3053 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9665 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'anonLambdaExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3056 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3056 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9676 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'withClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3059 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mMatch = (rhs parseState 1)
                             let mWith,(clauses,mLast) = _3 
                             let spBind = SequencePointAtBinding(unionRanges mMatch mWith) 
                             SynExpr.Match (spBind, _2,clauses,unionRanges mMatch mLast) 
                   )
//# 3059 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9691 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3065 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileMatch())
                             // Produce approximate expression during error recovery 
                             exprFromParseError _2 
                   )
//# 3065 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9705 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'withClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3070 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mMatch = (rhs parseState 1)
                             let mWith,(clauses,mLast) = _3 
                             let spBind = SequencePointAtBinding(unionRanges mMatch mWith) 
                             SynExpr.MatchBang (spBind, _2,clauses,unionRanges mMatch mLast) 
                   )
//# 3070 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9720 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3076 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileMatch())
                             // Produce approximate expression during error recovery 
                             exprFromParseError _2 
                   )
//# 3076 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9734 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'withClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3081 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mTry = (rhs parseState 1)
                             let spTry = SequencePointAtTry(mTry) 
                             let mWith,(clauses,mLast) = _3 
                             let spWith = SequencePointAtWith(mWith) 
                             let mTryToWith = unionRanges mTry mWith 
                             let mWithToLast = unionRanges mWith mLast 
                             let mTryToLast = unionRanges mTry mLast
                             SynExpr.TryWith (_2, mTryToWith, clauses,mWithToLast, mTryToLast,spTry,spWith) 
                   )
//# 3081 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9753 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3091 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // Produce approximate expression during error recovery 
                             // Include any expressions to make sure they gets type checked in case that generates useful results for intellisense 
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileTry())
                             exprFromParseError _2 
                   )
//# 3091 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9768 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3097 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mTry = rhs parseState 1 
                             let spTry = SequencePointAtTry(mTry) 
                             let spFinally = SequencePointAtFinally(rhs parseState 3) 
                             let mTryToLast = unionRanges mTry _4.Range 
                             SynExpr.TryFinally (_2, _4,mTryToLast,spTry,spFinally) 
                   )
//# 3097 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9784 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ifExprCases)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3104 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mIf = (rhs parseState 1)
                             _3 _2 mIf 
                   )
//# 3104 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9797 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3108 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsIncompleteIf()) 
                             // Produce an approximate expression during error recovery. 
                             // Include expressions to make sure they get type checked in case that generates useful results for intellisense. 
                             // Generate a throwAway for the expression so it isn't forced to have a type 'bool' 
                             // from the context it is used in. 
                             exprFromParseError _2 
                   )
//# 3108 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9814 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3116 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsIncompleteIf())
                             // Produce an approximate expression during error recovery. There can still be value in doing this even
                             // for this pathological case.
                             let m = (rhs parseState 1)
                             let mEnd = m.EndRange
                             let spIfToThen = SequencePointAtBinding mEnd
                             exprFromParseError (SynExpr.IfThenElse (arbExpr("ifGuard1",mEnd),arbExpr("thenBody1",mEnd),None,spIfToThen,true,m,m)) 
                   )
//# 3116 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9831 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3125 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Lazy (_2,unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3125 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9842 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3128 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Assert (_2, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3128 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9853 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3131 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             raiseParseErrorAt (rhs parseState 1) (FSComp.SR.parsAssertIsNotFirstClassValue()) 
                   )
//# 3131 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9863 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3134 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Lazy (_2,unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3134 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9874 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3137 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Assert (_2, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3137 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9885 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3140 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             raiseParseErrorAt (rhs parseState 1) (FSComp.SR.parsAssertIsNotFirstClassValue()) 
                   )
//# 3140 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9895 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3143 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mWhileHeader = unionRanges (rhs parseState 1) _2.Range
                             let spWhile = SequencePointAtWhileLoop mWhileHeader 
                             let mWhileAll = unionRanges (rhs parseState 1) _4.Range
                             SynExpr.While (spWhile,_2,_4,mWhileAll) 
                   )
//# 3143 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9912 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3149 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _5 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileWhile())
                             let mWhileHeader = unionRanges (rhs parseState 1) _2.Range
                             let spWhile = SequencePointAtWhileLoop mWhileHeader 
                             let mWhileAll = unionRanges (rhs parseState 1) _4.Range
                             exprFromParseError (SynExpr.While (spWhile,_2,_4,mWhileAll)) 
                   )
//# 3149 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9930 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3156 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // silent recovery 
                             let mWhileHeader = unionRanges (rhs parseState 1) _2.Range
                             let spWhile = SequencePointAtWhileLoop mWhileHeader 
                             let mWhileBodyArb = unionRanges (rhs parseState 4) (rhs parseState 5)
                             let mWhileAll = unionRanges (rhs parseState 1) (rhs parseState 5)
                             SynExpr.While (spWhile,_2,arbExpr("whileBody1",mWhileBodyArb),mWhileAll) 
                   )
//# 3156 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9948 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3164 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsWhileDoExpected())
                             let mWhileHeader = unionRanges (rhs parseState 1) _2.Range
                             let spWhile = SequencePointAtWhileLoop mWhileHeader 
                             let mWhileBodyArb = rhs parseState 3
                             let mWhileAll = unionRanges (rhs parseState 1) (rhs parseState 3)
                             exprFromParseError (SynExpr.While (spWhile,_2,arbExpr("whileBody2",mWhileBodyArb),mWhileAll))  
                   )
//# 3164 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9965 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3172 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _2 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileWhile())
                             arbExpr("whileLoop1",rhs parseState 1)  
                   )
//# 3172 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9977 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3176 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             //silent recovery
                             let mWhileHeader = rhs parseState 1
                             let spWhile = SequencePointAtWhileLoop mWhileHeader 
                             let mWhileBodyArb = rhs parseState 3
                             let mWhileAll = unionRanges (rhs parseState 1) (rhs parseState 3)
                             exprFromParseError (SynExpr.While (spWhile,arbExpr("whileGuard1",mWhileHeader),arbExpr("whileBody3",mWhileBodyArb),mWhileAll))  
                   )
//# 3176 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 9993 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopBinder)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3184 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let spBind = SequencePointAtForLoop(rhs2 parseState 1 3)
                             let (a,b,_) = _2 
                             SynExpr.ForEach (spBind,SeqExprOnly false,true,a,b,_4,unionRanges (rhs parseState 1) _4.Range) 
                   )
//# 3184 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10009 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopBinder)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3189 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _5 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileFor())
                             let spBind = SequencePointAtForLoop(rhs2 parseState 1 3)
                             let (a,b,_) = _2 
                             let mForLoopAll = unionRanges (rhs parseState 1) _4.Range
                             SynExpr.ForEach (spBind,SeqExprOnly false,true,a,b,_4,mForLoopAll) 
                   )
//# 3189 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10027 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopBinder)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3196 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // Silent recovery
                             let mForLoopHeader = rhs2 parseState 1 3
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let (a,b,_) = _2 
                             let mForLoopBodyArb = rhs parseState 5
                             let mForLoopAll = rhs2 parseState 1 5
                             SynExpr.ForEach (spBind,SeqExprOnly false,true,a,b,arbExpr("forLoopBody2a",mForLoopBodyArb),mForLoopAll) 
                   )
//# 3196 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10046 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopBinder)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3205 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _4 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsExpectedExpressionAfterToken())
                             let mForLoopHeader = rhs2 parseState 1 3
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let (a,b,_) = _2 
                             let mForLoopBodyArb = rhs parseState 3
                             let mForLoopAll = rhs2 parseState 1 3
                             SynExpr.ForEach (spBind,SeqExprOnly false,true,a,b,arbExpr("forLoopBody2",mForLoopBodyArb),mForLoopAll) 
                   )
//# 3205 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10065 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopBinder)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3214 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let (a,b,ok) = _2 
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsForDoExpected())
                             let mForLoopHeader = rhs2 parseState 1 3
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let mForLoopBodyArb = rhs parseState 3
                             let mForLoopAll = rhs2 parseState 1 3
                             SynExpr.ForEach (spBind,SeqExprOnly false,true,a,b,arbExpr("forLoopBody1",mForLoopBodyArb),mForLoopAll) 
                   )
//# 3214 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10083 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopRange)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3223 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mForLoopHeader = rhs2 parseState 1 3
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let (a,b,c,d) = _2 
                             let mForLoopAll = unionRanges (rhs parseState 1) _4.Range
                             SynExpr.For (spBind,a,b,c,d,_4,mForLoopAll) 
                   )
//# 3223 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10101 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopRange)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3230 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _5 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileFor())
                             // Still produce an expression
                             let mForLoopHeader = rhs2 parseState 1 3
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let (a,b,c,d) = _2 
                             let mForLoopAll = unionRanges (rhs parseState 1) _4.Range
                             exprFromParseError (SynExpr.For (spBind,a,b,c,d,_4,mForLoopAll)) 
                   )
//# 3230 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10121 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopRange)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3239 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // silent recovery 
                             let mForLoopHeader = rhs2 parseState 1 3
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let (a,b,c,d) = _2 
                             let mForLoopBodyArb = rhs parseState 5
                             let mForLoopAll = rhs2 parseState 1 5
                             SynExpr.For (spBind,a,b,c,d,arbExpr("declExpr11",mForLoopBodyArb),mForLoopAll) 
                   )
//# 3239 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10140 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopRange)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3248 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _4 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileFor())
                             let mForLoopHeader = rhs2 parseState 1 3
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let (a,b,c,d) = _2 
                             let mForLoopBodyArb = rhs parseState 3
                             let mForLoopAll = rhs2 parseState 1 3
                             exprFromParseError (SynExpr.For (spBind,a,b,c,d,arbExpr("declExpr11",mForLoopBodyArb),mForLoopAll)) 
                   )
//# 3248 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10159 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopRange)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3257 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileFor())
                             let mForLoopHeader = rhs2 parseState 1 2
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let (a,b,c,d) = _2 
                             let mForLoopBodyArb = (rhs parseState 2).EndRange
                             let mForLoopAll = rhs2 parseState 1 2
                             exprFromParseError (SynExpr.For (spBind,a,b,c,d,arbExpr("declExpr11",mForLoopBodyArb),mForLoopAll)) 
                   )
//# 3257 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10177 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'doToken)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3267 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // silent recovery 
                             let mForLoopHeader = rhs2 parseState 1 2
                             let mForLoopAll = unionRanges (rhs parseState 1) _4.Range
                             let spBind = SequencePointAtForLoop(mForLoopHeader)
                             SynExpr.For (spBind,mkSynId mForLoopHeader "_loopVar",arbExpr("startLoopRange1",mForLoopHeader),true,arbExpr("endLoopRange1",rhs parseState 3),_4,mForLoopAll) 
                   )
//# 3267 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10194 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3286 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsIdentifierExpected())
                             arbExpr("declExpr12",(rhs parseState 1)) 
                   )
//# 3286 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10206 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'doneDeclEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3290 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsInOrEqualExpected())
                             let mForLoopHeader = rhs2 parseState 1 2
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let mForLoopBodyArb = rhs parseState 4
                             let mForLoopAll = rhs2 parseState 1 4
                             SynExpr.ForEach (spBind,SeqExprOnly false,true,_2,arbExpr("forLoopCollection",mForLoopHeader),arbExpr("forLoopBody3",mForLoopBodyArb),mForLoopAll) 
                   )
//# 3290 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10223 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3298 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileFor())
                             let mForLoopHeader = rhs2 parseState 1 2
                             let spBind = SequencePointAtForLoop mForLoopHeader
                             let mForLoopBodyArb = (rhs parseState 2).EndRange
                             let mForLoopAll = rhs2 parseState 1 2
                             exprFromParseError (SynExpr.ForEach (spBind,SeqExprOnly false,true,_2,arbExpr("forLoopCollection",mForLoopHeader),arbExpr("forLoopBody3",mForLoopBodyArb),mForLoopAll)) 
                   )
//# 3298 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10240 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3307 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExpr.YieldOrReturn ((_1,not _1),_2, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3307 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10252 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3310 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExpr.YieldOrReturnFrom ((_1,not _1), _2, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3310 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10264 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3313 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let spBind = SequencePointAtBinding(rhs2 parseState 1 5)
                            let m = unionRanges (rhs parseState 1) _7.Range
                            SynExpr.LetOrUseBang (spBind,(_1 = "use"),true,_2,_4,_7,m) 
                   )
//# 3313 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10281 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteDefnBindingsTerminator)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3318 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _5 (if _1 = "use" then "use!" else "let!") (rhs parseState 1)  // report unterminated error 
                            let spBind = SequencePointAtBinding(unionRanges (rhs parseState 1) _4.Range)
                            let m = unionRanges (rhs parseState 1) _7.Range
                            SynExpr.LetOrUseBang (spBind,(_1 = "use"),true,_2,_4,_7,m) 
                   )
//# 3318 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10300 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynPat)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteDefnBindingsTerminator)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3324 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // error recovery that allows intellisense when writing incomplete computation expressions 
                            let spBind = SequencePointAtBinding(unionRanges (rhs parseState 1) _4.Range) 
                            let mAll = unionRanges (rhs parseState 1) (rhs parseState 7)
                            let m = _4.Range.EndRange // zero-width range
                            SynExpr.LetOrUseBang (spBind,(_1 = "use"),true,_2,_4, SynExpr.ImplicitZero m, mAll) 
                   )
//# 3324 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10319 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3331 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let spBind = NoSequencePointAtDoBinding
                            SynExpr.LetOrUseBang (spBind,false,true,SynPat.Const(SynConst.Unit,_2.Range),_2,_5, unionRanges (rhs parseState 1) _5.Range) 
                   )
//# 3331 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10333 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'hardwhiteDefnBindingsTerminator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3335 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExpr.DoBang (_2, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3335 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10345 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopBinder)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'arrowThenExprR)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3338 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let spBind = SequencePointAtForLoop(rhs2 parseState 1 2)
                            let (a,b,_) = _2 in SynExpr.ForEach (spBind,SeqExprOnly true,true,a,b,_4,unionRanges (rhs parseState 1) _4.Range) 
                   )
//# 3338 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10359 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3342 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExpr.Fixed (_2, (unionRanges (rhs parseState 1) _2.Range)) 
                   )
//# 3342 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10370 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3345 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            errorR(Error(FSComp.SR.parsArrowUseIsLimited(),lhs parseState))
                            SynExpr.YieldOrReturn ((true,true),_2, (unionRanges (rhs parseState 1) _2.Range)) 
                   )
//# 3345 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10382 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3350 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                             SynExpr.TypeTest (_1,_3, unionRanges _1.Range _3.Range) 
                   )
//# 3350 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10394 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3351 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                             SynExpr.Upcast (_1,_3, unionRanges _1.Range _3.Range) 
                   )
//# 3351 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10406 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3352 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                             SynExpr.Downcast (_1,_3, unionRanges _1.Range _3.Range) 
                   )
//# 3352 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10418 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3355 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 ":=" _3 
                   )
//# 3355 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10430 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3356 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                         mkSynAssign _1 _3 
                   )
//# 3356 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10442 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3358 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                        let exprs,commas = _1 in SynExpr.Tuple (false, List.rev exprs, List.rev commas, (commas.Head, exprs) ||> unionRangeWithListBy (fun e -> e.Range) ) 
                   )
//# 3358 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10453 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3359 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    SynExpr.JoinIn (_1,rhs parseState 2,_3,unionRanges _1.Range _3.Range) 
                   )
//# 3359 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10465 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3360 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "||" _3 
                   )
//# 3360 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10477 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3361 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3361 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10490 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3362 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "or" _3 
                   )
//# 3362 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10502 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3363 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "&" _3 
                   )
//# 3363 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10514 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3364 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "&&" _3 
                   )
//# 3364 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10526 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3365 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3365 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10539 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3366 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "=" _3 
                   )
//# 3366 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10551 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3367 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3367 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10564 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3368 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "$" _3 
                   )
//# 3368 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10576 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3369 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "<" _3 
                   )
//# 3369 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10589 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3370 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                   if not _3 then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("<"))  
                                                                   exprFromParseError (mkSynInfix (rhs parseState 2) _1 "<" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3370 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10603 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3372 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 ">" _3 
                   )
//# 3372 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10616 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3373 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3373 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10629 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3374 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3374 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10642 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3375 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    SynExpr.App (ExprAtomicFlag.NonAtomic, true, mkSynIdGet (rhs parseState 2) opNameCons,SynExpr.Tuple (false,[_1;_3],[rhs parseState 2],unionRanges _1.Range _3.Range),unionRanges _1.Range _3.Range) 
                   )
//# 3375 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10654 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3376 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3376 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10667 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3377 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "-" _3 
                   )
//# 3377 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10679 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3378 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 "*" _3 
                   )
//# 3378 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10691 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3379 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3379 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10704 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3380 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                    mkSynInfix (rhs parseState 2) _1 _2 _3 
                   )
//# 3380 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10717 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3382 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("in")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "@in" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3382 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10729 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3384 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("||")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "||" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3384 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10741 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3386 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3386 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10754 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3388 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("or")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "or" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3388 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10766 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3390 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("&")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "&" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3390 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10778 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3392 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("&&")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "&&" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3392 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10790 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3394 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3394 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10803 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3396 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("=")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "=" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3396 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10815 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3398 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3398 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10828 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3400 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("$")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "$" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3400 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10840 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3402 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("<")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "<" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3402 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10853 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3404 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(">")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 ">" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3404 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10866 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3406 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3406 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10879 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3408 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3408 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10892 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3410 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("::")) 
                                                                                 SynExpr.App (ExprAtomicFlag.NonAtomic, true, mkSynIdGet (rhs parseState 2) opNameCons,SynExpr.Tuple (false,[_1;(arbExpr("declExprInfix",(rhs parseState 3).StartRange))],[rhs parseState 2],unionRanges _1.Range (rhs parseState 3).StartRange),unionRanges _1.Range (rhs parseState 3).StartRange) 
                   )
//# 3410 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10904 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3412 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3412 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10917 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3414 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("-")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "-" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3414 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10929 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3416 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression("*")) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 "*" (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3416 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10941 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3418 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3418 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10954 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3420 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                                 reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnfinishedExpression(_2)) 
                                                                                 exprFromParseError(mkSynInfix (rhs parseState 2) _1 _2 (arbExpr("declExprInfix",(rhs parseState 3).StartRange))) 
                   )
//# 3420 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10967 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3423 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                  _1 
                   )
//# 3423 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 10978 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3427 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let con = SynConst.String (_1,rhs parseState 1)
                             let arg2 = SynExpr.Const (con,con.Range (rhs parseState 1)) 
                             arg2 
                   )
//# 3427 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'dynamicArg));
//# 10991 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3431 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 3431 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'dynamicArg));
//# 11003 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'withPatternClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3435 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             rhs parseState 1, _2 
                   )
//# 3435 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'withClauses));
//# 11014 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'withPatternClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3437 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             rhs parseState 1, _2 
                   )
//# 3437 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'withClauses));
//# 11025 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'withPatternClauses)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3439 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileWith())
                             rhs parseState 1, _2 
                   )
//# 3439 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'withClauses));
//# 11038 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3444 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3444 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'withPatternClauses));
//# 11049 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3446 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              _2 
                   )
//# 3446 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'withPatternClauses));
//# 11060 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3448 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              // silent recovery 
                              let mLast = rhs parseState 1
                              [], mLast 
                   )
//# 3448 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'withPatternClauses));
//# 11072 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3452 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              // silent recovery 
                              let mLast = rhs parseState 1
                              [], mLast 
                   )
//# 3452 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'withPatternClauses));
//# 11084 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternGuard)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3459 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1, _2, rhs parseState 1 
                   )
//# 3459 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternAndGuard));
//# 11096 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternAndGuard)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3463 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let pat,guard,patm = _1 
                            let mLast = _2.Range 
                            [Clause(pat,guard,_2,patm,SequencePointAtTarget)], mLast  
                   )
//# 3463 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternClauses));
//# 11110 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternAndGuard)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3467 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let pat,guard,patm = _1 
                            let clauses,mLast = _4 
                            (Clause(pat,guard,_2,patm,SequencePointAtTarget) :: clauses), mLast 
                   )
//# 3467 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternClauses));
//# 11125 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternAndGuard)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3471 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let pat,guard,patm = _1 
                            let mLast = rhs parseState 3 
                            // silent recovery 
                            [Clause(pat,guard,_2,patm,SequencePointAtTarget)], mLast  
                   )
//# 3471 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternClauses));
//# 11140 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternAndGuard)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3476 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let pat,guard,patm = _1 
                            let mLast = _2.Range 
                            // silent recovery 
                            [Clause(pat,guard,_2,patm,SequencePointAtTarget)], mLast 
                   )
//# 3476 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternClauses));
//# 11155 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternAndGuard)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3481 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let pat,guard,patm = _1 
                            let mLast = rhs parseState 2
                            // silent recovery 
                            [Clause(pat,guard,SynExpr.Const (SynConst.Unit,mLast.EndRange),patm,SequencePointAtTarget)], mLast 
                   )
//# 3481 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternClauses));
//# 11169 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3488 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            Some _2 
                   )
//# 3488 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternGuard));
//# 11180 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3490 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            None 
                   )
//# 3490 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'patternGuard));
//# 11190 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3494 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 3494 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11201 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ifExprThen)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ifExprElifs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3498 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let exprThen,mThen = _1 
                             (fun exprGuard mIf -> 
                                 let mIfToThen = unionRanges mIf mThen
                                 let lastBranch : SynExpr = match _2 with None -> exprThen | Some e -> e
                                 let mIfToEndOfLastBranch = unionRanges mIf lastBranch.Range
                                 let spIfToThen = SequencePointAtBinding(mIfToThen)
                                 SynExpr.IfThenElse (exprGuard,exprThen,_2,spIfToThen,false,mIfToThen,mIfToEndOfLastBranch)) 
                   )
//# 3498 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprCases));
//# 11219 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3508 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2, rhs parseState 1 
                   )
//# 3508 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprThen));
//# 11230 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3510 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3,rhs parseState 1 
                   )
//# 3510 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprThen));
//# 11242 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3512 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _4 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileThen())
                             exprFromParseError _3,rhs parseState 1 
                   )
//# 3512 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprThen));
//# 11255 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3517 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             None 
                   )
//# 3517 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprElifs));
//# 11265 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3520 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some _2 
                   )
//# 3520 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprElifs));
//# 11276 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3523 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some _3 
                   )
//# 3523 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprElifs));
//# 11288 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3526 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _4 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileElse())
                             Some (exprFromParseError _3) 
                   )
//# 3526 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprElifs));
//# 11301 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ifExprCases)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3530 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mElif = rhs parseState 1 
                             Some (_3 _2 mElif) 
                   )
//# 3530 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprElifs));
//# 11314 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3534 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some (exprFromParseError _2) 
                   )
//# 3534 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ifExprElifs));
//# 11326 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3538 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let exprs,commas = _1 in (_3 :: exprs),((rhs parseState 2) :: commas) 
                   )
//# 3538 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleExpr));
//# 11338 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3541 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsExpectedExpressionAfterToken())
                             let exprs,commas = _1     
                             let zeroWidthAtNextToken = (rhs parseState 3).StartRange
                             ((arbExpr("tupleExpr1",zeroWidthAtNextToken)) :: exprs), (rhs parseState 2) :: commas 
                   )
//# 3541 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleExpr));
//# 11353 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3547 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsExpectedExpressionAfterToken())
                             let zeroWidthAtNextToken = (rhs parseState 3).StartRange 
                             ((arbExpr("tupleExpr2",zeroWidthAtNextToken)) :: [_1]), [rhs parseState 2] 
                   )
//# 3547 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleExpr));
//# 11367 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3552 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [_3 ; _1], [rhs parseState 2] 
                   )
//# 3552 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleExpr));
//# 11379 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3556 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             mkSynPrefix (rhs parseState 1) (unionRanges (rhs parseState 1) _2.Range) "~-" _2 
                   )
//# 3556 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11390 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3559 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not (IsValidPrefixOperatorUse _1) then reportParseErrorAt _2.Range (FSComp.SR.parsInvalidPrefixOperator())
                             mkSynPrefix (rhs parseState 1) (unionRanges (rhs parseState 1) _2.Range) ("~"+(_1)) _2 
                   )
//# 3559 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11403 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3563 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not (IsValidPrefixOperatorUse _1) then reportParseErrorAt _2.Range (FSComp.SR.parsInvalidPrefixOperator())
                             mkSynPrefix (rhs parseState 1) (unionRanges (rhs parseState 1) _2.Range) ("~"+(_1)) _2 
                   )
//# 3563 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11416 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3567 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not (IsValidPrefixOperatorUse _1) then reportParseErrorAt _2.Range (FSComp.SR.parsInvalidPrefixOperator())
                             mkSynPrefix (rhs parseState 1) (unionRanges (rhs parseState 1) _2.Range) ("~"+(_1)) _2 
                   )
//# 3567 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11429 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3571 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.AddressOf (true,_2,rhs parseState 1,unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3571 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11440 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3574 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.AddressOf (false,_2,rhs parseState 1, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3574 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11451 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3577 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.New (false,_2,_4,unionRanges (rhs parseState 1) _4.Range) 
                   )
//# 3577 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11464 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3580 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.New (false,_2,arbExpr("minusExpr",(rhs parseState 4)),unionRanges (rhs parseState 1) (_2).Range) 
                   )
//# 3580 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11476 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3583 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             arbExpr("minusExpr2",(rhs parseState 1)) 
                   )
//# 3583 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11486 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3586 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.InferredUpcast (_2,unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3586 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11497 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3589 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.InferredDowncast (_2,unionRanges (rhs parseState 1) _2.Range)
                   )
//# 3589 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11508 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3592 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3592 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11519 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3596 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.App (ExprAtomicFlag.NonAtomic, false, _1,_2,unionRanges _1.Range _2.Range)  
                   )
//# 3596 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11531 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3599 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg,_ = _1 
                             arg 
                   )
//# 3599 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11543 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3604 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg2,hpa2 = _2 
                             if not (IsValidPrefixOperatorUse _1) then reportParseErrorAt arg2.Range (FSComp.SR.parsInvalidPrefixOperator())
                             if hpa2 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsSuccessiveArgsShouldBeSpacedOrTupled())
                             mkSynPrefix (rhs parseState 1) (unionRanges (rhs parseState 1) arg2.Range) ("~"+(_1)) arg2 
                   )
//# 3604 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11558 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3610 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg,hpa = _1 
                             if hpa then reportParseErrorAt arg.Range (FSComp.SR.parsSuccessiveArgsShouldBeSpacedOrTupled())
                             arg 
                   )
//# 3610 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 11571 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3616 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg1,_ = _1 
                             let arg2,_ = _3 
                             SynExpr.App (ExprAtomicFlag.Atomic, false, arg1,arg2,unionRanges arg1.Range arg2.Range),true  
                   )
//# 3616 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11585 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3621 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg1,_ = _1 
                             let arg2,_ = _3 
                             SynExpr.App (ExprAtomicFlag.Atomic, false, arg1,arg2,unionRanges arg1.Range arg2.Range),true  
                   )
//# 3621 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11599 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : range * range option * bool     * Ast.SynType list * range list * range)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3626 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg1,_ = _1 
                             let mLessThan,mGreaterThan,_,args,commas,mTypeArgs = _3
                             let mWholeExpr = unionRanges arg1.Range mTypeArgs
                             SynExpr.TypeApp (arg1, mLessThan, args, commas, mGreaterThan, mTypeArgs, mWholeExpr), false 
                   )
//# 3626 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11614 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3632 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg2,hpa2 = _2 
                             if not (IsValidPrefixOperatorUse _1) then reportParseErrorAt arg2.Range (FSComp.SR.parsInvalidPrefixOperator())
                             mkSynPrefixPrim (rhs parseState 1) (unionRanges (rhs parseState 1) arg2.Range) _1 arg2,hpa2 
                   )
//# 3632 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11628 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicExprQualification)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3637 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg1,hpa1 = _1 
                             _3 arg1 (lhs parseState) (rhs parseState 2),hpa1 
                   )
//# 3637 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11641 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicExprQualification)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3641 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg1 = SynExpr.Ident (ident("base",rhs parseState 1))
                             _3 arg1 (lhs parseState) (rhs parseState 2),false 
                   )
//# 3641 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11653 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3645 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.LongIdent (true,LongIdentWithDots([_2],[]),None,rhs parseState 2),false 
                   )
//# 3645 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11664 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'dynamicArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3648 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let arg1,hpa1 = _1
                             mkSynInfix (rhs parseState 2) arg1 "?" _3, hpa1 
                   )
//# 3648 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11677 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3652 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Ident (ident(MangledGlobalName,rhs parseState 1)), false 
                   )
//# 3652 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11687 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'nameop)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3655 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Ident (_1),false 
                   )
//# 3655 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11698 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'listExprElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3658 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 (lhs parseState) false,false 
                   )
//# 3658 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11709 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'listExprElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3661 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBracket()) 
                             exprFromParseError (_2 (rhs2 parseState 1 2) false), false 
                   )
//# 3661 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11722 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3665 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // silent recovery 
                             SynExpr.ArrayOrList (false,[ ], lhs parseState),false  
                   )
//# 3665 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11733 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3669 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBracket()) 
                             // silent recovery 
                             exprFromParseError (SynExpr.ArrayOrList (false,[ ], rhs parseState 1)),false  
                   )
//# 3669 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11746 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3674 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let exprs,commas = _3 in SynExpr.Tuple (true, List.rev exprs, List.rev commas, (commas.Head, exprs) ||> unionRangeWithListBy (fun e -> e.Range) ), false 
                   )
//# 3674 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11758 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3677 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnmatchedBracket()); 
                             let exprs,commas = _3 in SynExpr.Tuple (true, List.rev exprs, List.rev commas, (commas.Head, exprs) ||> unionRangeWithListBy (fun e -> e.Range) ), false 
                   )
//# 3677 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11771 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3681 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1,false 
                   )
//# 3681 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr * bool));
//# 11782 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'identOrOp)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3685 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let idm = rhs parseState 1 
                             (fun e lhsm dotm -> mkSynDot dotm lhsm e _1) 
                   )
//# 3685 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11794 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3689 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun e lhsm dotm -> 
                                 reportParseErrorAt (rhs parseState 3) (FSComp.SR.nrGlobalUsedOnlyAsFirstName()) 
                                 let fixedLhsm = mkRange lhsm.FileName lhsm.Start dotm.End // previous lhsm is wrong after 'recover'
                                 mkSynDotMissing dotm fixedLhsm e) 
                   )
//# 3689 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11807 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3695 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun e lhsm dotm -> 
                                 reportParseErrorAt dotm (FSComp.SR.parsMissingQualificationAfterDot()) 
                                 let fixedLhsm = mkRange lhsm.FileName lhsm.Start dotm.End // previous lhsm is wrong after 'recover'
                                 mkSynDotMissing dotm fixedLhsm e) 
                   )
//# 3695 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11820 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3700 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun e lhsm dotm -> 
                                 reportParseErrorAt dotm (FSComp.SR.parsMissingQualificationAfterDot()) 
                                 let fixedLhsm = mkRange lhsm.FileName lhsm.Start dotm.End // previous lhsm is wrong after 'recover'
                                 // Include 'e' in the returned expression but throw it away
                                 SynExpr.DiscardAfterMissingQualificationAfterDot (e,fixedLhsm)) 
                   )
//# 3700 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11835 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3706 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun e lhsm dotm -> 
                                 libraryOnlyError(lhs parseState)
                                 SynExpr.LibraryOnlyUnionCaseFieldGet (e,mkSynCaseName lhsm opNameCons,(fst _5),lhsm)) 
                   )
//# 3706 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11849 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3711 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun e lhsm dotm -> 
                                 mlCompatWarning (FSComp.SR.parsParenFormIsForML()) (lhs parseState) 
                                 mkSynDotParenGet lhsm dotm e _2) 
                   )
//# 3711 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11863 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3716 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun e lhsm dotm -> mkSynDotBrackGet lhsm dotm e _2) 
                   )
//# 3716 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11874 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3719 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBracket()) 
                             (fun e lhsm dotm -> exprFromParseError (mkSynDotBrackGet lhsm dotm e _2)) 
                   )
//# 3719 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11887 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'optRangeSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3723 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun e lhsm dotm -> mkSynDotBrackSeqSliceGet lhsm dotm e _2) 
                   )
//# 3723 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11898 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'optRangeSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3726 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBracket()) 
                             (fun e lhsm dotm -> exprFromParseError (mkSynDotBrackSeqSliceGet lhsm dotm e _2)) 
                   )
//# 3726 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11911 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3730 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mArg = rhs2 parseState 1 3
                             (fun e lhsm dotm -> mkSynDotBrackGet lhsm dotm e (arbExpr("indexerExpr1",mArg))) 
                   )
//# 3730 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11922 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3734 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBracket())
                             let mArg = (rhs parseState 1).EndRange 
                             (fun e lhsm dotm -> exprFromParseError (mkSynDotBrackGet lhsm dotm e (arbExpr("indexerExpr2",mArg)))) 
                   )
//# 3734 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomicExprQualification));
//# 11935 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'optRange)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'optRangeSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3739 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                            _1 :: _3 
                   )
//# 3739 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optRangeSeqExpr));
//# 11947 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'optRange)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3740 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    [_1] 
                   )
//# 3740 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optRangeSeqExpr));
//# 11958 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3744 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynIndexerArg.Two(mkSynOptionalExpr (rhs parseState 1) (Some _1), mkSynOptionalExpr (rhs parseState 3) (Some _3)) 
                   )
//# 3744 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optRange));
//# 11970 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3747 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynIndexerArg.Two(mkSynOptionalExpr (rhs parseState 1) (Some _1), mkSynOptionalExpr (rhs parseState 2) None) 
                   )
//# 3747 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optRange));
//# 11981 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3750 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynIndexerArg.Two(mkSynOptionalExpr (rhs parseState 1) None, mkSynOptionalExpr (rhs parseState 2) (Some _2)) 
                   )
//# 3750 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optRange));
//# 11992 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3753 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynIndexerArg.Two(mkSynOptionalExpr (rhs parseState 1) None, mkSynOptionalExpr (rhs parseState 1) None) 
                   )
//# 3753 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optRange));
//# 12002 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3756 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynIndexerArg.One(_1) 
                   )
//# 3756 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'optRange));
//# 12013 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'constant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3761 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Const (_1,_1.Range (lhs parseState)) 
                   )
//# 3761 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12024 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3763 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3763 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12035 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3765 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3765 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12046 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceBarExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3767 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3767 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12057 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3769 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Null (lhs parseState) 
                   )
//# 3769 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12067 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3771 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Const (SynConst.Bool false,lhs parseState) 
                   )
//# 3771 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12077 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3773 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Const (SynConst.Bool true,lhs parseState) 
                   )
//# 3773 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12087 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'quoteExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3775 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3775 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12098 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'arrayExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3777 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3777 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12109 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'beginEndExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3779 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3779 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynExpr));
//# 12120 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3783 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Paren (_2, rhs parseState 1, Some(rhs parseState 3), rhs2 parseState 1 3) 
                   )
//# 3783 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'beginEndExpr));
//# 12131 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3786 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBegin()); exprFromParseError _2 
                   )
//# 3786 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'beginEndExpr));
//# 12143 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3789 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (* silent recovery *) arbExpr("beginEndExpr",(lhs parseState))  
                   )
//# 3789 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'beginEndExpr));
//# 12153 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3792 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             mkSynUnit (lhs parseState) 
                   )
//# 3792 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'beginEndExpr));
//# 12163 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3796 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if _1 <> _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsMismatchedQuote(fst _1))
                             (SynExpr.Quote (mkSynIdGet (lhs parseState) (CompileOpName (fst _1)), snd _1, _2, false, lhs parseState)) 
                   )
//# 3796 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'quoteExpr));
//# 12177 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3800 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatched(fst _1))  
                             let mExpr = rhs2 parseState 1 2
                             exprFromParseError (SynExpr.Quote (mkSynIdGet (lhs parseState) (CompileOpName (fst _1)),snd _1, _2, false, mExpr))  
                   )
//# 3800 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'quoteExpr));
//# 12192 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3805 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (* silent recovery *) SynExpr.Quote (mkSynIdGet (lhs parseState) (CompileOpName (fst _1)),snd _1, arbExpr("quoteExpr",(rhs parseState 2)), false, lhs parseState)  
                   )
//# 3805 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'quoteExpr));
//# 12204 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3808 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatched(fst _1))
                             exprFromParseError (SynExpr.Quote (mkSynIdGet (lhs parseState) (CompileOpName (fst _1)),snd _1, arbExpr("quoteExpr2",(rhs parseState 1).EndRange), false, rhs parseState 1))  
                   )
//# 3808 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'quoteExpr));
//# 12217 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'listExprElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3813 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              _2 (lhs parseState) true 
                   )
//# 3813 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayExpr));
//# 12228 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'listExprElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3816 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBracketBar()) 
                             exprFromParseError (_2 (rhs2 parseState 1 2) true) 
                   )
//# 3816 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayExpr));
//# 12241 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3820 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              (* silent recovery *) SynExpr.ArrayOrList (true,[ ], lhs parseState) 
                   )
//# 3820 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayExpr));
//# 12251 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3823 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBracketBar())  
                             (* silent recovery *) 
                             exprFromParseError (SynExpr.ArrayOrList (true,[ ], rhs parseState 1)) 
                   )
//# 3823 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayExpr));
//# 12264 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3829 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynExpr.Const (SynConst.Unit,(rhs2 parseState 1 2)) 
                   )
//# 3829 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12275 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenExprBody)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3832 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let m = rhs2 parseState 1 3
                             SynExpr.Paren (_2 m, rhs parseState 1, Some(rhs parseState 3), m) 
                   )
//# 3832 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12288 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenExprBody)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_other_than_rparen_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3836 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not _3 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen())
                             let lhsm = unionRangeWithPos (rhs parseState 1) (rhs parseState 2).End
                             SynExpr.Paren (exprFromParseError (_2 lhsm), rhs parseState 1, None, lhsm) 
                   )
//# 3836 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12302 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3841 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             // silent recovery
                             SynExpr.Paren (arbExpr("parenExpr1",(rhs parseState 1).EndRange),(rhs parseState 1),Some(rhs parseState 3),(rhs2 parseState 1 3)) 
                   )
//# 3841 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12314 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3845 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen())
                             let lhsm = unionRangeWithPos (rhs parseState 1) (rhs parseState 2).Start
                             arbExpr("parenExpr2tcs", lhsm) 
                   )
//# 3845 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12326 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3850 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen())
                             let lhsm = unionRangeWithPos (rhs parseState 1) (rhs parseState 2).Start
                             arbExpr("parenExpr2mcs", lhsm) 
                   )
//# 3850 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12338 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3855 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen())
                             let lhsm = unionRangeWithPos (rhs parseState 1) (rhs parseState 2).Start
                             arbExpr("parenExpr2rbcs", lhsm) 
                   )
//# 3855 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12350 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3860 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let lparenRange = (rhs parseState 1)
                             reportParseErrorAt lparenRange (FSComp.SR.parsUnmatchedParen())
                             SynExpr.Paren(arbExpr("parenExpr2obecs", lparenRange.EndRange), lparenRange, None, lparenRange) 
                   )
//# 3860 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12362 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3865 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen()) 
                             arbExpr("parenExpr2",(lhs parseState))  
                   )
//# 3865 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExpr));
//# 12374 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticallyKnownHeadTypars)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'classMemberSpfn)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3877 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun m -> SynExpr.TraitCall (_1,_4,_6,m)) 
                   )
//# 3877 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExprBody));
//# 12388 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3879 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (fun _m -> _1) 
                   )
//# 3879 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExprBody));
//# 12399 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'inlineAssemblyExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3881 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 3881 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'parenExprBody));
//# 12410 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticallyKnownHeadTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3885 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [_1] 
                   )
//# 3885 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticallyKnownHeadTypars));
//# 12421 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticallyKnownHeadTyparAlts)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3888 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             List.rev _2 
                   )
//# 3888 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticallyKnownHeadTypars));
//# 12433 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticallyKnownHeadTyparAlts)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticallyKnownHeadTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3892 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _3 :: _1
                   )
//# 3892 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticallyKnownHeadTyparAlts));
//# 12445 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticallyKnownHeadTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3895 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [_1] 
                   )
//# 3895 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticallyKnownHeadTyparAlts));
//# 12456 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceExprBody)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3899 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let m,r = _2 in r (rhs2 parseState 1 3) 
                   )
//# 3899 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExpr));
//# 12468 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceExprBody)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3902 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBrace())  
                            let m,r = _2 
                            // Note, we can't use 'exprFromParseError' because the extra syntax node interferes with some syntax-directed transformations for computation expressions
                            r (unionRanges (rhs parseState 1) m) 
                   )
//# 3902 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExpr));
//# 12483 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3908 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // silent recovery 
                            arbExpr("braceExpr",rhs2 parseState 1 3)  
                   )
//# 3908 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExpr));
//# 12495 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3912 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBrace())  
                            // Note, we can't use 'exprFromParseError' because the extra syntax node interferes with some syntax-directed transformations for computation expressions
                            SynExpr.Record (None,None,[],rhs parseState 1) 
                   )
//# 3912 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExpr));
//# 12508 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3917 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let m = rhs2 parseState 1 2 
                             SynExpr.Record (None,None,[],m) 
                   )
//# 3917 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExpr));
//# 12520 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3922 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (lhs parseState), (fun m -> let a,b,c = _1 in SynExpr.Record (a,b,c,m)) 
                   )
//# 3922 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExprBody));
//# 12531 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3925 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 3925 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExprBody));
//# 12542 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'monadicExprInitial)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3928 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m,r = _1 in (m, r false) 
                   )
//# 3928 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceExprBody));
//# 12553 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'monadicExprInitial)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3932 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m,r = _1 in (fun lhsm isArray -> SynExpr.ArrayOrListOfSeqExpr (isArray, r true m, lhsm)) 
                   )
//# 3932 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'listExprElements));
//# 12564 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3934 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (fun lhsm isArray -> SynExpr.ArrayOrList (isArray,[ ], lhsm)) 
                   )
//# 3934 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'listExprElements));
//# 12574 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'seqExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3938 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1.Range, (fun isArrayOrList lhsm -> SynExpr.CompExpr (isArrayOrList,ref(isArrayOrList),_1,lhsm)) 
                   )
//# 3938 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'monadicExprInitial));
//# 12585 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'rangeSequenceExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3941 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 3941 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'monadicExprInitial));
//# 12596 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3945 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let opm = (rhs parseState 2)
                            (unionRanges _1.Range _3.Range),(fun _isArray wholem -> 
                                                                     // in the case of "{ 1 .. 10 }", we want the range of the expression to include the curlies, that comes from a higher level rule in the grammar,
                                                                     // passed down as 'wholem', so patch up that range here
                                                                     match (mkSynInfix opm _1 ".." _3) with
                                                                     | SynExpr.App (a,b,c,d,_) -> SynExpr.App (a,b,c,d,wholem)
                                                                     | _ -> failwith "impossible") 
                   )
//# 3945 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rangeSequenceExpr));
//# 12614 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3953 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (unionRanges _1.Range _5.Range),(fun _isArray wholem -> mkSynTrifix wholem ".. .." _1 _3 _5) 
                   )
//# 3953 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rangeSequenceExpr));
//# 12627 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3956 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _3 then reportParseErrorAt (rhs parseState 3) (FSComp.SR.parsUnexpectedEndOfFileExpression())
                            let opm = (rhs parseState 2)
                            let e = arbExpr("rangeSeqError1", (rhs parseState 3).StartRange)
                            (unionRanges _1.Range e.Range),(fun _isArray wholem -> 
                                                                     // in the case of "{ 1 .. 10 }", we want the range of the expression to include the curlies, that comes from a higher level rule in the grammar,
                                                                     // passed down as 'wholem', so patch up that range here
                                                                     match (mkSynInfix opm _1 ".." e) with
                                                                     | SynExpr.App (a,b,c,d,_) -> SynExpr.App (a,b,c,d,wholem)
                                                                     | _ -> failwith "impossible") 
                   )
//# 3956 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rangeSequenceExpr));
//# 12647 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3969 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynExpr.YieldOrReturn ((true,false), _2, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 3969 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrowThenExprR));
//# 12658 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3974 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (_1, _3, true) 
                   )
//# 3974 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopBinder));
//# 12670 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rangeSequenceExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3977 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m,r = _3 in (_1, r false m, true) 
                   )
//# 3977 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopBinder));
//# 12682 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3980 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _3 then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsExpectedExpressionAfterToken())
                            (_1, arbExpr("forLoopBinder",(rhs parseState 2)), false) 
                   )
//# 3980 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopBinder));
//# 12695 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3984 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _2 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsInOrEqualExpected())
                            (_1, arbExpr("forLoopBinder2",(rhs parseState 1).EndRange), false) 
                   )
//# 3984 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopBinder));
//# 12708 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'forLoopDirection)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3989 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             idOfPat (rhs parseState 1) _1,_3,_4,_5 
                   )
//# 3989 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopRange));
//# 12722 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'parenPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rangeSequenceExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3992 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            raiseParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnexpectedSymbolEqualsInsteadOfIn()) 
                   )
//# 3992 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopRange));
//# 12734 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3995 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  true 
                   )
//# 3995 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopDirection));
//# 12744 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 3996 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  false 
                   )
//# 3996 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'forLoopDirection));
//# 12754 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'stringOrKeywordString)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inlineAssemblyTypeArg)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_curriedArgExprs)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_inlineAssemblyReturnTypes)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4000 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             libraryOnlyWarning (lhs parseState)
                             let s,sm = _2,rhs parseState 2
                             (fun m -> SynExpr.LibraryOnlyILAssembly (ParseAssemblyCodeInstructions s sm,_3,List.rev _4,_5,m)) 
                   )
//# 4000 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'inlineAssemblyExpr));
//# 12770 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_curriedArgExprs)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4006 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 :: _1 
                   )
//# 4006 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_curriedArgExprs));
//# 12782 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4009 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 4009 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_curriedArgExprs));
//# 12792 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4013 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             None 
                   )
//# 4013 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_atomicExprAfterType));
//# 12802 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4016 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             Some(_1) 
                   )
//# 4016 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_atomicExprAfterType));
//# 12813 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4019 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 4019 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_inlineAssemblyTypeArg));
//# 12823 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeKeyword)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4020 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                           [_3] 
                   )
//# 4020 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_inlineAssemblyTypeArg));
//# 12836 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4024 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 4024 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_inlineAssemblyReturnTypes));
//# 12846 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4027 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_2] 
                   )
//# 4027 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_inlineAssemblyReturnTypes));
//# 12857 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4030 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [] 
                   )
//# 4030 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_inlineAssemblyReturnTypes));
//# 12868 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_atomicExprAfterType)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprBindings)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps_recd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4034 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let arg = match _4 with None -> mkSynUnit (lhs parseState) | Some e -> e 
                            let l = List.rev _5
                            let dummyField = mkRecdField (LongIdentWithDots([], [])) // dummy identifier, it will be discarded
                            let l = rebindRanges (dummyField, None) l _6 
                            let (_, _, inheritsSep) = List.head l
                            let bindings = List.tail l
                            (Some (_2,arg,rhs2 parseState 2 4, inheritsSep, rhs parseState 1), None, bindings) 
                   )
//# 4034 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExpr));
//# 12889 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprCore)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4042 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           let a,b = _1 in (None, a, b) 
                   )
//# 4042 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExpr));
//# 12900 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprBindings)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps_recd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4046 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            match _1 with 
                            | LongOrSingleIdent(false, (LongIdentWithDots(_,_) as f),None,m) ->  
                                 let f = mkRecdField f
                                 let l = List.rev _4
                                 let l = rebindRanges (f, Some _3) l _5
                                 (None, l)
                            | _ -> raiseParseErrorAt (rhs parseState 2) (FSComp.SR.parsFieldBinding()) 
                   )
//# 4046 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprCore));
//# 12920 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4059 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           let m = rhs parseState 1
                           reportParseErrorAt m (FSComp.SR.parsUnderscoreInvalidFieldName())
                           reportParseErrorAt m (FSComp.SR.parsFieldBinding())
                           let f = mkUnderscoreRecdField m
                           (None, [ (f, None, None)  ]) 
                   )
//# 4059 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprCore));
//# 12934 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4066 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           let m = rhs parseState 1
                           reportParseErrorAt m (FSComp.SR.parsUnderscoreInvalidFieldName())      
                           let f = mkUnderscoreRecdField m
                           reportParseErrorAt (rhs2 parseState 1 2) (FSComp.SR.parsFieldBinding())
                           
                           (None, [ (f, None, None) ]) 
                   )
//# 4066 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprCore));
//# 12949 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprBindings)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps_recd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4075 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnderscoreInvalidFieldName())
                           let f = mkUnderscoreRecdField (rhs parseState 1)
                           let l = List.rev _4
                           let l = rebindRanges (f, Some _3) l _5
                           (None, l) 
                   )
//# 4075 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprCore));
//# 12966 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdBinding)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprBindings)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps_recd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4083 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let l = List.rev _4
                             let l = rebindRanges _3 l _5
                             (Some (_1, (rhs parseState 2, None)), l) 
                   )
//# 4083 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprCore));
//# 12982 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps_recd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4088 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (Some (_1, (rhs parseState 2, None)), []) 
                   )
//# 4088 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprCore));
//# 12994 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdBinding)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprBindings)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_seps_recd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4091 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let l = List.rev _4
                             let l = rebindRanges _3 l _5
                             (Some (_1, (rhs parseState 2, None)), l) 
                   )
//# 4091 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprCore));
//# 13010 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps_recd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4096 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     Some _1 
                   )
//# 4096 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_seps_recd));
//# 13021 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4097 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           None 
                   )
//# 4097 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_seps_recd));
//# 13031 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4100 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     (rhs parseState 1), None 
                   )
//# 4100 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps_recd));
//# 13041 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4101 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                      let m = (rhs parseState 1) in (m, Some m.End) 
                   )
//# 4101 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps_recd));
//# 13051 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4102 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               (rhs2 parseState 1 2), Some (rhs parseState 1).End 
                   )
//# 4102 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps_recd));
//# 13061 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4103 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               (rhs2 parseState 1 2), Some (rhs parseState 2).End 
                   )
//# 4103 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps_recd));
//# 13071 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4110 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                mkRecdField _1 
                   )
//# 4110 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'pathOrUnderscore));
//# 13082 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4112 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           let m = rhs parseState 1
                           reportParseErrorAt m (FSComp.SR.parsUnderscoreInvalidFieldName())
                           mkUnderscoreRecdField m 
                   )
//# 4112 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'pathOrUnderscore));
//# 13094 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprBindings)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps_recd)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdBinding)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4118 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (_3, Some _2) :: _1 
                   )
//# 4118 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprBindings));
//# 13107 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4119 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 4119 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdExprBindings));
//# 13117 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'pathOrUnderscore)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4123 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             (_1, Some _3) 
                   )
//# 4123 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdBinding));
//# 13129 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'pathOrUnderscore)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4126 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsFieldBinding())
                             (_1, None) 
                   )
//# 4126 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdBinding));
//# 13141 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'pathOrUnderscore)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4130 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsFieldBinding())
                             (_1, None) 
                   )
//# 4130 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdBinding));
//# 13154 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'pathOrUnderscore)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4134 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsFieldBinding())
                             (_1, None) 
                   )
//# 4134 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdBinding));
//# 13166 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'pathOrUnderscore)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4138 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsFieldBinding())
                             (_1, None) 
                   )
//# 4138 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'recdBinding));
//# 13179 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExprBaseCall)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExprBindings)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_objExprInterfaces)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4149 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mNewExpr = rhs parseState 1
                            let fullRange = match _4 with [] -> (rhs parseState 1) | _ -> (rhs2 parseState 1 4)
                            fullRange, (fun m -> let (a,b) = _1 in SynExpr.ObjExpr (a,b,_2,_4, mNewExpr, m)) 
                   )
//# 4149 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExpr));
//# 13195 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExprBaseCall)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExprInterfaces)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4154 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mNewExpr = rhs parseState 1 
                            let fullRange = match _3 with [] -> (rhs parseState 1) | _ -> (rhs2 parseState 1 3)
                            fullRange, (fun m -> let (a,b) = _1 in SynExpr.ObjExpr (a,b,[],_3, mNewExpr, m)) 
                   )
//# 4154 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExpr));
//# 13210 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4159 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mNewExpr = rhs parseState 1 
                            (rhs2 parseState 1 2), (fun m -> let (a,b) = _2,None in SynExpr.ObjExpr (a,b,[],[], mNewExpr, m)) 
                   )
//# 4159 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExpr));
//# 13222 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'baseSpec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4165 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (_2, Some(_4,Some(_5))) 
                   )
//# 4165 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprBaseCall));
//# 13236 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_HIGH_PRECEDENCE_APP)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4168 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (_2, Some(_4,None)) 
                   )
//# 4168 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprBaseCall));
//# 13249 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeNonAtomicDeprecated)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4171 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2,None 
                   )
//# 4171 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprBaseCall));
//# 13260 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExprBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4176 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           _1 
                   )
//# 4176 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_objExprBindings));
//# 13271 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4177 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           [] 
                   )
//# 4177 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_objExprBindings));
//# 13281 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'localBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4181 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mWithKwd = (rhs parseState 1)
                             let _localBindingsLastRange, localBindingsBuilder = _2 
                             localBindingsBuilder [] None mWithKwd 
                   )
//# 4181 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprBindings));
//# 13294 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'localBindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4186 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let mWithKwd = (rhs parseState 1)
                             let _localBindingsLastRange, localBindingsBuilder = _2 
                             localBindingsBuilder [] None mWithKwd 
                   )
//# 4186 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprBindings));
//# 13307 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'objectImplementationBlock)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declEnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4191 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 |> 
                             (List.choose (function 
                                               | SynMemberDefn.Member(b,m) -> Some b
                                               | SynMemberDefn.AutoProperty(_,_,_,_,_,_,_,_,_,_,m) -> errorR(Error(FSComp.SR.parsIllegalMemberVarInObjectImplementation(),m)); None
                                               | x -> errorR(Error(FSComp.SR.parsMemberIllegalInObjectImplementation(),x.Range)); None)) 
                   )
//# 4191 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprBindings));
//# 13323 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExprInterface)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_objExprInterfaces)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4198 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                                  _1 :: _2 
                   )
//# 4198 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprInterfaces));
//# 13335 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4202 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [] 
                   )
//# 4202 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_objExprInterfaces));
//# 13345 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'objExprInterface)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_objExprInterfaces)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4205 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _2 
                   )
//# 4205 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_objExprInterfaces));
//# 13357 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_objExprInterfaces)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4208 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (* silent recovery *) _2 
                   )
//# 4208 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_objExprInterfaces));
//# 13368 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'interfaceMember)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_objExprBindings)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_declEnd)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_OBLOCKSEP)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4212 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           InterfaceImpl(_2, _3, lhs parseState) 
                   )
//# 4212 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'objExprInterface));
//# 13383 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceBarExprCore)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4216 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 true 
                   )
//# 4216 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarExpr));
//# 13394 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'braceBarExprCore)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4218 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 false 
                   )
//# 4218 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarExpr));
//# 13405 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprCore)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bar_rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4222 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let orig, flds = _2
                            let flds = 
                                flds |> List.choose (function 
                                  | ((LongIdentWithDots([id],_),_),Some e,_) -> Some (id,e) 
                                  | ((LongIdentWithDots([id],_),_),None,_) -> Some (id, arbExpr("anonField",id.idRange)) 
                                  | _ -> reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsInvalidAnonRecdType()); None) 
                            let m = rhs2 parseState 1 3
                            (fun isStruct -> SynExpr.AnonRecd (isStruct,orig,flds,m)) 
                   )
//# 4222 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarExprCore));
//# 13424 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdExprCore)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4232 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBraceBar())  
                            let orig, flds = _2 
                            let flds = 
                                flds |> List.choose (function 
                                  | ((LongIdentWithDots([id],_),_),Some e,_) -> Some (id,e) 
                                  | ((LongIdentWithDots([id],_),_),None,_) -> Some (id, arbExpr("anonField",id.idRange)) 
                                  | _ -> reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsInvalidAnonRecdType()); None) 
                            let m = rhs2 parseState 1 2
                            (fun isStruct -> SynExpr.AnonRecd (isStruct,orig,flds,m)) 
                   )
//# 4232 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarExprCore));
//# 13444 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'bar_rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4243 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            // silent recovery 
                            let m = rhs2 parseState 1 3
                            (fun _ -> arbExpr("braceBarExpr",m)) 
                   )
//# 4243 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarExprCore));
//# 13457 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4248 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedBraceBar())  
                            let m = rhs2 parseState 1 1
                            (fun isStruct -> SynExpr.AnonRecd (isStruct,None,[],m)) 
                   )
//# 4248 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarExprCore));
//# 13470 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'bar_rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4253 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = rhs2 parseState 1 2
                            (fun isStruct -> SynExpr.AnonRecd (isStruct,None,[],m)) 
                   )
//# 4253 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'braceBarExprCore));
//# 13482 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4258 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mAll = unionRanges (rhs parseState 1) _4.Range
                            mkSynFunMatchLambdas parseState.SynArgNameGenerator false mAll _2 _4 
                   )
//# 4258 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13495 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4262 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mAll = rhs2 parseState 1 3
                            mkSynFunMatchLambdas parseState.SynArgNameGenerator false mAll _2 (arbExpr("anonLambdaExpr1",(rhs parseState 4))) 
                   )
//# 4262 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13507 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4266 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mAll = unionRanges (rhs parseState 1) _4.Range
                            mkSynFunMatchLambdas parseState.SynArgNameGenerator false mAll _2 _4 
                   )
//# 4266 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13520 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typedSeqExprBlockR)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4270 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _5 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileFunBody());
                            let mAll = unionRanges (rhs parseState 1) _4.Range
                            exprFromParseError (mkSynFunMatchLambdas parseState.SynArgNameGenerator false mAll _2 _4) 
                   )
//# 4270 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13535 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4275 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs2 parseState 1 3) (FSComp.SR.parsMissingFunctionBody())
                            mkSynFunMatchLambdas parseState.SynArgNameGenerator false (rhs2 parseState 1 3) _2 (arbExpr("anonLambdaExpr2",(rhs parseState 4))) 
                   )
//# 4275 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13547 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4279 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _4 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileFunBody())
                            exprFromParseError (mkSynFunMatchLambdas parseState.SynArgNameGenerator false (rhs2 parseState 1 3) _2 (arbExpr("anonLambdaExpr3",(rhs parseState 4)))) 
                   )
//# 4279 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13560 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4283 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            exprFromParseError (mkSynFunMatchLambdas parseState.SynArgNameGenerator false (rhs2 parseState 1 2) _2 (arbExpr("anonLambdaExpr4",(rhs parseState 3)))) 
                   )
//# 4283 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13571 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4286 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            exprFromParseError (mkSynFunMatchLambdas parseState.SynArgNameGenerator false (rhs parseState 1) [] (arbExpr("anonLambdaExpr5",(rhs parseState 2)))) 
                   )
//# 4286 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonLambdaExpr));
//# 13581 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'withPatternClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4290 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let clauses,mLast = _2
                             let mAll = unionRanges (rhs parseState 1) mLast
                             SynExpr.MatchLambda (false,(rhs parseState 1),clauses,NoSequencePointAtInvisibleBinding,mAll) 
                   )
//# 4290 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonMatchingExpr));
//# 13594 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'withPatternClauses)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4295 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let clauses,mLast = _2
                             let mAll = unionRanges (rhs parseState 1) mLast
                             SynExpr.MatchLambda (false,(rhs parseState 1),clauses,NoSequencePointAtInvisibleBinding,mAll) 
                   )
//# 4295 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'anonMatchingExpr));
//# 13607 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4304 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4304 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeWithTypeConstraints));
//# 13618 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4307 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynType.WithGlobalConstraints(_1, List.rev _3,lhs parseState) 
                   )
//# 4307 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeWithTypeConstraints));
//# 13630 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4311 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4311 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topTypeWithTypeConstraints));
//# 13641 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4314 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let ty,arity = _1 
                            // nb. it doesn't matter where the constraints go in the structure of the type. 
                            SynType.WithGlobalConstraints(ty,List.rev _3,lhs parseState), arity 
                   )
//# 4314 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topTypeWithTypeConstraints));
//# 13655 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4320 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            None 
                   )
//# 4320 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_topReturnTypeWithTypeConstraints));
//# 13665 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTypeWithTypeConstraints)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4323 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let ty,arity = _2 
                            let arity = (match arity with SynValInfo([],rmdata)-> rmdata | _ -> SynInfo.unnamedRetVal)
                            Some (SynReturnInfo((ty,arity),rhs parseState 2)) 
                   )
//# 4323 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_topReturnTypeWithTypeConstraints));
//# 13678 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTupleType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'topType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4329 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let dty,dmdata= _1 
                            let rty,(SynValInfo(dmdatas,rmdata)) = _3 
                            SynType.Fun(dty,rty,lhs parseState), (SynValInfo(dmdata :: dmdatas, rmdata)) 
                   )
//# 4329 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topType));
//# 13692 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTupleType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4334 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let ty,rmdata = _1 in ty, (SynValInfo([],(match rmdata with [md] -> md | _ -> SynInfo.unnamedRetVal))) 
                   )
//# 4334 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topType));
//# 13703 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topAppType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTupleTypeElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4338 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let ty,mdata = _1 in let tys,mdatas = List.unzip _3 in (SynType.Tuple(false,List.map (fun ty -> (false,ty)) (ty :: tys), lhs parseState)),(mdata :: mdatas) 
                   )
//# 4338 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topTupleType));
//# 13715 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topAppType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4341 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let ty,mdata = _1 in ty,[mdata] 
                   )
//# 4341 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topTupleType));
//# 13726 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topAppType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'topTupleTypeElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4345 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 :: _3 
                   )
//# 4345 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topTupleTypeElements));
//# 13738 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topAppType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4348 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            [_1] 
                   )
//# 4348 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topTupleTypeElements));
//# 13749 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4352 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            match _2 with 
                            | SynType.LongIdent(LongIdentWithDots([id],_)) -> _4,SynArgInfo(_1,false,Some id)
                            | _ -> raiseParseErrorAt (rhs parseState 2) (FSComp.SR.parsSyntaxErrorInLabeledType())  
                   )
//# 4352 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topAppType));
//# 13764 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4357 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _5,SynArgInfo(_1,true,Some _3) 
                   )
//# 4357 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topAppType));
//# 13777 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'attributes)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4360 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (_2,SynArgInfo(_1,false,None)) 
                   )
//# 4360 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topAppType));
//# 13789 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4363 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            match _1 with 
                            | SynType.LongIdent(LongIdentWithDots([id],_)) -> _3,SynArgInfo([],false,Some id)
                            | _ -> raiseParseErrorAt (rhs parseState 2) (FSComp.SR.parsSyntaxErrorInLabeledType())  
                   )
//# 4363 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topAppType));
//# 13803 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4368 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _4,SynArgInfo([],true,Some _2) 
                   )
//# 4368 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topAppType));
//# 13815 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4371 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1,SynArgInfo([],false,None) 
                   )
//# 4371 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topAppType));
//# 13826 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4377 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynType.Fun(_1,_3,lhs parseState) 
                   )
//# 4377 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynType));
//# 13838 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4380 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4380 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynType));
//# 13849 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LexerWhitespaceContinuation)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4383 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   checkEndOfFileError _2; _1 
                   )
//# 4383 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynType));
//# 13861 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleOrQuotTypeElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4388 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           SynType.Tuple(false,(false,_1) :: _3,lhs parseState) 
                   )
//# 4388 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleType));
//# 13873 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleOrQuotTypeElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4391 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if _1 <> "/" then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedInfixOperator());
                           SynType.Tuple(false,(true, SynType.StaticConstant (SynConst.Int32 1, lhs parseState)) :: _2, lhs parseState) 
                   )
//# 4391 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleType));
//# 13886 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleOrQuotTypeElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4395 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if _2 <> "/" then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedInfixOperator());
                           SynType.Tuple(false,(true,_1) :: _3, lhs parseState) 
                   )
//# 4395 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleType));
//# 13900 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4399 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           _1 
                   )
//# 4399 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleType));
//# 13911 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleOrQuotTypeElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4403 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           (false,_1) :: _3 
                   )
//# 4403 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleOrQuotTypeElements));
//# 13923 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleOrQuotTypeElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4406 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if _2 <> "/" then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedInfixOperator());
                           (true,_1) :: _3 
                   )
//# 4406 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleOrQuotTypeElements));
//# 13937 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4410 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           [(false,_1)] 
                   )
//# 4410 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'tupleOrQuotTypeElements));
//# 13948 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4414 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           SynType.LongIdent(_1) 
                   )
//# 4414 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appTypeCon));
//# 13959 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4417 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           SynType.Var(_1, lhs parseState) 
                   )
//# 4417 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appTypeCon));
//# 13970 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeCon)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicRationalConstant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4421 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if _2 <> "^" && _2 <> "^-" then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnexpectedInfixOperator());
                           if _2 = "^-" then SynType.MeasurePower(_1, SynRationalConst.Negate(_3), lhs parseState)
                           else SynType.MeasurePower(_1, _3, lhs parseState)  
                   )
//# 4421 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appTypeConPower));
//# 13985 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeCon)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4426 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           _1 
                   )
//# 4426 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appTypeConPower));
//# 13996 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'arrayTypeSuffix)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4430 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              SynType.Array(_2,_1,lhs parseState) 
                   )
//# 4430 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appType));
//# 14008 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'arrayTypeSuffix)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4433 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              SynType.Array(_3,_1,lhs parseState) 
                   )
//# 4433 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appType));
//# 14020 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeConPower)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4436 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynType.App(_2, None, [_1], [], None, true, unionRanges (rhs parseState 1) _2.Range) 
                   )
//# 4436 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appType));
//# 14032 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypePrefixArguments)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeConPower)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4439 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let args, commas = _2
                             mlCompatWarning (FSComp.SR.parsMultiArgumentGenericTypeFormDeprecated()) (unionRanges (rhs parseState 1) _4.Range); 
                             SynType.App(_4, None, args, commas, None, true, unionRanges (rhs parseState 1) _4.Range) 
                   )
//# 4439 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appType));
//# 14047 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'powerType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4444 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 4444 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appType));
//# 14058 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4447 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              let tp,typ = _1,_3 
                              let m = lhs parseState 
                              SynType.WithGlobalConstraints(SynType.Var (tp, rhs parseState 1), [WhereTyparSubtypeOfType(tp,typ,m)],m)  
                   )
//# 4447 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appType));
//# 14072 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4452 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              SynType.HashConstraint(_3, lhs parseState) 
                   )
//# 4452 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appType));
//# 14083 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4456 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             1 
                   )
//# 4456 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayTypeSuffix));
//# 14093 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4459 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             2 
                   )
//# 4459 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayTypeSuffix));
//# 14103 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4462 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             3 
                   )
//# 4462 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayTypeSuffix));
//# 14113 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4465 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             4 
                   )
//# 4465 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'arrayTypeSuffix));
//# 14123 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActual)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActual)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgListElements)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4469 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let typeArgs, commas = _4 in _1 :: _3 :: List.rev typeArgs, (rhs parseState 2) :: (List.rev commas) 
                   )
//# 4469 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'appTypePrefixArguments));
//# 14136 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgListElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActual)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4473 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let typeArgs, commas = _1
                             _3 :: typeArgs, (rhs parseState 2) :: commas 
                   )
//# 4473 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgListElements));
//# 14149 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgListElements)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'dummyTypeArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4477 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsMissingTypeArgs())
                            let typeArgs, commas = _1
                            _3 :: typeArgs, (rhs parseState 2) :: commas 
                   )
//# 4477 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgListElements));
//# 14163 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4482 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [], [] 
                   )
//# 4482 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgListElements));
//# 14173 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeOrAnonRecdType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4486 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           _1 
                   )
//# 4486 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'powerType));
//# 14184 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomTypeOrAnonRecdType)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicRationalConstant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4489 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if _2 <> "^" && _2 <> "^-" then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnexpectedInfixOperator());
                            if _2 = "^-" then SynType.MeasurePower(_1, SynRationalConst.Negate(_3), lhs parseState)
                            else SynType.MeasurePower(_1, _3, lhs parseState) 
                   )
//# 4489 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'powerType));
//# 14199 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypePrefixArguments)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeConPower)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4498 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let args, commas = _2
                             mlCompatWarning (FSComp.SR.parsMultiArgumentGenericTypeFormDeprecated()) (unionRanges (rhs parseState 1) _4.Range); 
                             SynType.App(_4, None, args, commas, None, true, unionRanges (rhs parseState 1) _4.Range) 
                   )
//# 4498 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomTypeNonAtomicDeprecated));
//# 14214 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4503 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 4503 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomTypeNonAtomicDeprecated));
//# 14225 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4507 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4507 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomTypeOrAnonRecdType));
//# 14236 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'anonRecdType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4509 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let flds,isStruct = _1
                            let flds2 = 
                                flds |> List.choose (function 
                                  | (Field([],false,Some id,ty,false,_xmldoc,None,_m)) -> Some (id,ty) 
                                  | _ -> reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsInvalidAnonRecdType()); None)
                            SynType.AnonRecd (isStruct,flds2, rhs parseState 1) 
                   )
//# 4509 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomTypeOrAnonRecdType));
//# 14252 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4522 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynType.HashConstraint(_2, lhs parseState) 
                   )
//# 4522 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14263 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeConPower)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4525 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4525 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14274 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4528 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynType.Anon (lhs parseState) 
                   )
//# 4528 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14284 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4531 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _2 
                   )
//# 4531 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14296 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4534 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnmatchedParen()) 
                            _2 
                   )
//# 4534 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14309 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleOrQuotTypeElements)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4538 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           SynType.Tuple(true, (false,_3) :: _5,lhs parseState) 
                   )
//# 4538 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14322 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleOrQuotTypeElements)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4541 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnmatchedParen()) 
                           SynType.Tuple(true, (false,_3) :: _5,lhs parseState) 
                   )
//# 4541 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14336 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4545 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnmatchedParen()) 
                           SynType.Anon (lhs parseState) 
                   )
//# 4545 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14349 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appType)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4549 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnmatchedParen()) 
                           SynType.Anon (lhs parseState) 
                   )
//# 4549 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14362 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4553 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnmatchedParen()) 
                           SynType.Anon (lhs parseState) 
                   )
//# 4553 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14374 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'rawConstant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4557 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynType.StaticConstant(_1, rhs parseState 1) 
                   )
//# 4557 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14385 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4560 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = rhs parseState 1
                            SynType.StaticConstant(SynConst.String (null, m), m) 
                   )
//# 4560 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14396 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynExpr * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4564 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let e,_ = _2
                             SynType.StaticConstantExpr(e, e.Range) 
                   )
//# 4564 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14408 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4568 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynType.StaticConstant(SynConst.Bool false,lhs parseState) 
                   )
//# 4568 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14418 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4571 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             SynType.StaticConstant(SynConst.Bool true,lhs parseState) 
                   )
//# 4571 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14428 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4574 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (* silent recovery *) SynType.Anon (lhs parseState) 
                   )
//# 4574 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14439 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeCon)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : range * range option * Ast.SynType list * range list * range)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4577 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mLessThan,mGreaterThan,args,commas,mWhole = _2 in SynType.App(_1, Some(mLessThan), args, commas, mGreaterThan, false, unionRanges _1.Range mWhole) 
                   )
//# 4577 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14451 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4580 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynType.LongIdentApp(_1, _3, None, [], [], None, unionRanges (rhs parseState 1) _3.Range) 
                   )
//# 4580 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14463 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : range * range option * Ast.SynType list * range list * range)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4583 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mLessThan,mGreaterThan,args,commas,mWhole = _4 
                            SynType.LongIdentApp(_1, _3, Some(mLessThan), args, commas, mGreaterThan, unionRanges _1.Range mWhole) 
                   )
//# 4583 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14477 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTypeCon)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4587 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _3 then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsExpectedNameAfterToken())
                            _1 
                   )
//# 4587 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'atomType));
//# 14490 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : range * range option * bool     * Ast.SynType list * range list * range)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4593 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mLessThan, mGreaterThan, parsedOk, args, commas, mAll = _1
                            if parsedOk then // if someone has "foo<bar" without a closing greater-than, then the lexfilter does not introduce a HPA, even though it is adjacent
                                warning(Error(FSComp.SR.parsNonAdjacentTyargs(),rhs parseState 1))
                            mLessThan, mGreaterThan, args, commas, mAll 
                   )
//# 4593 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * Ast.SynType list * range list * range));
//# 14504 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : range * range option * bool     * Ast.SynType list * range list * range)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4599 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let mLessThan, mGreaterThan, _, args, commas, mAll = _2
                            mLessThan, mGreaterThan, args, commas, mAll 
                   )
//# 4599 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * Ast.SynType list * range list * range));
//# 14516 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActualOrDummyIfEmpty)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActualOrDummyIfEmpty)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgListElements)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4604 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let typeArgs, commas = _5
                            (rhs parseState 1), Some(rhs parseState 6), true, (_2 :: _4 :: List.rev typeArgs), (rhs parseState 3) :: (List.rev commas), lhs parseState 
                   )
//# 4604 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * bool     * Ast.SynType list * range list * range));
//# 14532 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActualOrDummyIfEmpty)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActualOrDummyIfEmpty)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgListElements)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4608 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _6 then 
                                reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedEndOfFileTypeArgs())
                            else
                                reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsMissingGreaterThan())
                            let typeArgs, commas = _5
                            let nextToken = rhs parseState 6
                            let zeroWidthAtStartOfNextToken = nextToken.StartRange
                            (rhs parseState 1), None, false, (_2 :: _4 :: List.rev typeArgs), (rhs parseState 3) :: (List.rev commas), unionRanges (rhs parseState 1) zeroWidthAtStartOfNextToken 
                   )
//# 4608 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * bool     * Ast.SynType list * range list * range));
//# 14554 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActualOrDummyIfEmpty)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4618 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _4 then reportParseErrorAt (rhs parseState 4) (FSComp.SR.parsMissingTypeArgs())
                            let nextToken = rhs parseState 4
                            let zeroWidthAtStartOfNextToken = nextToken.StartRange
                            (rhs parseState 1), None, false, [_2], [rhs parseState 3], unionRanges (rhs parseState 1) zeroWidthAtStartOfNextToken 
                   )
//# 4618 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * bool     * Ast.SynType list * range list * range));
//# 14570 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActual)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4624 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (rhs parseState 1), Some(rhs parseState 3), true, [_2], [], lhs parseState 
                   )
//# 4624 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * bool     * Ast.SynType list * range list * range));
//# 14583 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActual)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4627 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let nextToken = rhs parseState 3
                            if not _3 then reportParseErrorAt nextToken (FSComp.SR.parsMissingTypeArgs())
                            let zeroWidthAtStartOfNextToken = nextToken.StartRange
                            (rhs parseState 1), None, false, [_2], [], unionRanges (rhs parseState 1) zeroWidthAtStartOfNextToken 
                   )
//# 4627 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * bool     * Ast.SynType list * range list * range));
//# 14599 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4633 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (rhs parseState 1), Some(rhs parseState 2), true, [], [], lhs parseState 
                   )
//# 4633 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * bool     * Ast.SynType list * range list * range));
//# 14611 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4636 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _2 then  
                                reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsExpectedTypeAfterToken())
                            else
                                reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsMissingTypeArgs())
                            let nextToken = rhs parseState 2
                            let zeroWidthAtStartOfNextToken = nextToken.StartRange
                            (rhs parseState 1), None, false, [], [], unionRanges (rhs parseState 1) zeroWidthAtStartOfNextToken 
                   )
//# 4636 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : range * range option * bool     * Ast.SynType list * range list * range));
//# 14629 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4646 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4646 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgActual));
//# 14640 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4649 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynType.StaticConstantNamed(_1, _3, unionRanges _1.Range _3.Range) 
                   )
//# 4649 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgActual));
//# 14652 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4652 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsMissingTypeArgs())
                            let dummy = SynType.StaticConstant(SynConst.Int32(0), rhs parseState 2)
                            SynType.StaticConstantNamed(_1, dummy, (rhs2 parseState 1 2))
                          
                   )
//# 4652 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgActual));
//# 14666 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeArgActual)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4659 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4659 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgActualOrDummyIfEmpty));
//# 14677 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'dummyTypeArg)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4662 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsMissingTypeArgs())
                            _1 
                   )
//# 4662 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeArgActualOrDummyIfEmpty));
//# 14689 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4667 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let m = rhs parseState 1
                            let dummyStatVal = SynType.StaticConstant(SynConst.Int32(0), m)
                            let dummyName = SynType.LongIdent(LongIdentWithDots([ident("",m)],[]))
                            let dummyTypeArg = SynType.StaticConstantNamed(dummyName, dummyStatVal, m)
                            dummyTypeArg 
                   )
//# 4667 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'dummyTypeArg));
//# 14703 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4676 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 4676 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeArg));
//# 14716 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4679 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynMeasure.Anon (lhs parseState) 
                   )
//# 4679 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeArg));
//# 14728 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4683 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynMeasure.Named(_1.Lid, _1.Range) 
                   )
//# 4683 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeAtom));
//# 14739 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.SynTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4686 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            SynMeasure.Var(_1, lhs parseState) 
                   )
//# 4686 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeAtom));
//# 14750 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4689 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _2 
                   )
//# 4689 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeAtom));
//# 14762 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeAtom)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4693 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _1 
                   )
//# 4693 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypePower));
//# 14773 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeAtom)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicRationalConstant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4696 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if _2 <> "^" && _2 <> "^-" then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnexpectedOperatorForUnitOfMeasure());
                            if _2 = "^-" then SynMeasure.Power(_1, SynRationalConst.Negate(_3), lhs parseState)
                            else SynMeasure.Power(_1, _3, lhs parseState) 
                   )
//# 4696 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypePower));
//# 14788 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4701 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if fst _1 <> 1 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedIntegerLiteralForUnitOfMeasure());
                            SynMeasure.One 
                   )
//# 4701 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypePower));
//# 14800 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypePower)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4706 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           [_1] 
                   )
//# 4706 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeSeq));
//# 14811 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypePower)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeSeq)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4709 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           _1 :: _2 
                   )
//# 4709 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeSeq));
//# 14823 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeSeq)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4713 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           SynMeasure.Seq(_1, lhs parseState) 
                   )
//# 4713 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeExpr));
//# 14834 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeExpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4716 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           SynMeasure.Product(_1, _3, lhs parseState) 
                   )
//# 4716 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeExpr));
//# 14846 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeExpr)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4719 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                           if _2 <> "*" && _2 <> "/" then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsUnexpectedOperatorForUnitOfMeasure());
                           if _2 = "*" then SynMeasure.Product(_1, _3, lhs parseState)
                           else SynMeasure.Divide(_1, _3, lhs parseState) 
                   )
//# 4719 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeExpr));
//# 14861 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'measureTypeExpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4724 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if _1 <> "/" then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedOperatorForUnitOfMeasure());
                            SynMeasure.Divide(SynMeasure.One, _2, lhs parseState) 
                   )
//# 4724 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'measureTypeExpr));
//# 14874 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4729 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             let id = mkSynId (lhs parseState) (_2).idText
                             Typar(id, NoStaticReq,false) 
                   )
//# 4729 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypar));
//# 14886 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'staticallyKnownHeadTypar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4733 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4733 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.SynTypar));
//# 14897 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4737 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if _1 <> "^" then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsUnexpectedTypeParameter());
                            let id = mkSynId (lhs parseState) (_2).idText
                            Typar(id,HeadTypeStaticReq,false) 
                   )
//# 4737 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'staticallyKnownHeadTypar));
//# 14911 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4745 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            ident(_1,rhs parseState 1) 
                   )
//# 4745 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.Ident));
//# 14922 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4751 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             LongIdentWithDots([ident(MangledGlobalName,rhs parseState 1)],[]) 
                   )
//# 4751 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 14932 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4754 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            LongIdentWithDots([_1],[]) 
                   )
//# 4754 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 14943 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4757 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let (LongIdentWithDots(lid,dotms)) = _1 in LongIdentWithDots(lid @ [_3], dotms @ [rhs parseState 2]) 
                   )
//# 4757 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 14955 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ends_coming_soon_or_recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4760 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            if not _3 then reportParseErrorAt (rhs parseState 2) (FSComp.SR.parsExpectedNameAfterToken())
                            let (LongIdentWithDots(lid,dotms)) = _1 in LongIdentWithDots(lid, dotms @ [rhs parseState 2])  
                   )
//# 4760 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 14968 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'operatorName)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4767 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             ident(CompileOpName _2,rhs parseState 2) 
                   )
//# 4767 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opName));
//# 14980 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4770 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             reportParseErrorAt (lhs parseState) (FSComp.SR.parsErrorParsingAsOperatorName()); ident(CompileOpName "****",rhs parseState 2) 
                   )
//# 4770 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opName));
//# 14991 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4773 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             ident(CompileOpName "*",rhs parseState 1) 
                   )
//# 4773 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opName));
//# 15001 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'activePatternCaseNames)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4777 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let text = ("|" + String.concat "|" (List.rev _2) + "|")
                            ident(text,rhs2 parseState 2 3) 
                   )
//# 4777 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opName));
//# 15014 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'activePatternCaseNames)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4782 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let text = ("|" + String.concat "|" (List.rev _2) + "|_|" )
                            ident(text,rhs2 parseState 2 5) 
                   )
//# 4782 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opName));
//# 15027 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4788 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not (IsValidPrefixOperatorDefinitionName _1) then 
                                 reportParseErrorAt (lhs parseState) (FSComp.SR.parsInvalidPrefixOperatorDefinition());
                             _1 
                   )
//# 4788 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15040 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4792 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               _1 
                   )
//# 4792 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15051 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4794 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                            _1 
                   )
//# 4794 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15062 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4796 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                            _1 
                   )
//# 4796 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15073 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4798 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                         _1 
                   )
//# 4798 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15084 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4800 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        _1 
                   )
//# 4800 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15095 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4802 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          _1 
                   )
//# 4802 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15106 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4804 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                 _1 
                   )
//# 4804 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15117 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4806 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  "$" 
                   )
//# 4806 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15127 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4808 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              _1 
                   )
//# 4808 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15138 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4810 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 "-" 
                   )
//# 4810 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15148 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4812 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                "*" 
                   )
//# 4812 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15158 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4814 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  "=" 
                   )
//# 4814 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15168 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4816 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                              "or" 
                   )
//# 4816 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15178 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4818 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                "<" 
                   )
//# 4818 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15189 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4820 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   ">" 
                   )
//# 4820 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15200 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4822 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 "?" 
                   )
//# 4822 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15210 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4824 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               "&" 
                   )
//# 4824 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15220 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4826 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   "&&" 
                   )
//# 4826 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15230 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4828 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   "||" 
                   )
//# 4828 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15240 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4830 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        ":=" 
                   )
//# 4830 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15250 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4833 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if _1 <> ".[]"  && _1 <> ".()" && _1 <> ".()<-" then 
                                  deprecatedOperator (lhs parseState); 
                             _1 
                   )
//# 4833 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15263 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4837 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                      _1 
                   )
//# 4837 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15274 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4839 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   ".." 
                   )
//# 4839 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15284 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4841 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                           ".. .." 
                   )
//# 4841 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15294 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4844 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if _1 <> _2 then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsMismatchedQuotationName(fst _1));  
                             fst _1 
                   )
//# 4844 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'operatorName));
//# 15307 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4850 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             if not (String.isUpper _1) then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsActivePatternCaseMustBeginWithUpperCase());  
                             if (_1.IndexOf('|') <> -1) then reportParseErrorAt (rhs parseState 1) (FSComp.SR.parsActivePatternCaseContainsPipe());  
                             _1 
                   )
//# 4850 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'activePatternCaseName));
//# 15320 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'activePatternCaseName)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4857 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             [_2] 
                   )
//# 4857 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'activePatternCaseNames));
//# 15331 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'activePatternCaseNames)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'activePatternCaseName)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4860 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             _3 :: _1 
                   )
//# 4860 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'activePatternCaseNames));
//# 15343 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4865 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4865 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'identOrOp));
//# 15354 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opName)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4868 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            _1 
                   )
//# 4868 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'identOrOp));
//# 15365 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4874 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            LongIdentWithDots([_1],[]) 
                   )
//# 4874 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 15376 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'opName)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4877 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            LongIdentWithDots([_1],[]) 
                   )
//# 4877 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 15387 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.LongIdentWithDots)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4880 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            let (LongIdentWithDots(lid,dotms)) = _3 in LongIdentWithDots(_1 :: lid, rhs parseState 2 :: dotms) 
                   )
//# 4880 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 15399 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Ast.Ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4883 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            (* silent recovery *) LongIdentWithDots([_1],[rhs parseState 2]) 
                   )
//# 4883 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : Ast.LongIdentWithDots));
//# 15410 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'identOrOp)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4888 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                      _1 
                   )
//# 4888 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'nameop));
//# 15421 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4891 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 4891 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topSeparator));
//# 15431 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4892 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               
                   )
//# 4892 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topSeparator));
//# 15441 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4893 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 4893 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topSeparator));
//# 15451 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4896 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                            
                   )
//# 4896 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topSeparators));
//# 15462 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparator)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparators)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4897 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                      
                   )
//# 4897 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'topSeparators));
//# 15474 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'topSeparator)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'opt_topSeparators)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4900 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                          
                   )
//# 4900 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_topSeparators));
//# 15486 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4901 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                          
                   )
//# 4901 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_topSeparators));
//# 15496 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4905 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 4905 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps));
//# 15506 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4906 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 4906 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps));
//# 15516 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4907 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               
                   )
//# 4907 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps));
//# 15526 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4908 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                               
                   )
//# 4908 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'seps));
//# 15536 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4913 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             
                   )
//# 4913 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'declEnd));
//# 15546 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4915 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               
                   )
//# 4915 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'declEnd));
//# 15556 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4917 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             
                   )
//# 4917 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'declEnd));
//# 15566 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4922 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            
                   )
//# 4922 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_declEnd));
//# 15576 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4924 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                             
                   )
//# 4924 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_declEnd));
//# 15586 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4926 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            
                   )
//# 4926 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_declEnd));
//# 15596 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4928 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                            
                   )
//# 4928 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_declEnd));
//# 15606 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4931 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4931 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_ODECLEND));
//# 15616 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4932 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4932 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_ODECLEND));
//# 15626 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4935 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       deprecatedWithError (FSComp.SR.parsNoEqualShouldFollowNamespace()) (lhs parseState); () 
                   )
//# 4935 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'deprecated_opt_equals));
//# 15636 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4936 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        
                   )
//# 4936 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'deprecated_opt_equals));
//# 15646 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4939 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4939 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_OBLOCKSEP));
//# 15656 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4940 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4940 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_OBLOCKSEP));
//# 15666 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'seps)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4943 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4943 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_seps));
//# 15677 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4944 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4944 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_seps));
//# 15687 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4947 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       true 
                   )
//# 4947 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_rec));
//# 15697 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4948 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       false 
                   )
//# 4948 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_rec));
//# 15707 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4951 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4951 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_bar));
//# 15717 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4952 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       
                   )
//# 4952 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_bar));
//# 15727 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4955 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       true 
                   )
//# 4955 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_inline));
//# 15737 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4956 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       false 
                   )
//# 4956 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_inline));
//# 15747 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4959 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       true 
                   )
//# 4959 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_mutable));
//# 15757 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4960 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                       false 
                   )
//# 4960 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_mutable));
//# 15767 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4964 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               
                   )
//# 4964 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'doToken));
//# 15777 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4965 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               
                   )
//# 4965 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'doToken));
//# 15787 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4968 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                
                   )
//# 4968 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'doneDeclEnd));
//# 15797 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4969 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                    
                   )
//# 4969 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'doneDeclEnd));
//# 15807 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4972 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  mlCompatWarning (FSComp.SR.parsSyntaxModuleStructEndDeprecated()) (lhs parseState); 
                   )
//# 4972 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'structOrBegin));
//# 15817 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4973 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 
                   )
//# 4973 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'structOrBegin));
//# 15827 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4976 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                               mlCompatWarning (FSComp.SR.parsSyntaxModuleSigEndDeprecated()) (lhs parseState); 
                   )
//# 4976 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'sigOrBegin));
//# 15837 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4977 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 
                   )
//# 4977 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'sigOrBegin));
//# 15847 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4980 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                 mlCompatWarning (FSComp.SR.parsSyntaxModuleSigEndDeprecated()) (lhs parseState); 
                   )
//# 4980 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'colonOrEquals));
//# 15857 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4981 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  
                   )
//# 4981 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'colonOrEquals));
//# 15867 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4985 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  _1 
                   )
//# 4985 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'stringOrKeywordString));
//# 15878 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4986 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          _1 
                   )
//# 4986 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'stringOrKeywordString));
//# 15889 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4989 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                     
                   )
//# 4989 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_HIGH_PRECEDENCE_APP));
//# 15899 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4990 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                     
                   )
//# 4990 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_HIGH_PRECEDENCE_APP));
//# 15909 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4991 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                         
                   )
//# 4991 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_HIGH_PRECEDENCE_APP));
//# 15919 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4994 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                 
                   )
//# 4994 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_HIGH_PRECEDENCE_TYAPP));
//# 15929 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4995 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                         
                   )
//# 4995 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'opt_HIGH_PRECEDENCE_TYAPP));
//# 15939 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typeKeyword)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 4999 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                        
                   )
//# 4999 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeKeyword));
//# 15950 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5000 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                        
                   )
//# 5000 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeKeyword));
//# 15960 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5001 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                
                   )
//# 5001 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'typeKeyword));
//# 15970 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleKeyword)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5005 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                            
                   )
//# 5005 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleKeyword));
//# 15981 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5006 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          
                   )
//# 5006 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleKeyword));
//# 15991 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5007 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  
                   )
//# 5007 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'moduleKeyword));
//# 16001 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'rbrace)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5010 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                     
                   )
//# 5010 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rbrace));
//# 16012 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5011 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          
                   )
//# 5011 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rbrace));
//# 16022 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5012 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  
                   )
//# 5012 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rbrace));
//# 16032 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5015 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                      
                   )
//# 5015 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'bar_rbrace));
//# 16042 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'rparen)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5018 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                     
                   )
//# 5018 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rparen));
//# 16053 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5019 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                          
                   )
//# 5019 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rparen));
//# 16063 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5020 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                  
                   )
//# 5020 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'rparen));
//# 16073 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'oblockend)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5023 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                           
                   )
//# 5023 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'oblockend));
//# 16084 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5024 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                             
                   )
//# 5024 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'oblockend));
//# 16094 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5025 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                     
                   )
//# 5025 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'oblockend));
//# 16104 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5028 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                            false 
                   )
//# 5028 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_other_than_rparen_coming_soon_or_recover));
//# 16114 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5029 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              false 
                   )
//# 5029 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_other_than_rparen_coming_soon_or_recover));
//# 16124 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5030 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              false 
                   )
//# 5030 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_other_than_rparen_coming_soon_or_recover));
//# 16134 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5031 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                 false 
                   )
//# 5031 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_other_than_rparen_coming_soon_or_recover));
//# 16144 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5032 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   _1 
                   )
//# 5032 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_other_than_rparen_coming_soon_or_recover));
//# 16155 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5035 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                            false 
                   )
//# 5035 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_coming_soon_or_recover));
//# 16165 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5036 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              false 
                   )
//# 5036 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_coming_soon_or_recover));
//# 16175 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5037 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              false 
                   )
//# 5037 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_coming_soon_or_recover));
//# 16185 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5038 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                              false 
                   )
//# 5038 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_coming_soon_or_recover));
//# 16195 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5039 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                                 false 
                   )
//# 5039 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_coming_soon_or_recover));
//# 16205 "pars.fs"
        (fun (parseState : Internal.Utilities.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'recover)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
//# 5040 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                                   _1 
                   )
//# 5040 "/fcs/fcs-fable/codegen/../../../src/fsharp/pars.fsy"
                 : 'ends_coming_soon_or_recover));
|]
//# 16217 "pars.fs"
let tables () : Internal.Utilities.Text.Parsing.Tables<_> = 
  { reductions= _fsyacc_reductions ();
    endOfInputTag = _fsyacc_endOfInputTag;
    tagOfToken = tagOfToken;
    dataOfToken = _fsyacc_dataOfToken; 
    actionTableElements = _fsyacc_actionTableElements;
    actionTableRowOffsets = _fsyacc_actionTableRowOffsets;
    stateToProdIdxsTableElements = _fsyacc_stateToProdIdxsTableElements;
    stateToProdIdxsTableRowOffsets = _fsyacc_stateToProdIdxsTableRowOffsets;
    reductionSymbolCounts = _fsyacc_reductionSymbolCounts;
    immediateActions = _fsyacc_immediateActions;
    gotos = _fsyacc_gotos;
    sparseGotoTableRowOffsets = _fsyacc_sparseGotoTableRowOffsets;
    tagOfErrorTerminal = _fsyacc_tagOfErrorTerminal;
    parseError = (fun (ctxt:Internal.Utilities.Text.Parsing.ParseErrorContext<_>) -> 
                              match parse_error_rich with 
                              | Some f -> f ctxt
                              | None -> parse_error ctxt.Message);
    numTerminals = 197;
    productionToNonTerminalTable = _fsyacc_productionToNonTerminalTable  }
let engine lexer lexbuf startState = (tables ()).Interpret(lexer, lexbuf, startState)
let signatureFile lexer lexbuf : Ast.ParsedSigFile =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 0))
let implementationFile lexer lexbuf : Ast.ParsedImplFile =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 2))
let interaction lexer lexbuf : Ast.ParsedFsiInteraction =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 4))
let typedSeqExprEOF lexer lexbuf : Ast.SynExpr =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 6))
let typEOF lexer lexbuf : Ast.SynType =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 8))
